
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
// Class for complex data type

class _COMPLEX{
       float real;
       float imag;


         float arctan(float l,float m)
         {
           float tht;

           if (l==0) tht=M_PI/2;
                  else tht=(float) atan( fabs (m/l));
           if (l<0) {
             if (m>0) 
                tht=M_PI-tht;
               else tht=M_PI+tht;
                    }
            else
              if (m<0)tht=2*M_PI-tht;
              return(tht);
          } /* {of arctan} */


       public:
          _COMPLEX(){real=imag=0.0;}
          _COMPLEX(float x,float y){real=x;imag=y;}

       void set(float x,float y){real=x;imag=y;}
       void conjugate(){imag=-imag;}
       float get_r(){return(real);}
       float get_i(){return(imag);}
       void write(){cout<<"("<<real<<","<<imag<<")\n";}

       _COMPLEX operator+(_COMPLEX ob)
          {_COMPLEX t(real+ob.real,imag+ob.imag);
          return(t);
          }

       _COMPLEX operator-(_COMPLEX ob)
          {_COMPLEX t(real-ob.real,imag-ob.imag);
          return(t);
          }

       _COMPLEX operator*(_COMPLEX ob)
          {_COMPLEX t(real*ob.real-imag*ob.imag,real*ob.imag+ob.real*imag);
          return(t);
          }

       _COMPLEX operator/(_COMPLEX ob)
          {_COMPLEX t(real*ob.real+imag*ob.imag,-real*ob.imag+ob.real*imag);
            t.real=t.real/(sqr(ob.real)-sqr(ob.imag));
            t.imag=t.imag/(sqr(ob.real)-sqr(ob.imag));
          return(t);
          }

       _COMPLEX operator+(float val)
          {_COMPLEX t(real+val,imag);
          return(t);
          }

       _COMPLEX operator-(float val)
          {_COMPLEX t(real-val,imag);
          return(t);
          }

       _COMPLEX operator*(float val)
          {_COMPLEX t(real*val,imag*val);
          return(t);
          }


       _COMPLEX operator/(float val)
          {_COMPLEX t(real/val,imag/val);
          return(t);
          }

         float get_m(){return((float)sqrt((double)(sqr(real)+sqr(imag))));}
         float get_ang(){return(arctan(real,imag));}

         _COMPLEX convert_phasor()
           {
            _COMPLEX t(real*(float)cos((double)imag),real*(float)sin((double)imag));
             return(t);
            }

         _COMPLEX get_phasor()
          {
          _COMPLEX t(get_m(),get_ang());
           return(t);
          }
  };


  

