
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
void fft(_COMPLEX *a,int m);
void ifft(_COMPLEX *a,int m);
int power(int base,int y);


void fft(_COMPLEX *a,int m)
{
	_COMPLEX u,w,t,v;
         float x,y;
	int n,nv2,nm1,i,j,k,l,le1,ip,le;

	n=power(2,m);
	nv2=n/2;
	nm1=n-1;
	j=1;
	for(i=1;i<=nm1;i++)
	{
		if(i<j)
		{
			t=a[i-1];
			a[i-1]=a[j-1];
			a[j-1]=t;
		}
		k=nv2;
		while(k<j)
		{ 
			j=j-k;
			k=k/2;
		}
		j=j+k;
	}


	for(l=1;l<=m;l++)
	{  
		le=power(2,l);
		le1=le/2;
                 u.set(1.0,0.0);

		x=(float)cos((double)(M_PI/(float)le1));
		y=-(float)sin((double)(M_PI/(float)le1));
                w.set(x,y);
		for(j=0;j<le1;j++)
		{
			for(i=j;i<n;i+=le)
			{
				ip=i+le1;
                                 t=a[ip]*u;

                                  a[ip]=a[i]-t;

                                a[i]=a[i]+t;

			}
                        v=w*u;

                        u=v;
		}
	}
}


void ifft(_COMPLEX *a,int m)
{
	int i,n;
        float x,y;

	n=power(2,m);

	for(i=0;i<n;i++)
	{
                 x=a[i].get_r()/n;
                 y= -a[i].get_i()/n;
                 a[i].set(x,y);
	}	

	fft(a,m);

	for(i=0;i<n;i++)
          {
                 x=a[i].get_r();
                 y= -a[i].get_i();
                 a[i].set(x,y);
          }

}



int power(int base,int y)
{
	int i,p;
	p=1;
	for(i=0;i<y;i++)
		p*=base;
	return p;
}


