
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
 //implements GREY image classes
class _GREY{
	short id;
	short type;
	short width;
	short height;
	short depth;
	unsigned char imin;
	unsigned char imax;
        int int_min;
        int int_max;
        float fmin;
        float fmax;
	_signal hist;
	unsigned char **pic;
        int **pint;
        float **rval;
        float **ival;
        int data_type; //DCHAR(0),DINT(1),DFLOAT(2),DCOMPLEX(3)
        float max_range,min_range;
        int domain;//SPACE,FREQ,OTHER

     void segnum(int **thinpat,int a,int b,int num,float mn,int &npnt,int wsize,float diff);
     void segmentation(int **thinpat,int a,int b,int num,float mn,int &npnt,int wsize,float diff);
     void view_segment(int **thinpat,int num,int nums);
     void fine_smooth(int **thinpat,int num,int fth);
     int  DARK(int **pat,int a,int b);
     void UVWTRANS(int **pat,int *n,int p,int q);
     int  SAFE(int **pat,int p,int q,int mode);
     int  BND(int **pat,int x,int y,int t,int m);
     void SKELETONIZE(int **pat,int level,int t,int &complete);
     float g1(float dI,float K);
     float g2(float dI,float K);
     float mytan(int theta);


        public:
               _GREY(){
                       pic=NULL;pint=NULL;rval=NULL;ival=NULL;data_type=DCHAR;
               width=height=depth=int_min=int_max=0;fmin=fmax=0;
                       max_range=MAX_VAL;min_range=MIN_VAL; domain=SPACE; hist.step(0,256);
                       }
           _GREY(int w,int h);//constructor
        _GREY(int w,int h,int val);//constructor
         ~_GREY();

        void free();
        void   set(int w,int h);
        void set(int w,int h,int val);
        void set(int w,int h,float val,int dtype);//
        void set(unsigned char **p,int w,int h)
        {
         pic=p;
         width=w;
         height=h;
         data_type=DCHAR;
         }
        void set(int **p,int w,int h)
        {
         pint=p;
         width=w;
         height=h;
         data_type=DINT;
         }

        void set(float **p,int w,int h)
        {
         rval=p;
         width=w;
         height=h;
         data_type=DFLOAT;
         }

        float pixel(int x, int y);
        void  put(float val,int x,int y);
        char load_picture(char *fname,int w,int h);
        void load(char *fname,int w,int h){load_picture(fname,w,h);}
        char load_picture(unsigned char **p,int w,int h);
        void load(unsigned char **p,int w,int h){load_picture(p,w,h);}

        char save_picture( char *fname);
        void save(char *fname){save_picture(fname);}

        unsigned char **get_picture(){return(pic);}
        unsigned char **get_pic(){return(pic);}
        int **get_picture_int(){return(pint);}
        int **get_i(){return(pint);}
        float **get_real(){return(rval);}
        float **get_imag(){return(ival);}
        float **get_f(){return(rval);}

        int get_h(){return(height);}
        int get_w(){return(width);}
        float get_min(){if(pint!=NULL){
                        return((float)int_min);
                        }
                        else if(rval!=NULL){
                        return(fmin);
                        }
                        else if(pic!=NULL){
                        return((float)imin);
                        }
                        else return(99999);
                       }

        float get_max(){if(pint!=NULL){
                        return((float)int_max);
                        }
                        else if(rval!=NULL){
                        return(fmax);
                        }
                        else if(pic!=NULL){
                        return((float)imax);
                        }
                        else return(-99999);
                        }

        _signal get_hist(){return(hist);}
         void get_Neighbor(float **val,int i,int j,int wsize);
         _MASK get_Neighbor(int i,int j,int wsize);
         _MASK get_Neighbor(int i,int j,int hsize,int wsize);
         _MASK get_Rect(int i,int j,int hsize,int wsize);
         void get_Rect(_MASK temp,int i,int j,int hsize,int wsize);
         void get_Rect(float **val,int i,int j,int hsize,int wsize);
         _MASK get_Rect(int i,int j,int wsize);
         void get_Rect(_MASK temp,int i,int j,int wsize);
         void  init_Rect(int i,int j,int wsize,int hsize,float val);
         void apply_affine_to(int x,int y,int i,int j,int wsize,int hsize,float a,float b,int txno);
         void apply_affine_to(int x,int y,_MASK domBlock,float a,float b,int txno);

        void find_histogram();
        char save_header(char *fname);
        void adjust_image();
        void normalise_pic(float min_range,float max_range);
        void normalise(float min_range=255,float max_range=0){
             normalise_pic(min_range,max_range);
             }
       void truncate_pic();
       void truncate(float min_range,float max_range);

        double sobel_x(int i,int j);
        double sobel_y(int i,int j);
        double statistics(int mode);
        void calc_histogram_strech(int s,int e,int *g);
        void calc_histogram_modify(long *r,long *z,int *g,long n);
        _GREY  histogram_modify(long *desired);
        _GREY  histogram_modify(int a, int b);
        _GREY histogram_strech(float percentage);
        _GREY histogram_strech(int s,int e);
        void calc_threshold(long n,int& threshold,int& zero,int& one);
        _GREY  threshold_picture(int full);
         _GREY seg_hist(_signal hseg);

        _GREY operator+(_GREY ob);
        _GREY operator-(_GREY ob);
        _GREY operator*(_GREY ob);//convolution
        _GREY operator/(_GREY ob);//Phase
        _GREY operator^(_GREY ob);//Magnitude
        _GREY operator&&(_GREY ob);//Minimum
        _GREY operator||(_GREY ob);//Maximum
        double operator%(_GREY ob);//Error (sqrt(sqrsum)) between two objects

        _GREY operator*(_MASK ob);//convolution
        _GREY operator+(_MASK ob);//DILATION
        _GREY operator-(_MASK ob);//EROSION

        _GREY operator+(float val);
        _GREY operator-(float val);
        _GREY operator*(float val);
        _GREY operator/(float val);//thrseholded below
        _GREY operator%(float val);//thrseholded above
        _GREY operator&(float val);//thrseholded above and binarise
        _GREY operator|(float val);//thrseholded below and binarise
        // _GREY &operator=(_GREY ob);

        friend ofstream & operator<<(ofstream & fout, const _GREY & im); // implemented on 30.11.2000
        friend ifstream & operator>>(ifstream & fin, const _GREY & im); // implemented on 30.11.2000


         _GREY edge_s(int mode);//sobel edge op
         _GREY edge_c(float sigma);//Canny edge gradient 
         _GREY edge_mh(float sigma);//Marr-Hildreth Edge Op
         _GREY edge_canny(int nangle,float sigma,float high,float low);
         _GREY edge_canny_mh(float sigma,float high,float low);
         _GREY fextract(int xstart,int ystart,int w,int h);
         _GREY shrink(float factor);
         _GREY jthresh(float thresh_factor);
         _GREY zcross(int nth,int zth);
         _GREY zcross_to_positive(int nth,int zth);
         _GREY rgrow(float diff,int seg_thresh,int wsize,int fsmooth);
         _GREY spta();
         _GREY smooth(int mode,int wsize);
         _GREY smooth_weighted(_MASK mwt, int mode=AVG_MODE); // implemented on 22.3.2
         _GREY smooth_gauss(float sigma);
         _GREY form_scale_space();
         _GREY form_sigma_valley();
         _GREY gauss_noise(float sigma,float mean);
         _GREY uniform_noise(float max_grey);
         _GREY dft();
         _GREY idft();
         void convert_to_phasor();
         void convert_to_complex();
         _GREY aniso_diffusion(float lamda,float weight,int Niter);
         _GREY relaxation(float lamda,float epsilon,int Niter,float w);
         _GREY adaptive_smoothing(float sigma,int Niter);
         _GREY get_bnd();
         _GREY shift(int x,int y);



         void  place(_GREY ob,int xstart,int ystart,int dtype);
         void  place(_MASK ob,int xstart,int ystart);
         void  place(float **val,int xstart,int ystart,int w,int h);
         void  place(_PNT *vertex,int num,int val);

          // Added from MS
         _signal getInteriorHist(_POLYGON Plg,int mode=0);
          _GREY extractInterior(_POLYGON Plg,int val=0,int mode=0);
		    // mode==0 means according to gaphics window ,
                    //     ==1 means according to image
      _signal get_image_profile(int x1,int y1,int x2,int y2,int mode=_IM_OBLIQUE);
  _POLYGON extract_contour_of_cavity(int x0,int y0,double Radius,float eThresh=120,double srcRadThresh=10,int DelTheta=5);
         };


           _GREY::_GREY(int w,int h)//constructor
         {
         int x,y;

        pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        }
        pint=NULL;
        rval=NULL;
        ival=NULL;
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         pic[x][y]=0;
        data_type=DCHAR;
        domain=SPACE;
        hist.step(0,256);
        adjust_image();
         }



        _GREY::_GREY(int w,int h,int val)//constructor
         {
         int x,y;

        pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         pic[x][y]=val;
        data_type=DCHAR;
        domain=SPACE;
        pint=NULL;
        rval=NULL;
        ival=NULL;
        hist.step(0,256);
        adjust_image();
         }

  _GREY::~_GREY(){
   }

   void _GREY::free()
    {
    if((pic==NULL)&&(pint==NULL)&&(rval==NULL)&&(ival==NULL))
       cout<<"The image is NULL \n"<<flush;
    if(pic!=NULL){
                 // cout<<"Going to free pic \n"<<flush;
                 free_matrix(pic,height);
                 pic=NULL;
                 }
    if(pint!=NULL){
                 //cout<<"Going to free pint \n"<<flush;
                   free_matrix_int(pint,height);
                   pint=NULL;
                  }
    if(rval!=NULL){
                 //cout<<"Going to free rval \n"<<flush;
                    free_matrix_float(rval,height);
                    rval=NULL;
                  }
    if(ival!=NULL){
                 //cout<<"Going to free ival \n"<<flush;
                      free_matrix_float(ival,height);
                      ival=NULL;
                   }
                 // cout<<"Going to free hist \n"<<flush;
    hist.free();
      width=height=depth=int_min=int_max=0;fmin=fmax=0; //name[0]='\0';
    //cout<<"GREY image freed \n"<<flush;
    }

    void  _GREY::set(int w,int h)
         {

         int x, y;
        
        //free();
        pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         pic[x][y]=0;
        data_type=DCHAR;
        domain=SPACE;
        pint=NULL;
        rval=NULL;
        ival=NULL;
        hist.step(0,256);
        adjust_image();
         }

        void _GREY::set(int w,int h,int val)
         {
         int x, y;

        //free();
        pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         pic[x][y]=val;
        data_type=DCHAR;
        domain=SPACE;
        pint=NULL;
        rval=NULL;
        ival=NULL;
        hist.step(0,256);
        adjust_image();
         }

        void _GREY::set(int w,int h,float val,int dtype)//
         {
         int x, y;

        switch(dtype){
        case DCHAR:
                   // if(pic!=NULL) free_matrix(pic,height);
                   pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
                   if(pic==NULL){
                    cout<<"Memory not allocated \n";
                    }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         pic[x][y]=(unsigned char) val;
        data_type=DCHAR;
        domain=SPACE;
        adjust_image();
                    break;
        case DINT:
                   // if(pint!=NULL) free_matrix_int(pint,height);
                   pint=(int **)allocate_matrix(h,w,sizeof(int));
                   if(pint==NULL){
                    cout<<"Memory not allocated \n";
                    }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         pint[x][y]=(int)val;
        data_type=DINT;
        domain=SPACE;
                    break;
        case DFLOAT:
                   // if(rval!=NULL) free_matrix_float(rval,height);
                   rval=(float **)allocate_matrix_float(h,w,sizeof(float));
                   if(rval==NULL){
                    cout<<"Memory not allocated \n";
                    }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         rval[x][y]=val;
        data_type=DFLOAT;
        domain=SPACE;
                    break;
        case DCOMPLEX:
                   // if(rval!=NULL) free_matrix_float(rval,height);
                   rval=(float **)allocate_matrix_float(h,w,sizeof(float));
                   if(rval==NULL){
                    cout<<"Memory not allocated \n";
                    }
                   // if(ival!=NULL) free_matrix_float(ival,height);
                   ival=(float **)allocate_matrix_float(h,w,sizeof(float));
                   if(ival==NULL){
                    cout<<"Memory not allocated \n";
                    }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         rval[x][y]=ival[x][y]=val;
        data_type=DCOMPLEX;
        domain=FREQ;
                    break;
         default:
                   // if(pic!=NULL) free_matrix(pic,height);
                   pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
                   if(pic==NULL){
                    cout<<"Memory not allocated \n";
                    }
        height=h;
        width=w;
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
                         pic[x][y]=(unsigned char)val;
        data_type=DCHAR;
        domain=SPACE;
        adjust_image();
                    break;

        }//switch(dtype)
        //hist.step(0,256);
         }


float _GREY::pixel(int x, int y)
 { 

	if (x<0 || y<0 || x>=height || y>=width) return(0);
	else {
         if(pint!=NULL) return((float)pint[x][y]);
         else if(rval!=NULL) return(rval[x][y]);
         else if(pic!=NULL) return((float)pic[x][y]);
         else return(0);
         }
}

void _GREY::put(float val,int x, int y)
 { 

	if (x<0 || y<0 || x>=height || y>=width)  ;
	else {
         if(pint!=NULL) pint[x][y]=(int) val;
         else if(rval!=NULL) {
         rval[x][y]=val;
         }
         else if(pic!=NULL) {
                      if(val<0) val=0;
                      if(val>255) val=255;
                      pic[x][y]=(unsigned char) ((int)val);
                     }
         else cout<<"Memory not allocated for setting pixel";
         }
}

char _GREY::load_picture(char *fname,int w,int h)
{
        ifstream in(fname);
	int i;
	
        // if(pic!=NULL) free_matrix(pic,h);
        pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        return(0);
        }
	if (!in) {
		cout<< "unable to open"<<fname<<"\n";
		return(0);
	}
        // in.setmode(ios::binary);
	for (i=0;i<h;++i){
		in.read((char *)pic[i],w); 
		if (in.gcount()!=w){ 
			cout<<"reading error in "<<fname<<"\n";
			return(0);
                          }
		}
	in.close();
        height=h;
        width=w;
        data_type=DCHAR;
        domain=SPACE;
        pint=NULL;
        rval=NULL;
        ival=NULL;
        hist.step(0,256);
        adjust_image();
	return(1);
}

char _GREY::load_picture(unsigned char **p,int w,int h)
{
	int i,j;
	
        // if(pic!=NULL) free_matrix(pic,h);
        pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        return(0);
        }

	for (i=0;i<h;++i)
	for (j=0;j<w;++j)
            pic[i][j]=p[i][j];

        height=h;
        width=w;
        data_type=DCHAR;
        domain=SPACE;
        pint=NULL;
        rval=NULL;
        ival=NULL;
        hist.step(0,256);
        adjust_image();
	return(1);
}


char _GREY::save_picture( char *fname)
{
        ofstream out(fname);
	int i;

        if(pic==NULL){cout<<"Not in char format \n";
                      cout<<"File not saved \n";
                     }
        if(!out){
        cout<<"Unable to create "<<fname<<"\n";
        return(0);
        }
	for (i=0;i<height;++i){
		out.write((char *)pic[i],width); 
                /*
		if (out.gcount()!=width) {
			cout<<"writing error in"<<fname<<"\n";
			return(0);
		}
                */
                }
	out.close();
	return(1);
}

void _GREY::normalise_pic(float min_range=255,float max_range=0)
{
 int x,y,min,max;
 int val;

 if(pic!=NULL) cout<<"Warning:The image is already normalised \n";
        else
        pic=(unsigned char **)allocate_matrix(height,width,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        return;
       }
 if(pint!=NULL){
 for(x=0;x<height;x++)
 for(y=0;y<width;y++)
 {
  if(int_max!=int_min)
  {
  if(min_range>max_range)
  val= (int)((255.0)*(float)(pint[x][y]-int_min)/(float)(int_max-int_min));
  else
  {
  if((float)pint[x][y]>max_range) val=255;
  else if((float)pint[x][y]<min_range)val=0;
  else
  val= (int)((255.0)*((float)pint[x][y]-min_range)/(max_range-min_range));
  }
   
  pic[x][y]=(unsigned char)val;
  }
 }
        //find_histogram();
 }
 if(rval!=NULL){
 if(data_type==DCOMPLEX){
 cout<<"WARNING: NORMALISING COMPLEX DATA \n";
 }
 for(x=0;x<height;x++)
 for(y=0;y<width;y++)
 {
  if(fmax!=fmin){
  if(min_range>max_range)
  val= (int)((255.0)*(rval[x][y]-fmin)/(fmax-fmin));
  else
  {
  if(rval[x][y]>max_range) val=255;
  else if(rval[x][y]<min_range)val=0;
  else
  val= (int)((255.0)*(rval[x][y]-min_range)/(max_range-min_range));
  }

  pic[x][y]=(unsigned char)val;
  }
 }
        //find_histogram();
 }
        if(pic!=NULL){
	min=max=pic[0][0];
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
			if (pic[x][y]<min) min=pic[x][y];
			else if (pic[x][y]>max) max=pic[x][y];
	imin=(unsigned char)min;
	imax=(unsigned char)max;
        cout<<"imin="<<min<<" imax="<<max<<"\n";
        //find_histogram();
        }
}

void _GREY::truncate_pic()
{
 int x,y,min,max;
 int val;

 if(pic!=NULL) cout<<"Warning Truncate:The image is already normalised \n";
        else
        pic=(unsigned char **)allocate_matrix(height,width,sizeof(unsigned char));
        if(pic==NULL){
        cout<<"Memory not allocated \n";
        return;
       }
 if(rval!=NULL)
 if(data_type==DCOMPLEX){
 cout<<"WARNING Truncate: NORMALISING COMPLEX DATA \n";
 }
 for(x=0;x<height;x++)
 for(y=0;y<width;y++)
 {
   val=(int)pixel(x,y);
   if(val<0) val=0;
   if(val>255) val=255;

  pic[x][y]=(unsigned char)val;
  }
}

void _GREY::truncate(float min_range=0,float max_range=255)
{
 int x,y,min,max;
 float val;

 for(x=0;x<height;x++)
 for(y=0;y<width;y++)
 {
   val=pixel(x,y);
   if(val<min_range) val=min_range;
   if(val>max_range) val=max_range;

    put(val,x,y);

  }
}

void _GREY::find_histogram()
{
	int i,j;
        float *h;

        if(pic==NULL){
          cout<<"Histogram not computed on different data_type \n";
          return;
          }
        h= new float[256];
	for (i=0;i<MAX_COLOR;++i)
		h[i]=0;
	for (i=0;i<height;++i)
		for (j=0;j<width;++j)
			++h[pic[i][j]];
        hist.free();
        hist.set(h,256,OTHER);
}

char _GREY::save_header(char *fname)
{
        if(data_type!=DCHAR){
          cout<<"Header of different data_type not saved\n";
          return(0);
          }


        ofstream fout(fname);
        if(!fout){cout<<"File "<<fname<<" not created \n";
                 return(0);
                 }
	int i;

	fout<<"row="<<height<<" col="<<width<<"\n";
	fout<<"imin="<<imin<<" imax="<<imax<<"\n";
        fout<<"HISTOGRAM: x-------h(x) \n";
	 for (i=0;i<256;i++)
	fout<<i<<"      "<<(long)(hist&i)<<"\n";
	fout<<"END HEADER  \n";
	fout.close();
	return(1);
}



void _GREY::adjust_image()
{
	int x, y, min, max;
        float min_val,max_val;
	float mf;

        if(pic!=NULL){
	min=max=pic[0][0];
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
			if (pic[x][y]<min) min=pic[x][y];
			else if (pic[x][y]>max) max=pic[x][y];
	imin=(unsigned char)min;
	imax=(unsigned char)max;
        find_histogram();
        }

        if(pint!=NULL){
	min=max=pint[0][0];
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
			if (pint[x][y]<min) min=pint[x][y];
			else if (pint[x][y]>max) max=pint[x][y];
	int_min=min;
	int_max=max;
        }

        if(rval!=NULL){
	min_val=max_val=rval[0][0];
	for (x=0; x<height; ++x)
		for (y=0; y<width; ++y)
			if (rval[x][y]<min_val) min_val=rval[x][y];
			else if (rval[x][y]>max_val) max_val=rval[x][y];
	fmin=min_val;
	fmax=max_val;
        }
}

double _GREY::sobel_x(int i,int j)
{ double val1,val2,val3;
 if ((i>0) && (i<(width-1)))
 if ((j>0) && (j<(height-1)))
	{
	 val1=(double)(pixel(j+1,i-1)-pixel(j-1,i-1));
	 val2=2.0*(double)(pixel(j+1,i)-pixel(j-1,i));
	 val3=(double)(pixel(j+1,i+1)-pixel(j-1,i+1));
	 return(val1+val2+val3);
	 }
	 else return(9999999.0);
	 }

double _GREY::sobel_y(int i,int j)
{ double val1,val2,val3;
 if ((i>0) && (i<(width-1)))
 if ((j>0) && (j<(height-1)))
	{
	 val1=(double)(pixel(j-1,i+1)-pixel(j-1,i-1));
	 val2=2.0*(double)(pixel(j,i+1)-pixel(j,i-1));
	 val3=(double)(pixel(j+1,i+1)-pixel(j+1,i-1));

	 return(val1+val2+val3);
	 }
	 else return(9999999.0);
	 }

 double _GREY::statistics(int mode=SD_MODE)
 {double sum=0,sqrsum=0,maxval=0,minval=99999.0;
  double val;
  int i,j;

  for(i=0;i<height;i++)
  for(j=0;j<width;j++){
   val=(double)pixel(i,j);
   sum+=val;
   sqrsum+=sqr(val);
   if(val>maxval) maxval=val;
   if(val<minval) minval=val;
   }

  switch(mode)
  {
   case MAX_MODE: return(maxval);
   case MIN_MODE: return(minval);
   case AVG_MODE: return(sum/((double)height*(double)width));
   case SD_MODE: 
               {
                double size;
                size=(double)height*(double)width;
                return(sqrt(sqrsum/size-sqr(sum/size)));
                }
   default: return(0.0);
  }
  }
                

void _GREY::calc_histogram_strech(int s,int e,int *g)
{
	int i;

	if (e<s) {
		cout<<"calc_histogram_strech : illegal range\n";
		 exit_with_error(); 
	} else if (e==s) {
		for (i=0;i<MAX_COLOR;++i)
			g[i]=s;
	} else {
		for (i=0;i<MAX_COLOR;++i)
			if (i<=s) g[i]=0;
			else if (i<e) g[i]=((i-s)*(MAX_COLOR-1))/(e-s);
			else g[i]=MAX_COLOR-1;
	}
}

void _GREY::calc_histogram_modify(long *r,long *z,int *g,long n)
{
	int i,j;
	long t[MAX_COLOR],x[MAX_COLOR],p=n/MAX_COLOR;

	for (t[0]=z[0],i=1;i<MAX_COLOR;++i)
		t[i] = t[i-1]+z[i];
	for (j=0,i=0;i<MAX_COLOR;++i) {
		while ((i+1)*p>=t[j] && j<MAX_COLOR) ++j;
		if ((i+1)*p>t[j]) x[i]=j-1;
		else x[i]=j;
	}
	for (t[0]=r[0],i=1;i<MAX_COLOR;++i)
		t[i] = t[i-1]+r[i];
	for (i=0;i<MAX_COLOR;++i)
		t[i] = ((MAX_COLOR-1)*t[i])/n;
	for (i=0;i<MAX_COLOR;++i)
		g[i]=x[t[i]];
}

_GREY  _GREY::histogram_modify(long *desired)
{
        _GREY temp(width,height);

        if(pic==NULL){
        cout<<"histogram eqaulisation not performed on other d_type \n";
        return(temp);
         }
	long actual[MAX_COLOR];
	int  conv[MAX_COLOR],i,j;

        temp.set(width,height);
        for(i=0;i<MAX_COLOR;i++) actual[i]=(long) (hist&i);
	calc_histogram_modify(actual,desired,conv,(long)(width*height));
	for (i=0;i<height;++i)
		for (j=0;j<width;++j)
			temp.pic[i][j]=conv[pic[i][j]];
          temp.adjust_image();
          return(temp);
}


_GREY _GREY::histogram_modify(int a=0, int b=255)
{
	int i,j, color_tr[MAX_COLOR];
	long hist_d[MAX_COLOR], dest[MAX_COLOR], st;

        _GREY temp(width,height);
	if (a>b) {cout<< "Not modified \n"; return(temp);}

        if(pic==NULL){
        cout<<"histogram eqaulisation not performed on other d_type \n";
        return(temp);
         }
        temp.set(width,height);

		for (i=0; i<MAX_COLOR; ++i)
			hist_d[i]=0L;
		for (st=0L, i=a; i<=b; ++i) {
			hist_d[(int) ((float) (i-a)*(MAX_COLOR-1)/(b-a))]=(long)(hist&i);
			st += (long)(hist&i);
		}
		for (i=0; i<MAX_COLOR; ++i)
			dest[i]=(long) st/MAX_COLOR;
		calc_histogram_modify(hist_d, dest, color_tr, st);
	for (i=0;i<height;++i)
		for (j=0;j<width;++j)
			temp.pic[i][j]=color_tr[pic[i][j]];
          temp.adjust_image();
          return(temp);

}

_GREY _GREY::histogram_strech(float percentage=0.2)
{
        _GREY temp;
	int conv[MAX_COLOR],i,j;
	long a[MAX_COLOR];

        if(pic==NULL){
        cout<<"histogram eqaulisation not performed on other d_type \n";
        return(temp);
         }

        temp.set(width,height);

        for(i=0;i<MAX_COLOR;i++) a[i]=(long) (hist&i);
	for (i=1;i<MAX_COLOR;++i)
		a[i] += a[i-1];
	for (i=0;(float) a[i]/(float) (width*height) < 0.5 - percentage/2.0;++i) ;
	j=MAX_COLOR-1;
	while((float) a[j]/(float) (width*height) > 0.5 + percentage/2.0) --j;
	if ((float) a[j]/(float) (width*height) < 0.5 + percentage/2.0) ++j;
	if ((float) a[i]/(float) (width*height) > 0.5 - percentage/2.0) --i;
	calc_histogram_strech(i,j,conv);
	for (i=0;i<height;++i)
		for (j=0;j<width;++j)
			temp.pic[i][j]=conv[pic[i][j]];
          temp.adjust_image();
          return(temp);
}



_GREY _GREY::histogram_strech(int s,int e)
{
        _GREY temp;
	int conv[MAX_COLOR],i,j;
	// long a[MAX_COLOR];

        if(pic==NULL){
        cout<<"histogram eqaulisation not performed on other d_type \n";
        return(temp);
         }

        temp.set(width,height);

        /*
        for(i=0;i<MAX_COLOR;i++) a[i]=(long) (hist&i);
	for (i=1;i<MAX_COLOR;++i)
		a[i] += a[i-1];
	for (i=0;(float) a[i]/(float) (width*height) < 0.5 - percentage/2.0;++i) ;
	j=MAX_COLOR-1;
	while((float) a[j]/(float) (width*height) > 0.5 + percentage/2.0) --j;
	if ((float) a[j]/(float) (width*height) < 0.5 + percentage/2.0) ++j;
	if ((float) a[i]/(float) (width*height) > 0.5 - percentage/2.0) --i;
        */
	calc_histogram_strech(s,e,conv);
	for (i=0;i<height;++i)
		for (j=0;j<width;++j)
			temp.pic[i][j]=conv[pic[i][j]];
          temp.adjust_image();
          return(temp);
}


void _GREY::calc_threshold(long n,int& threshold,int& zero,int& one)
{
	float cum[MAX_COLOR],his[MAX_COLOR],sum;
	int   t,old_t,i, init_t, cost=65536, min=0, min_t;
	float mean_one,mean_two,sdev_one,sdev_two,a,b,c;

	for (i=0;i<MAX_COLOR;++i)
		his[i] = (hist&i)/(float)n;
	for (cum[0]=his[0],i=1;i<MAX_COLOR;++i)
		cum[i]=cum[i-1]+his[i];
	for (t=0;t<MAX_COLOR && cum[t]<0.5;)
		++t;
	if (cum[t]==0.5) ++t;
	else if (cum[t-1]>=0.5*cum[t]) --t;
	min_t=init_t=t;
        cout<<"Before iteration \n";
	do {
                if(cum[t-1]!=0)
                {
		old_t=t;
		for (i=0,sum=0.0;i<t;++i)
			sum += (float) i*his[i];
		mean_one = (sum/cum[t-1]);
		for (sum=0.0;i<MAX_COLOR;++i)
			sum += (float) i*his[i];
		mean_two = (sum/(1.0-cum[t-1]));
		for (i=0,sum=0.0;i<t;++i)
			sum += (float) (i-mean_one)*(i-mean_one)*his[i];
		sdev_one = sqrt((sum/cum[t-1]));
		for (sum=0.0;i<MAX_COLOR;++i)
			sum += (float) (i-mean_two)*(i-mean_two)*his[i];
		sdev_two = sqrt((sum/(1.0-cum[t-1])));
		a = sdev_one*sdev_one-sdev_two*sdev_two;
		b = 2.0*(mean_one*sdev_two*sdev_two-mean_two*sdev_one*sdev_one);
		c = sdev_one*sdev_one*mean_two*mean_two
		   -sdev_two*sdev_two*mean_one*mean_one
		   +2*sdev_one*sdev_one*sdev_two*sdev_two
			 *log(sdev_two*cum[t-1]*cum[t-1]/
				 (sdev_one*(1.0-cum[t-1])*(1.0-cum[t-1])));
		c = (b*b-4*a*c);
		if (c>=0) {
			c=sqrt(c);
			if (-b+c<0 || -b+c>=MAX_COLOR) c=-c;
			t = (int)((-b+c)/(2*a));
			if (t<0 || t>=MAX_COLOR) t=init_t;
			if (cost>abs(t-old_t)) {
				cost=abs(t-old_t);
				min_t=t=(t+old_t)/2;
			} else if (cost<abs(t-old_t)) {
				min=1;
			}
		} else t=init_t;
                }
                else{
                 cout<<"Divide by zero error \n";
	t=min_t;
	threshold=t;
	zero=(int)mean_one;
	one=(int)mean_two;
                 return;
                }
	} while (!min && old_t!=t && init_t!=t && min_t!=t);
	t=min_t;
	threshold=t;
	zero=(int)mean_one;
	one=(int)mean_two;
}

_GREY  _GREY::threshold_picture(int full=1)
{
        _GREY temp;
	int  th,i,j,zero,one;

        if(pic==NULL){
        cout<<"histogram eqaulisation not performed on other d_type \n";
        return(temp);
        }
        find_histogram();
        temp.set(width,height);
        cout<<"Going to calculate threshold value \n";
	calc_threshold((long) width*height,th,zero,one);
        cout<<"Threshold calculated \n";
	if (full) {
		zero = 0;
		one  = MAX_COLOR-1;
	}
	for (i=0;i<height;++i)
		for (j=0;j<width;++j)
			temp.pic[i][j]=(pic[i][j]<th)?zero:one;
          temp.adjust_image();
          return(temp);
}

_GREY _GREY::operator+(_GREY ob)
{
 _GREY temp;
  int x,y;
  int val1,val2;

  if((height!=ob.height)||(width!=ob.width)){
   cout<<"Dimension not matched \n";
   return(temp);
   }
   
   temp.set(width,height,0,DFLOAT);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=pixel(x,y)+ob.pixel(x,y);
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}


_GREY _GREY::operator+(float val)
{
 _GREY temp;
  int x,y;
  int val1,val2;

   
   temp.set(width,height,0,DFLOAT);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=pixel(x,y)+val;
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

_GREY _GREY::operator-(_GREY ob)
{
 _GREY temp;
  int x,y;
  int val1,val2;

  if((height!=ob.height)||(width!=ob.width)){
   cout<<"Dimension not matched \n";
   return(temp);
   }
   
   temp.set(width,height,0,DFLOAT);
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=pixel(x,y)-ob.pixel(x,y);
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}




_GREY _GREY::operator-(float val)
{
 _GREY temp;
  int x,y;
  int val1,val2;

   
   temp.set(width,height,0,DFLOAT);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=pixel(x,y)-val;
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

_GREY _GREY::operator*(float val)
{
 _GREY temp;
  int x,y;
  int val1,val2;

   
   temp.set(width,height,0,DFLOAT);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=pixel(x,y)*val;
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

_GREY _GREY::operator/(float val)//thresholded below
{
 _GREY temp;
  int x,y;
  int val1,val2;

   
   temp.set(width,height,0,DFLOAT);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    if(pixel(x,y)<val)
    temp.rval[x][y]=pixel(x,y);
    else temp.rval[x][y]=0;
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

_GREY _GREY::operator%(float val)//thresholded above 
{
 _GREY temp;
  int x,y;
  int val1,val2;

   
   temp.set(width,height,0,DFLOAT);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    if(pixel(x,y)>val)
    temp.rval[x][y]=pixel(x,y);
    else temp.rval[x][y]=0;
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

_GREY _GREY::operator&(float val)//thresholded above and binarise 
{
 _GREY temp;
  int x,y;

   
   temp.set(width,height);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    if(pixel(x,y)>val)
    temp.pic[x][y]=255;
    else temp.pic[x][y]=0;
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

_GREY _GREY::operator|(float val)//thresholded below and binarise 
{
 _GREY temp;
  int x,y;

   
   temp.set(width,height);

   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    if(pixel(x,y)<val)
    temp.pic[x][y]=255;
    else temp.pic[x][y]=0;
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

        _GREY _GREY::operator*(_GREY ob)//convolution
       {
        _GREY temp;
         int x,y,i,j;
         float  sum;

   temp.set(width,height,0,DFLOAT);
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
   {
     sum=0;
     for(i=0;i<ob.height;i++)
     for(j=0;j<ob.width;j++)
     sum+=ob.pixel(i,j)*pixel(x+i-ob.height/2,y+j-ob.width/2);
     temp.rval[x][y]=sum;
   }
    temp.adjust_image();
    //temp.normalise_pic();
     return(temp);
       }


        _GREY _GREY::operator*(_MASK ob)//convolution
       {
        _GREY temp;
         int x,y,i,j;
         float  sum;

   temp.set(width,height,0,DFLOAT);
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
   {
     sum=0;
     for(i=0;i<ob.get_h();i++)
     for(j=0;j<ob.get_w();j++)
     sum+=ob.pixel(i,j)*pixel(x+i-ob.get_h()/2,y+j-ob.get_w()/2);
     temp.rval[x][y]=sum;
   }
    temp.adjust_image();
    //temp.normalise_pic();
     return(temp);
       }



        _GREY _GREY::operator+(_MASK ob)//Dilation
       {
        _GREY s_temp,m_temp,op_temp;

         int x,y,i,j;

     m_temp.set(width,height,0,DFLOAT);
     for(i=0;i<ob.get_h();i++)
     for(j=0;j<ob.get_w();j++)
     {
     if(ob.pixel(i,j)>0)
     {
     s_temp=shift(i-ob.get_h()/2,j-ob.get_w()/2);
     op_temp=m_temp||s_temp;
     m_temp.free();
     s_temp.free();
     m_temp=op_temp;
     }
     }
     
    m_temp.adjust_image();
     return(m_temp);
       }


        _GREY _GREY::operator-(_MASK ob)//EROSION
       {
        _GREY s_temp,m_temp,op_temp;

         int x,y,i,j;

     m_temp.set(width,height,255,DFLOAT);
     for(i=0;i<ob.get_h();i++)
     for(j=0;j<ob.get_w();j++)
     {
     if(ob.pixel(i,j)>0)
     {
     s_temp=shift(i-ob.get_h()/2,j-ob.get_w()/2);
     op_temp=m_temp&&s_temp;
     m_temp.free();
     s_temp.free();
     m_temp=op_temp;
     }
     }
     
    m_temp.adjust_image();
     return(m_temp);
       }


_GREY _GREY::operator^(_GREY ob)//Magnitude
{
 _GREY temp;
  int x,y;
  int val1,val2;

  if((height!=ob.height)||(width!=ob.width)){
   cout<<"Dimension not matched \n";
   return(temp);
   }
   
   temp.set(width,height,0,DFLOAT);
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=(float)sqrt((double)(sqr(pixel(x,y))+sqr(ob.pixel(x,y))));
    temp.adjust_image();
    //temp.normalise_pic();
   return(temp);
}

_GREY _GREY::operator/(_GREY ob)//Phase
{
 _GREY temp;
  int x,y;
  float val;

  if((height!=ob.height)||(width!=ob.width)){
   cout<<"Dimension not matched \n";
   return(temp);
   }
   
   temp.set(width,height,0,DFLOAT);
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    {
    val=pixel(x,y);
    if(val!=0)
    temp.rval[x][y]= 180.0*(float)atan((double)(ob.pixel(x,y)/val))/M_PI;
    else if (ob.pixel(x,y)>0) temp.rval[x][y]=90.0;
         else temp.rval[x][y]= -90.0;
    }
    temp.adjust_image();
    //temp.normalise_pic();
    //temp.save("temp_ang");
   return(temp);
}


   _GREY _GREY::operator&&(_GREY ob)//Minimum
  {
 _GREY temp;
  int x,y;
  int val1,val2;

  if((height!=ob.height)||(width!=ob.width)){
   cout<<"Dimension not matched \n";
   return(temp);
   }
   
   temp.set(width,height,0,DFLOAT);
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=min(pixel(x,y),ob.pixel(x,y));
    temp.adjust_image();
   return(temp);
   }


   _GREY _GREY::operator||(_GREY ob)//Maximum
  {
 _GREY temp;
  int x,y;
  int val1,val2;

  if((height!=ob.height)||(width!=ob.width)){
   cout<<"Dimension not matched \n";
   return(temp);
   }
   
   temp.set(width,height,0,DFLOAT);
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    temp.rval[x][y]=max(pixel(x,y),ob.pixel(x,y));
    temp.adjust_image();
   return(temp);
   }


double _GREY::operator%(_GREY ob)//RMS Error between two objects
{
  int x,y;
  double error=0.0;

  if((height!=ob.height)||(width!=ob.width)){
   cout<<"Dimension not matched \n";
   return(-1.0);
   }
   
   for(x=0;x<height;x++)
   for(y=0;y<width;y++)
    error+=((double)(sqr(pixel(x,y)-ob.pixel(x,y))));
   //if(error<1.0) return(0.0);
   //else
   return(sqrt(error/((double)width * (double)(height))));
}
/*

_GREY &_GREY::operator=(_GREY ob)
 {
 int x,y;
 
	id=ob.id;
	//strcpy(name,ob.name);
	type=ob.type;

	width=ob.width;
	height=ob.height;
        set(width,height);//allocate matrices

	depth=ob.depth;
	imin=ob.imin;
	imax=ob.imax;
        int_min=ob.int_min;
        int_max=ob.int_max;
        fmin=ob.fmin;
        fmax=ob.fmax;
        //cout<<"Going to assign histogram\n";
	hist=ob.hist;

        //cout<<"Going to assign pic\n";
        if(ob.pic!=NULL)
        for(x=0;x<ob.height;x++)
        for(y=0;y<ob.width;y++)
	pic[x][y]=ob.pic[x][y];
        else pic=NULL;

        //cout<<"Going to assign pint\n";
        if(ob.pint!=NULL)
        for(x=0;x<ob.height;x++)
        for(y=0;y<ob.width;y++)
	pint[x][y]=ob.pint[x][y];
        else pint=NULL;

        //cout<<"Going to assign rval\n";
        if(ob.rval!=NULL)
        for(x=0;x<ob.height;x++)
        for(y=0;y<ob.width;y++)
	rval[x][y]=ob.rval[x][y];
        else rval=NULL;

        //cout<<"Going to assign ival\n";
        if(ob.ival!=NULL)
        for(x=0;x<ob.height;x++)
        for(y=0;y<ob.width;y++)
	ival[x][y]=ob.ival[x][y];
        else ival=NULL;

        data_type=ob.data_type; //DCHAR(0),DINT(1),DFLOAT(2)
        max_range=ob.max_range;
        min_range=ob.min_range;
        domain=ob.domain;//SPACE,FREQ,OTHER
        return(*this);
  }
*/
         _GREY _GREY::edge_s(int mode=0)//sobel edge op; mode=0 -->No phase comp
        {
          _GREY temp1,temp2,temp;
           _MASK s_x,s_y;

           temp1.set(width,height,0,DFLOAT);
           temp2.set(width,height,0,DFLOAT);
           temp.set(width,height,0,DCOMPLEX);
           s_x.sobel_x();
           s_y.sobel_y();
           temp1=(*this)*s_x;
           temp2=(*this)*s_y;

           cout<<"CONVOLUTION OVER \n";

           temp.rval=(temp1^temp2).get_real();
           cout<<"Magnitude computed \n";
           if(mode!=0)
           {
           temp.ival=(temp1/temp2).get_real();
           cout<<"Angle computed \n";
           }
           temp.domain=EDGE;
           temp1.free();
           temp2.free();
           s_x.free();
           s_y.free();
           temp.adjust_image();
           return(temp);
        }


         _GREY _GREY::edge_c(float sigma=1.0)//Canny edge gradient 
        {
          _GREY temp1,temp2,temp;
           _MASK s_x,s_y;

           temp1.set(width,height,0,DFLOAT);
           temp2.set(width,height,0,DFLOAT);
           temp.set(width,height,0,DCOMPLEX);
           s_x.gauss_der_x(sigma);
           s_x.gauss_der_y(sigma);
           temp1=(*this)*s_x;
           temp2=(*this)*s_y;

           cout<<"CONVOLUTION OVER \n";

           temp.rval=(temp1^temp2).get_real();
           cout<<"Magnitude computed \n";
           //temp.ival=(temp1/temp2).get_real();
           temp.domain=EDGE;
           temp1.free();
           temp2.free();
           s_x.free();
           s_y.free();
           temp.adjust_image();
           return(temp);
        }


       _GREY _GREY::edge_mh(float sigma=1.0)
        {
         _GREY temp,temp1;
         _MASK lg;

           lg.lap_gauss(sigma);
           temp1=(*this)*lg;
           temp=temp1.zcross(0,0);
           temp1.free();
           lg.free();
           return(temp);
        }

       _GREY _GREY::edge_canny(int nangle=4,float sigma=1.0,float high=0.9,float low=0.7)
        {
         _GREY ztemp,temp1,edge_grad,final_edge;
         _MASK lg;
          float theta;
          int i,j,k,l,m;
          int lth,hth;
          _signal ghist;
          unsigned char **tpic,**fpic,**epic;

           final_edge.set(width,height);
           fpic=final_edge.get_picture();

           edge_grad=edge_c(sigma);
           edge_grad.normalise();
           epic=edge_grad.get_pic();
           ghist=edge_grad.get_hist();
           //ghist.save("out_h");
           lth=(int)ghist.get_thresh(low);
           hth=(int)ghist.get_thresh(high);
           cout<<"lth="<<lth<<" hth="<<hth<<"\n";
           ghist.free();
           for(i=0;i<nangle;i++){
           theta=M_PI*(float)i/(float)nangle;
           lg.gauss_der2_theta(theta,sigma);
           temp1=(*this)*lg;
           lg.free();
           ztemp=temp1.zcross(0,1);

           {
           char fname[30];

           ostrstream ostr(fname,sizeof fname);

           ostr<<"out_"<<i;
           ztemp.save(fname);
            char ch;
            cout<<fname<<" created  and zcross computed\n";
            cin>>ch;
           }
          
           temp1.free();
           tpic=ztemp.get_picture();

           for(j=0;j<height;j++)
           for(k=0;k<width;k++)
           {

            if(tpic[j][k]>250)
            {
            if((int)epic[j][k]>=hth) fpic[j][k]=255;
            else if((int)epic[j][k]>=lth){
          
            for(l=-1;l<=1;l++)
            for(m=-1;m<=1;m++)
            if((j+l)>=0 && (j+l)<height)
            if((k+m)>=0 && (k+m)<width)
            if((int)fpic[j+l][k+m]==255) fpic[j][k]=255;
            }
            }
           }

           {
           char fname[30];

           ostrstream ostr(fname,sizeof fname);

           ostr<<"out_e"<<i;
           final_edge.save(fname);
            char ch;
            cout<<fname<<" created  and edges computed\n";
            cin>>ch;
           }
          
          
           ztemp.free();
            //free_matrix(tpic,height);
           }
           
           edge_grad.free();
           return(final_edge);
        }
       

       _GREY _GREY::edge_canny_mh(float sigma=1.0,float high=0.9,float low=0.7)
        {
         _GREY ztemp,temp1,edge_grad,final_edge;
         _MASK lg;
          float theta;
          int j,k,l,m;
          int lth,hth;
          _signal ghist;
          unsigned char **tpic,**fpic,**epic;

           final_edge.set(width,height);
           fpic=final_edge.get_picture();

           edge_grad=edge_c(sigma);
           edge_grad.normalise();
           epic=edge_grad.get_pic();
           ghist=edge_grad.get_hist();
           //ghist.save("out_h");
           lth=(int)ghist.get_thresh(low);
           hth=(int)ghist.get_thresh(high);
           cout<<"lth="<<lth<<" hth="<<hth<<"\n";
           ghist.free();
           lg.lap_gauss(sigma);
           temp1=(*this)*lg;
           lg.free();
           ztemp=temp1.zcross_to_positive(0,0);

           {

           ztemp.save("out_lg");
            char ch;
            cout<<" out_lg created  and zcross computed\n";
            cin>>ch;
           }
          
           temp1.free();
           tpic=ztemp.get_picture();

           for(j=0;j<height;j++)
           for(k=0;k<width;k++)
           {

            if(tpic[j][k]>250)
            {
            if((int)epic[j][k]>=hth) fpic[j][k]=255;
            else if((int)epic[j][k]>=lth){
          
            for(l=-1;l<=1;l++)
            for(m=-1;m<=1;m++)
            if((j+l)>=0 && (j+l)<height)
            if((k+m)>=0 && (k+m)<width)
            if((int)fpic[j+l][k+m]==255) fpic[j][k]=255;
            }
            }
           }

           {
           final_edge.save("out_e");
            char ch;
            cout<<" out_e created  and edges computed\n";
            cin>>ch;
           }
          
          
           ztemp.free();
            //free_matrix(tpic,height);
           
           edge_grad.free();
           return(final_edge);
        }
       
_GREY  _GREY::fextract(int xstart,int ystart,int w,int h)
 { int x,y;
   _GREY temp;

     if(pic==NULL){
        cout<<"Image not in CHAR format\n";
        cout<<"Not extracted \n";
        return(temp);
        }
     temp.set(w,h,0);
	 cout<<"extracting.......\n";

	 for (x=0;x<w;x++)
	 for (y=0;y<h;y++)
  	 if (xstart+x<= width)
	 if (ystart+y<= height)
		temp.pic[y][x]=pic[ystart+y][xstart+x];
		temp.adjust_image();
                return(temp);
		}

void  _GREY::place(_GREY ob,int xstart,int ystart,int dtype=DCHAR)
 { int x,y;
   
     switch(dtype){

     case DCHAR:

     if(pic==NULL||ob.pic==NULL){
        cout<<"One of the images not in CHAR format\n";
        cout<<"Not placed\n";
        return;
        }
	if ((xstart+ob.width<= width)&& (ystart+ob.height<= height))
        {
        
	 for (x=0;x<ob.width;x++)
	 for (y=0;y<ob.height;y++)
		pic[ystart+y][xstart+x]=ob.pic[y][x];
		adjust_image();
          }
          else cout<<"Composition not possible \n";
         break;

     case DINT:

     if(pint==NULL||ob.pint==NULL){
        cout<<"One of the images not in INT format\n";
        cout<<"Not placed\n";
        return;
        }
	if ((xstart+ob.width<= width)&& (ystart+ob.height<= height))
        {
        
	 for (x=0;x<ob.width;x++)
	 for (y=0;y<ob.height;y++)
		pint[ystart+y][xstart+x]=ob.pint[y][x];
		adjust_image();
          }
          else cout<<"Composition not possible \n";
         break;

      case DFLOAT:

     if(rval==NULL||ob.rval==NULL){
        cout<<"One of the images not in FLOAT format\n";
        cout<<"Not placed\n";
        return;
        }
	if ((xstart+ob.width<= width)&& (ystart+ob.height<= height))
        {
        
	 for (x=0;x<ob.width;x++)
	 for (y=0;y<ob.height;y++)
		rval[ystart+y][xstart+x]=ob.rval[y][x];
		adjust_image();
          }
          else cout<<"Composition not possible \n";
         break;

       case DCOMPLEX:

     if((ival==NULL||ob.ival==NULL)||(rval==NULL||ob.rval==NULL)){
        cout<<"One of the images not in COMPLEX format\n";
        cout<<"Not placed\n";
        return;
        }
	if ((xstart+ob.width<= width)&& (ystart+ob.height<= height))
        {
	 cout<<"composing.......\n";
        
	 for (x=0;x<ob.width;x++)
	 for (y=0;y<ob.height;y++)
               {
		rval[ystart+y][xstart+x]=ob.rval[y][x];
		ival[ystart+y][xstart+x]=ob.ival[y][x];
                }
		adjust_image();
          }
          else cout<<"Composition not possible \n";
         break;
        }
   }


void  _GREY::place(_MASK ob,int xstart,int ystart)
 { int x,y;
   

     if(rval==NULL){
        cout<<"the image not in FLOAT format\n";
        cout<<"Not placed\n";
        return;
        }
	if ((xstart+ob.get_w()<= width)&& (ystart+ob.get_h()<= height))
        {
        
	 for (x=0;x<ob.get_w();x++)
	 for (y=0;y<ob.get_h();y++)
		rval[ystart+y][xstart+x]=ob.pixel(y,x);
	// 	adjust_image();
          }
          else cout<<"Composition not possible \n";
   }
         void  _GREY::place(float **val,int xstart,int ystart,int w,int h)
	  {
            int x,y;
             if(rval==NULL){
               cout<<"the image not in FLOAT format\n";
               cout<<"Not placed\n";
               return;
               }
	if ((xstart+w<= width)&& (ystart+h<= height))
        {
        
	 for (x=0;x<w;x++)
	 for (y=0;y<h;y++)
		rval[ystart+y][xstart+x]=val[y][x];
		// adjust_image();
          }
          else cout<<"Composition not possible \n";
	  }

  void _GREY::place(_PNT *vertex,int num,int val=255)
      {
        int i;
        int x,y;

        if(pic==NULL) {
                     cout<<"the image not in UCHAR format \n";
                     cout<<"Not placed\n";
                     return;
                     }
        for(i=0;i<num;i++){
               x=(int)vertex[i].get_x();
               y=(int)vertex[i].get_y();
               if((x>=0)&&(x<height))
               if((y>=0)&&(y<width))
                    pic[x][y]=val;
                }
      }

_GREY _GREY::shrink(float factor=2.0)
{
 int h,w,i,j;

   _GREY temp;

     if(pic==NULL){
        cout<<"Image not in CHAR format\n";
        cout<<"Not extracted \n";
        return(temp);
        }

 h=(int) ((float) height/factor);
 w=(int) ((float) width/factor);
     temp.set(w,h,0);
      cout<<"dimension : "<<w<<" x "<<h<<" \n";
		for (j=0;j<h;++j)
		for (i=0;i<w;++i)
		temp.pic[j][i]=pic[(int)((float)j*factor)] [(int)((float)i*factor)];
		return(temp);
}

											



_GREY _GREY::jthresh(float thresh_factor=1.5)
{

	int x, y, i, j, npix;
        float sum,emag;
	float min=9999999.0, max=-9999999.0;

   _GREY temp(width,height);

    sum=0.0;npix=0;
    for (x=0; x<height; ++x)
    for (y=0; y<width; ++y) {
     npix++;
     emag = pixel(x,y);
     sum=sum+emag;
 if (emag>= thresh_factor*sum/(float) npix)
			temp.pic[x][y]=(unsigned char) 255;
			else temp.pic[x][y]=(unsigned char) 0;
		 }
		 temp.adjust_image();
		 return(temp);
} 

_GREY _GREY::zcross(int nth=0,int zth=0)
{

	int x, y, i, j, n[3][3];
        _GREY temp(width,height);

		for (x=1; x<(height-1); ++x)
			for (y=1; y<(width-1); ++y) {
			for (i=-1;i<=1;i++)
			for (j=-1;j<=1;j++)
				{
			 if ((int)pixel(x+i,y+j)<nth) n[i+1][j+1]= -1;
			 else {if ((int)pixel(x+i,y+j)>=zth) n[i+1][j+1]=1;
				 else n[i+1][j+1]=0;
						}
						}
	if ((n[0][0]*n[2][2]<0)||(n[0][2]*n[2][0]<0)||(n[1][2]*n[1][0]<0)||(n[2][1]*n[0][1]<0))
			temp.pic[x][y]=(unsigned char) 255;
			else temp.pic[x][y]=(unsigned char) 0;
		 }
		 temp.adjust_image();
		 return(temp);
} 


_GREY _GREY::zcross_to_positive(int nth=0,int zth=0)
{

	int x, y, i, j, n[3][3];
        _GREY temp(width,height);

		for (x=1; x<(height-1); ++x)
			for (y=1; y<(width-1); ++y) {
			for (i=-1;i<=1;i++)
			for (j=-1;j<=1;j++)
				{
			 if ((int)pixel(x+i,y+j)<nth) n[i+1][j+1]= -1;
			 else {if ((int)pixel(x+i,y+j)>=zth) n[i+1][j+1]=1;
				 else n[i+1][j+1]=0;
						}
						}
	if (((n[0][0]<0)&&(n[2][2]>0))||((n[2][0]<0)&&(n[0][2]>0))||((n[1][0]<0)&&(n[1][2]>0))||((n[0][1]<0)&&(n[2][1]>0)))
			temp.pic[x][y]=(unsigned char) 255;
			else temp.pic[x][y]=(unsigned char) 0;
		 }
		 temp.adjust_image();
		 return(temp);
} 

     void _GREY::segnum(int **thinpat,int a,int b,int num,float mn,int &npnt,int wsize,float diff)
     {
      int i,j,x,y;
      npnt=npnt+1;
      thinpat[a][b]= -num;
      for (i= -wsize;i<=wsize;i++)
      for (j= -wsize;j<=wsize;j++)
      if (((a+i)<(height)) && ((b+j)<(width)))
      if (((a+i)>=0) && ((b+j)>=0))
      if (thinpat[a+i][b+j]==0)
      if (abs(pixel(a+i,b+j)-mn)<=diff)
      segnum(thinpat,a+i,b+j,num,mn,npnt,wsize,diff);
      }

     void _GREY::segmentation(int **thinpat,int a,int b,int num,float mn,int &npnt,int wsize,float diff)
     {
      npnt=0;
      segnum(thinpat,a,b,num,mn,npnt,wsize,diff);
      }


      _GREY  _GREY::rgrow(float diff,int seg_thresh=50,int wsize=1,int fsmooth=-1)
      {
       int i,j,nums,num,k,npnt;
      // int **thinpat;
       _GREY temp;

       temp.set(width,height,0,DINT);
       if(temp.pint==NULL){
       cout<<"Memory not allocated----Region growing not possible \n";
       return(temp);
       }

       num=1;nums=0;
       for (i=0;i<height;i++)
       for (j=0;j<width;j++)
         if (pixel(i,j)>0)
         if (temp.pint[i][j]==0)
         {
          segmentation(temp.pint,i,j,num,pixel(i,j),npnt,wsize,diff);
          if (npnt>seg_thresh) 
          {
           nums=nums+1;
           view_segment(temp.pint,num,nums);
           cout<<"segment no.="<<nums<<" value="<<temp.pint[i][j]<<" no of points="<<npnt<<"\n";
            if (fsmooth>=0)
           fine_smooth(temp.pint,nums,fsmooth);
           cout<<"Smoothened \n";
           }
          num++;
          }
         cout<<"Region Growing Over \n";
         
       for (i=0;i<height;i++)
       for (j=0;j<width;j++)
       if(temp.pint[i][j]<0) temp.pint[i][j]=0;
         temp.adjust_image();
         cout<<"Maxm No. of Segments "<<(int)temp.get_max()<<"\n";
         return(temp);
       }

      void _GREY::view_segment(int **thinpat,int num,int nums)
      {
       int i,j;
       for (i=0;i<height;i++)
       for (j=0;j<width;j++)
       if (thinpat[i][j]== -num)
         thinpat[i][j]=nums;
       }


  void _GREY::fine_smooth(int **thinpat,int num,int fth)
  {
   int i,j,k,l,m,depth;
   int found1,found2;

  for (i=0;i<height;i++) 
    {
       found1=0;
       found2=0;
        for (j=0;j<width;j++) 
         {
         if (thinpat[i][j]==num) 
          {
             if (!(found1)) 
                  l=j;
             if (found1) 
               {
                   m=j;
                   found2=1;
                }
              found1=1;
            if (found2) 
             {
             if ((m-l)<=fth) 
              {
                for (k=l;k<=m;k++)
                 if (thinpat[i][k]<=0) 
                   {
                   thinpat[i][k]=num;
                   }
               }
               else
                {
                 l=m;
                 found2=0;
                }
             }
            }
           }
      }
  for (j=0;j<width;j++)
    {
       found1=0;
       found2=0;
        for (i=0;i<height;i++)
        {
         if (thinpat[i][j]==num) 
           {
             if (!(found1)) l=i;
             if (found1)
               {
                   m=i;
                   found2=1;
               }
              found1=1;
            if (found2) 
            {
             if ((m-l)<=fth) 
             {
                for (k=l;k<=m;k++) 
                 if (thinpat[k][j]<=0) 
                  {
                   thinpat[k][j]=num;
                  }
              }
               else
                 { 
                 l=m;
                 found2=0;
                 }
              }
           }
         }
        }
 } /* of fine_smooth */



int _GREY::DARK(int **pat,int a,int b)
 { int p;
 if (pat[a][b]>=0) p=1; 
                  else p=0;
  return(p);
  } /*of DARK*/

void _GREY::UVWTRANS(int **pat,int *n,int p,int q)
{
n[0]=DARK(pat,p,q+1);    
n[1]=DARK(pat,p-1,q+1); 
n[2]=DARK(pat,p-1,q);  
n[3]=DARK(pat,p-1,q-1);
n[4]=DARK(pat,p,q-1); 
n[5]=DARK(pat,p+1,q-1);
n[6]=DARK(pat,p+1,q); 
n[7]=DARK(pat,p+1,q+1);
n[8]=DARK(pat,p,q);   
}/*of UVWTRANS*/

int _GREY::SAFE(int **pat,int p,int q,int mode)
 {
   int s1,s2,n[9];

    UVWTRANS(pat,n,p,q);
   switch(mode) {
   case 0: 
      s1=n[4] && (n[5] || n[6] || n[2] || n[3]) && (n[6] || !(n[7]));
      s1=s1 && (n[2] || !(n[1]));
      return(s1);
      break;

  case 4:
   s1=n[0] && (n[1] || n[2] || n[6] || n[7] ) && (n[2] || !(n[3]));
   s1=s1 && (n[6] || !(n[5]));
      return(s1);
    break;

  case 2: 
    s1=n[6] && (n[7] || n[0] || n[4] || n[5]) && (n[0] || !(n[1]));
    s1= s1 && (n[4] ||!( n[3]));
      return(s1);
    break;

case 6:
   s1=n[2] && (n[3] || n[4] || n[0] || n[1]) && (n[4] || !(n[5]));               
   s1= s1 && (n[0] || !(n[7]));
      return(s1);
    }
   return(-1);
 } /* SAFE */

   int _GREY::BND(int **pat,int x,int y,int t,int m)
   {int p;
    switch(t) {
    case 0: 
            if (pat[x][y+1] <= m) p=1; else p=0;
            break;
    case 4:
            if (pat[x][y-1] <= m)  p= 1;  else p=0; 
            break;
    case 2:
            if (pat[x-1][y] <= m)  p=1; else p=0; 
            break;
    case 6:
            if (pat[x+1][y] <=m) p=1; else p=0; 
            break;
              }
     return(p);
   } /* BND(*/

void  _GREY::SKELETONIZE(int **pat,int level,int t,int &complete)
 {
 int threshold,i,j,k;

 threshold=(level-1)-1000;
 complete=1;
 for (i=1;i<=height;i++)
 for (j=1;j<=width;j++)
  {
   if ((pat[i][j]<level) && (pat[i][j]>=0)) { 
         if (BND(pat,i,j,t,threshold)) {

                 if (SAFE(pat,i,j,t)) 
                 {
                 pat[i][j]=threshold+1;
                 complete=0;
                 }
                 else       
                 pat[i][j]=level;
                 }
 if ((pat[i][j]!=level) && (BND(pat,i,j,t+4,threshold))) { 
                 if (SAFE(pat,i,j,t+4)) 
                 {
                 pat[i][j]=threshold+1;              
                 complete=0;
                 }
                 else      
                 pat[i][j]=level;
                 }
                 }
 }
}/*of SKELETONIZE*/


_GREY _GREY::spta()
{
int nomore1,nomore2,scantype,iteration,i,j,k;
_GREY temp;

 temp.set(width+2,height+2,0,DINT);

nomore1=0;
nomore2=0;
scantype=0;            
  iteration=0;
   
   for(i=0;i<=(height+1);i++) temp.pint[i][width+1]=temp.pint[i][0]=-1000;
   for(j=0;j<=(width+1);j++) temp.pint[height+1][j]=temp.pint[0][j]=-1000;

   for(i=1;i<=height;i++)
     for(j=1;j<=width;j++)
       if (pixel(i-1,j-1)<255) 
             temp.pint[i][j]= -1000;


   while (!(nomore1 && nomore2)) 
    {
   iteration=iteration+1;
   if (!nomore1) 
   SKELETONIZE(temp.pint,iteration,scantype,nomore1);
   scantype=2; 
   if (!nomore2) 
   SKELETONIZE(temp.pint,iteration,scantype,nomore2);
   scantype=0;
       }

 _GREY thintemp(width,height);

 for (i=1;i<=height;i++)
 for (j=1;j<=width;j++)
    if (temp.pint[i][j]>=0) thintemp.pic[i-1][j-1]=(unsigned char) 255;
                   else thintemp.pic[i-1][j-1]=0;
     temp.free();
     return(thintemp);
}

         void  _GREY::get_Neighbor(float **val,int i,int j,int wsize=1)
          {
            int m,n;

            for(m=-wsize;m<=wsize;m++)
            for(n=-wsize;n<=wsize;n++)
               val[m+wsize][n+wsize]=pixel(i+m,j+n);
          }
 
         _MASK _GREY::get_Neighbor(int i,int j,int wsize=1)
          {
            int m,n;
            _MASK t_mask(2*wsize+1,2*wsize+1);
            float **val;

            val=t_mask.get_mask();

            for(m=-wsize;m<=wsize;m++)
            for(n=-wsize;n<=wsize;n++)
               val[m+wsize][n+wsize]=pixel(i+m,j+n);
            return(t_mask);
           }

         _MASK _GREY::get_Neighbor(int i,int j,int hsize,int wsize)
          {
            int m,n;
            _MASK t_mask(2*hsize+1,2*wsize+1);
            float **val;

            val=t_mask.get_mask();

            for(m=-hsize;m<=hsize;m++)
            for(n=-wsize;n<=wsize;n++)
               val[m+hsize][n+wsize]=pixel(i+m,j+n);
            return(t_mask);
           }

         _MASK _GREY::get_Rect(int i,int j,int hsize,int wsize)
          {
            int m,n;
            _MASK t_mask(hsize,wsize);
            float **val;

            val=t_mask.get_mask();

            for(m=0;m<hsize;m++)
            for(n=0;n<wsize;n++)
               val[m][n]=pixel(i+m,j+n);
            return(t_mask);
           }

         void _GREY::get_Rect(_MASK temp,int i,int j,int hsize,int wsize)
          {
            if((temp.get_w()!=wsize) || (temp.get_h()!=hsize))
              {
                cout<<"WARNING! Rectangular portion not extracted due to mismatch in dimensions \n";
                return;
              }
            int m,n;
            float **val;

            val=temp.get_mask();

            for(m=0;m<hsize;m++)
            for(n=0;n<wsize;n++)
               val[m][n]=pixel(i+m,j+n);
            return;
           }

         void _GREY::get_Rect(float **val,int i,int j,int hsize,int wsize)
	 // Assumes float array val is allocated properly
          {
            int m,n;


            for(m=0;m<hsize;m++)
            for(n=0;n<wsize;n++)
               val[m][n]=pixel(i+m,j+n);
            return;
           }

         _MASK _GREY::get_Rect(int i,int j,int wsize)
          {
            int m,n;
            _MASK t_mask(wsize,wsize);
            float **val;

            val=t_mask.get_mask();

            for(m=0;m<wsize;m++)
            for(n=0;n<wsize;n++)
               val[m][n]=pixel(i+m,j+n);
            return(t_mask);
           }

         void  _GREY::get_Rect(_MASK temp,int i,int j,int wsize)
          {
            if((temp.get_w()!=wsize) || (temp.get_h()!=wsize))
              {
                cout<<"WARNING! Rectangular portion not extracted due to mismatch in dimensions \n";
                return;
              }

            int m,n;
            float **val;

            val=temp.get_mask();

            for(m=0;m<wsize;m++)
            for(n=0;n<wsize;n++)
               val[m][n]=pixel(i+m,j+n);
            return;
           }

         void _GREY::init_Rect(int i,int j,int wsize,int hsize,float val=0)
          {
            int m,n;


            cout<<"val="<<val<<'\n';
            for(m=0;m<hsize;m++)
            for(n=0;n<wsize;n++)
               put(val,i+m,j+n);
           }

         void _GREY::apply_affine_to(int x,int y,int i,int j,int wsize,int hsize,float a,float b,int txno=0)
          {
            int m,n;
            float val;


            for(m=0;m<hsize;m++)
            for(n=0;n<wsize;n++)
            {
               switch(txno){
             case ROT_0:
                    val=pixel(i+m,j+n);
                    break;
             case ROT_90:
                    val=pixel(i+n,j+wsize-1-m);
                    break;
             case ROT_180:
                    val=pixel(i+hsize-1-m,j+wsize-1-n);
                    break;
             case ROT_270:
                    val=pixel(i+hsize-1-n,j+m);
                    break;
             case REFLECT_X:
                    val=pixel(i+hsize-1-m,j+n);
                    break;
             case REFLECT_Y:
                    val=pixel(i+m,j+wsize-1-n);
                    break;
             case REFLECT_DIAGONAL:
                    val=pixel(i+hsize-1-n,j+wsize-1-m);
                    break;
             case REFLECT_ANTIDIAGONAL:
                    val=pixel(i+n,j+m);
                    break;
             default:
                     val=0;
                     break;
                }
               put(b+a*val,x+m,y+n);
            }
           }

         void _GREY::apply_affine_to(int x,int y,_MASK domBlock,float a,float b,int txno=0)
          {
            int m,n;
            float val;
            int wsize,hsize;
            float **dom;

            wsize=domBlock.get_w();
            hsize=domBlock.get_h();
            dom=domBlock.get_mask();

            for(m=0;m<hsize;m++)
            for(n=0;n<wsize;n++)
            {
               switch(txno){

             case ROT_0:
                    val=dom[m][n];
                    break;
             case ROT_90:
                    val=dom[n][wsize-1-m];
                    break;
             case ROT_180:
                    val=dom[hsize-1-m][wsize-1-n];
                    break;
             case ROT_270:
                    val=dom[hsize-1-n][m];
                    break;
             case REFLECT_X:
                    val=dom[hsize-1-m][n];
                    break;
             case REFLECT_Y:
                    val=dom[m][wsize-1-n];
                    break;
             case REFLECT_DIAGONAL:
                    val=dom[hsize-1-n][wsize-1-m];
                    break;
             case REFLECT_ANTIDIAGONAL:
                    val=dom[n][m];
                    break;
             default:
                     val=0;
                     break;
                }
               put(a*val+b,x+m,y+n);
            }
           }

         _GREY _GREY::smooth(int mode=AVG_MODE,int wsize=1)
         {
          _GREY temp;
          _MASK pat(2*wsize+1,2*wsize+1,0);
           float **val;
           int i,j,m,n;

           temp.set(width,height,0,DFLOAT);
           val=pat.get_mask();

           for(i=0;i<height;i++)
           for(j=0;j<width;j++){

            get_Neighbor(val,i,j,wsize);

            switch(mode){
            case AVG_MODE: 
                       temp.rval[i][j]=pat.N_compute(AVG_MODE);
                       break;
            case MAX_MODE: 
                       temp.rval[i][j]=pat.N_compute(MAX_MODE);
                       break;
            case MIN_MODE: 
                       temp.rval[i][j]=pat.N_compute(MIN_MODE);
                       break;
            case MEDIAN_MODE: 
                       temp.rval[i][j]=pat.N_compute(MEDIAN_MODE);
                       break;
            default: temp.rval[i][j]=0;
            }
           }
           pat.free();
           temp.adjust_image();
           return(temp);
         }

         _GREY _GREY::smooth_weighted(_MASK mwt, int mode) // implemented on 22.3.2
         {
          _GREY temp;
          _MASK pat;
           float **val;
           int i,j,m,n;
           int wsize=mwt.get_w(), hsize=mwt.get_h();

           if((wsize!=hsize) || (wsize%2 ==0))
            {
               cout<<"Mask width and height should be same and of ODD value\n";
               return temp;
            }

            pat.set(wsize,wsize,0);

           temp.set(width,height,0,DFLOAT);
           val=pat.get_mask();

           for(i=0;i<height;i++)
           for(j=0;j<width;j++){

            get_Neighbor(val,i,j,wsize/2);


            switch(mode){
            case AVG_MODE: 
                       temp.rval[i][j]=pat.N_compute_weighted(mwt,AVG_MODE);
                       break;
            case MEDIAN_MODE: 
                       temp.rval[i][j]=pat.N_compute_weighted(mwt,MEDIAN_MODE);
                       break;
            default: temp.rval[i][j]=0;
            }
           }
           pat.free();
           temp.adjust_image();
           return(temp);
         }

       _GREY _GREY::smooth_gauss(float sigma=1.0)
        {
         _GREY temp;
         _MASK g;

           g.gauss(sigma);
           temp=(*this)*g;
           g.free();
           return(temp);
        }

  _GREY _GREY::form_scale_space()
   {
     _GREY temp;
      int sigma,j;
      _signal zero_cross;

      if(pic==NULL){
      cout<<"Not of CHAR datatype. Scale_space not formed \n";
      return(temp);
      }

      temp.set(256,256);//scale space: sigma x grey:
      find_histogram();
      //hist.write();
      for(sigma=1;sigma<100;sigma++){
      zero_cross=hist.ssf((float)sigma);
      cout<<"sigma="<<sigma<<" no.="<<zero_cross.get_num()<<"\n";
      for(j=0;j<zero_cross.get_num();j++)
        temp.pic[256-sigma][(int)((zero_cross&j)+0.5)]=(unsigned char) 255;
      zero_cross.free();
      }
     temp.adjust_image();
     return(temp);
   }


         _GREY _GREY::form_sigma_valley()
   {
     _GREY temp;
      int sigma,j;
      _signal val_cross,thist;

      if(pic==NULL){
      cout<<"Not of CHAR datatype. Scale_space not formed \n";
      return(temp);
      }

      temp.set(256,256);//scale space: sigma x grey:
      find_histogram();
      for(sigma=1;sigma<50;sigma++){
      thist=hist.gauss_smooth((float)sigma);
      val_cross=thist.valley();
      cout<<"sigma="<<sigma<<" no.="<<val_cross.get_num()<<"\n";

     // char ch;
      //cin>>ch;

      for(j=0;j<val_cross.get_num();j++)
        temp.pic[256-sigma][(int)(val_cross&j)]=(unsigned char) 255;
      thist.free();
      val_cross.free();
      }
     temp.adjust_image();
     return(temp);
   }


_GREY _GREY::gauss_noise(float sigma=1.0,float mean=0.0)
{
 _GREY temp;
 int i,j,k;
 float val;

 if(sigma==0) return(*this);
 temp.set(width,height,0,DFLOAT);
 for(i=0;i<height;i++)
 for(j=0;j<width;j++)
 {
   val=0;
   for(k=0;k<12;k++)
   val=val+(float)drand48();
   val= sigma*(val-6.0)+mean;
   temp.rval[i][j]=pixel(i,j)+val;
 }
 temp.adjust_image();
 return(temp);
}


_GREY _GREY::uniform_noise(float max_grey=255.0)
{
 _GREY temp;
 int i,j,k;
 float val;

 if(max_grey==0) return(*this);
 temp.set(width,height,0,DFLOAT);
 for(i=0;i<height;i++)
 for(j=0;j<width;j++)
 {
   val=(float)drand48()*max_grey;
   temp.rval[i][j]=pixel(i,j)+val;
 }
 temp.adjust_image();
 return(temp);
}


_GREY _GREY::dft()
 {_GREY temp;
   int num,m,w=1;
   int i,j;

   if(domain==FREQ){
    cout<<"DFT in FREQ domain not allowed \n";
    return(temp);
    }

    num=max(width,height);
    m=(int)(log((double)num)/log(2));
    if((w=w<<m)<num){
          w=w<<1;
          m++;}
    cout<<"performing "<<m<<" point dft on "<<w<<" data points \n";


    temp.set(w,w,0,DCOMPLEX);
    
    _COMPLEX *data;

     data=new _COMPLEX[w];


     for(i=0;i<height;i++)
     {
     for(j=0;j<w;j++)
      data[j].set(pixel(i,j),0.0);

     /*
     {
     char ch;
     for(j=0;j<w;j++)
      data[j].write();
      cin>>ch;
      }
      */

      fft(data,m);

      /*
      cout<<"IDFT\n";
      ifft(data,m);
     {
     char ch;
     for(j=0;j<w;j++)
      data[j].write();
      cin>>ch;
      }
      */
     
     for(j=0;j<w;j++)
      {
      temp.rval[i][j]=data[j].get_r();
      temp.ival[i][j]=data[j].get_i();
      }
    }

     for(i=0;i<w;i++)
     {
     for(j=0;j<w;j++)
      data[j].set(temp.rval[j][i]/w,temp.ival[j][i]/w);
      fft(data,m);

     /*
     char ch;
     for(j=0;j<w;j++)
      data[j].write();
      cin>>ch;
     */

     for(j=0;j<w;j++)
      {
      temp.rval[j][i]=data[j].get_r();
      temp.ival[j][i]=data[j].get_i();
      }
    }
    delete data;
    temp.adjust_image();
    cout<<"fmin="<<temp.fmin<<" fmax="<<temp.fmax<<"\n";
    return(temp);
  }

   
_GREY _GREY::idft()
 {_GREY temp,temp1;
   int num,m,w=1;
   int i,j;

   if(domain!=FREQ){
    cout<<"IDFT in FREQ domain only allowed \n";

     char c;
     cin>>c;

    return(temp);
    }


    m=(int)(log((double)height)/log(2));
    w=w<<m;

     cout<<"m="<<m<<" w="<<w<<"\n";

    if(w<height) m++;
    else if(w>height) m--;
    cout<<"performing "<<m<<" point idft on "<<w<<" data points \n";


    temp.set(width,width,0,DFLOAT);
    temp1.set(width,width,0,DCOMPLEX);
    
    _COMPLEX *data;

     data=new _COMPLEX[width];

     for(i=0;i<height;i++)
     {
     for(j=0;j<width;j++)
      data[j].set(rval[i][j],ival[i][j]);


      ifft(data,m);

     /*
     char ch;
     for(j=0;j<w;j++)
      data[j].write();
      cin>>ch;
     */
   
     for(j=0;j<width;j++)
      {
      temp1.rval[i][j]=data[j].get_r();
      temp1.ival[i][j]=data[j].get_i();
      }
    }

     for(i=0;i<width;i++)
     {
     for(j=0;j<height;j++)
      data[j].set(temp1.rval[j][i]*width,temp1.ival[j][i]*width);


      ifft(data,m);

     /*
     char ch;
     for(j=0;j<w;j++)
      data[j].write();
      cin>>ch;
     */

     for(j=0;j<width;j++)
      {
      temp.rval[j][i]=data[j].get_r();
      //if(temp.rval[j][i]>255)
      //cout<<temp.rval[j][i]<<"at ("<<j<<","<<i<<")\n";
      }
    }
    temp1.free();
    delete data;
    temp.adjust_image();
    cout<<"fmin="<<temp.fmin<<" fmax="<<temp.fmax<<"\n";
    return(temp);
  }

  void _GREY::convert_to_phasor()
  {
    int i,j;
    float mag,angle;

    if(domain==FREQ){
    for(i=0;i<height;i++)
    for(j=0;j<width;j++)
     {
       mag=(float)sqrt((double)(sqr(rval[i][j])+sqr(ival[i][j])));
       angle=(float)atan((double)(ival[i][j]/rval[i][j]));
       rval[i][j]=mag;
       ival[i][j]=angle;
       //cout<<"mag="<<mag<<" ang="<<angle<<"\n";
     }
   adjust_image();
   cout<<"fmin="<<fmin<<" fmax="<<fmax<<"\n";
   }
   else cout<<"Not in FREQ domain \n";
  }

  void _GREY::convert_to_complex()
  {
    int i,j;

    if(domain==FREQ){
    for(i=0;i<height;i++)
    for(j=0;j<width;j++)
     {
       rval[i][j]=rval[i][j]*cos((double)(ival[i][j]));
       ival[i][j]=rval[i][j]*sin((double)(ival[i][j]));
     }
   adjust_image();
   }
   else cout<<"Not in FREQ domain \n";
  }


 _GREY _GREY::seg_hist(_signal hseg)
 {
  _GREY temp(width,height);
   int i,j,k;

   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
    {
       for(k=0;k<hseg.get_num();k++)
         {
          if(pixel(i,j)<(hseg&k)) break;
         }
        temp.pic[i][j]=(unsigned char)(k+1);
    }
    return(temp);
 }
 
 float _GREY::g1(float dI,float K)
 {
  return((float)exp((double)(-sqr(dI/K))));
 }

 float _GREY::g2(float dI,float K)
 {
  return(1/(1+sqr(dI/K)));
 }

 _GREY _GREY::aniso_diffusion(float lamda=0.2,float weight=0.9,int Niter=20)
 {
  _GREY im_t,im_t1,grad;
  _signal hist;
   float **t,**t1,**temp;
   float cN,cS,cW,cE;
   float K,Kmax;
   float dIN,dIS,dIW,dIE;
   float dImax,dIavg;
   long count=0;
 
   
   
   int i,j,k;

   /*
   grad=edge_s();
   grad.normalise();
   hist=grad.get_hist();
   K=hist.get_thresh(thresh);
   Kmax=K;
   //K=grad.get_min()+(grad.get_max()-grad.get_min())*K/255.0;
   cout<<"Edge Thresh "<<K<<"\n";
   //cout<<"Emax="<<grad.get_max()<<" Emin="<<grad.get_min()<<"\n";
   grad.free();
   hist.free();
  */
  K=5;
   
   
   im_t.set(width,height,0,DFLOAT);
   im_t1.set(width,height,0,DFLOAT);
   t=im_t.get_f();
   t1=im_t1.get_f();
   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
     t[i][j]=pixel(i,j);

   for(k=0;k<Niter;k++){
   dImax=0;
   dIavg=0;
   count=0;

   /*
   grad=im_t.edge_s();
   grad.normalise();
   hist=grad.get_hist();
   K=hist.get_thresh(thresh);
   //cout<<"Normalised Edge Thresh "<<K<<"\n";
   //K=grad.get_min()+(grad.get_max()-grad.get_min())*K/255.0;
   cout<<"Edge Thresh "<<K<<"\n";
   //cout<<"Emax="<<grad.get_max()<<" Emin="<<grad.get_min()<<"\n";
   grad.free();
   hist.free();
   */

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dIN=t[i-1][j]-t[i][j];
   dIS=t[i+1][j]-t[i][j];
   dIE=t[i][j+1]-t[i][j];
   dIW=t[i][j-1]-t[i][j];
   
   if(abs(dIN)>dImax) dImax=abs(dIN);
   if(abs(dIS)>dImax) dImax=abs(dIS);
   if(abs(dIE)>dImax) dImax=abs(dIE);
   if(abs(dIW)>dImax) dImax=abs(dIW);
   dIavg=((float)count*dIavg+abs(dIN)+abs(dIS)+abs(dIW)+abs(dIE))/(float)(count+4);
   count=count+4;

   t1[i][j]=t[i][j]+lamda*(g1(dIN,K)*dIN+g1(dIS,K)*dIS+g1(dIE,K)*dIE+g1(dIW,K)*dIW);
   }
   /*
   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
      t[i][j]=t1[i][j];
     */

     temp=t;
     t=t1;
     t1=temp;

     //K=Kmax-(float)(k/8);
    // K=dImax*Kmax/255.0;
   //K=K*(float)exp(-((double)k)/500);
   //K=K-K*(float)exp(-1/(double)K)/10;
   //cout<<"Edge Thresh "<<K<<"\n";

   K=weight*dIavg+(1-weight)*dImax;
   cout<<"Edge Thresh "<<K<<" dIavg= "<<dIavg<<" dImax= "<<dImax<<"\n";

   cout<<"Iteration :"<<k<<"\n";

   }
  im_t1.free();
  im_t.adjust_image();
   
  return(im_t);
 }

 
 _GREY _GREY::relaxation(float lamda=10,float epsilon=5,int Niter=1000,float w=1.5)
 {
  _GREY im_t,im_t1;
   int i,j,k;
   int terminate=0,iteration=0;;
   float T,max_dev;
   float **t,**t1,**temp;

   im_t.set(width,height,0,DFLOAT);
   im_t1.set(width,height,0,DFLOAT);
   t=im_t.get_f();
   t1=im_t1.get_f();
   /*
   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
     t[i][j]=pixel(i,j);
    */

   while(!terminate){
   max_dev=0;
   iteration++;
   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
   {
    if((i==0)&&(j==0)) T=2.0*lamda;
    else if((i==0)||(j==0)) T=3.0*lamda;
    else T=4.0*lamda;

    t1[i][j]=t[i][j]-w*(T*t[i][j]-pixel(i,j)-lamda*(im_t1.pixel(i-1,j)+im_t.pixel(i+1,j)+im_t1.pixel(i,j-1)+im_t.pixel(i,j+1)))/T;
    if(max_dev<abs(t1[i][j]-t[i][j])) max_dev=abs(t1[i][j]-t[i][j]);
    
   }
    if((Niter<iteration)||(max_dev<epsilon)) terminate=1;
    else{
     temp=t;
     t=t1;
     t1=temp;
    }
    cout<<"iteration= "<<iteration<<" max_dev="<<max_dev<<"\n";
   }
   im_t.free();
   im_t1.adjust_image();
   return(im_t1);
 }

  _GREY _GREY::adaptive_smoothing(float sigma=1.0,int Niter=10)
  {
  _GREY im_t,im_t1,grad;
   int i,j,k,l,m;
   float **t,**t1,**temp;
   float **gr;
   float gr_sum,pix_sum;

   sigma=(float)sqrt(2.0)*sigma;
   im_t.set(width,height,0,DFLOAT);
   im_t1.set(width,height,0,DFLOAT);
   t=im_t.get_f();
   t1=im_t1.get_f();

   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
     t[i][j]=pixel(i,j);

   for(k=0;k<Niter;k++){

   grad=im_t.edge_s();
   gr=grad.get_f();

   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
   {
    gr[i][j]=1-g1(gr[i][j],sigma);
   }
   

   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
   {
    gr_sum=0;
    pix_sum=0;
    for(l=-1;l<=1;l++)
    for(m=-1;m<=1;m++)
    {
     pix_sum+=grad.pixel(i+l,j+m)*im_t.pixel(i+l,j+m);
     gr_sum+=grad.pixel(i+l,j+m);
    }
     if(gr_sum==0) t1[i][j]=0;
     else
     t1[i][j]=pix_sum/gr_sum;
    }
     temp=t;
     t=t1;
     t1=temp;

     grad.free();
     cout<<"iteration no. : "<<k<<"\n";
     }
   im_t1.free();
   //grad.free();
   im_t.adjust_image();
   cout<<"fmin= "<<im_t.get_min()<<" fmax= "<<im_t.get_max()<<"\n";
   return(im_t);
  }

  _GREY _GREY::get_bnd()
 {
  _GREY im_t;
   int i,j,k,l,m;
   float **t;

   im_t.set(width,height,0,DFLOAT);
   t=im_t.get_f();

   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
    {
    for(l=-1;l<=1;l++)
    for(m=-1;m<=1;m++)
    {
     if(pixel(i,j)>0)
     if(((i+l)>=0)&&((i+l)<height))
     if(((j+m)>=0)&&((j+m)<width))
     if (pixel(i+l,j+m)!=pixel(i,j))
      t[i][j]=pixel(i,j);
    }
    }

   im_t.adjust_image();
   cout<<"fmin= "<<im_t.get_min()<<" fmax= "<<im_t.get_max()<<"\n";
   return(im_t);
 }


  _GREY _GREY::shift(int x,int y)
 {
  _GREY im_t;
   int i,j,k,l,m;
   float **t;

   im_t.set(width,height,0,DFLOAT);
   t=im_t.get_f();

   for(i=0;i<height;i++)
   for(j=0;j<width;j++)
    {
      t[i][j]=pixel(i-x,j-y);
    }

   im_t.adjust_image();
   return(im_t);
 }

 //Added from MS

  /************************************************************
Function Name: mytan
Parameters : theta which is an integer between 0 and 360.
The main problems is with multiples of 90 where tan(theta) is
undefined. At these points the function returns FLT_MAX.
Beyond this a conversion into radians is required.

************************************************************/
  float _GREY::mytan(int theta)
{
	double angle,ret;

	if((theta%90==0)&&((theta/90)%2==1)) return(9999999);
	else{
		angle = PI*theta/180;
		ret = tan(angle);
	 	if(abs(ret)<0.001) return((float).001);
	 	else return((float)ret);
	}
}
	

  _POLYGON _GREY::extract_contour_of_cavity(int x0,int y0,double Radius,float eThresh,double srcRadThresh,int DelTheta)
  {
	  _GREY tmp;
	  float **eVal;
	  int theta; //,i,length;
     // float x,y,xincrement,yincrement,slope,tx,ty;
     _POLYGON vList;
	 //int X_SIZE=height,Y_SIZE=width;
	 _PNT v,vc;
	 int xd,yd;
	 int prevx,prevy;
	 int x,y;
	      int s1,s2;
          int interchange;
          int err;
	      int temp;
	      int i,detx,dety;
		 // double newDist;

     tmp=edge_s();
	  eVal=tmp.get_f();

	  //cout<<"Edge computed \n";

	  vc.x=(double)x0;
	  vc.y=(double)y0;

	  for(theta=0;theta<360;theta+=DelTheta)
	  {
		  xd=(int)((double)x0+Radius*cos(PI*(double)theta/180.0));
		  yd=(int)((double)y0+Radius*sin(PI*(double)theta/180.0));

		 // newDist=sqrt(sqr((double)(xd-x0))+sqr((double)(yd-y0)));

		  x=(int)((double)x0+srcRadThresh*cos(PI*(double)theta/180.0));
		  y=(int)((double)y0+srcRadThresh*sin(PI*(double)theta/180.0));

		 

		  	detx=abs((xd-x));
        	dety=abs((yd-y));
   	s1=sign((xd-x));
	s2=sign((yd-y));
	if(dety>detx)
	{temp=detx;
	 detx=dety;
	 dety=temp;
	 interchange=1;
	 }
	 else interchange=0;
	 err=2*dety-detx;
        
	    
     
	 prevx=x;
	 prevy=y;
	 
	 //for(i=0;i<detx;i++)
	 while((xd!=x )|| (yd!=y))
	 {
		
		if (err>=0)
		{
			if(interchange==1)
		      x+=s1;
		    else y+=s2;
		 err-=(2*detx);
		}
		else
		{
		    if(interchange==1)
		       y+=s2;
		    else x+=s1;
		    err+=(2*dety);
		 }
		if((prevx>=0)&&(prevx<height))
		if((prevy>=0)&&(prevy<width))
		if((eVal[prevx][prevy]>eThresh) && (eVal[x][y]<eVal[prevx][prevy]))
		{

			break;//&& (v.distance(vc)>srcRadThresh) )break;
		}
		
		prevx=x;
		prevy=y;
		  
		}
	    v.x=(double)prevx; v.y=(double)prevy;
		if(v.distance(vc)<Radius-srcRadThresh)
		         vList.Add_vertex(v);

	  }

   //cout<<"Contour computed \n";
   
   tmp.free();// Freed edge emage
   
   //cout<<"Edge image freed \n";
   return(vList);


  }

  _signal  _GREY::get_image_profile(int x1,int y1,int x2,int y2,int mode)
  {
	      _signal tmp;
          float *data;
          int x,y;
	      int s1,s2;
          int interchange;
          int err;
	      int temp;
	      int i,detx,dety;
	 
		switch(mode)
		{
		case _IM_OBLIQUE:
			
			    break;
		case _IM_VERTICAL:
		    y2=y1;
			break;
		case _IM_HORIZONTAL:
			x2=x1;
           	break;
		default:
			;
		
		}

	x=x1;
	y=y1;
	detx=abs((x2-x1));
	dety=abs((y2-y1));
	s1=sign((x2-x1));
	s2=sign((y2-y1));
	if(dety>detx)
	{temp=detx;
	 detx=dety;
	 dety=temp;
	 interchange=1;
	 }
	 else interchange=0;
	 err=2*dety-detx;
        
	     //cout<<"Going to set _signal object \n";
         tmp.step(0,detx);
         data=tmp.get_r();
		 if(data==NULL) 
		 {
			//cout<<"Object not set \n";
			 return tmp;

		 }

	 data[0]= pixel(x1,y1);
	 for(i=0;i<detx;i++)
	 {
		data[i+1]= pixel(x,y);
		if (err>=0)
		{if(interchange==1)
		x+=s1;
		else y+=s2;
		err-=(2*detx);
		}
		else {
		if(interchange==1)
		y+=s2;
		else x+=s1;
		err+=(2*dety);
				 }
		}
	 // cout<<"Profile computed \n";
        return(tmp);

  }

  _GREY    _GREY::extractInterior(_POLYGON Plg,int val,int mode)// mode==0 means according to gaphics window , ==1 means according to image
  {
	    _RECT mrect;
	   	int xmin,xmax,ymin,ymax,x,y;
		_GREY temp;
		int i,no_vx;
		int xs,xd,ys;
		unsigned char** tpic;
		_PNT  intersect_vx[200];

		if(pic==NULL)
		{
			cout<<"Not operated on other than unsigned char datatype \n";
			return temp;
		}

		Plg.Remove_Hor_Edges();
		 // cout<<"Horizontal edges removed \n";
          mrect=Plg.Min_Rect_Bound();
          xmin=(int)(mrect.pLb.get_x());
          xmax=(int)(mrect.pRu.get_x());
          ymin=(int)(mrect.pLb.get_y());
          ymax=(int)(mrect.pRu.get_y());

		 // cout<<"Minimum Rectangle tracked \n";

           //cout<<"Contour Drawn \n"<<flush;
          if(!mode)
               temp.set(xmax-xmin+1,ymax-ymin+1,val);
		  else
			  temp.set(ymax-ymin+1,xmax-xmin+1,val);

          

          tpic=temp.get_pic();
           for(y=ymin;y<=ymax;y++)
           {
           no_vx=Plg.Hor_Edge_Intersect((float)y,intersect_vx);
          // if(no_vx>199) cout<<"Error in polygon filling \n"<<flush;
              for(i=0;i<no_vx-1;i++)
              {
               if(i%2==0){
				   if(!mode)
				   {
                     ys=height-y;
                     xs=(int)intersect_vx[i].get_x();
                     xd=(int)intersect_vx[i+1].get_x();
                     for(x=xs;x<=xd;x++)
                        tpic[ymax-y][x-xmin]=pic[ys][x];
				   }
				   else
				   {
					 //ys=height-y;
                     xs=(int)intersect_vx[i].get_x();
                     xd=(int)intersect_vx[i+1].get_x();
                     for(x=xs;x<=xd;x++)
                        tpic[x-xmin][y-ymin]=pic[x][y];
				   }
               }
              }
           }
         
		// cout<<"Interior Extracted \n";
         return(temp);

  }

  _signal     _GREY::getInteriorHist(_POLYGON Plg,int mode)
  {
	  _signal temp_hist;


	   _RECT mrect;
	   	int xmin,xmax,ymin,ymax,x,y;
		
		int i,no_vx;
		int xs,xd,ys;
		
		_PNT  intersect_vx[200];
		float *rval;

		if(pic==NULL)
		{
			cout<<"Not operated on other than unsigned char datatype \n";
			return temp_hist;
		}
		  temp_hist.step(0,256);
		  rval=temp_hist.get_r();

		Plg.Remove_Hor_Edges();
		 // cout<<"Horizontal edges removed \n";
          mrect=Plg.Min_Rect_Bound();
          xmin=(int)(mrect.pLb.get_x());
          xmax=(int)(mrect.pRu.get_x());
          ymin=(int)(mrect.pLb.get_y());
          ymax=(int)(mrect.pRu.get_y());

		 // cout<<"Minimum Rectangle tracked \n";

        
          

          
           for(y=ymin;y<=ymax;y++)
           {
           no_vx=Plg.Hor_Edge_Intersect((float)y,intersect_vx);
          // if(no_vx>199) cout<<"Error in polygon filling \n"<<flush;
              for(i=0;i<no_vx-1;i++)
              {
               if(i%2==0){
				   if(!mode)
				   {
                     ys=height-y;
                     xs=(int)intersect_vx[i].get_x();
                     xd=(int)intersect_vx[i+1].get_x();
                     for(x=xs;x<=xd;x++)
                        rval[pic[ys][x]]++;
				   }
				   else
				   {
					 //ys=height-y;
                     xs=(int)intersect_vx[i].get_x();
                     xd=(int)intersect_vx[i+1].get_x();
                     for(x=xs;x<=xd;x++)
                        rval[pic[ys][x]]++;
				   }
               }
              }
           }

		   return(temp_hist);

  }

// Interface for I/O 


        ofstream & operator<<(ofstream & fout, const _GREY & im) // implemented on 30.11.2000
        {

	int i;

        if(im.pic==NULL){cout<<"Not in char format \n";
                      cout<<"File not saved \n";
                      return fout;
                     }
	for (i=0;i<im.height;++i){
		fout.write((char *)im.pic[i],im.width); 
                }
	return(fout);
        }

        ifstream & operator>>(ifstream & fin, const _GREY & im) // implemented on 30.11.2000
                                 // Assume the pic array pre-allocated with proper deimension
        {
          int i;

        // if(pic!=NULL) free_matrix(pic,h);
        // pic=(unsigned char **)allocate_matrix(h,w,sizeof(unsigned char));
        if(im.pic==NULL){
        cout<<"Memory not allocated for reading using operator >> \n";
        return(fin);
        }

	for (i=0;i<im.height;++i){
		fin.read((char *)im.pic[i],im.width); 
		if (fin.gcount()!=im.width){ 
			cout<<"reading error in \n";
			return(fin);
                          }
		}
	return(fin);
        }
