
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
/* MACROS */

/* RANGE forces a to be in the range b..c (inclusive) */
#define RANGE(a,b,c) { if (a < b) a = b;  if (a > c) a = c; }

/* PTINRECT returns '1' if x,y is in rect (inclusive) */
#define PTINRECT(x,y,rx,ry,rw,rh) \
           ((x)>=(rx) && (y)>=(ry) && (x)<=(rx)+(rw) && (y)<=(ry)+(rh))

/* MONO returns total intensity of r,g,b components */
#define MONO(rd,gn,bl) (((rd)*11 + (gn)*16 + (bl)*5) >> 5)  /*.33R+ .5G+ .17B*/

#define sqr(x) ((x)*(x))
#define abs(x) (((x)>0)?(x):(-(x)))
#define sign(x) (((x)<0)?(-1):(((x)==0)?0:1))
#define max(x,y) (((x)>(y))?(x):(y))
#define min(x,y) (((x)<(y))?(x):(y))


#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE  1
#endif

#ifndef false 
#define false 0
#endif

#ifndef true
#define true  1
#endif

#ifndef PI
#define PI M_PI
#endif

#define MAX_COLOR   256
#define MAXROW 512
#define MAXCOL 512

#define IMAGE_NAME_SIZE 16
#define HEADER_SIZE     512

#define DCHAR  0
#define DINT   1
#define DFLOAT 2
#define DCOMPLEX  3



#define    TIME         0
#define    SPACE        1
#define    FREQ         2
#define    CHROMA       3
#define    EDGE         4
#define    OTHER        5

#define RGB 0
#define XYZ 1
#define NXYZ 2
#define LMS 3
#define LHS 4 //according to CIE chart
#define AC1C2 5
#define IC1C2 6
#define STLMS 7
#define NTSC 8
#define UVW 9
#define NUVW 10
#define MOD_UVW 11
#define YIQ  12
#define MacAdam  13
#define OHTA 14
#define LAB 15
#define CIELAB 16
#define CIELUV 17
#define YUV 18 // YCrCb


#define AVG_MODE 0
#define MAX_MODE 1
#define MIN_MODE 2
#define MEDIAN_MODE 3
#define SD_MODE     4

#define EUCLID    0
#define CHESSBOARD 1
#define CITYBLOCK 2 /* D1 */
#define D2        3
#define D3        4 /* Chessboard in 3D */ 
#define D12       5
#define D13       6
#define D23       7
#define D112      8 
#define D113      9 
#define D122     10 
#define D123     11 
#define D133     12 
#define D223     13 
#define D233     14 


#define MAX_PT  18000

#define MAX_VAL 10000.
#define MIN_VAL .00001

#define ROT_0 0
#define ROT_90 1
#define ROT_180 2
#define ROT_270 3
#define REFLECT_X 4 //About X axis
#define REFLECT_Y 5 //About Y axis
#define REFLECT_DIAGONAL 6 // About an axis at 45 degree with X axis
#define REFLECT_ANTIDIAGONAL 7 // About an axis at 135 degree with X axis

#define _IM_VERTICAL   0
#define _IM_HORIZONTAL 1
#define _IM_OBLIQUE    2

#define  _EVEN 0
#define  _ODD  1
#define  _DEINTERLACE  0
#define  _INTERLACE  1
