
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
//Header file for mask
 class _MASK{
             float **mask;
             int height;
             int width;
            public:
                 _MASK(){mask=NULL;width=height=0;}
                 _MASK(int w,int h,float val=0){
                       int i,j;
                       
                       mask=(float **)allocate_matrix_float(h,w,sizeof(float));
                       if(mask!=NULL){
                       for(i=0;i<h;i++)
                       for(j=0;j<w;j++)
                       mask[i][j]=val;
                       height=h;
                       width=w;
                       }
                       else {
                       cout<<"Memory not allocated for creating mask\n";
                       exit(0);
                       w=h=0;
                       }
                       }

              ~_MASK(){}

                   float **get_mask(){return(mask);}
                   int    get_h(){return(height);}
                   int    get_w(){return(width);}

              void set(int w,int h,int val=0){
                       int i,j;
                       
                       mask=(float **)allocate_matrix_float(h,w,sizeof(float));
                       if(mask!=NULL){
                       for(i=0;i<h;i++)
                       for(j=0;j<w;j++)
                       mask[i][j]=val;
                       height=h;
                       width=w;
                       }
                       else {
                       cout<<"Memory not allocated for creating mask\n";
                       exit(0);
                       w=h=0;
                       }
                    }

              void  set(float **val,int w,int h){ mask=val; height=h; width=w;}

              void free(){
                    if(mask!=NULL) {
                    free_matrix_float(mask,height);
                    mask=NULL;
                     }
                   }

                  void step(int w,int h,float val=1.0){
                       int i,j;

                       set(w,h);
                       if(mask!=NULL){
                       for(i=0;i<h;i++)
                       for(j=0;j<w;j++)
                       mask[i][j]=val;
                        }
                       else {
                       cout<<"Memory not allocated for creating mask\n";
                        exit(0);
                       w=h=0;
                       }
                       }

                   void sobel_y(){ 
                       width=height=3;
                       mask=(float **)allocate_matrix_float(height,width,sizeof(float));
                       if(mask!=NULL){
                       mask[0][0]=-1;mask[0][1]=-2;mask[0][2]=-1;
                       mask[1][0]=0;mask[1][1]=0;mask[1][2]=0;
                       mask[2][0]=1;mask[2][1]=2;mask[2][2]=1;
                       }
                       else {
                       cout<<"Memory not allocated for creating mask\n";
                       width=height=0;
                       }
                       }

                   void sobel_x(){ 
                       width=height=3;
                       mask=(float **)allocate_matrix_float(height,width,sizeof(float));
                       if(mask!=NULL){
                       mask[0][0]=-1;mask[0][1]=0;mask[0][2]=1;
                       mask[1][0]=-2;mask[1][1]=0;mask[1][2]=2;
                       mask[2][0]=-1;mask[2][1]=0;mask[2][2]=1;
                       }
                       else {
                       cout<<"Memory not allocated for creating mask\n";
                       width=height=0;
                       }
                       }



                      void  gauss(float sigma=1.0)
                       {
                        int w,h;
                        int i,j;
                        float rsq;

                        w=h=(int)(2.0*sigma)+1;
                        set(w,h);

                        for(i=0;i<h;i++)
                        for(j=0;j<w;j++)
                        {
                          rsq=sqr((float)(i-w/2))+sqr((float)(j-w/2));
                     mask[i][j]=(float)exp((double)(-rsq/(2*sqr(sigma))))/2.0*M_PI*sqr(sigma);
                        }
                       }

                      void  gauss_der_x(float sigma=1.0)
                       {
                        int w,h;
                        int i,j;
                        float rsq;

                        w=h=3*(int)(2.0*sqrt(2.0)*(double)sigma)+1;
                        set(w,h);

                        for(i=0;i<h;i++)
                        for(j=0;j<w;j++)
                        {
                          rsq=sqr((float)(i-w/2))+sqr((float)(j-w/2));
                     mask[i][j]=(float)exp((double)(-rsq/(2*sqr(sigma))))/2.0*M_PI*sqr(sigma);
                      mask[i][j]=mask[i][j]*(-(float)(j-w/2)/sqr(sigma));
                        }
                       }


                      void  gauss_der_y(float sigma=1.0)
                       {
                        int w,h;
                        int i,j;
                        float rsq;

                        w=h=3*(int)(2.0*sqrt(2.0)*(double)sigma)+1;
                        set(w,h);

                        for(i=0;i<h;i++)
                        for(j=0;j<w;j++)
                        {
                          rsq=sqr((float)(i-w/2))+sqr((float)(j-w/2));
                     mask[i][j]=(float)exp((double)(-rsq/(2*sqr(sigma))))/2.0*M_PI*sqr(sigma);
                      mask[i][j]=mask[i][j]*(-(float)(i-w/2)/sqr(sigma));
                        }
                       }

                      void  gauss_der_theta(float theta,float sigma=1.0)
                       {
                        int w,h;
                        int i,j;
                        float rsq,costh,sinth,val;

                        theta=theta;
                        costh=(float)cos((double)theta);
                        sinth=(float)sin((double)theta);

                        w=h=3*(int)(2.0*sqrt(2.0)*(double)sigma)+1;
                        set(w,h);

                        for(i=0;i<h;i++)
                        for(j=0;j<w;j++)
                        {
                          rsq=sqr((float)(i-w/2))+sqr((float)(j-w/2));
                          val=(float)exp((double)(-rsq/(2*sqr(sigma))))/2.0*M_PI*sqr(sigma);
                      mask[i][j]=val*(-(float)(j-w/2)/sqr(sigma))*costh +val*(-(float)(i-w/2)/sqr(sigma)*sinth);
                        }
                       }

                      void  gauss_der2_theta(float theta,float sigma=1.0)
                       {
                        int w,h;
                        int i,j;
                        float rsq,costh,sinth,val,var;
                        float x,y;

                        theta=theta;
                        costh=(float)cos((double)theta);
                        sinth=(float)sin((double)theta);

                        w=h=3*(int)(2.0*sqrt(2.0)*(double)sigma)+1;
                        set(w,h);
                        var=sqr(sigma);

                        for(i=0;i<h;i++)
                        for(j=0;j<w;j++)
                        {
                          x=(float)(j-w/2);
                          y=(float)(i-h/2);
                          rsq=sqr(x)+sqr(y);
                          val=(float)exp((double)(-rsq/(2*sqr(sigma))))/2.0*M_PI*sqr(var);
                      mask[i][j]=val*(sqr(x*costh/sigma)+2*x*y*costh*sinth/var+sqr(y*sinth/sigma)-1);
                        }
                       }



                      void  lap_gauss(float sigma=1.0)
                       {
                        int w,h;
                        int i,j;
                        float rsq,var;

                        w=h=3*(int)(2.0*sqrt(2.0)*(double)sigma)+1;
                        var=sqr(sigma);
                        set(w,h);

                        for(i=0;i<h;i++)
                        for(j=0;j<w;j++)
                        {
                         rsq=sqr((float)(i-w/2))+sqr((float)(j-w/2));
                        mask[i][j]=(2-rsq/var)*(float)exp((double)(-rsq/(2*var)));
                        mask[i][j]=mask[i][j]/(2*M_PI*sqr(var));
                        }
                       }


                   void normalise(){
                   int i,j;
                   float sum=0;

                       for(i=0;i<height;i++)
                       for(j=0;j<width;j++)
                       sum+=mask[i][j];

                       for(i=0;i<height;i++)
                       for(j=0;j<width;j++)
                       mask[i][j]/=sum;
                     }

                    float pixel(int x,int y){
                        if(((x>=0)&&(x<height))&& ((y>=0)&&(y<width)))
                         return(mask[x][y]);
                        else return(0);
                        }

                      void write(){
                      int i,j;

                       cout<<"MASK:\n";
                       for(i=0;i<height;i++)
                       {
                       for(j=0;j<width;j++)
                       cout<<mask[i][j]<<" ";
                       cout<<"\n";
                       }
                       }

     float N_compute(int mode) //Modified on 22.3.2 for separating each module
     {
      float maxval=-999999.0,minval=999999.0;
      int i,j,k;
      float sqr_sum=0,sum=0,temp;

      switch(mode){
      case AVG_MODE: 
                      for(i=0;i<height;i++)
                      for(j=0;j<width;j++)
                          {
                          sum+=mask[i][j];
                         //  sqr_sum+=sqr(mask[i][j]);
                          }
                    return(sum/(float)(height*width));
      case MAX_MODE: 
                       for(i=0;i<height;i++)
                       for(j=0;j<width;j++)
                           {
                             if(mask[i][j]>maxval) maxval=mask[i][j];
                          }
                      return(maxval);
      case MIN_MODE: 
                       for(i=0;i<height;i++)
                       for(j=0;j<width;j++)
                           {
                            if(mask[i][j]<minval) minval=mask[i][j];
                            }
                            return(minval);
      case MEDIAN_MODE:
                      float *val;

                       val=new float[height*width];
                         if(val==NULL) {
                          cout<<"Temporary array for median computation not allocated \n";
                          return maxval;
                         }
                        for(i=0,k=0;i<height;i++)
                         for(j=0;j<width;j++)
                               val[k++]=mask[i][j];

                       for(i=0;i<(height*width);i++){
                       for(j=i+1;j<(height*width);j++)
                        if(val[i]<val[j]){
                        temp=val[i];
                        val[i]=val[j];
                        val[j]=temp;
                        }
                       }
                       temp=val[(height*width)/2];
                       delete val;
                       return(temp);
      case SD_MODE:
                  float sqr_avg,avg;
                  float size;
                  float variance;

                  size=(float)height*(float)width;
                      for(i=0;i<height;i++)
                      for(j=0;j<width;j++)
                          {
                          sum+=mask[i][j];
                          sqr_sum+=sqr(mask[i][j]);
                          }

                  avg=sum/size;
                  sqr_avg=sqr_sum/size;
                  variance=sqr_avg-sqr(avg);
                  if (variance<0)
                  {
                  // cout<<"size="<<size<<" sum="<<sum<<" avg="<<avg<<" sqr_sum="<<sqr_sum<<" sqr_avg="<<sqr_avg<<" variance="<<variance<<"\n";
                    cout<<"WARNING! Limitations of floating point computation makes the variance as negative, hence forcing it to zero !! \n";
                   variance=0;
                  }
                  if(variance==0) return 0;
                  return((float)sqrt((double)variance));

      default: return(0);
      }
     }

     float N_compute_weighted(_MASK mwt, int mode) // included on 22.3.2
     {
      float maxval=-999999.0,minval=999999.0;
      int i,j,k;
      float sqr_sum=0,sum=0,temp,total_wt=0;
   
       float **wt;
       int wt_h=mwt.get_h(), wt_w=mwt.get_w();

       if((wt_h != height) && (wt_w!=width))
       {
          cout<<"DIMENSIONS of WEIGHTING MASK are IMPROPER !! \n";
          return maxval;
       }

        wt=mwt.get_mask();
        

      switch(mode){
      case AVG_MODE: 
                      for(i=0;i<height;i++)
                      for(j=0;j<width;j++)
                          {
                          sum+=mask[i][j]*wt[i][j];
                          total_wt+=wt[i][j];
                          }
                    if(total_wt<0)
                        {
                       cout<<"WARNING!! NON_POSITIVE TOTAL WEIGHT \n";
                         }
                    return(sum/total_wt);
      case MEDIAN_MODE:
                      float *val,*wt_val;

                       val=new float[height*width];
                       wt_val=new float[height*width];
                         if((val==NULL) || (wt_val==NULL)) {
                          cout<<"Temporary arrays for weighted median computation not allocated \n";
                          return maxval;
                         }
                        for(i=0,k=0;i<height;i++)
                         for(j=0;j<width;j++)
                               {
                               val[k]=mask[i][j];
                               wt_val[k]=wt[i][j];
                               total_wt+=wt[i][j];
                               k++;
                               }

                       for(i=0;i<(height*width);i++){
                       for(j=i+1;j<(height*width);j++)
                        if(val[i]>val[j]){ // Ascending order
                        temp=val[i];
                        val[i]=val[j];
                        val[j]=temp;

                        temp=wt_val[i];
                        wt_val[i]=wt_val[j];
                        wt_val[j]=temp;
                        }
                       }
                         /*
                       for(i=0;i<(height*width);i++){
                        cout<<val[i]<<" "<<wt_val[i]<<"\n";
                       }
                        */
                     
               
                       // Compute cumulative weight
                        i=0;
                       if(wt_val[0]>(total_wt/2)) temp= val[0];
                        else
                         do{
                             i++;
                             wt_val[i]+=wt_val[i-1];
                            } while(wt_val[i]<(total_wt/2));

                       temp=val[i];

                         /*
                       cout<<"i="<<i<<" val="<<val[i]<<"\n";

                       {
                         char c;
                         cin>>c;
                       }
                        */

                       delete val;
                       delete wt_val;
                       return(temp);
      case SD_MODE:
                  float sqr_avg,avg;
                  float size;
                  float variance;

                      for(i=0;i<height;i++)
                      for(j=0;j<width;j++)
                          {
                          sum+=mask[i][j]*wt[i][j];
                          sqr_sum+=sqr(mask[i][j])*wt[i][j];
                          total_wt+=wt[i][j];
                          }
                    if(total_wt<0)
                        {
                       cout<<"WARNING!! NON_POSITIVE TOTAL WEIGHT \n";
                         }

                  avg=sum/total_wt;
                  sqr_avg=sqr_sum/total_wt;
                  variance=sqr_avg-sqr(avg);
                  if (variance<0)
                  {
                  // cout<<"size="<<size<<" sum="<<sum<<" avg="<<avg<<" sqr_sum="<<sqr_sum<<" sqr_avg="<<sqr_avg<<" variance="<<variance<<"\n";
                    cout<<"WARNING! Limitations of floating point computation makes the variance as negative, hence forcing it to zero !! \n";
                   variance=0;
                  }
                  if(variance==0) return 0;
                  return((float)sqrt((double)variance));

   default: 
      cout<<"NO NEIGBOURHOOD OPERATION PERFORMED. ZERO ASSIGNED !!! \n";
                return(0);
      }
     }

     float correlate(_MASK ob)
     {
      float sum=0;
      int i,j;
      float avg1,avg2,sd1,sd2,avg_prod;
      float size;

      if((ob.height!=height)||(ob.width!=width)){
       cout<<"correlate: Dimension not matching \n";
       return(0);
       }
       avg1=N_compute(AVG_MODE);
       avg2=ob.N_compute(AVG_MODE);
       sd1=N_compute(SD_MODE);
       sd2=ob.N_compute(SD_MODE);

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        sum+=pixel(i,j)*ob.pixel(i,j);

        size=height*width;
        avg_prod=sum/size;
        if((sd1==0)||(sd2==0)) return(1.0);
        return((avg_prod-avg1*avg2)/(sd1*sd2));

     }

     float avg_product(_MASK ob)
     {
      float sum=0;
      int i,j;
      float size;

      if((ob.height!=height)||(ob.width!=width)){
       cout<<"correlate: Dimension not matching \n";
       return(0);
       }
        size=(float)height*(float)width;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        sum+=pixel(i,j)*ob.pixel(i,j);

        return(sum/size);
     }

     float RMS_Error(_MASK ob,float a=1.0,float b=0)// Error after applying -- 23.11.2000
                                                     //linear transformation
     {
      float sum=0;
      int i,j;
      float size;

      if((ob.height!=height)||(ob.width!=width)){
       cout<<"RMS_Error: Dimension not matching \n";
       return(0);
       }
        size=(float)height*(float)width;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        sum+=sqr(pixel(i,j)-(a*ob.pixel(i,j)+b));
        if(sum<=0) return 0;

        return((float)sqrt((double)sum/(double)size));
     }

    _MASK copy()
     {
     _MASK temp(width,height);
      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[i][j];
       return(temp);
     }

    void copy(_MASK temp)
     {
      if((temp.width!=width) && (temp.height!=height))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[i][j];
       return;
     }

    _MASK rotate_90()
     {
     _MASK temp(height,width);
      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[j][width-1-i];
       return(temp);
     }

     _MASK rotate_180()
     {
     _MASK temp(width,height);
      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=mask[height-1-i][width-1-j];
       return(temp);
     }

     _MASK rotate_270()
     {
     _MASK temp(height,width);
      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[height-j-1][i];
       return(temp);
     }

    _MASK reflect_x()
     {
     _MASK temp(width,height);
      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=mask[height-1-i][j];
       return(temp);
     }

     _MASK reflect_y()
     {
     _MASK temp(width,height);
      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=mask[i][width-1-j];
       return(temp);
     }

    _MASK reflect_diagonal()
     {
     _MASK temp(height,width);
      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[height-1-j][width-1-i];
       return(temp);
     }

     _MASK reflect_antidiagonal()
     {
     _MASK temp(height,width);
      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[j][i];
       return(temp);
     }

     _MASK affine(float a,float b)
      {
     _MASK temp(width,height);
      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=a+b*mask[i][j];
       return(temp);
      }

    _MASK shrink(float factor) // factor should be greater than 1
    {
     _MASK temp((int)(width/factor),(int)(height/factor));
      int i,j;

       for(i=0;i<(int)(height/factor);i++)
       for(j=0;j<(int)(width/factor);j++)
        temp.mask[i][j]=mask[(int)(i*factor)][(int)(j*factor)];
       return(temp);
    }

    void rotate_90(_MASK temp)
     {
      if((temp.width!=height) || (temp.height!=width))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[j][width-1-i];
       return;
     }

    void reflect_x(_MASK temp)
     {
      if((temp.width!=width) || (temp.height!=height))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=mask[height-1-i][j];
       return;
     }

    void reflect_diagonal(_MASK temp)
     {
      if((temp.width!=height) || (temp.height!=width))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[height-1-j][width-1-i];
       return;
     }

     void rotate_180(_MASK temp)
     {
      if((temp.width!=width) || (temp.height!=height))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=mask[height-1-i][width-1-j];
       return;
     }

     void reflect_y(_MASK temp)
     {
      if((temp.width!=width) || (temp.height!=height))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=mask[i][width-1-j];
       return;
     }

     void reflect_antidiagonal(_MASK temp)
     {
      if((temp.width!=height) || (temp.height!=width))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[j][i];
       return;
     }

     void rotate_270(_MASK temp)
     {
      if((temp.width!=height) || (temp.height!=width))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<width;i++)
       for(j=0;j<height;j++)
        temp.mask[i][j]=mask[height-j-1][i];
       return;
     }

     void affine(_MASK temp,float a,float b)
      {
      if((temp.width!=width) || (temp.height!=height))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<height;i++)
       for(j=0;j<width;j++)
        temp.mask[i][j]=a*mask[i][j]+b;
       return;
      }

    void shrink(_MASK temp,float factor) // factor should be greater than 1
    {
      if((temp.width!=(int)(width/factor)) || (temp.height!=(int)(height/factor)))
        {
           cout<<"WARNING! Mask could not be copied as dimensions do not match \n"<<flush;
        return;
        }

      int i,j;

       for(i=0;i<(int)(height/factor);i++)
       for(j=0;j<(int)(width/factor);j++)
        temp.mask[i][j]=mask[(int)(i*factor)][(int)(j*factor)];
       return;
    }

};

