
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
// Class description of polygon
struct _VERTEX {
               _PNT v;
             struct _VERTEX *next,*prev;
               };

typedef struct {
        _PNT ps;
        _PNT pd;
         } _EDGE;

typedef struct {
        _PNT pLb; //Leftmost and Bottommost point
        _PNT pRu; //Rightmost and Uppermost point
        } _RECT;

typedef struct _VERTEX *_VLIST;

void sort_points_by_X(_PNT *v,int num);
void sort_points_by_Y(_PNT *v,int num);
_PNT intersect_X(_EDGE e,float y);
_PNT intersect_Y(_EDGE e,float x);

void sort_points_by_X(_PNT *v,int num)
     {
       int i,j;
       float xmin=999999.0;
       _PNT temp;

       /*
       for(i=0;i<num;i++)
        v[i].print2D();
        cout<<"\n"<<flush;
       */

       for(i=0;i<num-1;i++)
       {
       xmin=v[i].get_x();
       for(j=i;j<num;j++)
       {
             if(v[j].get_x()<xmin){
               temp=v[i];
               v[i]=v[j];
               v[j]=temp;
             }
       }
       }
     }


void sort_points_by_Y(_PNT *v,int num)
     {
       int i,j;
       float ymin=999999.0;
       _PNT temp;

       for(i=0;i<num-1;i++)
       {
       ymin=v[i].get_y();
       for(j=i;j<num;j++)
       {
             if(v[j].get_y()<ymin){
               temp=v[i];
               v[i]=v[j];
               v[j]=temp;
             }
       }
       }
     }

_PNT intersect_X(_EDGE e,float y)
     {
      _PNT tmp(-9999.0,-9999.0);
       float ymin,ymax,x,temp;
       
       ymin=e.ps.get_y();
       ymax=e.pd.get_y();
       if(ymin>ymax) {temp=ymin; ymin=ymax; ymax=temp;}
       if((y<ymin)||(y>ymax))
        return(tmp); // No intersection
       if(ymin==ymax) {
               tmp.set(-9999.0,y); // e is an horizontal edge
               return(tmp);
               }
       x=e.ps.get_x()+(y-e.ps.get_y())* (e.pd.get_x()-e.ps.get_x())/(e.pd.get_y()-e.ps.get_y());
       tmp.set(x,y);
       return(tmp);
     }


_PNT intersect_Y(_EDGE e,float x)
     {
      _PNT tmp(-9999.0,-9999.0);
       float xmin,xmax,y,temp;
       
       xmin=e.ps.get_x();
       xmax=e.pd.get_x();
       if(xmin>xmax) {temp=xmin; xmin=xmax; xmax=temp;}
       if((x<xmin)||(x>xmax))
        return(tmp); // No intersection
       if(xmin==xmax) {
               tmp.set(x,-9999.0); // e is an vertical edge
               return(tmp);
               }
       y=e.ps.get_y()+(x-e.ps.get_x())* (e.pd.get_y()-e.ps.get_y())/(e.pd.get_x()-e.ps.get_x());
       tmp.set(x,y);
       return(tmp);
     }

class _POLYGON {
               int clock;
               int  no_vx;
               int dimension;
              _VLIST head;
              _VLIST cur_vx;
              _VLIST traverse;
               int EOT; // Status for end of traversal

          float Area_of_Triangle(float a,float b,float c);

          public:
                 _POLYGON(){clock=1; head=cur_vx=NULL;no_vx=0; dimension=2; EOT=0;}
                ~_POLYGON(){};

         void  Add_vertex(_PNT v);
         void  Delete_vertex();
         void  Free_Polygon();
         void  Form_Polygon(_PNT *v, int N);
         void  Begin_traversal(){traverse=head; EOT=0;}
          int  End_of_traversal(){return EOT;}
         _PNT  Get_Next_Vertex();
         int   Get_Pnt_Array(_PNT *v);
      //   int   Edge_Intersect(_EDGE e, _PNT *v);
         int   Hor_Edge_Intersect(float y, _PNT *v);
         int   Vert_Edge_Intersect(float x, _PNT *v);
      // _POLYGON Convex_hull();
       _RECT  Min_Rect_Bound();
        void  print();
        int   get_no_vertex(){return(no_vx);}
        void  Remove_Hor_Edges();

  //Added from MS
         float Compute_Area();
         _PNT  Compute_Centre();
         float Compute_Area_By_Triangle();
         _POLYGON  BSpline_Smooth();
         _POLYGON  Discretize(int interval=2);
         };

void    _POLYGON::Add_vertex(_PNT v)
       {
        if(no_vx){
            cur_vx->next= new _VERTEX;
            cur_vx->next->v=v;
            cur_vx->next->next=head;
            cur_vx->next->prev=cur_vx;
            cur_vx=cur_vx->next;
            head->prev=cur_vx;
            no_vx++;
           }
        else {
           head=new _VERTEX;
           head->v=v;
           head->next=head;
           head->prev=head;
           cur_vx=head;
           traverse=head;
           EOT=0;
           no_vx++;
        }
      }

void  _POLYGON::Delete_vertex()
     {
      _VLIST temp;
       if(no_vx>1){
       temp=cur_vx;
       cur_vx=cur_vx->prev;
       cur_vx->next=head;
       head->prev=cur_vx;
       no_vx--;
       delete temp;
       }
       else if(no_vx==1){
       delete head;
       head=cur_vx=NULL;
       no_vx--;
       }
       else 
        cout<<" POLYGON IS EMPTY \n";
     }

_PNT  _POLYGON::Get_Next_Vertex()
      {
       _PNT v(-99999.0,-99999.0);
        if(traverse){
        v=traverse->v;
        traverse=traverse->next;
        if(traverse==head) EOT=1;
       }
       return(v);
      }

void  _POLYGON::Free_Polygon()
      {
       _VLIST frtemp,temp=head;
        while(temp!=cur_vx) {frtemp=temp; temp=temp->next; delete frtemp;}
        delete temp;
        head=cur_vx=NULL;
	no_vx=0;
	EOT=0;
      }

void  _POLYGON::Form_Polygon(_PNT *v, int N)
     {
      int i;
      
      if(head) Free_Polygon();
      for(i=0;i<N;i++)
	{
	 //cout<<"Adding "<<i<<"th vertex \n";
         Add_vertex(v[i]);
	 }
     }

int  _POLYGON:: Get_Pnt_Array(_PNT *v)
     {
       int i=0;

       Begin_traversal();
       while(!EOT) v[i++]=Get_Next_Vertex();
       return(i);
     }

_RECT _POLYGON::Min_Rect_Bound()
     {
      _RECT temp;
       _PNT v;
       float xmin,ymin,xmax,ymax;

       Begin_traversal();
       v=Get_Next_Vertex();
       xmin=xmax=v.get_x();
       ymin=ymax=v.get_y();
       while(!EOT)
       {
       v=Get_Next_Vertex();
       if(xmin>v.get_x()) xmin=v.get_x();
       if(xmax<v.get_x()) xmax=v.get_x();
       if(ymin>v.get_y()) ymin=v.get_y();
       if(ymax<v.get_y()) ymax=v.get_y();
       }

       temp.pLb.set(xmin,ymin);
       temp.pRu.set(xmax,ymax);
       return(temp);
     }

int   _POLYGON::Hor_Edge_Intersect(float y, _PNT *v)
     {
       _EDGE e;
       _PNT  pt;
        int i=0;
        int yprev,ynext;

       Begin_traversal();
       while(!EOT)
       {
       e.ps=Get_Next_Vertex();
       e.pd=traverse->v;
       /*
       cout<<"ps="; e.ps.print2D();
       cout<<"pd="; e.pd.print2D();
       */
       pt=intersect_X(e,y);
       /*
       cout<<"Intersecting point:"; pt.print2D();
       cout<<"\n"<<flush;
       */
       if(pt.get_y()>-9999.0)
       {
        if(pt.get_x()>-9999.0){
          if(((int) pt.get_x()==(int) e.ps.get_x())
            &&((int) pt.get_y()==(int) e.ps.get_y()))
          {
          yprev=(int)(traverse->prev->prev->v.get_y());
          ynext=(int)(traverse->v.get_y());
            if(((y>yprev) && (y>ynext)) || ((y<yprev) && (y<ynext)))
            {
            v[i]=pt; i++; v[i]=pt; i++;
            }
            else {
            v[i]=pt; i++;
            }
          }
         else
          if(((int) pt.get_x()!=(int) e.pd.get_x())
            ||((int) pt.get_y()!=(int) e.pd.get_y()))
            {
            v[i]=pt; i++;
            }
        } // if actual intersection found
        else {
        v[i]=e.ps; i++;
        }
      }

     }// while

     sort_points_by_X(v,i);
     return(i);
  }


int   _POLYGON::Vert_Edge_Intersect(float x, _PNT *v)
     {
       _EDGE e;
       _PNT  pt;
        int i=0;
        int xprev,xnext;

       Begin_traversal();
       while(!EOT)
       {
       e.ps=Get_Next_Vertex();
       e.pd=traverse->v;
       /*
       cout<<"ps="; e.ps.print2D();
       cout<<"pd="; e.pd.print2D();
       */
       pt=intersect_X(e,x);
       /*
       cout<<"Intersecting point:"; pt.print2D();
       cout<<"\n"<<flush;
       */
       if(pt.get_x()>-9999.0)
       {
        if(pt.get_y()>-9999.0){
          if(((int) pt.get_x()==(int) e.ps.get_x())
            &&((int) pt.get_y()==(int) e.ps.get_y()))
          {
          xprev=(int)(traverse->prev->prev->v.get_x());
          xnext=(int)(traverse->v.get_x());
            if(((x>xprev) && (x>xnext)) || ((x<xprev) && (x<xnext)))
            {
            v[i]=pt; i++; v[i]=pt; i++;
            }
            else {
            v[i]=pt; i++;
            }
          }
         else
          if(((int) pt.get_x()!=(int) e.pd.get_x())
            ||((int) pt.get_y()!=(int) e.pd.get_y()))
            {
            v[i]=pt; i++;
            }
        } // if actual intersection found
        else {
        v[i]=e.ps; i++;
        }
      }

     }// while

     sort_points_by_Y(v,i);
     return(i);
  }


void  _POLYGON::print()
  {
  _PNT v;

  Begin_traversal();
  while(!EOT)
  {
  v=Get_Next_Vertex();
  cout<<"("<<v.get_x()<<","<<v.get_y()<<") ";
  }
  cout<<"\n"<<flush;
  }

void  _POLYGON::Remove_Hor_Edges()
    {
     _PNT v;
     _VLIST tmp;
     float x,y;

      Begin_traversal();
      while(!EOT)
      {
       v=Get_Next_Vertex();
             if((int)v.get_y()==(int)traverse->v.get_y())
             {
              if((int)traverse->v.get_y()>(int)traverse->next->v.get_y())
              {
               x=traverse->v.get_x();
               y=traverse->v.get_y()+1;
               traverse->v.set(x,y);
              }
              else if((int)traverse->v.get_y()==(int)traverse->next->v.get_y())
                   {
                    tmp=traverse;
                    traverse->next->prev=traverse->prev;
                    traverse->prev->next=traverse->next;
                    if(!EOT)
                    traverse=traverse->prev; // Backtracking
                    delete tmp;
                   }
              else {
               x=traverse->v.get_x();
               y=traverse->v.get_y()-1;
               traverse->v.set(x,y);
              }
             }
      }// while
      cur_vx=head->prev;
    }

    // Added from MS

float _POLYGON::Compute_Area()
{
	 _RECT mrect;
	 int xmin,xmax,ymin,ymax;
	 int i,y,no_vx;
	 _PNT  intersect_vx[200];
	 float area=0;


	 Remove_Hor_Edges();
		 // cout<<"Horizontal edges removed \n";
          mrect=Min_Rect_Bound();
          xmin=(int)(mrect.pLb.get_x());
          xmax=(int)(mrect.pRu.get_x());
          ymin=(int)(mrect.pLb.get_y());
          ymax=(int)(mrect.pRu.get_y());

		 // cout<<"Minimum Rectangle tracked \n";

           for(y=ymin;y<=ymax;y++)
           {
           no_vx=Hor_Edge_Intersect((float)y,intersect_vx);
              if(no_vx>199)
			  {
			   
			  cout<<"Error in polygon filling \n";
			      return -1;
			  }
              for(i=0;i<no_vx-1;i++)
              {
                  if(i%2==0)
				  {
                area+=(float)(intersect_vx[i+1].get_x()-intersect_vx[i].get_x());
             
               }
              }
           }
	return area;
}

_PNT  _POLYGON::Compute_Centre()
{
	_PNT v;
    double sx=0,sy=0;

      Begin_traversal();
      while(!EOT)
      {
       v=Get_Next_Vertex();
	   sx+=v.x;
	   sy+=v.y;
	  }
	  v.x=sx/(double)no_vx;
	  v.y=sy/(double)no_vx;

	  return v;
}

float  _POLYGON::Area_of_Triangle(float a,float b,float c)
{
	float s;

	s=(a+b+c)/2;
	s=s*(s-a)*(s-b)*(s-c);

	if(s>0) return (float)sqrt((double)s);
	else    return 0;

}


float _POLYGON::Compute_Area_By_Triangle()
{
	_PNT centre=Compute_Centre();
	_PNT v1,v2,startVertex;
	float area=0;

	Begin_traversal();
	startVertex=Get_Next_Vertex();
	v1=startVertex;
      while(!EOT)
      {
       v2=Get_Next_Vertex();
	   area+=Area_of_Triangle((float)centre.distance(v1),(float)centre.distance(v2),(float)v1.distance(v2));
	  }
	  v1=startVertex;
	  area+=Area_of_Triangle((float)centre.distance(v1),(float)centre.distance(v2),(float)v1.distance(v2));

     return area;
}

_POLYGON   _POLYGON::BSpline_Smooth()
{
		_PNT last,first,second,third;
		_PNT p0,p1,p2,p3;
		_PNT v;
		_POLYGON  tmp;
		

		if(no_vx<4)
		{
			Begin_traversal();
            while(!EOT)
			{
               v=Get_Next_Vertex();
			   tmp.Add_vertex(v);
			   return tmp;
			   
			}
		}

     Begin_traversal();
      while(!EOT)
      {
       v=Get_Next_Vertex();
	  }
     	last =v;

/* for the first point the last point is the predecessor. */

/* for every four points :

	6 P(0)   = P(i-1) + 4*P(i) + P(i+1)
	6 P(1/3) = 8/27 P(i-1) + 31/9 P(i) +  20/9 P(i+1) + 1/27 P(i+2)
	6 P(2/3) = 1/27 P(i-1) + 20/9 P(i) +  31/9 P(i+1) + 8/27 P(i+2)
	6 P(1)   = P(i) + 4 P(i+1) + P(i+2)
*/
	p0  = last;	
	Begin_traversal();
	 p1=Get_Next_Vertex();
	 first=p1;
	 p2=Get_Next_Vertex();
	 second=p2;
	 p3=Get_Next_Vertex();
	 third=p3;
      while(!EOT)
      {
		v.x = (p0.x + 4*p1.x + p2.x)/6;
 		v.y = (p0.y + 4*p1.y + p2.y)/6;
		tmp.Add_vertex(v);

		v.x = (8*p0.x + 93*p1.x + 60*p2.x + p3.x)/162;
 		v.y = (8*p0.y + 93*p1.y + 60*p2.y + p3.y)/162;
		tmp.Add_vertex(v);

		v.x = (p0.x + 60*p1.x + 93*p2.x + 8*p3.x)/162;
 		v.y = (p0.y + 60*p1.y + 93*p2.y + 8*p3.y)/162;
		tmp.Add_vertex(v);

		p0=p1;
		p1=p2;
		p2=p3;
        p3=Get_Next_Vertex();

	  }

	  p0=p1; p1=p2; p2=p3; p3=first;
	    v.x = (p0.x + 4*p1.x + p2.x)/6;
 		v.y = (p0.y + 4*p1.y + p2.y)/6;
		tmp.Add_vertex(v);

		v.x = (8*p0.x + 93*p1.x + 60*p2.x + p3.x)/162;
 		v.y = (8*p0.y + 93*p1.y + 60*p2.y + p3.y)/162;
		tmp.Add_vertex(v);

		v.x = (p0.x + 60*p1.x + 93*p2.x + 8*p3.x)/162;
 		v.y = (p0.y + 60*p1.y + 93*p2.y + 8*p3.y)/162;
		tmp.Add_vertex(v);

		p0=p1; p1=p2; p2=p3; p3=second;
		v.x = (p0.x + 4*p1.x + p2.x)/6;
 		v.y = (p0.y + 4*p1.y + p2.y)/6;
		tmp.Add_vertex(v);

		v.x = (8*p0.x + 93*p1.x + 60*p2.x + p3.x)/162;
 		v.y = (8*p0.y + 93*p1.y + 60*p2.y + p3.y)/162;
		tmp.Add_vertex(v);

		v.x = (p0.x + 60*p1.x + 93*p2.x + 8*p3.x)/162;
 		v.y = (p0.y + 60*p1.y + 93*p2.y + 8*p3.y)/162;
		tmp.Add_vertex(v);

	
	return tmp;

}

_POLYGON   _POLYGON::Discretize(int interval)
{
		_POLYGON  tmp;
		_PNT last,first;
		_PNT p1,p2;
		_PNT v;
		int x1,y1,x2,y2;
                int x,y;
	        int s1,s2;
                int interchange;
                int err;
	        int temp;
	        int i,detx,dety;

     Begin_traversal();
      while(!EOT)
      {
       v=Get_Next_Vertex();
	  }
     	last =v;

/* for the first point the last point is the predecessor. */
	Begin_traversal();
	 p1=Get_Next_Vertex();
	 first=p1;
	 p2=Get_Next_Vertex();

   while(!EOT)
   {
       tmp.Add_vertex(p1);
       x1=(int)p1.x;
       y1=(int)p1.y;
       x2=(int)p2.x;
       y2=(int)p2.y;

	x=x1;
	y=y1;
	detx=abs((x2-x1));
	dety=abs((y2-y1));
	s1=sign((x2-x1));
	s2=sign((y2-y1));
	if(dety>detx)
	{temp=detx;
	 detx=dety;
	 dety=temp;
	 interchange=1;
	 }
	 else interchange=0;
	 err=2*dety-detx;

	 for(i=0;i<detx;i++)
	 {
		v.x=(float)x;
		v.y=(float)y;

		if(i%interval==0)
		tmp.Add_vertex(v);

		if (err>=0)
		{if(interchange==1)
		x+=s1;
		else y+=s2;
		err-=(2*detx);
		}
		else {
		if(interchange==1)
		y+=s2;
		else x+=s1;
		err+=(2*dety);
				 }
		}
	 // cout<<"Profile computed \n";


		p1=p2;
        p2=Get_Next_Vertex();
    }
		tmp.Add_vertex(last);
        
       x1=(int)last.x;
       y1=(int)last.y;
       x2=(int)first.x;
       y2=(int)first.y;

	x=x1;
	y=y1;
	detx=abs((x2-x1));
	dety=abs((y2-y1));
	s1=sign((x2-x1));
	s2=sign((y2-y1));
	if(dety>detx)
	{temp=detx;
	 detx=dety;
	 dety=temp;
	 interchange=1;
	 }
	 else interchange=0;
	 err=2*dety-detx;

	 for(i=0;i<detx-1;i++)
	 {
		v.x=(float)x;
		v.y=(float)y;

		if(i%interval==0)
		tmp.Add_vertex(v);

		if (err>=0)
		{if(interchange==1)
		x+=s1;
		else y+=s2;
		err-=(2*detx);
		}
		else {
		if(interchange==1)
		y+=s2;
		else x+=s1;
		err+=(2*dety);
				 }
		}
	 // cout<<"Profile computed \n";

	 return tmp;
}

