
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
// The segment class


class _SEGMENT{
       int seg_id;
       int area;
       _PNT center;
       _PNT *pset;
       _PNT *bset;
       int bcount;
       char *descr;
       float inv_moment[7];

        void swap(_PNT *vertex,int i,int j)
             {
               _PNT temp;
 
                   temp=vertex[j];
                   vertex[j]=vertex[i];
                   vertex[i]=temp;
              }  /* {of swap } */


                  int  fnd_line_end(_PNT *vertex,int b,int e,float dist_thresh,float edge_thresh)
                  {
                  int i,j,k,count;
                  float dist,denom,factor;
                  float xl,ym;

                    count=0;
                    xl=vertex[e].get_x()-vertex[b].get_x(); 
                    ym=vertex[e].get_y()-vertex[b].get_y(); 
                    //if ((l==0) && (m==0)) printf("\n ERROR");
                    for (i=(b+1);i<= (e-1);i++)
                     {
                      dist= fabs(ym*vertex[i].get_x()-xl*vertex[i].get_y()+xl*vertex[b].get_y()-ym*vertex[b].get_x());
                      denom= (float)sqrt((double)(xl*xl+ym*ym));
                      dist=dist/denom;
                      if (dist>dist_thresh) count++;
                     }
                     factor=count/(e-b);
                     if (factor<edge_thresh)  return 1;
                                  return 0;

                  }

      public:
            _SEGMENT(int id=0){seg_id=id; area=bcount=0; pset=bset=NULL; descr=NULL;center.set(0,0);}
       void set(int id,_PNT *inter,_PNT *bnd,int pcnt,int bcnt){
           seg_id=id; area=pcnt;bcount=bcnt;pset=inter;bnd=bset;}
       void write_comment(char *comment){descr=comment;}
       int get_area(){return(area);}
       int get_bcount(){return(bcount);}
       int get_id(){return(seg_id);}
       _PNT  *get_pset(){return(pset);}
       _PNT  *get_bset(){return(bset);}
       char  *get_comment(){return(descr);}
       _PNT  get_center(){return(center);}

/*
       _VECTOR get_fv(int num);
       float   get_moment(int m,int n);
       float   get_normalised_moment(int m,int n);
*/


   float central_moment(_GREY im,int p,int q) // added by Anurag (JM 19/6/09) 
   {
	float x_mean,y_mean;
	float moment=0,pix_intensity[MAX_PT];
	int x[MAX_PT],y[MAX_PT];
	float sum_x=0,sum_y=0,sum_intensity=0;
	int i;

   if(area>MAX_PT)
   {
	cout<<"Area too big"<<endl;
	return 0;
   }
	for(i=0;i<area;i++)
	{
		x[i]=(int)pset[i].get_x();
		y[i]=(int)pset[i].get_y();
		pix_intensity[i]=(float)im.pixel(x[i],y[i]);
		
		sum_x+=x[i]*pix_intensity[i];
		sum_y+=y[i]*pix_intensity[i];
		sum_intensity+=pix_intensity[i];
		
	}

	x_mean=sum_x/sum_intensity;
	y_mean=sum_y/sum_intensity;
  	
	cout<<"sum_x="<<sum_x<<"  sum_y="<<sum_y<<" in="<<sum_intensity<<endl;
	cout<<"x_mean="<<x_mean<<"  y_mean="<<y_mean<<endl;

	for(i=0;i<area;i++)
	{
		moment+=float(pow(double(x[i]-x_mean),double(p))*(pow(double(y[i]-y_mean),double(q))))*pix_intensity[i];
	
	}

	return moment;
    }	


  void cal_inv_moments(_GREY im) //added by Anurag
  {
	float ncm[4][4];	//normalized central moments	
 	int p,q;	
	int i;

	for(p=0;p<4;p++)
	   for(q=0;q<4;q++)
	   {
		ncm[p][q]=central_moment(im,p,q)/pow(double(central_moment(im,0,0)),double((p+q)/2+1));
	   }

	
	inv_moment[0]=ncm[2][0]+ncm[0][2];
	
	inv_moment[1]=(ncm[2][0]-ncm[0][2])*(ncm[2][0]+ncm[0][2]) + 4*ncm[1][1]*ncm[1][1];
	
	inv_moment[2]=(ncm[3][0]-3*ncm[1][2])*(ncm[3][0]-3*ncm[1][2]) + (3*ncm[2][1]-ncm[0][3])*(3*ncm[2][1]-ncm[0][3]);
	
	inv_moment[3]=(ncm[3][0]+ncm[1][2])*(ncm[3][0]+ncm[1][2]) + (ncm[2][1]+ncm[0][3])*(ncm[2][1]+ncm[0][3]);

	inv_moment[4]=(ncm[3][0]-3*ncm[1][2])*(ncm[3][0] + ncm[1][2])*((ncm[3][0]+ncm[1][2])*(ncm[3][0]+ncm[1][2]) - 3*(ncm[2][1]+ncm[0][3])*(ncm[2][1]+ncm[0][3])) + (3*ncm[2][1]-ncm[0][3])*(ncm[2][1]+ncm[0][3])*(3*(ncm[3][0]+ncm[1][2])*(ncm[3][0]+ncm[1][2])-(ncm[2][1]+ncm[0][3])*(ncm[2][1]+ncm[0][3]));

	inv_moment[5]=(ncm[2][0]-ncm[0][2])*((ncm[3][0]+ncm[1][2])*(ncm[3][0]+ncm[1][2])-(ncm[2][1]+ncm[0][3])*(ncm[2][1]+ncm[0][3])) + 4*ncm[1][1]*(ncm[3][0]+ncm[1][2])*(ncm[2][1]+ncm[0][3]);

	inv_moment[6]=(3*ncm[2][1]-ncm[0][3])*(ncm[3][0]+ncm[1][2])*((ncm[3][0]+ncm[1][2])*(ncm[3][0]+ncm[1][2])-3*(ncm[2][1]+ncm[0][3])*(ncm[2][1]+ncm[0][3])) + (3*ncm[1][2]-ncm[3][0])*(ncm[2][1]+ncm[0][3])*(3*(ncm[3][0]+ncm[1][2])*(ncm[3][0]+ncm[1][2])-(ncm[2][1]+ncm[0][3])*(ncm[2][1]+ncm[0][3]));


	for(i=0;i<7;i++)
		cout<<"inv_moment["<<i<<"]="<<inv_moment[i]<<endl;


  }



 float* get_inv_moments()
 {
	return  inv_moment;
 }



       
       void  make_segment(_GREY im,int id,int mode=0) //mode==0 --> NO INTERIOR
                {int i,j,l,m;

                  _PNT inter[MAX_PT];
                  _PNT bnd[MAX_PT];
                   int bfound=0;
                   int xsum=0,ysum=0;
                   float xc,yc;

                  cout<<"Forming segment "<<id<<"\n"<<flush;
                  seg_id=id;
                  for(i=0;i<im.get_h();i++)
                  for(j=0;j<im.get_w();j++)
                  {
                   if((int)im.pixel(i,j)==id){
                   if(mode>0)
                   inter[area].set((float)i,(float)j);
                   area++;
                  
                   if(mode>0)
                   if(area>MAX_PT){
                   cout<<"WARNING:Area is too big! \n";
                   return;
                   }

                   bfound=0;
                   for(l=-1;l<=1;l++)
                   for(m=-1;m<=1;m++)
                   {
                   if((int)im.pixel(i+l,j+m)!=id){
                   bnd[bcount].set((float)i,(float)j);
                   bfound=1;
                   xsum+=i;
                   ysum+=j;
                   bcount++;
                   }
                   if(bfound) break;
                   }
                   }
                  }

                  cout<<"Boundaries and Area (if asked) Formed \n"<<flush;
            
                  if(mode>0)
                  {
                  pset=new _PNT[area];
                  if(pset==NULL) cout<<"Interior point set not allocated \n"<<flush;
                  for(i=0;i<area;i++) pset[i]=inter[i];
                  }

                  bset=new _PNT[bcount];
                  if(bset==NULL) cout<<"Boundary point set not allocated \n"<<flush;
                  for(i=0;i<bcount;i++) bset[i]=bnd[i];
                  xc=(float)xsum/(float)bcount;
                  yc=(float)ysum/(float)bcount;
                  center.set(xc,yc);
                }


              _PNT *graham_poly(int& pcount,float cos_ang_factor=0.8,float rad_factor=0.9)
              {
               int i,j,k,l,m,n;
               _PNT *polar;
                float sum_rad=0,avg_rad;
                float tht_i,tht_j;
                _PNT vtc,vtnp;// vect_to_center and vect_to_nxt_pnt
             
                 if(bcount<1) return(NULL);
                 polar= new _PNT[bcount];
                 if(polar==NULL) cout<<"Memory not allocated for Graham Polygonisation \n"<<flush;
                    //printf("\n xint= %d yint = %d ",xint,yint);
                    for (i=0;i<bcount;i++)
                     {
                     polar[i]=bset[i].cart_to_polar_2D(center);
                     sum_rad+=polar[i].get_x();
                     }

                      avg_rad=sum_rad/(float)bcount;

                      pcount=0; 
                      k=0;//remembers last point to be considered
                      for (i=0;i<bcount;i++) 
                      {
                      for (j=i+1;j<bcount;j++) {
                            tht_i=polar[i].get_y();
                            tht_j=polar[j].get_y(); 
                            if (tht_i<tht_j) 
                               {
                                swap(bset,i,j);
                                swap(polar,i,j);
                               }

                           else if (tht_i==tht_j)
                                     if (polar[i].get_x()<polar[j].get_x()) 
                                     {
                                      swap(bset,i,j);
                                      swap(polar,i,j);
                                      //polar[j].set(0,tht_j);
                                     }
                         }
                         if(i>0){
                         vtc=(bset[k]-center).unit_vect();
                         vtnp=(bset[k]-bset[i]).unit_vect();
                         //vtc=(bset[i]-center).unit_vect();
                         //vtnp=(bset[i-1]-bset[i]).unit_vect();

                         if(((vtc*vtnp)>cos_ang_factor)||(polar[i].get_x()<rad_factor*avg_rad))
                              polar[i].set(-1.0,0);
                          else {pcount++;
                                k=i;//the point is included in the list
                               }
                         }
                         }
                         pcount++;



                        /*
                        {char ch;
                        cout<<"POints are sorted \n";
                        cin>>ch;}
                        */

                       _PNT *temp;
        
                        temp=new _PNT[pcount];
                 if(temp ==NULL) cout<<"Temp Memory not allocated for Graham Polygonisation \n"<<flush;
                        pcount=0;

                        for(i=0;i<bcount;i++) 
                         if(polar[i].get_x()>0) temp[pcount++]=bset[i];

                         //if(polar[i].get_x()>factor*avg_rad) temp[pcount++]=bset[i];
                         delete polar;
                         return(temp);
          
                   } /* {of graham_poly} */


             _PNT *form_poly(int& ncorn,float gr_factor=0.5,float dist_thresh=1.5,float edge_thresh=1.5)
             {
             int i,j,k,lcorn,icorn;
             int    check;
             _PNT *xcorn;
             _PNT *vertex;
              int pcount;


                 vertex=graham_poly(pcount,gr_factor); 
                 if(vertex==NULL) return NULL;
                 xcorn=new _PNT[pcount];
                 if(xcorn ==NULL) cout<<"Memory for Corner Points not allocated for Graham Polygonisation \n"<<flush;
    
                 ncorn=0;
                 xcorn[ncorn].set(vertex[0].get_x(),vertex[0].get_y());
                 lcorn=0;
                 icorn=lcorn+5;
                  do {
                 if(fnd_line_end(vertex, lcorn, icorn,dist_thresh,edge_thresh))
                        icorn=icorn+1;
                           else 
                             {
                               lcorn=icorn-1;
                               ncorn=ncorn+1;
                              xcorn[ncorn].set(vertex[lcorn].get_x(),vertex[lcorn].get_y());
                               icorn=lcorn+5;
                             }
                      }
                 while (icorn>pcount);
                 delete vertex;
                 vertex=new _PNT[ncorn];
                 if(vertex==NULL) cout<<"Memory for vertices not allocated for Graham Polygonisation \n"<<flush;

                 for(i=0;i<ncorn;i++) vertex[i]=xcorn[i];
                 delete xcorn;

                 return(vertex);

              } /* end of form_poly */

       
};







// An useful function for general use

_SEGMENT *form_segments(_GREY im,int &num,int mode);

           _SEGMENT *form_segments(_GREY im,int &num, int mode=0)
            {
             _SEGMENT *temp;
             int i,j;
             char c;

             num=(int)( im.get_max());
             temp= new _SEGMENT[num];
             if(temp==NULL) cout<<"Segments are not allocated \n"<<flush;

             for(i=0;i<num;i++)
                 {
                 temp[i].make_segment(im,i+1,mode);
                 cout<<i<<"th Segment formed. \n"<<flush;
                 }

              return(temp);
            }

                  
  

