
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
 //implements the COLOR image class
class _COLOR{
       _GREY A,B,C;
        int col_space;
        int width,height;

        float u_from_xy(float x,float y){return(4*x/(-2*x+12*y+3));}
        float v_from_xy(float x,float y){return(6*y/(-2*x+12*y+3));}

        float Xr,Yr,Xg,Yg,Xb,Yb,Xw,Yw;
        float Ur,Vr,Ug,Vg,Ub,Vb,Uo,Vo;
        float xr,yr,xg,yg,xb,yb,xw,yw;


        void inverse(float a[][3],float b[][3]);
        void define_rx(float rx[][3]);//RGB to XYZ
        void define_xyz_ntsc(float rx[][3]);//to NTSC from XYZ
        void define_ntsc_xyz(float rx[][3]);//to XYZ from NTSC 
        void define_ntsc_uvw(float rx[][3]);//from NTSC
        void define_ntsc_yiq(float rx[][3]);//from NTSC
        void define_ntsc_rgb(float rx[][3]);
        void define_matu(float u[][3]);
        void define_matp(float p[][3]);
        void define_matri(float a[][3]);
        void define_matri_ohta(float a[][3]);
        void define_yuv_rgb(float a[][3]); // From YUV (or YCrCb to RGB) ..27.02.2001

        float arctan(float l,float m);
        float find_angle(float x,float y,float xw,float yw);
        void find_xy(float xw,float yw,float x1,float y1,float xe1,float ye1,float xe2,float ye2,float &px,float &py);
        void max_sat(float xw,float yw,float x1,float y1,float theta,float &px,float &py);
        void max_sat(float xw,float yw,float theta,float &px,float &py);

        float dist(float x1,float y1,float x2,float y2);
        float col_dist(int x1,int y1,int x2,int y2,int mode,float wr,float wg,float wb);
        float _g1(float dI,float K);

        void segnum(int **thinpat,int a,int b,int num,int &npnt,int wsize,float diff,int mode,float wr,float wg,float wb);
        void  segmentation(int **thinpat,int a,int b,int num,int &npnt,int wsize,float diff,int mode,float wr,float wg,float wb);
      void view_segment(int **thinpat,int num,int nums);
      void fine_smooth(int **thinpat,int num,int fth);
      float sigmoid(float x,float shift,float scale);





        public:

               _COLOR(int c_space=RGB){reset_primary();col_space=c_space; width=height=0;}
 
               _COLOR(int w,int h,int c_space=RGB,int val=0){reset_primary();A.set(w,h,val);B.set(w,h,val);C.set(w,h,val);width=w;height=h;}
               void set(int w,int h,int d_type=DCHAR,int c_space=RGB){A.set(w,h,0,d_type);B.set(w,h,0,d_type);C.set(w,h,0,d_type);
                                   col_space=c_space;width=w; height=h;}
               void load(char *fname,int w, int h,int c_space);
               void load(char *rf,char *gf,char *bf,int w,int h,int c_space=RGB)
                  {

                    A.load(rf,w,h);
                    B.load(gf,w,h);
                    C.load(bf,w,h);
                    col_space=c_space;
                  }
               void save(char *fname);
               void load(unsigned char **red,unsigned char **grn,unsigned char **blu,int w,int h,int c_space=RGB)
                     { A.set(red,w,h);B.set(grn,w,h);C.set(blu,w,h); width=w;height=h; col_space=c_space;}
               void load(_GREY X,_GREY Y,_GREY Z,int c_space=RGB)
                    {
                    if((X.get_h()==Y.get_h())&&(Y.get_h()==Z.get_h()))
                    {
                    if((X.get_w()==Y.get_w())&&(Y.get_w()==Z.get_w()))
                    {
                    A=X;B=Y;C=Z;col_space=c_space;width=X.get_w(); height=X.get_h();}
                    else cout<<"Dimensions not matched \n";
                    }
                    else cout<<"Dimensions not matched \n";
                    }

              void normalise(){
                  A.adjust_image();B.adjust_image();C.adjust_image();
                  float min_range,max_range;
                  float amin=A.get_min(),amax=A.get_max(),bmin=B.get_min(),bmax=B.get_max(),cmin=C.get_min(),cmax=C.get_max();

                  min_range=min(min(amin,bmin),min(bmin,cmin));
                  max_range=max(max(amax,bmax),max(bmax,cmax));
	          cout<<"minVal="<<min_range<<" maxVal="<<max_range<<"\n";

                  A.normalise_pic(min_range,max_range);B.normalise_pic(min_range,max_range);C.normalise_pic(min_range,max_range);}

              void truncate_pic() {
                  A.truncate_pic();
                  B.truncate_pic();
                  C.truncate_pic();
              }

              void truncate(float min_range=0,float max_range=255) {
                  A.truncate(min_range,max_range);
                  B.truncate(min_range,max_range);
                  C.truncate(min_range,max_range);
              }

	      void adjust_image(){
                  A.adjust_image();B.adjust_image();C.adjust_image();
	      }

	      void normalise(float minRange,float maxRange) //newly added 1999
		   {
                  A.adjust_image();B.adjust_image();C.adjust_image();
                  A.normalise_pic(minRange,maxRange);B.normalise_pic(minRange,maxRange);C.normalise_pic(minRange,maxRange);
		   }

              void free(){ A.free();B.free();C.free();width=height=0;}

        void load_ref_xy(){ xr=Xr;yr=Yr;xg=Xg;yg=Yg;xb=Xb;yb=Yb;xw=Xw;yw=Yw;}
        void load_ref_uv(){ xr=Ur;yr=Vr;xg=Ug;yg=Vg;xb=Ub;yb=Vb;xw=Uo=4.0/19.0;yw=Vo=6.0/19.0;}
	void setRefWhitePoint(float xW,float yW){xw=xW; yw=yW;} //Added on 28.06.2000

        void Wright_primary(){
                    Xr=0.7137;Yr=0.2863; Xg=0.2071;Yg=0.7663;Xb=0.1389;Yb=.0589;
                    Ur=u_from_xy(Xr,Yr);Vr=v_from_xy(Xr,Yr);
                    Ug=u_from_xy(Xg,Yg);Vg=v_from_xy(Xg,Yg);
                    Ub=u_from_xy(Xb,Yb);Vb=v_from_xy(Xb,Yb);
                    Xw=1/3.0; Yw=1/3.0;
                    load_ref_xy();
                    }

        void NTSC_primary(){
                    Xr=0.67;Yr=0.33; Xg=0.21;Yg=0.71;Xb=0.14;Yb=.08;
                    Ur=u_from_xy(Xr,Yr);Vr=v_from_xy(Xr,Yr);
                    Ug=u_from_xy(Xg,Yg);Vg=v_from_xy(Xg,Yg);
                    Ub=u_from_xy(Xb,Yb);Vb=v_from_xy(Xb,Yb);
                    Xw=1/3.0; Yw=1/3.0;
                    load_ref_xy();
                    }

        void Screen_primary(){
                    Xr=0.68;Yr=0.32; Xg=0.28;Yg=0.60;Xb=0.15;Yb=.07;
                    Ur=u_from_xy(Xr,Yr);Vr=v_from_xy(Xr,Yr);
                    Ug=u_from_xy(Xg,Yg);Vg=v_from_xy(Xg,Yg);
                    Ub=u_from_xy(Xb,Yb);Vb=v_from_xy(Xb,Yb);
                    Xw=1.0/3.0; Yw=1/3.0;
                    load_ref_xy();
                    }

        void Ahmed_primary(){
                    Xr=0.735;Yr=0.265; Xg=0.2757;Yg=0.7147;Xb=0.167;Yb=.009;
                    Ur=u_from_xy(Xr,Yr);Vr=v_from_xy(Xr,Yr);
                    Ug=u_from_xy(Xg,Yg);Vg=v_from_xy(Xg,Yg);
                    Ub=u_from_xy(Xb,Yb);Vb=v_from_xy(Xb,Yb);
                    Xw=1.0/3.0; Yw=1.0/3.0;
                    load_ref_xy();
                    }

        void reset_primary(){
                    Xr=0.674;Yr=0.326;Xg=0.216;Yg=0.716;Xb=0.162;Yb=0.090;
                    Ur=u_from_xy(Xr,Yr);Vr=v_from_xy(Xr,Yr);
                    Ug=u_from_xy(Xg,Yg);Vg=v_from_xy(Xg,Yg);
                    Ub=u_from_xy(Xb,Yb);Vb=v_from_xy(Xb,Yb);
                    Xw=0.31; Yw=0.316;
                    load_ref_xy();
                    }



               _GREY get_A(){return(A);}
               _GREY get_B(){return(B);}
               _GREY get_C(){return(C);}

	       //newly added 1999
	       float** get_fA(){return(A.get_f());}
	       float** get_fB(){return(B.get_f());}
	       float** get_fC(){return(C.get_f());}
	       float** get_imagA(){return(A.get_imag());}
	       float** get_imagB(){return(B.get_imag());}
	       float** get_imagC(){return(C.get_imag());}
	       unsigned char** get_picA(){return(A.get_pic());}
	       unsigned char** get_picB(){return(B.get_pic());}
	       unsigned char** get_picC(){return(C.get_pic());}
	       int** get_iA(){return(A.get_i());}
	       int** get_iB(){return(B.get_i());}
	       int** get_iC(){return(C.get_i());}
	       int get_h(){return(height);}
	       int get_w(){return(width);}
	       //End newly added 1999

               _COLOR RGB_to_XYZ();
               _COLOR XYZ_to_RGB();
               _COLOR XYZ_to_LAB();
               _COLOR XYZ_to_NXYZ();
               _COLOR NXYZ_to_XYZ();
               _COLOR NXYZ_to_RGB();
               _COLOR NXYZ_to_MacAdam();

               _COLOR RGB_to_NTSC();
               _COLOR NTSC_to_RGB();
               _COLOR XYZ_to_NTSC();
               _COLOR NTSC_to_XYZ();
               _COLOR NTSC_to_UVW();
               _COLOR UVW_to_NTSC();
               _COLOR NTSC_to_YIQ();
               _COLOR YIQ_to_NTSC();

               _GREY NTSC_to_GREY();
               _GREY RGB_to_GREY();

               _COLOR UVW_to_NUVW();
               _COLOR NUVW_to_UVW();
               _COLOR UVW_to_MOD_UVW();
               _COLOR LHS_to_NUVW();
               _COLOR NUVW_to_LHS();

               _COLOR RGB_to_LMS(); 
               _COLOR LMS_to_RGB(); 
               _COLOR NXYZ_to_LHS();
               _COLOR LHS_to_NXYZ();
               _COLOR STLMS_to_AC1C2(); 
               _COLOR AC1C2_to_STLMS(); 
               _COLOR RGB_to_IC1C2();
               _COLOR IC1C2_to_RGB();
               _COLOR RGB_to_OHTA();
               _COLOR OHTA_to_RGB();
               _COLOR YUV_to_RGB(); //  Added 27.02.2001
               _COLOR RGB_to_YUV(); //  Added 27.02.2001

               _COLOR XYZ_to_CIELUV(); // Added on 19.01.2000
               _COLOR XYZ_to_CIELAB(); // Added on 19.01.2000

	        _PNT  RGB_to_XYZ(_PNT a); //Added on 21.06.2000

               _COLOR max_sat_LHS(float ang1,float ang2,float s_thresh);

               _COLOR operator+(_COLOR ob){
                      _COLOR temp(col_space);
                      if(col_space!=ob.col_space) cout<<"WARNING: Colour space not matched in addition \n";
                      if((height!=ob.height)&&(width!=ob.width)) {
                      cout<<"DIMENSION MIS_MATCH. NO ADDITION PERFORMED.\n";
                      return(temp);
                     }
                     temp.width=width;
                     temp.height=height;
                     temp.A=A+ob.A; temp.B=B+ob.B; temp.C=C+ob.C;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator-(_COLOR ob){
                      _COLOR temp(col_space);
                      if(col_space!=ob.col_space) cout<<"WARNING: Colour space not matched in addition \n";
                      if((height!=ob.height)&&(width!=ob.width)) {
                      cout<<"DIMENSION MIS_MATCH. NO ADDITION PERFORMED.\n";
                      return(temp);
                     }
                     temp.width=width;
                     temp.height=height;
                     temp.A=A-ob.A; temp.B=B-ob.B; temp.C=C-ob.C;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator*(_COLOR ob){
                      _COLOR temp(col_space);
                      if(col_space!=ob.col_space) cout<<"WARNING: Colour space not matched in addition \n";
                      if((height!=ob.height)&&(width!=ob.width)) {
                      cout<<"DIMENSION MIS_MATCH. NO CONVOLUTION PERFORMED.\n";
                      return(temp);
                     }
                     temp.width=width;
                     temp.height=height;
                     temp.A=A*ob.A; temp.B=B*ob.B; temp.C=C*ob.C;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator*(_MASK ob){
                      _COLOR temp(col_space);
                     temp.width=width;
                     temp.height=height;
                     temp.A=A*ob; temp.B=B*ob; temp.C=C*ob;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator*(_GREY ob){
                      _COLOR temp(col_space);
                       float **x,**y,**z;
                       int i,j;
                       float val,sum;

                     temp.set(width,height,DFLOAT,col_space);
                     x=temp.A.get_f();
                     y=temp.B.get_f();
                     z=temp.C.get_f();

                     temp.width=width;
                     temp.height=height;

                     for(i=0;i<height;i++)
                     for(j=0;j<width;j++)
                     {
                      val=ob.pixel(i,j);
                      sum=A.pixel(i,j)+B.pixel(i,j)+C.pixel(i,j);
                      if(sum<=0.000){
                       x[i][j]=y[i][j]=z[i][j]=0;
                      }
                      else {
                       x[i][j]=val*A.pixel(i,j)/sum;
                       y[i][j]=val*B.pixel(i,j)/sum;
                       z[i][j]=val*C.pixel(i,j)/sum;
                      }
                     
                      }
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator&&(_COLOR ob){
                      _COLOR temp(col_space);
                      if(col_space!=ob.col_space) cout<<"WARNING: Colour space not matched in addition \n";
                      if((height!=ob.height)&&(width!=ob.width)) {
                      cout<<"DIMENSION MIS_MATCH. NO ANDING  PERFORMED.\n";
                      return(temp);
                     }
                     temp.width=width;
                     temp.height=height;
                     temp.A=A&&ob.A; temp.B=B&&ob.B; temp.C=C&&ob.C;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator||(_COLOR ob){
                      _COLOR temp(col_space);
                      if(col_space!=ob.col_space) cout<<"WARNING: Colour space not matched in addition \n";
                      if((height!=ob.height)&&(width!=ob.width)) {
                      cout<<"DIMENSION MIS_MATCH. NO ORING PERFORMED.\n";
                      return(temp);
                     }
                     temp.width=width;
                     temp.height=height;
                     temp.A=A||ob.A; temp.B=B||ob.B; temp.C=C||ob.C;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator^(_COLOR ob){
                      _COLOR temp(col_space);
                      if(col_space!=ob.col_space) cout<<"WARNING: Colour space not matched in addition \n";
                      if((height!=ob.height)&&(width!=ob.width)) {
                      cout<<"DIMENSION MIS_MATCH. NO MAGNITUDE COMPUTATION  PERFORMED.\n";
                      return(temp);
                     }
                     temp.width=width;
                     temp.height=height;
                     temp.A=A^ob.A; temp.B=B^ob.B; temp.C=C^ob.C;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator/(_COLOR ob){
                      _COLOR temp(col_space);
                      if(col_space!=ob.col_space) cout<<"WARNING: Colour space not matched in addition \n";
                      if((height!=ob.height)&&(width!=ob.width)) {
                      cout<<"DIMENSION MIS_MATCH. NO MAGNITUDE COMPUTATION  PERFORMED.\n";
                      return(temp);
                     }
                     temp.width=width;
                     temp.height=height;
                     temp.A=A/ob.A; temp.B=B/ob.B; temp.C=C/ob.C;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator%(float val){
                      _COLOR temp(col_space);
                     temp.width=width;
                     temp.height=height;
                     temp.A=A%val; temp.B=B%val; temp.C=C%val;
                     //temp.normalise();
                     return(temp);
                      }

                double operator%(_COLOR ob)//error computation
                      {
                       return(sqrt((sqr(A%ob.A)+sqr(B%ob.B)+sqr(C%ob.C))/3.0));
                      }

               _COLOR operator/(float val){
                      _COLOR temp(col_space);
                     temp.width=width;
                     temp.height=height;
                     temp.A=A/val; temp.B=B/val; temp.C=C/val;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR operator&(float val){
                      _COLOR temp(col_space);
                     temp.width=width;
                     temp.height=height;
                     temp.A=A&val; temp.B=B&val; temp.C=C&val;
                     //temp.normalise();
                     return(temp);
                      }

               _COLOR edge_s(){
                      _COLOR temp(col_space);
                     temp.width=width;
                     temp.height=height;
                     temp.A=A.edge_s(); temp.B=B.edge_s(); temp.C=C.edge_s();
                     //temp.normalise();
                     return(temp);
               }

      _GREY aniso_diffusion(float lamda,float weight,int Niter);
      _COLOR aniso_diffusion_smooth(float lamda,float weight,int Niter);

      //newly added 1999
      _COLOR aniso_diffusion_retinex(float lamda,float weight,int Niter,float gain,float boff,float crf_alpha,float crf_beta);
      _COLOR iso_diffusion_retinex(float lamda,int Niter,float gain,float boff,float crf_alpha,float crf_beta);
      _COLOR iso_diffusion_multi_retinex(float lamda,int Niter,float gain,float boff,float crf_alpha,float crf_beta,int mode);
      _COLOR JRW_multi_retinex(int mode); //As implemented by Jobson, Rahman & Woodell
      _COLOR iso_diffusion_multi_retinex_sigmoid(float lamda,int Niter,float gain,float boff,float crf_alpha, float crf_beta,float shift,float scale,int mode); // multi_scale
      _COLOR grey_retinex_sigmoid(float lamda,int Niter,float gain,float boff,float crf_alpha, float crf_beta,float shift,float scale,int mode); // multi_scale
      // End added 1999


      _GREY  rgrow(float diff,int seg_thresh,int wsize,int fsmooth,int mode,float wr,float wg,float wb);
       _COLOR gauss_noise(float sd=1.0,float mean=0.0)
         {
          _COLOR tim(col_space);
 

                     tim.width=width;
                     tim.height=height;
            tim.A=A.gauss_noise(sd,mean);
            tim.B=B.gauss_noise(sd,mean);
            tim.C=C.gauss_noise(sd,mean);

            //tim.normalise();
            return(tim);
           }

       _COLOR uniform_noise(float max_grey=255.0)
         {
          _COLOR tim(col_space);
 

                     tim.width=width;
                     tim.height=height;
            tim.A=A.uniform_noise(max_grey);
            tim.B=B.uniform_noise(max_grey);
            tim.C=C.uniform_noise(max_grey);

            //tim.normalise();
            return(tim);
           }

        _COLOR saturate_HSL()
         {
          _COLOR temp(RGB);

          if(col_space!=RGB){
          cout<<"Saturate_HSL() not applied to any non-RGB space \n";
          return(temp);
          }
        temp.set(width,height);

	int i,j;
        unsigned char **r,**g,**b;
        unsigned char **tr,**tg,**tb;
        float c1,c2,factor;

        r=A.get_pic(); g=B.get_pic(); b=C.get_pic();
        tr=temp.A.get_pic(); tg=temp.B.get_pic(); tb=temp.C.get_pic();


	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
         c1=(float)max(max(r[i][j],g[i][j]),b[i][j]);
         c2=(float)min(min(r[i][j],g[i][j]),b[i][j]);
         if(c1!=c2){
         factor=c1/(c1-c2);
         tr[i][j]=(unsigned char)((int)(((float)r[i][j]-c2)*factor));
         tg[i][j]=(unsigned char)((int)(((float)g[i][j]-c2)*factor));
         tb[i][j]=(unsigned char)((int)(((float)b[i][j]-c2)*factor));
         }
         else{
         tr[i][j]=r[i][j];
         tg[i][j]=g[i][j];
         tb[i][j]=b[i][j];
         }
	}
        return(temp);

         }

      _GREY seg_hist(_signal rseg,_signal gseg,_signal bseg)
      {
       _GREY temp;
        int rh_no,gh_no,bh_no;
        int i,j,k;
        int r_index,g_index,b_index;
        int **tpint;

        rh_no=rseg.get_num();
        gh_no=gseg.get_num();
        bh_no=bseg.get_num();

        {
         cout<<"rh_no "<<rh_no<<" gh_no "<<gh_no<<" bh_no "<<bh_no<<"\n";
        }

        temp.set(width,height,0,DINT);
        tpint=temp.get_i();
      
        for(i=0;i<height;i++)
        for(j=0;j<width;j++)
        {
         for(r_index=0;r_index<rh_no;r_index++) 
            {
               if(A.pixel(i,j)<(rseg&r_index)) break;
            }
         for(g_index=0;g_index<gh_no;g_index++) 
           {
               if(B.pixel(i,j)<(gseg&g_index)) break;
           }
         for(b_index=0;b_index<bh_no;b_index++) 
          {
               if(C.pixel(i,j)<(bseg&b_index)) break;
          }
         r_index++; g_index++; b_index++;
         //tpint[i][j]=(r_index*(rh_no+1)+g_index)*(gh_no+1)+b_index;
         tpint[i][j]=r_index*(gh_no+1)*(bh_no+1)+g_index*(bh_no+1)+b_index;
        }

        {
         cout<<"Intermediate classification done \n";
        }

      _GREY temp1;

       temp1=temp.rgrow(0,50,1,5);
       temp.free();
       temp1.adjust_image();
       return(temp1);
      }

}; 


               void _COLOR::load(char *fname,int w, int h,int c_space=RGB)
               {
                ifstream fin(fname);
                if(!fin){
                cout<<"File "<<fname<<" not opened \n";
                return;
                }
                unsigned char **red,**grn,**blu;
                int i,j;

                set(w,h);
                //set(w,h,DCHAR,c_space);

                red=A.get_pic(); grn=B.get_pic(); blu=C.get_pic();
                for(i=0;i<height;i++)
                for(j=0;j<width;j++)
                 {
                 //fin>>red[i][j]>>grn[i][j]>>blu[i][j];
                 fin.get(red[i][j]);
                 fin.get(grn[i][j]);
                 fin.get(blu[i][j]);
                 }

                 fin.close();
                col_space=c_space;
                A.adjust_image();
                B.adjust_image();
                C.adjust_image();

               }

               void _COLOR::save(char *fname)
               {
                int i,j;
                unsigned char **red,**grn,**blu;

                red=A.get_pic(); grn=B.get_pic(); blu=C.get_pic();
                 if((red==NULL)||(grn==NULL)||(blu==NULL))
                 {
                 cout<<"Data format in unsigned char not available. File "<<fname<<" not saved. \n";
                 return;
                 }
                 ofstream fout(fname);
                 if(!fout){
                cout<<"File "<<fname<<" not created\n";
                return;
                 }

                for(i=0;i<height;i++)
                for(j=0;j<width;j++)
                 {
                 // fout<<red[i][j]<<grn[i][j]<<blu[i][j];
                 fout.put(red[i][j]);// <<grn[i][j]<<blu[i][j];
                 fout.put(grn[i][j]);
                 fout.put(blu[i][j]);
                 }
                 fout.close();

               }


void _COLOR::inverse(float a[][3],float b[][3])
{
	float det,p00,p01,p02,p10,p11,p12,p20,p21,p22;

	p00=(a[1][1]*a[2][2]-a[2][1]*a[1][2]);	
	p01=(a[1][0]*a[2][2]-a[2][0]*a[1][2]);	
	p02=(a[1][0]*a[2][1]-a[2][0]*a[1][1]);	

	det=a[0][0]*p00-a[0][1]*p01+a[0][2]*p02;

	p10=(a[0][1]*a[2][2]-a[2][1]*a[0][2]);	
	p11=(a[0][0]*a[2][2]-a[2][0]*a[0][2]);	
	p12=(a[0][0]*a[2][1]-a[2][0]*a[0][1]);	

	p20=(a[0][1]*a[1][2]-a[1][1]*a[0][2]);	
	p21=(a[0][0]*a[1][2]-a[1][0]*a[0][2]);	
	p22=(a[0][0]*a[1][1]-a[1][0]*a[0][1]);	
	
	b[0][0]=p00/det;
	b[0][1]=-p10/det;
	b[0][2]=p20/det;
	b[1][0]=-p01/det;
	b[1][1]=p11/det;
	b[1][2]=-p21/det;
	b[2][0]=p02/det;
	b[2][1]=-p12/det;
	b[2][2]=p22/det;
}

//void _COLOR::define_rx(float rx[][3]) //obtained from Varaprasad NTSC_to_XYZ
// float rx[3][3];
void _COLOR::define_ntsc_xyz(float rx[][3]) //obtained from Varaprasad NTSC_to_XYZ
{
	rx[0][0]=0.618;
	rx[0][1]=0.177;
	rx[0][2]=0.205;
	rx[1][0]=0.299;
	rx[1][1]=0.587;
	rx[1][2]=0.114;
	rx[2][0]=0.000;
	rx[2][1]=0.056;
	rx[2][2]=0.944;
}

void _COLOR::define_rx(float rx[][3])
// float rx[3][3];
{
	rx[0][0]=0.49;
	rx[0][1]=0.31;
	rx[0][2]=0.20;
	rx[1][0]=0.177;
	rx[1][1]=0.813;
	rx[1][2]=0.011;
	rx[2][0]=0.000;
	rx[2][1]=0.010;
	rx[2][2]=0.990;
}
	        _PNT  _COLOR::RGB_to_XYZ(_PNT a) //Added on 21.06.2000
	       {
		 _PNT tmp;
	         float rx[3][3];
	
		  define_rx(rx);
		tmp.x=rx[0][0]*a.x+rx[0][1]*a.y+rx[0][2]*a.z;
		tmp.y=rx[1][0]*a.x+rx[1][1]*a.y+rx[1][2]*a.z;
		tmp.z=rx[2][0]*a.x+rx[2][1]*a.y+rx[2][2]*a.z;

		return tmp;
	       }

_COLOR _COLOR::RGB_to_XYZ()
{
        _COLOR temp(XYZ);
      if(col_space!=RGB){
         cout<<"Image is not in RGB space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,XYZ);
	int i,j;
	float rx[3][3];
        float **x,**y,**z;
        unsigned char **r,**g,**b;

        r=A.get_pic(); g=B.get_pic(); b=C.get_pic();
        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();

	define_rx(rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		x[i][j]=(rx[0][0]*(float)r[i][j]+rx[0][1]*(float)g[i][j]+rx[0][2]*(float)b[i][j]);
		y[i][j]=(rx[1][0]*(float)r[i][j]+rx[1][1]*(float)g[i][j]+rx[1][2]*(float)b[i][j]);
		z[i][j]=(rx[2][0]*(float)r[i][j]+rx[2][1]*(float)g[i][j]+rx[2][2]*(float)b[i][j]);
	}
      //temp.normalise();
      return(temp);
}

_COLOR _COLOR::XYZ_to_RGB()
{
         int count=0;

        _COLOR temp;
      if(col_space!=XYZ){
         cout<<"Image is not in XYZ space \n";
         return temp;
         }
        temp.set(width,height);

	int i,j,rtemp,gtemp,btemp;
	float rx[3][3],irx[3][3];
	float fr,fg,fb;
        float **x,**y,**z;
        unsigned char **r,**g,**b;

        x=A.get_f(); y=B.get_f(); z=C.get_f();
        r=temp.A.get_pic(); g=temp.B.get_pic(); b=temp.C.get_pic();
	define_rx(rx);
	inverse(rx,irx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		rtemp=(int)(irx[0][0]*x[i][j]+irx[0][1]*y[i][j]+irx[0][2]*z[i][j]);
		if(rtemp>255) rtemp=255;
		if(rtemp<0)   rtemp=0;  // Added on June 8, 2000
		gtemp=(int)(irx[1][0]*x[i][j]+irx[1][1]*y[i][j]+irx[1][2]*z[i][j]);
		if(gtemp>255) gtemp=255;
		if(gtemp<0)   gtemp=0;  // Added on June 8, 2000
		btemp=(int)(irx[2][0]*x[i][j]+irx[2][1]*y[i][j]+irx[2][2]*z[i][j]);
		if(btemp>255) btemp=255;
		if(btemp<0)   btemp=0;  // Added on June 8, 2000
                if((rtemp<0)||(btemp<0)||(gtemp<0))
                {
                count++;
                cout<<rtemp<<" "<<gtemp<<" "<<btemp<<"\n";
                //rtemp=btemp=gtemp=0;  // Modified on June 8, 2000
                }
		r[i][j]=(unsigned char) rtemp;
		g[i][j]=(unsigned char) gtemp;
		b[i][j]=(unsigned char) btemp;
	}
        if(count>0) cout<<count<<" No. of pixels not mapped to RGB and set to zero \n";
        return(temp);
}



_GREY _COLOR::RGB_to_GREY()
{
        _GREY temp;
      if(col_space!=RGB){
         cout<<"Image is not in RGB space \n";
         return temp;
         }
        temp.set(width,height,0,DFLOAT);
	int i,j;
	float rx[3][3];
        float **rval;

        rval=temp.get_f(); 

	define_rx(rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		rval[i][j]=(rx[1][0]*A.pixel(i,j)+rx[1][1]*B.pixel(i,j)+rx[1][2]*C.pixel(i,j));
	}
      temp.adjust_image();
      return(temp);
}


_COLOR _COLOR::XYZ_to_LAB()
{
        _COLOR temp;
      if(col_space!=XYZ){
         cout<<"Image is not in XYZ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,LAB);

	int i,j;
        float **x,**y,**z,**l,**a,**b;

        x=A.get_f(); y=B.get_f(); z=C.get_f();
        l=temp.A.get_f(); a=temp.B.get_f(); b=temp.C.get_f();

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
         l[i][j]=25.0*(float)pow(100.0*(double)y[i][j]/255.0,1/3.0)-16.0;
         a[i][j]=500.0*((float)pow((double)x[i][j]/255.0,1/3.0)-(float)pow((double)y[i][j]/255.0,1/3.0));
         b[i][j]=200.0*((float)pow((double)y[i][j]/255.0,1/3.0)-(float)pow((double)z[i][j]/255.0,1/3.0));
         
	}
     //temp.normalise();
     return(temp);
}


_COLOR _COLOR::XYZ_to_NXYZ()
{
        _COLOR temp;
      if(col_space!=XYZ){
         cout<<"Image is not in XYZ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,NXYZ);

	int i,j;
	float acc;
        float **x,**y,**z,**nx,**ny,**nz;

        x=A.get_f(); y=B.get_f(); z=C.get_f();
        nx=temp.A.get_f(); ny=temp.B.get_f(); nz=temp.C.get_f();

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		acc=x[i][j]+y[i][j]+z[i][j];
		if (acc<1e-20) {
		      nx[i][j]=1/3;
		      ny[i][j]=1/3;
		      nz[i][j]=0;
		 }
		 else
		 {
	         	nx[i][j]=x[i][j]/acc;
		         ny[i][j]=y[i][j]/acc;
		//nz[i][j]=1.0-nx[i][j]-ny[i][j];
                         nz[i][j]=acc/3;//Luminance info. is stored
		}
	}
     //temp.normalise();
     return(temp);
}

_COLOR _COLOR::NXYZ_to_XYZ()
{
        _COLOR temp(XYZ);
      if(col_space!=NXYZ){
         cout<<"Image is not in NXYZ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,XYZ);

	int i,j;
	float acc;
        float **x,**y,**z,**nx,**ny,**nz;

        nx=A.get_f(); ny=B.get_f(); nz=C.get_f();
        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		x[i][j]=nx[i][j]*3.0*nz[i][j];
		y[i][j]=ny[i][j]*3.0*nz[i][j];
		z[i][j]=(1-nx[i][j]-ny[i][j])*3.0*nz[i][j];
	}
     //temp.normalise();
     return(temp);
}


_COLOR _COLOR::NXYZ_to_MacAdam()
{
        _COLOR temp(MacAdam);
      if(col_space!=NXYZ){
         cout<<"Image is not in NXYZ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,MacAdam);

	int i,j;
	float acc;
        float **x,**y,**z,**nx,**ny,**nz;
        double a1,b1,a2,b2,denom1,denom2;
        double psi,ita;

        nx=A.get_f(); ny=B.get_f(); nz=C.get_f();
        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
                
                denom1=(2.4*(double)nx[i][j]+34.0*(double)ny[i][j]+1.0);
                denom2=(4.2*(double)ny[i][j]-(double)nx[i][j]+1.0);
                a1=10.0*(double)nx[i][j]/denom1;
                b1=10.0*(double)ny[i][j]/denom1;
                a2=10.0*(double)nx[i][j]/denom2;
                b2=10.0*(double)ny[i][j]/denom2;

        psi= 3751.0*sqr(a1)-10.0*sqr(sqr(a1))-520.0*sqr(b1);
        psi+=13295.0*sqr(b1)*b1+32327.0*a1*b1-25491.0*sqr(a1)*b1;
        psi-=41672.0*a1*sqr(b1)+10.0*sqr(a1)*a1-5227.0*sqrt(a1)+2952.0*sqrt(sqrt(a1));

                ita=404.0*b2-185.0*sqr(b2)+52.0*sqr(b2)*b2+69.0*a2*(1-sqr(b2));
                ita-=3.0*sqr(a2)*b2+30.0*a2*sqr(b2)*b2;

                x[i][j]=(float)psi;
                y[i][j]=(float)ita;
		z[i][j]=3.0*nz[i][j]*ny[i][j];
	}
     //temp.normalise();
     return(temp);
}


/*
void lms_caplms(l,m,s,ls,ms,ss,row_size,col_size)
float **l,**m,**s;
float **ls,**ms,**ss;
int row_size,col_size;
{
	int i,j;

	for(i=0;i<row_size;i++)
	for(j=0;j<col_size;j++)  {
	   ls[i][j]=log((double)l[i][j]);
	   ms[i][j]=log((double)m[i][j]);
	   ss[i][j]=log((double)s[i][j]);
	}
}

void caplms_lms(ls,ms,ss,l,m,s,row_size,col_size)
float **ls,**ms,**ss;
float **l,**m,**s;
int row_size,col_size;
{
	int i,j;

	for(i=0;i<row_size;i++)
	for(j=0;j<col_size;j++)  {
	   l[i][j]=exp((double)ls[i][j]);
	   m[i][j]=exp((double)ms[i][j]);
	   s[i][j]=exp((double)ss[i][j]);
	}
}
*/

void _COLOR::define_matu(float u[][3])
{
	u[0][0]=0.2381;
	u[0][1]=0.3423;
	u[0][2]=0.0642;
	u[1][0]=0.0459;
	u[1][1]=0.2328;
	u[1][2]=0.0502;
	u[2][0]=4.528e-6;
	u[2][1]=4e-4;
	u[2][2]=6.824e-3;
}

void _COLOR::define_matp(float p[][3])
{
	float a,al,be,u1,u2;

	a=22.6; al=0.7186; be=1.0-al; u1=41.6; u2=10.5;

	p[0][0]=a*al;
	p[0][1]=a*be;
	p[0][2]=0.0;
	p[1][0]=u1;
	p[1][1]=-u1;
	p[1][2]=0;
	p[2][0]=u2;
	p[2][1]=0;
	p[2][2]=-u2;
}

_COLOR _COLOR::RGB_to_LMS() 
{
        _COLOR temp(LMS);
      if(col_space!=RGB){
         cout<<"Image is not in RGB space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,LMS);

unsigned char **r,**g,**b;
float **l,**m,**s;
	float u[3][3];
	int i,j;

        r=A.get_pic(); g=B.get_pic(); b=C.get_pic();
        l=temp.A.get_f(); m=temp.B.get_f(); s=temp.C.get_f();

	define_matu(u);
	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
	   l[i][j]=u[0][0]*r[i][j]+u[0][1]*g[i][j]+u[0][2]*b[i][j];
	   if(l[i][j]<=0.0) l[i][j]=-l[i][j];
	   if(l[i][j]<=1.0) l[i][j]=1.0;
	   m[i][j]=u[1][0]*r[i][j]+u[1][1]*g[i][j]+u[1][2]*b[i][j];
	   if(m[i][j]<=0.0) m[i][j]=-m[i][j];
	   if(m[i][j]<=1.0) m[i][j]=1.0;
	   s[i][j]=u[2][0]*r[i][j]+u[2][1]*g[i][j]+u[2][2]*b[i][j];
	   if(s[i][j]<=0.0) s[i][j]=-s[i][j];
	   if(s[i][j]<=0.0) s[i][j]=1.0;
	}
     //temp.normalise();
      return(temp);
}

_COLOR _COLOR::STLMS_to_AC1C2() 
{

        _COLOR temp(AC1C2);
      if(col_space!=STLMS){
         cout<<"Image is not in STLMS space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,AC1C2);


	float p[3][3];
	int i,j,val;

float **ls,**ms,**ss;
unsigned char **a,**c1,**c2;

        ls=A.get_f(); ms=B.get_f(); ss=C.get_f();
        a=temp.A.get_pic(); c1=temp.B.get_pic(); c2=temp.C.get_pic();

	define_matp(p);
	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {

	   val=(int)(p[0][0]*ls[i][j]+p[0][1]*ms[i][j]+p[0][2]*ss[i][j]);
	   if (val<0) val = -val;
	   if (val>255) val=255;
	   a[i][j]=(unsigned char) val;

	   val=(int)(p[1][0]*ls[i][j]+p[1][1]*ms[i][j]+p[1][2]*ss[i][j]);
	   if (val<0) val = -val;
	   if (val>255) val=255;
	   c1[i][j]=(unsigned char) val;

	   val=(int)(p[2][0]*ls[i][j]+p[2][1]*ms[i][j]+p[2][2]*ss[i][j]);
	   if (val<0) val = -val;
	   if (val>255) val=255;
	   c2[i][j]=(unsigned char) val;
	}
     //temp.normalise();
   return(temp);
}

_COLOR _COLOR::AC1C2_to_STLMS()
{
        _COLOR temp(STLMS);
      if(col_space!=AC1C2){
         cout<<"Image is not in AC1C2 space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,STLMS);
	int i,j;
	float p[3][3];
	float pinv[3][3];

unsigned char **a,**c1,**c2;
float **ls,**ms,**ss;

        ls=temp.A.get_f(); ms=temp.B.get_f(); ss=temp.C.get_f();
        a=A.get_pic(); c1=B.get_pic(); c2=C.get_pic();
	define_matp(p);
	inverse(p,pinv);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
	   ls[i][j]=(float)(pinv[0][0]*(float)a[i][j]+pinv[0][1]*(float)c1[i][j]+pinv[0][2]*(float)c2[i][j]);
	   ms[i][j]=(float)(pinv[1][0]*(float)a[i][j]+pinv[1][1]*(float)c1[i][j]+pinv[1][2]*(float)c2[i][j]);
	   ss[i][j]=(float)(pinv[2][0]*(float)a[i][j]+pinv[2][1]*(float)c1[i][j]+pinv[2][2]*(float)c2[i][j]);
	}
     //temp.normalise();
     return(temp);
}

_COLOR _COLOR::LMS_to_RGB()
{
        _COLOR temp;
      if(col_space!=LMS){
         cout<<"Image is not in LMS space \n";
         return temp;
         }

        temp.set(width,height);
	float u[3][3];
	float uinv[3][3];
	int i,j,val;
        float **l,**m,**s;
        unsigned char **r,**g,**b;

        l=A.get_f(); m=B.get_f(); s=C.get_f();
        r=temp.A.get_pic(); g=temp.B.get_pic(); b=temp.C.get_pic();
	define_matu(u);
	inverse(u,uinv);
	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
	   val=(int) (uinv[0][0]*l[i][j]+uinv[0][1]*m[i][j]+uinv[0][2]*s[i][j]);
	   if (val<0) val = -val;
	   if (val>255) val=255;
	   r[i][j]=(unsigned char) val;

	   val=(int) (uinv[1][0]*l[i][j]+uinv[1][1]*m[i][j]+uinv[1][2]*s[i][j]);
	   if (val<0) val = -val;
	   if (val>255) val=255;
	   g[i][j]=(unsigned char) val;

	   val=(int) (uinv[2][0]*l[i][j]+uinv[2][1]*m[i][j]+uinv[2][2]*s[i][j]);
	   if (val<0) val = -val;
	   if (val>255) val=255;
	   b[i][j]=(unsigned char) val;
	}
     return(temp);
}

void _COLOR::define_matri(float a[][3])
{
	a[0][0]= 0.33333;
	a[0][1]= 0.33333;  
	a[0][2]= 0.33333;
	a[1][0]= 1.00;
	a[1][1]= -1.00;
	a[1][2]= 0.0;
	a[2][0]= 1.0;
	a[2][1]= 0.0;
	a[2][2]= -1.0;
}

_COLOR _COLOR::RGB_to_IC1C2()
{
        _COLOR temp(IC1C2);
      if(col_space!=RGB){
         cout<<"Image is not in RGB space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,IC1C2);

	float a[3][3];
	int i,j,val;

        unsigned char **red,**grn,**blu;
        float **mati,**matc1,**matc2;

        red=A.get_pic(); grn=B.get_pic(); blu=C.get_pic();
        mati=temp.A.get_f(); matc1=temp.B.get_f(); matc2=temp.C.get_f();
	define_matri(a);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
	val=(int)(a[0][0]*(int)red[i][j]+a[0][1]*(int)grn[i][j]+a[0][2]*(int)blu[i][j]);
	mati[i][j]=(float)val;
	val=(int)(a[1][0]*(int)red[i][j]+a[1][1]*(int)grn[i][j]+a[1][2]*(int)blu[i][j]);
	matc1[i][j]=(float)val;
	val=(int)(a[2][0]*(int)red[i][j]+a[2][1]*(int)grn[i][j]+a[2][2]*(int)blu[i][j]);
	matc2[i][j]=(float)val;
	}
     //temp.normalise();
   return(temp);
}

_COLOR _COLOR::IC1C2_to_RGB()
{
        _COLOR temp;
      if(col_space!=IC1C2){
         cout<<"Image is not in IC1C2 space \n";
         return temp;
         }

        temp.set(width,height);
	float a[3][3],b[3][3];
	int i,j,val;

        float **mati,**matc1,**matc2;
        unsigned char **red,**grn,**blu;

        mati=A.get_f(); matc1=B.get_f(); matc2=C.get_f();
        red=temp.A.get_pic(); grn=temp.B.get_pic(); blu=temp.C.get_pic();
	define_matri(a);
	inverse(a,b);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
	val=(int)(b[0][0]*mati[i][j]+b[0][1]*matc1[i][j]+b[0][2]*matc2[i][j]);
	if(val<0) val=-val;   
	if(val>255) val=255;   
	red[i][j]=(unsigned char)val;
	val=(int)(b[1][0]*mati[i][j]+b[1][1]*matc1[i][j]+b[1][2]*matc2[i][j]);
	if(val<0) val=-val;   
	if(val>255) val=255;   
	grn[i][j]=(unsigned char) val;
	val=(int)(b[2][0]*mati[i][j]+b[2][1]*matc1[i][j]+b[2][2]*matc2[i][j]);
	if(val<0) val=-val;   
	if(val>255) val=255;
	blu[i][j]=(unsigned char)val;   
	}
 return(temp);
}

void _COLOR::define_matri_ohta(float a[][3])
{
	a[0][0]= 0.33333;
	a[0][1]= 0.33333;  
	a[0][2]= 0.33333;
	a[1][0]= 0.50;
	a[1][1]= 0.00;
	a[1][2]= -0.5;
	a[2][0]= -0.25;
	a[2][1]= 0.5;
	a[2][2]= -0.25;
}

_COLOR _COLOR::RGB_to_OHTA()
{
        _COLOR temp(OHTA);
      if(col_space!=RGB){
         cout<<"Image is not in RGB space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,OHTA);

	float a[3][3];
	int i,j,val;

        unsigned char **red,**grn,**blu;
        float **mati,**matc1,**matc2;

        red=A.get_pic(); grn=B.get_pic(); blu=C.get_pic();
        mati=temp.A.get_f(); matc1=temp.B.get_f(); matc2=temp.C.get_f();
	define_matri_ohta(a);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
	val=(int)(a[0][0]*(int)red[i][j]+a[0][1]*(int)grn[i][j]+a[0][2]*(int)blu[i][j]);
	mati[i][j]=(float)val;
	val=(int)(a[1][0]*(int)red[i][j]+a[1][1]*(int)grn[i][j]+a[1][2]*(int)blu[i][j]);
	matc1[i][j]=(float)val;
	val=(int)(a[2][0]*(int)red[i][j]+a[2][1]*(int)grn[i][j]+a[2][2]*(int)blu[i][j]);
	matc2[i][j]=(float)val;
	}
     //temp.normalise();
   return(temp);
}

_COLOR _COLOR::OHTA_to_RGB()
{
        _COLOR temp;
      if(col_space!=OHTA){
         cout<<"Image is not in OHTA space \n";
         return temp;
         }

        temp.set(width,height);
	float a[3][3],b[3][3];
	int i,j,val;

        float **mati,**matc1,**matc2;
        unsigned char **red,**grn,**blu;

        mati=A.get_f(); matc1=B.get_f(); matc2=C.get_f();
        red=temp.A.get_pic(); grn=temp.B.get_pic(); blu=temp.C.get_pic();
	define_matri_ohta(a);
	inverse(a,b);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
	val=(int)(b[0][0]*mati[i][j]+b[0][1]*matc1[i][j]+b[0][2]*matc2[i][j]);
	if(val<0) val=-val;   
	if(val>255) val=255;   
	red[i][j]=(unsigned char)val;
	val=(int)(b[1][0]*mati[i][j]+b[1][1]*matc1[i][j]+b[1][2]*matc2[i][j]);
	if(val<0) val=-val;   
	if(val>255) val=255;   
	grn[i][j]=(unsigned char) val;
	val=(int)(b[2][0]*mati[i][j]+b[2][1]*matc1[i][j]+b[2][2]*matc2[i][j]);
	if(val<0) val=-val;   
	if(val>255) val=255;
	blu[i][j]=(unsigned char)val;   
	}
 return(temp);
}

_COLOR _COLOR::NXYZ_to_RGB()
{
        _COLOR temp1,temp; // Modified on 5.6.2000 at UCSB
      if(col_space!=NXYZ){
         cout<<"Image is not in NXYZ space \n";
         return temp;
         }

         temp1=NXYZ_to_XYZ(); // Modified on 5.6.2000 at UCSB
         temp=temp1.XYZ_to_RGB(); // Modified on 5.6.2000 at UCSB
	 temp1.free(); // Modified on 5.6.2000 at UCSB

    return(temp);
}


         float _COLOR::arctan(float l,float m) //returns between 0 and 2*PI
         {
           float tht;

           if (l==0) {
            if(m>0) tht=M_PI/2;
            else tht= 3*M_PI/2;
            //else tht= -M_PI/2;
            }
                  else tht=(float) atan( fabs (m/l));
           if (l<0) {
             if (m>0) 
                tht=M_PI-tht;
               else tht=M_PI+tht;
                    }
            else
              if (m<0)tht=2*M_PI-tht;
              return(tht);
          } /* {of arctan} */


float _COLOR::find_angle(float x,float y,float xw,float yw)
{
	int i,j;
	float ga,sl,pi;
        float tht;

        tht=arctan(x-xw,y-yw);
	if((tht>=0) && (tht<3*M_PI/2))
        return(M_PI/2+tht);
	else// tht between 270 and 360
	 return(tht-3*M_PI/2);
}

/*
float _COLOR::find_angle(float x,float y,float xw,float yw)
//float x,y,xw,yw;
{
	int i,j;
	float ga,sl,pi;

	pi=M_PI;
	if (abs(x-xw)<.001)  { if(y>yw) return(pi); else return(0); }
	else { 
		ga=(y-yw)/(x-xw);
		sl=atan(ga);
		//sl=sl*128.0/pi;
		if (x>xw) return((pi/2+sl));
		else return(3*pi/2+sl);
	}
}
*/


_COLOR _COLOR::NXYZ_to_LHS()
{
  //float  xw=0.310; 
  //float yw=0.316;
         load_ref_xy();
        _COLOR temp(LHS);
      if(col_space!=NXYZ){
         cout<<"Image is not in NXYZ space \n";
         return temp;
         }

        int i,j;
        float **nx,**ny,**nz,**angle,**sat,**lum;
       
        nx=A.get_f();ny=B.get_f();nz=C.get_f();

        temp.set(width,height,DFLOAT,LHS);
        lum=temp.A.get_f(); sat=temp.B.get_f(); angle=temp.C.get_f();
        
	for(i=0;i<height;i++)
	for(j=0;j<width;j++) {
                //sat[i][j]=sqrt((double)(sqr(nx[i][j]-xw)+sqr(ny[i][j]-yw)));
                sat[i][j]=sqr(nx[i][j]-xw)+sqr(ny[i][j]-yw);
		if(sat[i][j]>0) sat[i][j]=(float)sqrt((double)sat[i][j]);
		angle[i][j]= find_angle(nx[i][j],ny[i][j],xw,yw);
                lum[i][j]=nz[i][j];
	}
     //temp.normalise();
     return(temp);
}

_COLOR _COLOR::LHS_to_NXYZ()
{
  //float  xw=0.310; 
  //float yw=0.316;
         load_ref_xy();
        _COLOR temp(NXYZ);
      if(col_space!=LHS){
         cout<<"Image is not in LHS space \n";
         return temp;
         }

        int i,j;
        float **nx,**ny,**nz,**angle,**sat,**lum;
       
        temp.set(width,height,DFLOAT,NXYZ);
        nx=temp.A.get_f();ny=temp.B.get_f();nz=temp.C.get_f();

        lum=A.get_f(); sat=B.get_f(); angle=C.get_f();
        
	for(i=0;i<height;i++)
	for(j=0;j<width;j++) {
                nx[i][j]=xw+sat[i][j]*(float)cos((double)angle[i][j]-M_PI/2);
                ny[i][j]=yw+sat[i][j]*(float)sin((double)angle[i][j]-M_PI/2);
                nz[i][j]=lum[i][j];
	}
     //temp.normalise();
     return(temp);
}





void _COLOR::find_xy(float xw,float yw,float x1,float y1,float xe1,float ye1,float xe2,float ye2,float &px,float &py)
{
	float p,q,x,y;

	p=(ye2-ye1)/(xe2-xe1);
        if(abs(x1-xw)>0){
	q=(y1-yw)/(x1-xw);

	x=(yw-ye1+p*xe1-q*xw)/(p-q);
	y=ye1+p*(x-xe1);
        }
        else
        {
         x=xw;
         y=ye1+p*(xw-xe1);
         }
	
	px=x;py=y;
}

void _COLOR::max_sat(float xw,float yw,float x1,float y1,float theta,float &px,float &py)
{
	//float xr,yr,xg,yg,xb,yb;
	float thr,thg,thb;

	//xr=0.674;yr=0.326;
	//xg=0.216;yg=0.716;
	//xb=0.162;yb=0.090;

	//thr=91.0*M_PI/180.0;thg=193.0*M_PI/180.0;thb=326.0*M_PI/180.0;
        thr=find_angle(xr,yr,xw,yw);
        thg=find_angle(xg,yg,xw,yw);
        thb=find_angle(xb,yb,xw,yw);

	if(theta==thr) {px=xr;py=yr;} else
	if(theta==thg) {px=xg;py=yg;} else
	if(theta==thb) {px=xb;py=yb;} else

	if((theta<thg) && (theta>thr)) 
		find_xy(xw,yw,x1,y1,xr,yr,xg,yg,px,py); else
	if((theta<thb) && (theta>thg)) 
		find_xy(xw,yw,x1,y1,xg,yg,xb,yb,px,py); else
	find_xy(xw,yw,x1,y1,xb,yb,xr,yr,px,py);

}


void _COLOR::max_sat(float xw,float yw,float theta,float &px,float &py)
{
	//float xr,yr,xg,yg,xb,yb;
	float thr,thg,thb;
        float x1,y1;

	//xr=0.674;yr=0.326;
	//xg=0.216;yg=0.716;
	//xb=0.162;yb=0.090;

	//thr=91.0*M_PI/180.0;thg=193.0*M_PI/180.0;thb=326.0*M_PI/180.0;

        thr=find_angle(xr,yr,xw,yw);
        thg=find_angle(xg,yg,xw,yw);
        thb=find_angle(xb,yb,xw,yw);

	if(theta==thr) {px=xr;py=yr;return;} 
	if(theta==thg) {px=xg;py=yg;return;} 
	if(theta==thb) {px=xb;py=yb;return;} 

        //x1=xw+(float).06*cos((double)(theta-M_PI/2));
        //y1=yw+(float).06*sin((double)(theta-M_PI/2));
        x1=xw+(float)0.2*cos((double)(theta-M_PI/2));
        y1=yw+(float)0.2*sin((double)(theta-M_PI/2));
	if((theta<=thg) && (theta>thr)) 
		find_xy(xw,yw,x1,y1,xr,yr,xg,yg,px,py); 
		else
	           if((theta<=thb) && (theta>thg)) 
		      find_xy(xw,yw,x1,y1,xg,yg,xb,yb,px,py); 
		      else
	                 find_xy(xw,yw,x1,y1,xb,yb,xr,yr,px,py);
	//if((theta<thb) && (theta>thg)) 
         // cout<<"x1="<<x1<<" y1="<<y1<<"    px="<<px<<" py="<<py<<"\n";

}

float _COLOR::dist(float x1,float y1,float x2,float y2)
{
	float temp;

	temp=(float)(fabs((double)((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))));
	return((float)(sqrt((double)temp)));
}

_COLOR _COLOR::max_sat_LHS(float ang1=0,float ang2=2*M_PI,float s_thresh=0.03)
 {
  //float  xw=0.310; 
  //float yw=0.316;
  cout<<"xw="<<xw<<" yw="<<yw<<"\n";
  cout<<"xr="<<xr<<" yr="<<yr<<"\n";
  cout<<"xg="<<xg<<" yg="<<yg<<"\n";
  cout<<"xb="<<xb<<" yb="<<yb<<"\n";

        float thr,thg,thb;
        thr=find_angle(xr,yr,xw,yw);
        thg=find_angle(xg,yg,xw,yw);
        thb=find_angle(xb,yb,xw,yw);
        cout<<"thr="<<180.0*thr/M_PI<<" thg="<<180.0*thg/M_PI<<" thb="<<180.0*thb/M_PI<<"\n";

   cout<<"ang1="<<ang1<<" ang2="<<ang2<<"\n";
        _COLOR temp(LHS);
      if(col_space!=LHS){
         cout<<"Image is not in LHS space \n";
         return temp;
         }

        int i,j;
        float **tsat,**tangle,**tlum,**angle,**sat,**lum;
        float px,py;
	double count=0;
       
        temp.set(width,height,DFLOAT,LHS);
        tlum=temp.A.get_f();tsat=temp.B.get_f();tangle=temp.C.get_f();

        lum=A.get_f(); sat=B.get_f(); angle=C.get_f();
	for(i=0;i<height;i++)
	for(j=0;j<width;j++) {
        tlum[i][j]=lum[i][j];
        tangle[i][j]=angle[i][j];
        if(sat[i][j]>s_thresh){
        if((angle[i][j]>=ang1)&&(angle[i][j]<ang2))
        {
        max_sat( xw, yw,angle[i][j],px,py);
        if((abs(px)>1.0)||(abs(py)>1.0))
        cout<<"px="<<px<<" py="<<py<<"\n";
        //tsat[i][j]=(float)sqrt((double)(sqr(px-xw)+sqr(py-yw)));
        tsat[i][j]=sqr(px-xw)+sqr(py-yw);
	if(tsat[i][j]>0)
	   tsat[i][j]=(float)sqrt((double)tsat[i][j]);
        }
        else {
	       tsat[i][j]=sat[i][j];
	       count++;
	       //cout<<"angle..."<<angle[i][j]<<"?\n";
	       }
        }
        else {
	       tsat[i][j]=sat[i][j];
	       //count++;
	       }
        //if((angle[i][j]<=thb)&&(angle[i][j]>thg)){
        //cout<<"INITIAL   px="<<px<<" py="<<py<<"\n";
         //      px=xw+tsat[i][j]*(float)cos((double)angle[i][j]-M_PI/2);
          //    py=yw+tsat[i][j]*(float)sin((double)angle[i][j]-M_PI/2);
        //cout<<"RECOMPUTED px="<<px<<" py="<<py<<" SAT="<<tsat[i][j]<<"\n";
        //tsat[i][j]=tsat[i][j]/2.0;
        //}
        }
     //temp.normalise();
     cout<<"No. of pixels not processed :"<<count<<"\n";
   return(temp);
 }


void _COLOR::define_xyz_ntsc(float rx[][3])
// float rx[3][3];
{
	rx[0][0]=1.910;
	rx[0][1]=-0.533;
	rx[0][2]=-0.288;
	rx[1][0]=-0.985;
	rx[1][1]=2.000;
	rx[1][2]=-0.028;
	rx[2][0]=0.058;
	rx[2][1]=-0.118;
	rx[2][2]=0.896;
}

_COLOR _COLOR::XYZ_to_NTSC()
{
        _COLOR temp(NTSC);
      if(col_space!=XYZ){
         cout<<"Image is not in XYZ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,NTSC);
	int i,j;
	float rx[3][3];
        float **x,**y,**z;
        float **r,**g,**b;

        r=A.get_f(); g=B.get_f(); b=C.get_f();
        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();

	define_xyz_ntsc(rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		x[i][j]=(rx[0][0]*(float)r[i][j]+rx[0][1]*(float)g[i][j]+rx[0][2]*(float)b[i][j]);
		y[i][j]=(rx[1][0]*(float)r[i][j]+rx[1][1]*(float)g[i][j]+rx[1][2]*(float)b[i][j]);
		z[i][j]=(rx[2][0]*(float)r[i][j]+rx[2][1]*(float)g[i][j]+rx[2][2]*(float)b[i][j]);
	}
      //temp.normalise();
      return(temp);
}

_COLOR _COLOR::NTSC_to_XYZ()
{
        _COLOR temp(XYZ);
      if(col_space!=NTSC){
         cout<<"Image is not in NTSC space \n";
         return temp;
         }

        /*
        {char ch;
         cout<<"Converting to XYZ \n";
         cin>>ch;
        }
        */


        temp.set(width,height,DFLOAT,XYZ);

	int i,j,itemp;
	float rx[3][3],irx[3][3];
	float fr,fg,fb;
        float **x,**y,**z;

        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();
	define_xyz_ntsc(rx);
	inverse(rx,irx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++){  
		x[i][j]=(irx[0][0]*A.pixel(i,j)+irx[0][1]*B.pixel(i,j)+irx[0][2]*C.pixel(i,j));
		y[i][j]=(irx[1][0]*A.pixel(i,j)+irx[1][1]*B.pixel(i,j)+irx[1][2]*C.pixel(i,j));
		z[i][j]=(irx[2][0]*A.pixel(i,j)+irx[2][1]*B.pixel(i,j)+irx[2][2]*C.pixel(i,j));
	}
        return(temp);
}

_GREY _COLOR::NTSC_to_GREY()
{
        _GREY temp;
      if(col_space!=NTSC){
         cout<<"Image is not in NTSC space \n";
         return temp;
         }
        temp.set(width,height,0,DFLOAT);
	int i,j;
	float rx[3][3];
        float **rval;

        rval=temp.get_f(); 

	define_ntsc_xyz(rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		rval[i][j]=(rx[1][0]*A.pixel(i,j)+rx[1][1]*B.pixel(i,j)+rx[1][2]*C.pixel(i,j));
	}
      temp.adjust_image();
      return(temp);
}

void _COLOR::define_ntsc_uvw(float rx[][3])
// float rx[3][3];
{
	rx[0][0]=0.405;
	rx[0][1]=0.116;
	rx[0][2]=0.133;
	rx[1][0]=0.299;
	rx[1][1]=0.587;
	rx[1][2]=0.114;
	rx[2][0]=0.145;
	rx[2][1]=0.827;
	rx[2][2]=0.627;
}

_COLOR _COLOR::NTSC_to_UVW()
{
        _COLOR temp(UVW);
      if(col_space!=NTSC){
         cout<<"Image is not in NTSC space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,UVW);
	int i,j;
	float rx[3][3];
        float **x,**y,**z;
        float  **r,**g,**b;

        r=A.get_f(); g=B.get_f(); b=C.get_f();
        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();

	define_ntsc_uvw(rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		x[i][j]=(rx[0][0]*A.pixel(i,j)+rx[0][1]*B.pixel(i,j)+rx[0][2]*C.pixel(i,j));
		y[i][j]=(rx[1][0]*A.pixel(i,j)+rx[1][1]*B.pixel(i,j)+rx[1][2]*C.pixel(i,j));
		z[i][j]=(rx[2][0]*A.pixel(i,j)+rx[2][1]*B.pixel(i,j)+rx[2][2]*C.pixel(i,j));
	}
      //temp.normalise();
      return(temp);
}

_COLOR _COLOR::UVW_to_NTSC()
{
        _COLOR temp(NTSC);
      if(col_space!=UVW){
         cout<<"Image is not in UVW space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,NTSC);

	int i,j,itemp;
	float rx[3][3],irx[3][3];
	float fr,fg,fb;
        float **x,**y,**z;
        float **r,**g,**b;

        x=A.get_f(); y=B.get_f(); z=C.get_f();
        r=temp.A.get_f(); g=temp.B.get_f(); b=temp.C.get_f();
	define_ntsc_uvw(rx);
	inverse(rx,irx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		r[i][j]=(irx[0][0]*x[i][j]+irx[0][1]*y[i][j]+irx[0][2]*z[i][j]);
		g[i][j]=(irx[1][0]*x[i][j]+irx[1][1]*y[i][j]+irx[1][2]*z[i][j]);
		b[i][j]=(irx[2][0]*x[i][j]+irx[2][1]*y[i][j]+irx[2][2]*z[i][j]);
	}
        return(temp);
}


void _COLOR::define_ntsc_yiq(float rx[][3])
// float rx[3][3];
{
	rx[0][0]=0.299;
	rx[0][1]=0.587;
	rx[0][2]=0.114;
	rx[1][0]=0.596;
	rx[1][1]= -0.274;
	rx[1][2]= -0.322;
	rx[2][0]=0.211;
	rx[2][1]= -0.523;
	rx[2][2]=0.312;
}

_COLOR _COLOR::NTSC_to_YIQ()
{
        _COLOR temp(YIQ);
      if(col_space!=NTSC){
         cout<<"Image is not in NTSC space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,YIQ);
	int i,j;
	float rx[3][3];
        float **Y,**I,**Q;
        float  **r,**g,**b;

        r=A.get_f(); g=B.get_f(); b=C.get_f();
        Y=temp.A.get_f(); I=temp.B.get_f(); Q=temp.C.get_f();

	define_ntsc_yiq(rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		Y[i][j]=(rx[0][0]*A.pixel(i,j)+rx[0][1]*B.pixel(i,j)+rx[0][2]*C.pixel(i,j));
		I[i][j]=(rx[1][0]*A.pixel(i,j)+rx[1][1]*B.pixel(i,j)+rx[1][2]*C.pixel(i,j));
		Q[i][j]=(rx[2][0]*A.pixel(i,j)+rx[2][1]*B.pixel(i,j)+rx[2][2]*C.pixel(i,j));
	}
      //temp.normalise();
      return(temp);
}

_COLOR _COLOR::YIQ_to_NTSC()
{
        _COLOR temp(NTSC);
      if(col_space!=YIQ){
         cout<<"Image is not in YIQ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,NTSC);

	int i,j,itemp;
	float rx[3][3],irx[3][3];
	float fr,fg,fb;
        float **Y,**I,**Q;
        float **r,**g,**b;

        Y=A.get_f(); I=B.get_f(); Q=C.get_f();
        r=temp.A.get_f(); g=temp.B.get_f(); b=temp.C.get_f();
	define_ntsc_yiq(rx);
	inverse(rx,irx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		r[i][j]=(irx[0][0]*Y[i][j]+irx[0][1]*I[i][j]+irx[0][2]*Q[i][j]);
		g[i][j]=(irx[1][0]*Y[i][j]+irx[1][1]*I[i][j]+irx[1][2]*Q[i][j]);
		b[i][j]=(irx[2][0]*Y[i][j]+irx[2][1]*I[i][j]+irx[2][2]*Q[i][j]);
	}
        return(temp);
}


_COLOR _COLOR::UVW_to_NUVW()
{
        _COLOR temp;
      if(col_space!=UVW){
         cout<<"Image is not in UVW space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,NUVW);

	int i,j;
	float acc;
        float **x,**y,**z,**nx,**ny,**nz;

        x=A.get_f(); y=B.get_f(); z=C.get_f();
        nx=temp.A.get_f(); ny=temp.B.get_f(); nz=temp.C.get_f();

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		acc=x[i][j]+y[i][j]+z[i][j];
		if (acc==0.0) acc=1.0;
		nx[i][j]=x[i][j]/acc;
		ny[i][j]=y[i][j]/acc;
		//nz[i][j]=1.0-nx[i][j]-ny[i][j];
                nz[i][j]=acc/3;//Luminance info. is stored
	}
     //temp.normalise();
     return(temp);
}

_COLOR _COLOR::NUVW_to_UVW()
{
        _COLOR temp(UVW);
      if(col_space!=NUVW){
         cout<<"Image is not in NUVW space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,UVW);

	int i,j;
	float acc;
        float **x,**y,**z,**nx,**ny,**nz;

        nx=A.get_f(); ny=B.get_f(); nz=C.get_f();
        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		x[i][j]=nx[i][j]*3.0*nz[i][j];
		y[i][j]=ny[i][j]*3.0*nz[i][j];
		z[i][j]=(1-nx[i][j]-ny[i][j])*3.0*nz[i][j];
	}
     //temp.normalise();
     return(temp);
}

_COLOR _COLOR::UVW_to_MOD_UVW()
{
        _COLOR temp(MOD_UVW);
        _COLOR temp1;
         float ymin,ymax;
      if(col_space!=UVW){
         cout<<"Image is not in UVW space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,MOD_UVW);
        temp1=(*this).UVW_to_NUVW();

	int i,j;
	float acc;
        float **V,**nx,**ny,**W,**Y,**nu,**nv;;

        V=B.get_f(); 
        nx=temp.A.get_f(); ny=temp.B.get_f(); W=temp.C.get_f();
        nu=temp1.A.get_f(); nv=temp1.B.get_f(); 

        normalise();
        ymin=B.get_min();
        ymax=B.get_max();

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
           // W[i][j]=25.0*(float)(pow(100.0*(double)((V[i][j]-ymin)/(ymax-ymin)),1/3.0))-17;
           W[i][j]=25.0*(float)(pow(100.0*(double)(V[i][j]/255.0),1/3.0))-17;
           nx[i][j]=13*W[i][j]*(nu[i][j]-Uo);//Uo=4/19
           ny[i][j]=13*W[i][j]*(nv[i][j]-Vo);//Vo=6/19
	}
     temp1.free();
     //temp.normalise();
     return(temp);
}
/************this has been added on 19.01.2000 ****************/

_COLOR _COLOR::XYZ_to_CIELUV()
{
        _COLOR temp(CIELUV);
        _COLOR temp1;
        // float xmax,xmin,ymin,ymax,zmax,zmin;
      if(col_space!=XYZ){
         cout<<"Image is not in XYZ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,CIELUV);
     //   temp1=(*this).UVW_to_NUVW();

	int i,j;
	float acc;
        float **X,**Y,**Z,**nx,**ny,**nz,**W,**nu,**nv;

        X=A.get_f(); Y=B.get_f(); Z=C.get_f(); 
        W=temp.A.get_f(); nu=temp.B.get_f(); nv=temp.C.get_f();

        normalise();
	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
        if((Y[i][j]/255)>0.008856) 
          W[i][j]=116*pow((double)(Y[i][j]/255),1/3.0)-16;
        else
          W[i][j]=116*7.787*(Y[i][j]/255)+16/116; 
           nu[i][j]=13*W[i][j]*(((4*X[i][j])/(X[i][j]+Y[i][j]+Z[i][j]))-0.21052632);
           nv[i][j]=13*W[i][j]*(((9*Y[i][j])/(X[i][j]+Y[i][j]+Z[i][j]))-0.47368421);//Vo=9/19
	}
//     temp1.free();
     //temp.normalise();
     return(temp);
}


_COLOR _COLOR::XYZ_to_CIELAB()
{
        _COLOR temp(CIELAB);
        _COLOR temp1;
        // float xmax,xmin,ymin,ymax,zmax,zmin;
      if(col_space!=XYZ){
         cout<<"Image is not in XYZ space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,CIELAB);
     //   temp1=(*this).UVW_to_NUVW();

	int i,j;
	float acc;
        float **X,**Y,**Z,**nx,**ny,**nz,**W,**na,**nb;;

        X=A.get_f(); Y=B.get_f(); Z=C.get_f(); 
        W=temp.A.get_f(); na=temp.B.get_f(); nb=temp.C.get_f();

        normalise();
	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
        if((Y[i][j]/255)>0.008856) 
          W[i][j]=116*pow((double)(Y[i][j]/255),1/3.0)-16;
        else
          W[i][j]=116*7.787*(Y[i][j]/255)+16/116; 
           na[i][j]=500*(pow((double)(X[i][j]/255),1/3.0)-pow((double)(Y[i][j]/255),1/3.0));
           nb[i][j]=200*(pow((double)(Y[i][j]/255),1/3.0)-pow((double)(Z[i][j]/255),1/3.0));
	}
//     temp1.free();
     //temp.normalise();
     return(temp);
}
/****************************/


_COLOR _COLOR::NUVW_to_LHS()
{
 // float  u0=4/19; 
  //float v0=6/19;
         load_ref_uv();
        _COLOR temp(LHS);
      if(col_space!=NUVW){
         cout<<"Image is not in NUVW space \n";
         return temp;
         }

        int i,j;
        float **nx,**ny,**nz,**angle,**sat,**lum;
       
        nx=A.get_f();ny=B.get_f();nz=C.get_f();

        temp.set(width,height,DFLOAT,LHS);
        lum=temp.A.get_f(); sat=temp.B.get_f(); angle=temp.C.get_f();
        
	for(i=0;i<height;i++)
	for(j=0;j<width;j++) {
                sat[i][j]=sqrt((double)(sqr(nx[i][j]-Uo)+sqr(ny[i][j]-Vo)));
		angle[i][j]= find_angle(nx[i][j],ny[i][j],Uo,Vo);
                lum[i][j]=nz[i][j];
	}
     //temp.normalise();
     return(temp);
}

_COLOR _COLOR::LHS_to_NUVW()
{
  //float  u0=4/19; 
  //float v0=6/19;

         load_ref_uv();
        _COLOR temp(NUVW);
      if(col_space!=LHS){
         cout<<"Image is not in LHS space \n";
         return temp;
         }

        int i,j;
        float **nx,**ny,**nz,**angle,**sat,**lum;
       
        temp.set(width,height,DFLOAT,NUVW);
        nx=temp.A.get_f();ny=temp.B.get_f();nz=temp.C.get_f();

        lum=A.get_f(); sat=B.get_f(); angle=C.get_f();
        
	for(i=0;i<height;i++)
	for(j=0;j<width;j++) {
                nx[i][j]=Uo+(float)sat[i][j]*cos((double)angle[i][j]-M_PI/2);
                ny[i][j]=Vo+(float)sat[i][j]*sin((double)angle[i][j]-M_PI/2);
                nz[i][j]=lum[i][j];
	}
     //temp.normalise();
     return(temp);
}

void _COLOR::define_ntsc_rgb(float rx[][3])
// float rx[3][3];
{
	rx[0][0]=1.167;
	rx[0][1]=-0.146;
	rx[0][2]=-0.151;
	rx[1][0]=0.114;
	rx[1][1]=0.753;
	rx[1][2]=0.159;
	rx[2][0]=-0.001;
	rx[2][1]=0.059;
	rx[2][2]=1.128;
}


_COLOR _COLOR::RGB_to_NTSC()
{
        _COLOR temp(NTSC);
      if(col_space!=RGB){
         cout<<"Image is not in RGB space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,NTSC);
	int i,j;
	float rx[3][3],irx[3][3];
        float **x,**y,**z;
        unsigned char **r,**g,**b;

        r=A.get_pic(); g=B.get_pic(); b=C.get_pic();
        x=temp.A.get_f(); y=temp.B.get_f(); z=temp.C.get_f();

	define_ntsc_rgb(irx);
	inverse(irx,rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		x[i][j]=(rx[0][0]*(float)r[i][j]+rx[0][1]*(float)g[i][j]+rx[0][2]*(float)b[i][j]);
		y[i][j]=(rx[1][0]*(float)r[i][j]+rx[1][1]*(float)g[i][j]+rx[1][2]*(float)b[i][j]);
		z[i][j]=(rx[2][0]*(float)r[i][j]+rx[2][1]*(float)g[i][j]+rx[2][2]*(float)b[i][j]);
	}
      //temp.normalise();
      return(temp);
}

 

_COLOR _COLOR::NTSC_to_RGB()
{
         int count=0;
        _COLOR temp;
      if(col_space!=NTSC){
         cout<<"Image is not in NTSC space \n";
         return temp;
         }
        temp.set(width,height);

	int i,j,rtemp,gtemp,btemp;
	float irx[3][3];
	float fr,fg,fb;
        unsigned char **r,**g,**b;

        r=temp.A.get_pic(); g=temp.B.get_pic(); b=temp.C.get_pic();
	define_ntsc_rgb(irx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		rtemp=(int)(irx[0][0]*A.pixel(i,j)+irx[0][1]*B.pixel(i,j)+irx[0][2]*C.pixel(i,j));
		if(rtemp>255) rtemp=255;
		gtemp=(int)(irx[1][0]*A.pixel(i,j)+irx[1][1]*B.pixel(i,j)+irx[1][2]*C.pixel(i,j));
		if(gtemp>255) gtemp=255;
		btemp=(int)(irx[2][0]*A.pixel(i,j)+irx[2][1]*B.pixel(i,j)+irx[2][2]*C.pixel(i,j));
		if(btemp>255) btemp=255;
                if((rtemp<0)||(gtemp<0)||(btemp<0)){
                count++;
                //cout<<"rtemp="<<rtemp<<" gtemp="<<gtemp<<" btemp="<<btemp<<"\n";
                rtemp=gtemp=btemp=0;
                }
		r[i][j]=(unsigned char) rtemp;
		g[i][j]=(unsigned char) gtemp;
		b[i][j]=(unsigned char) btemp;
	}
        if(count>0) cout<<count<<" No. of pixels not mapped to RGB and set to zero \n";
        return(temp);
}

void _COLOR::define_yuv_rgb(float rx[][3]) //added 27.02.2001
// float rx[3][3];
{
	rx[0][0]=1.0;
	rx[0][1]=0;
	rx[0][2]=1.3707;
	rx[1][0]=1;
	rx[1][1]=-0.3365;
	rx[1][2]=-0.6982;
	rx[2][0]=1.0;
	rx[2][1]=1.7324;
	rx[2][2]=0;
}


_COLOR _COLOR::YUV_to_RGB() // Added 27.02.2001
{
        _COLOR temp(RGB);
      if(col_space!=YUV){
         cout<<"Image is not in YUV space \n";
         return temp;
         }
        temp.set(width,height);
	int i,j;
	float rx[3][3];
        float val;
        unsigned char  **x,**y,**z;
        float **r,**g,**b;

        r=A.get_f(); g=B.get_f(); b=C.get_f();
        x=temp.A.get_pic(); y=temp.B.get_pic(); z=temp.C.get_pic();

	define_yuv_rgb(rx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		val=(rx[0][0]*(float)r[i][j]+rx[0][1]*(float)g[i][j]+rx[0][2]*(float)b[i][j]);
                if(val<=0) x[i][j]=0;
                      else if(val>=255.0) x[i][j]=255;
                          else x[i][j]=(int) val;

		val=(rx[1][0]*(float)r[i][j]+rx[1][1]*(float)g[i][j]+rx[1][2]*(float)b[i][j]);
                if(val<=0) y[i][j]=0;
                      else if(val>=255.0) y[i][j]=255;
                          else y[i][j]=(int) val;

		val=(rx[2][0]*(float)r[i][j]+rx[2][1]*(float)g[i][j]+rx[2][2]*(float)b[i][j]);
                if(val<=0) z[i][j]=0;
                      else if(val>=255.0) z[i][j]=255;
                          else z[i][j]=(int) val;

	}
      //temp.normalise();
      return(temp);
}

 

_COLOR _COLOR::RGB_to_YUV() // added 27.02.2001
{
         int count=0;
        _COLOR temp;
      if(col_space!=RGB){
         cout<<"Image is not in RGB space \n";
         return temp;
         }
        temp.set(width,height,DFLOAT,YUV);

	int i,j,rtemp,gtemp,btemp;
	float irx[3][3],rx[3][3];
//	float fr,fg,fb;
        float **r,**g,**b;

        r=temp.A.get_f(); g=temp.B.get_f(); b=temp.C.get_f();
	define_yuv_rgb(rx);
	inverse(rx,irx);

	for(i=0;i<height;i++)
	for(j=0;j<width;j++)  {
		r[i][j]=(irx[0][0]*A.pixel(i,j)+irx[0][1]*B.pixel(i,j)+irx[0][2]*C.pixel(i,j));
		g[i][j]=(irx[1][0]*A.pixel(i,j)+irx[1][1]*B.pixel(i,j)+irx[1][2]*C.pixel(i,j));
		b[i][j]=(irx[2][0]*A.pixel(i,j)+irx[2][1]*B.pixel(i,j)+irx[2][2]*C.pixel(i,j));
	}
        return(temp);
}


float _COLOR::_g1(float dI,float K)
 {
  if(K==0) return(0);
  else
  return((float)exp((double) -(sqr(dI/K))));
 }

 _GREY _COLOR::aniso_diffusion(float lamda=0.2,float weight=0.9,int Niter=20)
 {
  _GREY im_t,im_t1,grad;
  _GREY im_r,im_r1,im_g,im_g1,im_b,im_b1;
  _signal hist;
   float **t,**t1,**temp;
   float **r,**r1,**g,**g1,**b,**b1;
   float cN,cS,cW,cE;
   float KI,Kmax,KR,KG,KB;
   float dIN,dIS,dIW,dIE;
   float dRN,dRS,dRW,dRE;
   float dGN,dGS,dGW,dGE;
   float dBN,dBS,dBW,dBE;
   float dImax,dIavg;
   float dRmax,dRavg;
   float dGmax,dGavg;
   float dBmax,dBavg;
   long count=0;
 
   
   
   int i,j,k;

  KI=KR=KG=KB=5;
   
   
   im_t.set(width,height,0,DFLOAT);
   im_t1.set(width,height,0,DFLOAT);
   im_r.set(width,height,0,DFLOAT);
   im_r1.set(width,height,0,DFLOAT);
   im_g.set(width,height,0,DFLOAT);
   im_g1.set(width,height,0,DFLOAT);
   im_b.set(width,height,0,DFLOAT);
   im_b1.set(width,height,0,DFLOAT);

   t=im_t.get_f();
   t1=im_t1.get_f();
   r=im_r.get_f();
   r1=im_r1.get_f();
   g=im_g.get_f();
   g1=im_g1.get_f();
   b=im_b.get_f();
   b1=im_b1.get_f();

    switch(col_space){

   case RGB:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=(A.pixel(i,j)+B.pixel(i,j)+C.pixel(i,j))/3;
                   }
                  break;
   case NTSC:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=(A.pixel(i,j)+B.pixel(i,j)+C.pixel(i,j))/3;
                   }
                  break;
   case XYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=g[i][j];
                   }
                  break;
   case UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=g[i][j];
                   }
                  break;
   case NUVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=b[i][j];
                   }
                  break;
   case NXYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=b[i][j];
                   }
                  break;
   case MOD_UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=b[i][j];
                   }
                  break;
   default:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   t[i][j]=r[i][j];
                   }
                   cout<<"WARNING: check col_space \n";
                  break;
   }

   for(k=0;k<Niter;k++){
   dImax=0;
   dIavg=0;
   dRmax=0;
   dRavg=0;
   dGmax=0;
   dGavg=0;
   dBmax=0;
   dBavg=0;
   count=0;


   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dIN=t[i-1][j]-t[i][j];
   dIS=t[i+1][j]-t[i][j];
   dIE=t[i][j+1]-t[i][j];
   dIW=t[i][j-1]-t[i][j];
   
   dRN=r[i-1][j]-r[i][j];
   dRS=r[i+1][j]-r[i][j];
   dRE=r[i][j+1]-r[i][j];
   dRW=r[i][j-1]-r[i][j];
   
   dGN=g[i-1][j]-g[i][j];
   dGS=g[i+1][j]-g[i][j];
   dGE=g[i][j+1]-g[i][j];
   dGW=g[i][j-1]-g[i][j];
   
   dBN=b[i-1][j]-b[i][j];
   dBS=b[i+1][j]-b[i][j];
   dBE=b[i][j+1]-b[i][j];
   dBW=b[i][j-1]-b[i][j];
   
   if(abs(dIN)>dImax) dImax=abs(dIN);
   if(abs(dIS)>dImax) dImax=abs(dIS);
   if(abs(dIE)>dImax) dImax=abs(dIE);
   if(abs(dIW)>dImax) dImax=abs(dIW);
   dIavg=((float)count*dIavg+abs(dIN)+abs(dIS)+abs(dIW)+abs(dIE))/(float)(count+4);

   if(abs(dRN)>dRmax) dRmax=abs(dRN);
   if(abs(dRS)>dRmax) dRmax=abs(dRS);
   if(abs(dRE)>dRmax) dRmax=abs(dRE);
   if(abs(dRW)>dRmax) dRmax=abs(dRW);
   dRavg=((float)count*dRavg+abs(dRN)+abs(dRS)+abs(dRW)+abs(dRE))/(float)(count+4);

   if(abs(dGN)>dGmax) dGmax=abs(dGN);
   if(abs(dGS)>dGmax) dGmax=abs(dGS);
   if(abs(dGE)>dGmax) dGmax=abs(dGE);
   if(abs(dGW)>dGmax) dGmax=abs(dGW);
   dGavg=((float)count*dGavg+abs(dGN)+abs(dGS)+abs(dGW)+abs(dGE))/(float)(count+4);

   if(abs(dBN)>dBmax) dBmax=abs(dBN);
   if(abs(dBS)>dBmax) dBmax=abs(dBS);
   if(abs(dBE)>dBmax) dBmax=abs(dBE);
   if(abs(dBW)>dBmax) dBmax=abs(dBW);
   dBavg=((float)count*dBavg+abs(dBN)+abs(dBS)+abs(dBW)+abs(dBE))/(float)(count+4);


   count=count+4;

   {
   float dIN1,dIS1,dIW1,dIE1;

   dIN1=(float)sqrt((double)(sqr(dRN)+sqr(dGN)+sqr(dBN)));
   dIS1=(float)sqrt((double)(sqr(dRS)+sqr(dGS)+sqr(dBS)));
   dIW1=(float)sqrt((double)(sqr(dRW)+sqr(dGW)+sqr(dBW)));
   dIE1=(float)sqrt((double)(sqr(dRE)+sqr(dGE)+sqr(dBE)));

   //t1[i][j]=t[i][j]+lamda*(_g1(dIN,KI)*dIN+_g1(dIS,KI)*dIS+_g1(dIE,KI)*dIE+_g1(dIW,KI)*dIW);
   //t1[i][j]=t[i][j]+lamda*(_g1(dIN,abs(KI-dIN1))*dIN+_g1(dIS,abs(KI-dIS1))*dIS+_g1(dIE,abs(KI-dIW1))*dIE+_g1(dIW,abs(KI-dIW1))*dIW);
   t1[i][j]=t[i][j]+lamda*(_g1(dIN1,KI)*dIN+_g1(dIS1,KI)*dIS+_g1(dIE1,KI)*dIE+_g1(dIW1,KI)*dIW);


   r1[i][j]=r[i][j]+lamda*(_g1(dRN,KR)*dRN+_g1(dRS,KR)*dRS+_g1(dRE,KR)*dRE+_g1(dRW,KR)*dRW);
   g1[i][j]=g[i][j]+lamda*(_g1(dGN,KG)*dGN+_g1(dGS,KG)*dGS+_g1(dGE,KG)*dGE+_g1(dGW,KG)*dGW);
   b1[i][j]=b[i][j]+lamda*(_g1(dBN,KB)*dBN+_g1(dBS,KB)*dBS+_g1(dBE,KB)*dBE+_g1(dBW,KB)*dBW);
   }
   }

     temp=t;
     t=t1;
     t1=temp;

     temp=r;
     r=r1;
     r1=temp;

     temp=g;
     g=g1;
     g1=temp;

     temp=b;
     b=b1;
     b1=temp;


   KR=weight*dRavg+(1-weight)*dRmax;
   KG=weight*dGavg+(1-weight)*dGmax;
   KB=weight*dBavg+(1-weight)*dBmax;
   KI=(float)sqrt((double)(sqr(KR)+sqr(KG)+sqr(KB)));
   cout<<"Edge Thresh "<<KI<<" dIavg= "<<dIavg<<" dImax= "<<dImax<<"\n";
   cout<<"R_Edge Thresh "<<KR<<" dRavg= "<<dRavg<<" dRmax= "<<dRmax<<"\n";
   cout<<"G_Edge Thresh "<<KG<<" dGavg= "<<dGavg<<" dGmax= "<<dGmax<<"\n";
   cout<<"B_Edge Thresh "<<KB<<" dBavg= "<<dBavg<<" dBmax= "<<dBmax<<"\n";

   cout<<"Iteration :"<<k<<"\n";

   }

  im_t1.free();
  im_r1.free();
  im_r.free();
  im_g1.free();
  im_g.free();
  im_b1.free();
  im_b.free();

  im_t.adjust_image();
   
  return(im_t);
 }


 _COLOR _COLOR::aniso_diffusion_smooth(float lamda=0.2,float weight=0.9,int Niter=20)
 {
  _GREY im_r,im_r1,im_g,im_g1,im_b,im_b1;
   _COLOR cim_t(col_space);
  _signal hist;
   float **temp,**r,**r1,**g,**g1,**b,**b1;
   float cN,cS,cW,cE;
   float KR,KG,KB;
   float dRN,dRS,dRW,dRE;
   float dGN,dGS,dGW,dGE;
   float dBN,dBS,dBW,dBE;
   float dRmax,dRavg;
   float dGmax,dGavg;
   float dBmax,dBavg;
   long count=0;
 
   
   
   int i,j,k;
 
   
    /*

   _signal kr_s(Niter),kg_s(Niter),kb_s(Niter);// To be removed later
    float *krval,*kgval,*kbval;
    krval=kr_s.get_r();
    kgval=kg_s.get_r();
    kbval=kb_s.get_r();

     */
  KR=KG=KB=5;
   
   
   im_r.set(width,height,0,DFLOAT);
   im_r1.set(width,height,0,DFLOAT);
   im_g.set(width,height,0,DFLOAT);
   im_g1.set(width,height,0,DFLOAT);
   im_b.set(width,height,0,DFLOAT);
   im_b1.set(width,height,0,DFLOAT);

   r=im_r.get_f();
   r1=im_r1.get_f();
   g=im_g.get_f();
   g1=im_g1.get_f();
   b=im_b.get_f();
   b1=im_b1.get_f();

    switch(col_space){

   case RGB:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NTSC:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case XYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NUVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NXYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case MOD_UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   default:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                   cout<<"WARNING: check col_space \n";
                  break;
   }

   for(k=0;k<Niter;k++){
   dRmax=0;
   dRavg=0;
   dGmax=0;
   dGavg=0;
   dBmax=0;
   dBavg=0;
   count=0;

   /*
   krval[k]=KR;
   kgval[k]=KG;
   kbval[k]=KB;
   */

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dRN=r[i-1][j]-r[i][j];
   dRS=r[i+1][j]-r[i][j];
   dRE=r[i][j+1]-r[i][j];
   dRW=r[i][j-1]-r[i][j];
   
   dGN=g[i-1][j]-g[i][j];
   dGS=g[i+1][j]-g[i][j];
   dGE=g[i][j+1]-g[i][j];
   dGW=g[i][j-1]-g[i][j];
   
   dBN=b[i-1][j]-b[i][j];
   dBS=b[i+1][j]-b[i][j];
   dBE=b[i][j+1]-b[i][j];
   dBW=b[i][j-1]-b[i][j];
   

   if(abs(dRN)>dRmax) dRmax=abs(dRN);
   if(abs(dRS)>dRmax) dRmax=abs(dRS);
   if(abs(dRE)>dRmax) dRmax=abs(dRE);
   if(abs(dRW)>dRmax) dRmax=abs(dRW);
   dRavg=((float)count*dRavg+abs(dRN)+abs(dRS)+abs(dRW)+abs(dRE))/(float)(count+4);

   if(abs(dGN)>dGmax) dGmax=abs(dGN);
   if(abs(dGS)>dGmax) dGmax=abs(dGS);
   if(abs(dGE)>dGmax) dGmax=abs(dGE);
   if(abs(dGW)>dGmax) dGmax=abs(dGW);
   dGavg=((float)count*dGavg+abs(dGN)+abs(dGS)+abs(dGW)+abs(dGE))/(float)(count+4);

   if(abs(dBN)>dBmax) dBmax=abs(dBN);
   if(abs(dBS)>dBmax) dBmax=abs(dBS);
   if(abs(dBE)>dBmax) dBmax=abs(dBE);
   if(abs(dBW)>dBmax) dBmax=abs(dBW);
   dBavg=((float)count*dBavg+abs(dBN)+abs(dBS)+abs(dBW)+abs(dBE))/(float)(count+4);


   count=count+4;

   {


   r1[i][j]=r[i][j]+lamda*(_g1(dRN,KR)*dRN+_g1(dRS,KR)*dRS+_g1(dRE,KR)*dRE+_g1(dRW,KR)*dRW);
   g1[i][j]=g[i][j]+lamda*(_g1(dGN,KG)*dGN+_g1(dGS,KG)*dGS+_g1(dGE,KG)*dGE+_g1(dGW,KG)*dGW);
   b1[i][j]=b[i][j]+lamda*(_g1(dBN,KB)*dBN+_g1(dBS,KB)*dBS+_g1(dBE,KB)*dBE+_g1(dBW,KB)*dBW);
   }
   }


     temp=r;
     r=r1;
     r1=temp;

     temp=g;
     g=g1;
     g1=temp;

     temp=b;
     b=b1;
     b1=temp;


   KR=weight*dRavg+(1-weight)*dRmax;
   KG=weight*dGavg+(1-weight)*dGmax;
   KB=weight*dBavg+(1-weight)*dBmax;
   cout<<"R_Edge Thresh "<<KR<<" dRavg= "<<dRavg<<" dRmax= "<<dRmax<<"\n";
   cout<<"G_Edge Thresh "<<KG<<" dGavg= "<<dGavg<<" dGmax= "<<dGmax<<"\n";
   cout<<"B_Edge Thresh "<<KB<<" dBavg= "<<dBavg<<" dBmax= "<<dBmax<<"\n";

   cout<<"Iteration :"<<k<<"\n";

   }

  /*
  kr_s.save("out.kr");
  kg_s.save("out.kg");
  kb_s.save("out.kb");
  kr_s.free();
  kg_s.free();
  kb_s.free();
  */


  im_r1.free();
  im_g1.free();
  im_b1.free();

  cim_t.load(im_r,im_g,im_b,col_space);

   
  return(cim_t);
 }



 _COLOR _COLOR::aniso_diffusion_retinex(float lamda=0.2,float weight=0.9,int Niter=20,float gain=192,float boff=-30,float crf_alpha=125, float crf_beta=46)
 {
  _GREY im_r,im_r1,im_g,im_g1,im_b,im_b1;
   _COLOR cim_t(col_space);
  _signal hist;
   float **temp,**r,**r1,**g,**g1,**b,**b1;
   float cN,cS,cW,cE;
   float KR,KG,KB;
   float dRN,dRS,dRW,dRE;
   float dGN,dGS,dGW,dGE;
   float dBN,dBS,dBW,dBE;
   float iRmax,iRavg;
   float iGmax,iGavg;
   float iBmax,iBavg;
   float iR,iG,iB;
   float valR,valG,valB;
   long count=0;

   float sumValR=0,sumValG=0,sumValB=0;
   float avgValR,maxValR=-9999,minValR=9999;
   float avgValG,maxValG=-9999,minValG=9999;
   float avgValB,maxValB=-9999,minValB=9999;
   float minRange,maxRange;
   float crfR,crfG,crfB;
 
   
   
   int i,j,k,l,m;
 
   
  KR=KG=KB=5;
   
   
   im_r.set(width,height,0,DFLOAT);
   im_r1.set(width,height,0,DFLOAT);
   im_g.set(width,height,0,DFLOAT);
   im_g1.set(width,height,0,DFLOAT);
   im_b.set(width,height,0,DFLOAT);
   im_b1.set(width,height,0,DFLOAT);

   r=im_r.get_f();
   r1=im_r1.get_f();
   g=im_g.get_f();
   g1=im_g1.get_f();
   b=im_b.get_f();
   b1=im_b1.get_f();

    switch(col_space){

   case RGB:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NTSC:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case XYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NUVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NXYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case MOD_UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   default:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                   cout<<"WARNING: check col_space \n";
                  break;
   }

   for(k=0;k<Niter;k++){
   iRmax=0;
   iRavg=0;
   iGmax=0;
   iGavg=0;
   iBmax=0;
   iBavg=0;
   count=0;

   /*
   krval[k]=KR;
   kgval[k]=KG;
   kbval[k]=KB;
   */

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dRN=(r[i-1][j]-r[i][j]);
   dRS=(r[i+1][j]-r[i][j]);
   dRE=(r[i][j+1]-r[i][j]);
   dRW=(r[i][j-1]-r[i][j]);
   
   dGN=(g[i-1][j]-g[i][j]);
   dGS=(g[i+1][j]-g[i][j]);
   dGE=(g[i][j+1]-g[i][j]);
   dGW=(g[i][j-1]-g[i][j]);
   
   dBN=(b[i-1][j]-b[i][j]);
   dBS=(b[i+1][j]-b[i][j]);
   dBE=(b[i][j+1]-b[i][j]);
   dBW=(b[i][j-1]-b[i][j]);
   
    iR=0;
    for(l=-1;l<=1;l++)
    for(m=-1;m<=1;m++)
       iR+=r[i+l][j+m];

       iR=iR/9;
   
   
    iG=0;
    for(l=-1;l<=1;l++)
    for(m=-1;m<=1;m++)
       iG+=g[i+l][j+m];

       iG=iG/9;
   
   
    iB=0;
    for(l=-1;l<=1;l++)
    for(m=-1;m<=1;m++)
       iB+=b[i+l][j+m];

       iB=iB/9;
   

   if(abs(iR)>iRmax) iRmax=abs(iR);
   if(abs(iG)>iGmax) iGmax=abs(iG);
   if(abs(iB)>iBmax) iBmax=abs(iB);
   iRavg=((float)count*iRavg+abs(iR))/(float)(count+1);
   iGavg=((float)count*iGavg+abs(iG))/(float)(count+1);
   iBavg=((float)count*iBavg+abs(iB))/(float)(count+1);

   count=count+1;



   r1[i][j]=r[i][j]+lamda*_g1(iR,KR)*(dRN+dRS+dRE+dRW);
   g1[i][j]=g[i][j]+lamda*_g1(iG,KG)*(dGN+dGS+dGE+dGW);
   b1[i][j]=b[i][j]+lamda*_g1(iB,KB)*(dBN+dBS+dBE+dBW);
   }


     temp=r;
     r=r1;
     r1=temp;

     temp=g;
     g=g1;
     g1=temp;

     temp=b;
     b=b1;
     b1=temp;
/*

   KR=weight*iRavg+(1-weight)*iRmax;
   KG=weight*iGavg+(1-weight)*iGmax;
   KB=weight*iBavg+(1-weight)*iBmax;
   */
   KR=weight*iRavg;
   KG=weight*iGavg;
   KB=weight*iBavg;
   cout<<"R_Brightness Thresh "<<KR<<" iRavg= "<<iRavg<<" iRmax= "<<iRmax<<"\n";
   cout<<"G_Brightness Thresh "<<KG<<" iGavg= "<<iGavg<<" iGmax= "<<iGmax<<"\n";
   cout<<"B_Brightness Thresh "<<KB<<" iBavg= "<<iBavg<<" iBmax= "<<iBmax<<"\n";

   cout<<"Iteration :"<<k<<"\n";

   }

  //Apply retinex transformation

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(r[i][j]<.001) r[i][j]=.001;
     if(g[i][j]<.001) g[i][j]=.001;
     if(b[i][j]<.001) b[i][j]=.001;
     if(valR<.001) valR=.001;
     if(valG<.001) valG=.001;
     if(valB<.001) valB=.001;
     r[i][j]= (float)log((double)valR/(double)r[i][j]);
     g[i][j]= (float)log((double)valG/(double)g[i][j]);
     b[i][j]= (float)log((double)valB/(double)b[i][j]);

     //Color Restoration Function (CRF) compensation
      crfR=crf_beta*(log((double)(crf_alpha*valR/(valR+valG+valB))));
      crfG=crf_beta*(log((double)(crf_alpha*valG/(valR+valG+valB))));
      crfB=crf_beta*(log((double)(crf_alpha*valB/(valR+valG+valB))));
      /*
      crfR=crf_beta*(crf_alpha*valR/(valR+valG+valB));
      crfG=crf_beta*(crf_alpha*valG/(valR+valG+valB));
      crfB=crf_beta*(crf_alpha*valB/(valR+valG+valB));
      */

     //Gain: gain offset: boff
      r[i][j]=gain*(crfR*r[i][j]+boff);
      g[i][j]=gain*(crfG*g[i][j]+boff);
      b[i][j]=gain*(crfB*b[i][j]+boff);

     sumValR+=r[i][j];
     sumValG+=g[i][j];
     sumValB+=b[i][j];

     if(r[i][j]>maxValR) maxValR=r[i][j];
     if(g[i][j]>maxValG) maxValG=g[i][j];
     if(b[i][j]>maxValB) maxValB=b[i][j];

     if(r[i][j]<minValR) minValR=r[i][j];
     if(g[i][j]<minValG) minValG=g[i][j];
     if(b[i][j]<minValB) minValB=b[i][j];
   }
     avgValR=sumValR/((float)width*(float)height);
     avgValG=sumValG/((float)width*(float)height);
     avgValB=sumValB/((float)width*(float)height);

     cout<<"Avg values :"<<avgValR<<" "<<avgValG<<" "<<avgValB<<"\n";
     cout<<"Max values :"<<maxValR<<" "<<maxValG<<" "<<maxValB<<"\n";
     cout<<"Min values :"<<minValR<<" "<<minValG<<" "<<minValB<<"\n";

     cout<<"Give minRange & maxRange for normalisation \n";
     cin>>minRange>>maxRange;

     im_r.adjust_image();
     im_g.adjust_image();
     im_b.adjust_image();

     im_r.normalise_pic(minRange,maxRange);
     im_g.normalise_pic(minRange,maxRange);
     im_b.normalise_pic(minRange,maxRange);

  im_r1.free();
  im_g1.free();
  im_b1.free();

  cim_t.load(im_r,im_g,im_b,col_space);
  //cim_t.normalise();

   
  return(cim_t);
 }

 _COLOR _COLOR::iso_diffusion_retinex(float lamda=0.2,int Niter=20,float gain=192,float boff=-30,float crf_alpha=125, float crf_beta=46) // single_scale
 {
  _GREY im_r,im_r1,im_g,im_g1,im_b,im_b1;
   _COLOR cim_t(col_space);
   float **temp,**r,**r1,**g,**g1,**b,**b1;
   float dRN,dRS,dRW,dRE;
   float dGN,dGS,dGW,dGE;
   float dBN,dBS,dBW,dBE;
   float valR,valG,valB;

   float sumValR=0,sumValG=0,sumValB=0;
   float avgValR,maxValR=-9999,minValR=9999;
   float avgValG,maxValG=-9999,minValG=9999;
   float avgValB,maxValB=-9999,minValB=9999;
   float minRange,maxRange;
   float crfR,crfG,crfB;
 
   
   
   int i,j,k,l,m;
 
   
   
   
   im_r.set(width,height,0,DFLOAT);
   im_r1.set(width,height,0,DFLOAT);
   im_g.set(width,height,0,DFLOAT);
   im_g1.set(width,height,0,DFLOAT);
   im_b.set(width,height,0,DFLOAT);
   im_b1.set(width,height,0,DFLOAT);

   r=im_r.get_f();
   r1=im_r1.get_f();
   g=im_g.get_f();
   g1=im_g1.get_f();
   b=im_b.get_f();
   b1=im_b1.get_f();

    switch(col_space){

   case RGB:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NTSC:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case XYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NUVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NXYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case MOD_UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   default:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                   cout<<"WARNING: check col_space \n";
                  break;
   }

   for(k=0;k<Niter;k++){


   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dRN=(r[i-1][j]-r[i][j]);
   dRS=(r[i+1][j]-r[i][j]);
   dRE=(r[i][j+1]-r[i][j]);
   dRW=(r[i][j-1]-r[i][j]);
   
   dGN=(g[i-1][j]-g[i][j]);
   dGS=(g[i+1][j]-g[i][j]);
   dGE=(g[i][j+1]-g[i][j]);
   dGW=(g[i][j-1]-g[i][j]);
   
   dBN=(b[i-1][j]-b[i][j]);
   dBS=(b[i+1][j]-b[i][j]);
   dBE=(b[i][j+1]-b[i][j]);
   dBW=(b[i][j-1]-b[i][j]);
   
   r1[i][j]=r[i][j]+lamda*(dRN+dRS+dRE+dRW);
   g1[i][j]=g[i][j]+lamda*(dGN+dGS+dGE+dGW);
   b1[i][j]=b[i][j]+lamda*(dBN+dBS+dBE+dBW);
   }


     temp=r;
     r=r1;
     r1=temp;

     temp=g;
     g=g1;
     g1=temp;

     temp=b;
     b=b1;
     b1=temp;


   cout<<"Iteration :"<<k<<"\n";

   }

  //Apply retinex transformation

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(r[i][j]<1) r[i][j]=1;
     if(g[i][j]<1) g[i][j]=1;
     if(b[i][j]<1) b[i][j]=1;
     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;
     r[i][j]= (float)log((double)valR/(double)r[i][j]);
     g[i][j]= (float)log((double)valG/(double)g[i][j]);
     b[i][j]= (float)log((double)valB/(double)b[i][j]);

     //Color Restoration Function (CRF) compensation
      crfR=crf_beta*(log((double)(crf_alpha*valR/(valR+valG+valB))));
      crfG=crf_beta*(log((double)(crf_alpha*valG/(valR+valG+valB))));
      crfB=crf_beta*(log((double)(crf_alpha*valB/(valR+valG+valB))));
      /*
      crfR=crf_beta*(crf_alpha*valR/(valR+valG+valB));
      crfG=crf_beta*(crf_alpha*valG/(valR+valG+valB));
      crfB=crf_beta*(crf_alpha*valB/(valR+valG+valB));
      */

     //Gain: gain offset: boff
      r[i][j]=gain*(crfR*r[i][j]+boff);
      g[i][j]=gain*(crfG*g[i][j]+boff);
      b[i][j]=gain*(crfB*b[i][j]+boff);

     sumValR+=r[i][j];
     sumValG+=g[i][j];
     sumValB+=b[i][j];

     if(r[i][j]>maxValR) maxValR=r[i][j];
     if(g[i][j]>maxValG) maxValG=g[i][j];
     if(b[i][j]>maxValB) maxValB=b[i][j];

     if(r[i][j]<minValR) minValR=r[i][j];
     if(g[i][j]<minValG) minValG=g[i][j];
     if(b[i][j]<minValB) minValB=b[i][j];
   }
     avgValR=sumValR/((float)width*(float)height);
     avgValG=sumValG/((float)width*(float)height);
     avgValB=sumValB/((float)width*(float)height);

     cout<<"Avg values :"<<avgValR<<" "<<avgValG<<" "<<avgValB<<"\n";
     cout<<"Max values :"<<maxValR<<" "<<maxValG<<" "<<maxValB<<"\n";
     cout<<"Min values :"<<minValR<<" "<<minValG<<" "<<minValB<<"\n";

     cout<<"Give minRange & maxRange for normalisation \n";
     cin>>minRange>>maxRange;

     im_r.adjust_image();
     im_g.adjust_image();
     im_b.adjust_image();

     im_r.normalise_pic(minRange,maxRange);
     im_g.normalise_pic(minRange,maxRange);
     im_b.normalise_pic(minRange,maxRange);

  im_r1.free();
  im_g1.free();
  im_b1.free();

  cim_t.load(im_r,im_g,im_b,col_space);
  //cim_t.normalise();

   
  return(cim_t);
 }

 _COLOR _COLOR::iso_diffusion_multi_retinex(float lamda=0.2,int Niter=20,float gain=192,float boff=-30,float crf_alpha=125, float crf_beta=46,int mode=1) // multi_scale, mode:1 with CRF, 0 w/o CRF
 {
  _GREY im_r,im_r1,im_g,im_g1,im_b,im_b1;
   _COLOR cim_t;
   float **temp,**r,**r1,**g,**g1,**b,**b1;
   float **cr,**cg,**cb;
   float dRN,dRS,dRW,dRE;
   float dGN,dGS,dGW,dGE;
   float dBN,dBS,dBW,dBE;
   float valR,valG,valB;
   float smR,smG,smB;

   float sumValR=0,sumValG=0,sumValB=0;
   float avgValR,maxValR=-9999,minValR=9999;
   float avgValG,maxValG=-9999,minValG=9999;
   float avgValB,maxValB=-9999,minValB=9999;
   float minRange,maxRange;
   float crfR,crfG,crfB;
 
   
   
   int i,j,k,l,m;
   int count_ret=0;
 
   
   
   
   im_r.set(width,height,0,DFLOAT);
   im_r1.set(width,height,0,DFLOAT);
   im_g.set(width,height,0,DFLOAT);
   im_g1.set(width,height,0,DFLOAT);
   im_b.set(width,height,0,DFLOAT);
   im_b1.set(width,height,0,DFLOAT);
   cim_t.set(width,height,DFLOAT,col_space);

   r=im_r.get_f();
   r1=im_r1.get_f();
   g=im_g.get_f();
   g1=im_g1.get_f();
   b=im_b.get_f();
   b1=im_b1.get_f();
   cr=cim_t.get_fA();
   cg=cim_t.get_fB();
   cb=cim_t.get_fC();


    switch(col_space){

   case RGB:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NTSC:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case XYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NUVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NXYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case MOD_UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   default:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                   cout<<"WARNING: check col_space \n";
                  break;
   }

   for(k=0;k<Niter;k++){


   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dRN=(r[i-1][j]-r[i][j]);
   dRS=(r[i+1][j]-r[i][j]);
   dRE=(r[i][j+1]-r[i][j]);
   dRW=(r[i][j-1]-r[i][j]);
   
   dGN=(g[i-1][j]-g[i][j]);
   dGS=(g[i+1][j]-g[i][j]);
   dGE=(g[i][j+1]-g[i][j]);
   dGW=(g[i][j-1]-g[i][j]);
   
   dBN=(b[i-1][j]-b[i][j]);
   dBS=(b[i+1][j]-b[i][j]);
   dBE=(b[i][j+1]-b[i][j]);
   dBW=(b[i][j-1]-b[i][j]);
   
   r1[i][j]=r[i][j]+lamda*(dRN+dRS+dRE+dRW);
   g1[i][j]=g[i][j]+lamda*(dGN+dGS+dGE+dGW);
   b1[i][j]=b[i][j]+lamda*(dBN+dBS+dBE+dBW);
   }


     temp=r;
     r=r1;
     r1=temp;

     temp=g;
     g=g1;
     g1=temp;

     temp=b;
     b=b1;
     b1=temp;



  //Apply retinex transformation

   if((k+1)%50==0)
   {
    count_ret++;

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(r[i][j]<1) smR=1;
	else smR=r[i][j];
     if(g[i][j]<1) smG=1;
	else smG=g[i][j];
     if(b[i][j]<1) smB=1;
	else smB=b[i][j];
     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;
     cr[i][j]+= (float)log((double)valR/(double)smR);
     cg[i][j]+= (float)log((double)valG/(double)smG);
     cb[i][j]+= (float)log((double)valB/(double)smB);
     }
     }

     cout<<"Iteration no:"<<k<<"\n";

   }

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;

       cr[i][j]=cr[i][j]/count_ret;
       cg[i][j]=cg[i][j]/count_ret;
       cb[i][j]=cb[i][j]/count_ret;

      if(mode)
      {
      //Suggestions incorporated as it was done by Jobson
       cr[i][j]=cr[i][j]*28.44+128;
       cg[i][j]=cg[i][j]*28.44+128;
       cb[i][j]=cb[i][j]*28.44+128;

     //Color Restoration Function (CRF) compensation
      crfR=crf_beta*(log((double)(crf_alpha*valR/(valR+valG+valB))));
      crfG=crf_beta*(log((double)(crf_alpha*valG/(valR+valG+valB))));
      crfB=crf_beta*(log((double)(crf_alpha*valB/(valR+valG+valB))));
      }
      else
      {
        crfR=crfG=crfB=1.0;
      }

     //Gain: gain offset: boff
      cr[i][j]=gain*(crfR*cr[i][j]+boff); //averaged over iteration and mapped
      cg[i][j]=gain*(crfG*cg[i][j]+boff);
      cb[i][j]=gain*(crfB*cb[i][j]+boff);


     sumValR+=cr[i][j];
     sumValG+=cg[i][j];
     sumValB+=cb[i][j];

     if(cr[i][j]>maxValR) maxValR=cr[i][j];
     if(cg[i][j]>maxValG) maxValG=cg[i][j];
     if(cb[i][j]>maxValB) maxValB=cb[i][j];

     if(cr[i][j]<minValR) minValR=cr[i][j];
     if(cg[i][j]<minValG) minValG=cg[i][j];
     if(cb[i][j]<minValB) minValB=cb[i][j];
   }
     avgValR=sumValR/((float)width*(float)height);
     avgValG=sumValG/((float)width*(float)height);
     avgValB=sumValB/((float)width*(float)height);

     cout<<"Avg values :"<<avgValR<<" "<<avgValG<<" "<<avgValB<<"\n";
     cout<<"Max values :"<<maxValR<<" "<<maxValG<<" "<<maxValB<<"\n";
     cout<<"Min values :"<<minValR<<" "<<minValG<<" "<<minValB<<"\n";

     cout<<"Give minRange & maxRange for normalisation \n";
     cin>>minRange>>maxRange;

     cim_t.normalise(minRange,maxRange);


  im_r1.free();
  im_g1.free();
  im_b1.free();
  im_r.free();
  im_g.free();
  im_b.free();


   
  return(cim_t);
 }


 _COLOR _COLOR::JRW_multi_retinex(int mode=1) // multi_scale, mode:1 with CRF, 0 w/o CRF
 {
   float lamda=0.25;
   float sigma1=15;
   float sigma2=80;
   float sigma3=250;
   float gain=192;
   float boff=-30;
   float crf_alpha=125; 
   float crf_beta=46;

  _GREY im_r,im_r1,im_g,im_g1,im_b,im_b1;
   _COLOR cim_t;
   float **temp,**r,**r1,**g,**g1,**b,**b1;
   float **cr,**cg,**cb;
   float dRN,dRS,dRW,dRE;
   float dGN,dGS,dGW,dGE;
   float dBN,dBS,dBW,dBE;
   float valR,valG,valB;
   float smR,smG,smB;

   float sumValR=0,sumValG=0,sumValB=0;
   float avgValR,maxValR=-9999,minValR=9999;
   float avgValG,maxValG=-9999,minValG=9999;
   float avgValB,maxValB=-9999,minValB=9999;
   float minRange,maxRange;
   float crfR,crfG,crfB;
 
   
   
   long int i,j,k,l,m;
   long int iter_bnd1,iter_bnd2,iter_bnd3;
   int count_ret=0;
 
   
    gain=2.7; //suggested by Jobson
    boff= -20; //suggested by Jobson
   
   iter_bnd1=(long int)(sigma1*sigma1/2);
   iter_bnd2=(long int)(sigma2*sigma2/2);
   iter_bnd3=(long int)(sigma3*sigma3/2);

    cout<<"Maximum no. of iteration "<<iter_bnd3<<"\n";
   
   im_r.set(width,height,0,DFLOAT);
   im_r1.set(width,height,0,DFLOAT);
   im_g.set(width,height,0,DFLOAT);
   im_g1.set(width,height,0,DFLOAT);
   im_b.set(width,height,0,DFLOAT);
   im_b1.set(width,height,0,DFLOAT);
   cim_t.set(width,height,DFLOAT,col_space);

   r=im_r.get_f();
   r1=im_r1.get_f();
   g=im_g.get_f();
   g1=im_g1.get_f();
   b=im_b.get_f();
   b1=im_b1.get_f();
   cr=cim_t.get_fA();
   cg=cim_t.get_fB();
   cb=cim_t.get_fC();


    switch(col_space){

   case RGB:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NTSC:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case XYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NUVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NXYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case MOD_UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   default:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                   cout<<"WARNING: check col_space \n";
                  break;
   }

   for(k=0;k<iter_bnd3;k++){


   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dRN=(r[i-1][j]-r[i][j]);
   dRS=(r[i+1][j]-r[i][j]);
   dRE=(r[i][j+1]-r[i][j]);
   dRW=(r[i][j-1]-r[i][j]);
   
   dGN=(g[i-1][j]-g[i][j]);
   dGS=(g[i+1][j]-g[i][j]);
   dGE=(g[i][j+1]-g[i][j]);
   dGW=(g[i][j-1]-g[i][j]);
   
   dBN=(b[i-1][j]-b[i][j]);
   dBS=(b[i+1][j]-b[i][j]);
   dBE=(b[i][j+1]-b[i][j]);
   dBW=(b[i][j-1]-b[i][j]);
   
   r1[i][j]=r[i][j]+lamda*(dRN+dRS+dRE+dRW);
   g1[i][j]=g[i][j]+lamda*(dGN+dGS+dGE+dGW);
   b1[i][j]=b[i][j]+lamda*(dBN+dBS+dBE+dBW);
   }


     temp=r;
     r=r1;
     r1=temp;

     temp=g;
     g=g1;
     g1=temp;

     temp=b;
     b=b1;
     b1=temp;



  //Apply retinex transformation

   if((k==iter_bnd1-1)||(k==iter_bnd2-1)||(k==iter_bnd3-1))
   {

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(r[i][j]<1) smR=1;
	else smR=r[i][j];
     if(g[i][j]<1) smG=1;
	else smG=g[i][j];
     if(b[i][j]<1) smB=1;
	else smB=b[i][j];
     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;
     cr[i][j]+= (float)log((double)valR/(double)smR);
     cg[i][j]+= (float)log((double)valG/(double)smG);
     cb[i][j]+= (float)log((double)valB/(double)smB);
     }
     }

     cout<<"Iteration no:"<<k<<"\n";

   }

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
       cr[i][j]=cr[i][j]/3;
       cg[i][j]=cg[i][j]/3;
       cb[i][j]=cb[i][j]/3;

     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;

      if(mode)
      {
      // Apply transformation as suggested by Jobson
       cr[i][j]=cr[i][j]*28.44+128;
       cg[i][j]=cg[i][j]*28.44+128;
       cb[i][j]=cb[i][j]*28.44+128;

     //Color Restoration Function (CRF) compensation
      crfR=crf_beta*(log((double)(crf_alpha*valR/(valR+valG+valB))));
      crfG=crf_beta*(log((double)(crf_alpha*valG/(valR+valG+valB))));
      crfB=crf_beta*(log((double)(crf_alpha*valB/(valR+valG+valB))));
      }
      else
      {
        crfR=crfG=crfB=1.0;
      }

     //Gain: gain offset: boff
      cr[i][j]=gain*(crfR*cr[i][j]+boff); //averaged over iteration and mapped
      cg[i][j]=gain*(crfG*cg[i][j]+boff);
      cb[i][j]=gain*(crfB*cb[i][j]+boff);


     sumValR+=cr[i][j];
     sumValG+=cg[i][j];
     sumValB+=cb[i][j];

     if(cr[i][j]>maxValR) maxValR=cr[i][j];
     if(cg[i][j]>maxValG) maxValG=cg[i][j];
     if(cb[i][j]>maxValB) maxValB=cb[i][j];

     if(cr[i][j]<minValR) minValR=cr[i][j];
     if(cg[i][j]<minValG) minValG=cg[i][j];
     if(cb[i][j]<minValB) minValB=cb[i][j];
   }
     avgValR=sumValR/((float)width*(float)height);
     avgValG=sumValG/((float)width*(float)height);
     avgValB=sumValB/((float)width*(float)height);

     cout<<"Avg values :"<<avgValR<<" "<<avgValG<<" "<<avgValB<<"\n";
     cout<<"Max values :"<<maxValR<<" "<<maxValG<<" "<<maxValB<<"\n";
     cout<<"Min values :"<<minValR<<" "<<minValG<<" "<<minValB<<"\n";

     cout<<"Give minRange & maxRange for normalisation \n";
     cin>>minRange>>maxRange;

     cim_t.normalise(minRange,maxRange);


  im_r1.free();
  im_g1.free();
  im_b1.free();
  im_r.free();
  im_g.free();
  im_b.free();


   
  return(cim_t);
 }

      float _COLOR::sigmoid(float x,float shift,float scale)
      {
	return(1/(1+(float)(exp((double)(-(x+shift)/scale)))));
      }


 _COLOR _COLOR::iso_diffusion_multi_retinex_sigmoid(float lamda=0.2,int Niter=20,float gain=192,float boff=-30,float crf_alpha=125, float crf_beta=46,float shift=128,float scale=300,int mode=1) // multi_scale, mode:1 with CRF; O w/o CRF
 {
  _GREY im_r,im_r1,im_g,im_g1,im_b,im_b1;
   _COLOR cim_t;
   float **temp,**r,**r1,**g,**g1,**b,**b1;
   float **cr,**cg,**cb;
   float dRN,dRS,dRW,dRE;
   float dGN,dGS,dGW,dGE;
   float dBN,dBS,dBW,dBE;
   float valR,valG,valB;
   float smR,smG,smB;

   float sumValR=0,sumValG=0,sumValB=0;
   float avgValR,maxValR=-9999,minValR=9999;
   float avgValG,maxValG=-9999,minValG=9999;
   float avgValB,maxValB=-9999,minValB=9999;
   float minRange,maxRange;
   float crfR,crfG,crfB;
 
   
   
   int i,j,k,l,m;
   int count_ret=0;

   long int ret_hist[401];
   long int cum_ret_hist[401];
   
 
   
   
   
   im_r.set(width,height,0,DFLOAT);
   im_r1.set(width,height,0,DFLOAT);
   im_g.set(width,height,0,DFLOAT);
   im_g1.set(width,height,0,DFLOAT);
   im_b.set(width,height,0,DFLOAT);
   im_b1.set(width,height,0,DFLOAT);
   cim_t.set(width,height,DFLOAT,col_space);

   r=im_r.get_f();
   r1=im_r1.get_f();
   g=im_g.get_f();
   g1=im_g1.get_f();
   b=im_b.get_f();
   b1=im_b1.get_f();
   cr=cim_t.get_fA();
   cg=cim_t.get_fB();
   cb=cim_t.get_fC();


    switch(col_space){

   case RGB:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NTSC:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case XYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NUVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case NXYZ:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   case MOD_UVW:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                  break;
   default:
                 for(i=0;i<height;i++)
                 for(j=0;j<width;j++)
                   {
                   r[i][j]=A.pixel(i,j);
                   g[i][j]=B.pixel(i,j);
                   b[i][j]=C.pixel(i,j);
                   }
                   cout<<"WARNING: check col_space \n";
                  break;
   }

   for(k=0;k<Niter;k++){


   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dRN=(r[i-1][j]-r[i][j]);
   dRS=(r[i+1][j]-r[i][j]);
   dRE=(r[i][j+1]-r[i][j]);
   dRW=(r[i][j-1]-r[i][j]);
   
   dGN=(g[i-1][j]-g[i][j]);
   dGS=(g[i+1][j]-g[i][j]);
   dGE=(g[i][j+1]-g[i][j]);
   dGW=(g[i][j-1]-g[i][j]);
   
   dBN=(b[i-1][j]-b[i][j]);
   dBS=(b[i+1][j]-b[i][j]);
   dBE=(b[i][j+1]-b[i][j]);
   dBW=(b[i][j-1]-b[i][j]);
   
   r1[i][j]=r[i][j]+lamda*(dRN+dRS+dRE+dRW);
   g1[i][j]=g[i][j]+lamda*(dGN+dGS+dGE+dGW);
   b1[i][j]=b[i][j]+lamda*(dBN+dBS+dBE+dBW);
   }


     temp=r;
     r=r1;
     r1=temp;

     temp=g;
     g=g1;
     g1=temp;

     temp=b;
     b=b1;
     b1=temp;



  //Apply retinex transformation

   if((k+1)%50==0)
   {
    count_ret++;

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);
     /*
     if(r[i][j]<1) smR=1;
	else smR=r[i][j];
     if(g[i][j]<1) smG=1;
	else smG=g[i][j];
     if(b[i][j]<1) smB=1;
	else smB=b[i][j];
     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;
     cr[i][j]+= (float)log((double)valR/(double)smR);
     cg[i][j]+= (float)log((double)valG/(double)smG);
     cb[i][j]+= (float)log((double)valB/(double)smB);
     */
     cr[i][j]+= sigmoid(valR,shift,scale)-sigmoid(r[i][j],shift,scale);
     cg[i][j]+= sigmoid(valG,shift,scale)-sigmoid(g[i][j],shift,scale);
     cb[i][j]+= sigmoid(valB,shift,scale)-sigmoid(b[i][j],shift,scale);
     }
     }

     cout<<"Iteration no:"<<k<<"\n";

   }

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;

     //Color Restoration Function (CRF) compensation
      if(mode)
      {
      crfR=crf_beta*(log((double)(crf_alpha*valR/(valR+valG+valB))));
      crfG=crf_beta*(log((double)(crf_alpha*valG/(valR+valG+valB))));
      crfB=crf_beta*(log((double)(crf_alpha*valB/(valR+valG+valB))));
      }
      else{
      crfR=crfG=crfB=1.0;
      }

     //Gain: gain offset: boff
      cr[i][j]=gain*(crfR*cr[i][j]/count_ret+boff); //averaged over iteration and mapped
      cg[i][j]=gain*(crfG*cg[i][j]/count_ret+boff);
      cb[i][j]=gain*(crfB*cb[i][j]/count_ret+boff);


     sumValR+=cr[i][j];
     sumValG+=cg[i][j];
     sumValB+=cb[i][j];

     if(cr[i][j]>maxValR) maxValR=cr[i][j];
     if(cg[i][j]>maxValG) maxValG=cg[i][j];
     if(cb[i][j]>maxValB) maxValB=cb[i][j];

     if(cr[i][j]<minValR) minValR=cr[i][j];
     if(cg[i][j]<minValG) minValG=cg[i][j];
     if(cb[i][j]<minValB) minValB=cb[i][j];
   }
     avgValR=sumValR/((float)width*(float)height);
     avgValG=sumValG/((float)width*(float)height);
     avgValB=sumValB/((float)width*(float)height);

     cout<<"Avg values :"<<avgValR<<" "<<avgValG<<" "<<avgValB<<"\n";
     cout<<"Max values :"<<maxValR<<" "<<maxValG<<" "<<maxValB<<"\n";
     cout<<"Min values :"<<minValR<<" "<<minValG<<" "<<minValB<<"\n";
     /*
     cout<<"Give minRange & maxRange for normalisation \n";
     cin>>minRange>>maxRange;
     */

     // Finding dynamic range of retinex values assuming ranges are 
     //  within -200  to 200       

     cout<<"Finding dynamic range of retinex values \n";

          // Initialise both arrays
            for(i=0;i<401;i++)
             {
               ret_hist[i]=0;
               cum_ret_hist[i]=0;
             }
   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
      {
           ret_hist[(int)cr[i][j]+200]++;
           ret_hist[(int)cg[i][j]+200]++;
           ret_hist[(int)cb[i][j]+200]++;
      }

      cum_ret_hist[0]=ret_hist[0];
            for(i=1;i<401;i++)
              cum_ret_hist[i]=cum_ret_hist[i-1]+ret_hist[i];
     i=0;
     while(cum_ret_hist[i]<0.02*cum_ret_hist[400]) i++;
     j=400;
     while(cum_ret_hist[j]>0.98*cum_ret_hist[400]) j--;

     cout<<"Dynamic range: min_range="<<i-200<<" max_range="<<j-200<<"\n";
     minRange=(float)(i-200);
     maxRange=(float)(j-200);



     cim_t.normalise(minRange,maxRange);


  im_r1.free();
  im_g1.free();
  im_b1.free();
  im_r.free();
  im_g.free();
  im_b.free();


   
  return(cim_t);
 }

 _COLOR _COLOR::grey_retinex_sigmoid(float lamda=0.2,int Niter=20,float gain=192,float boff=-30,float crf_alpha=125, float crf_beta=46,float shift=128,float scale=300,int mode=1) // multi_scale, mode:1 with CRF; O w/o CRF
 {
  _GREY im_grey,im_r1;
   _COLOR cim_t;
   float **temp,**r,**r1;
   float **cr,**cg,**cb;
   float dRN,dRS,dRW,dRE;
   float valR,valG,valB;
   float smR,smG,smB;

   float sumValR=0,sumValG=0,sumValB=0;
   float avgValR,maxValR=-9999,minValR=9999;
   float avgValG,maxValG=-9999,minValG=9999;
   float avgValB,maxValB=-9999,minValB=9999;
   float minRange,maxRange;
   float crfR,crfG,crfB;
 
   
   
   int i,j,k,l,m;
   int count_ret=0;
   long int ret_hist[401];
   long int cum_ret_hist[401];
 
   
   
   
                 im_r1.set(width,height,0,DFLOAT);
                 r1=im_r1.get_f();

   cim_t.set(width,height,DFLOAT,col_space);
   cr=cim_t.get_fA();
   cg=cim_t.get_fB();
   cb=cim_t.get_fC();


    switch(col_space){

   case RGB:
                im_grey=RGB_to_GREY();
                r=im_grey.get_f();
                  break;
   case NTSC:
                im_grey=NTSC_to_GREY();
                r=im_grey.get_f();
                  break;
   case XYZ:
                 im_grey.set(width,height,0,DFLOAT);
                 r=im_grey.get_f();
                    for(i=0;i<height;i++)
                    for(j=0;j<width;j++)
                       r[i][j]=B.pixel(i,j);
                  break;
   case UVW:
                 im_grey.set(width,height,0,DFLOAT);
                 r=im_grey.get_f();
                    for(i=0;i<height;i++)
                    for(j=0;j<width;j++)
                       r[i][j]=C.pixel(i,j);
                  break;
   case NUVW:
                 im_grey.set(width,height,0,DFLOAT);
                 r=im_grey.get_f();
                    for(i=0;i<height;i++)
                    for(j=0;j<width;j++)
                       r[i][j]=C.pixel(i,j);
                  break;
   case NXYZ:
                 im_grey.set(width,height,0,DFLOAT);
                 r=im_grey.get_f();
                    for(i=0;i<height;i++)
                    for(j=0;j<width;j++)
                       r[i][j]=C.pixel(i,j);
                  break;
   case MOD_UVW:
                 im_grey.set(width,height,0,DFLOAT);
                 r=im_grey.get_f();
                    for(i=0;i<height;i++)
                    for(j=0;j<width;j++)
                       r[i][j]=C.pixel(i,j);
                  break;
   default:
                 im_grey.set(width,height,0,DFLOAT);
                 r=im_grey.get_f();
                    for(i=0;i<height;i++)
                    for(j=0;j<width;j++)
                       r[i][j]=C.pixel(i,j);
                  break;
   }

   for(k=0;k<Niter;k++){

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {


   dRN=(r[i-1][j]-r[i][j]);
   dRS=(r[i+1][j]-r[i][j]);
   dRE=(r[i][j+1]-r[i][j]);
   dRW=(r[i][j-1]-r[i][j]);
   
   r1[i][j]=r[i][j]+lamda*(dRN+dRS+dRE+dRW);
   }


     temp=r;
     r=r1;
     r1=temp;



  //Apply retinex transformation

   if((k+1)%50==0)
   {
    count_ret++;

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);
     cr[i][j]+= sigmoid(valR,shift,scale)-sigmoid(r[i][j],shift,scale);
     cg[i][j]+= sigmoid(valG,shift,scale)-sigmoid(r[i][j],shift,scale);
     cb[i][j]+= sigmoid(valB,shift,scale)-sigmoid(r[i][j],shift,scale);
     }
     }

     cout<<"Iteration no:"<<k<<"\n";

   }

   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
   {
     valR=A.pixel(i,j);
     valG=B.pixel(i,j);
     valB=C.pixel(i,j);

     if(valR<1) valR=1;
     if(valG<1) valG=1;
     if(valB<1) valB=1;

     //Color Restoration Function (CRF) compensation
      if(mode)
      {
      crfR=crf_beta*(log((double)(crf_alpha*valR/(valR+valG+valB))));
      crfG=crf_beta*(log((double)(crf_alpha*valG/(valR+valG+valB))));
      crfB=crf_beta*(log((double)(crf_alpha*valB/(valR+valG+valB))));
      }
      else{
      crfR=crfG=crfB=1.0;
      }

     //Gain: gain offset: boff
      cr[i][j]=gain*(crfR*cr[i][j]/count_ret+boff); //averaged over iteration and mapped
      cg[i][j]=gain*(crfG*cg[i][j]/count_ret+boff);
      cb[i][j]=gain*(crfB*cb[i][j]/count_ret+boff);


     sumValR+=cr[i][j];
     sumValG+=cg[i][j];
     sumValB+=cb[i][j];

     if(cr[i][j]>maxValR) maxValR=cr[i][j];
     if(cg[i][j]>maxValG) maxValG=cg[i][j];
     if(cb[i][j]>maxValB) maxValB=cb[i][j];

     if(cr[i][j]<minValR) minValR=cr[i][j];
     if(cg[i][j]<minValG) minValG=cg[i][j];
     if(cb[i][j]<minValB) minValB=cb[i][j];
   }
     avgValR=sumValR/((float)width*(float)height);
     avgValG=sumValG/((float)width*(float)height);
     avgValB=sumValB/((float)width*(float)height);

     cout<<"Avg values :"<<avgValR<<" "<<avgValG<<" "<<avgValB<<"\n";
     cout<<"Max values :"<<maxValR<<" "<<maxValG<<" "<<maxValB<<"\n";
     cout<<"Min values :"<<minValR<<" "<<minValG<<" "<<minValB<<"\n";
     
     /*
     cout<<"Give minRange & maxRange for normalisation \n";
     cin>>minRange>>maxRange;
     */
     // Finding dynamic range of retinex values assuming ranges are 
     //  within -200  to 200       

     cout<<"Finding dynamic range of retinex values \n";

          // Initialise both arrays
            for(i=0;i<401;i++)
             {
               ret_hist[i]=0;
               cum_ret_hist[i]=0;
             }
   for(i=1;i<(height-1);i++)
   for(j=1;j<(width-1);j++)
      {
           ret_hist[(int)cr[i][j]+200]++;
           ret_hist[(int)cg[i][j]+200]++;
           ret_hist[(int)cb[i][j]+200]++;
      }

      cum_ret_hist[0]=ret_hist[0];
            for(i=1;i<401;i++)
              cum_ret_hist[i]=cum_ret_hist[i-1]+ret_hist[i];
     i=0;
     while(cum_ret_hist[i]<0.02*cum_ret_hist[400]) i++;
     j=400;
     while(cum_ret_hist[j]>0.98*cum_ret_hist[400]) j--;

     cout<<"Dynamic range: min_range="<<i-200<<" max_range="<<j-200<<"\n";
     minRange=(float)(i-200);
     maxRange=(float)(j-200);



     cim_t.normalise(minRange,maxRange);


  im_grey.free();
  im_r1.free();


   
  return(cim_t);
 }

     float _COLOR::col_dist(int x1,int y1,int x2,int y2,int mode=EUCLID,float wr=1,float wg=1,float wb=1)
     {
      float a,b,c;

      a=wr*abs(A.pixel(x1,y1)-A.pixel(x2,y2));
      b=wg*abs(B.pixel(x1,y1)-B.pixel(x2,y2));
      c=wb*abs(C.pixel(x1,y1)-C.pixel(x2,y2));

     switch(mode){
     case EUCLID:
                    return((float)sqrt((double)(sqr(a)+sqr(b)+sqr(c))));
                    break;
     case CITYBLOCK:
                    return(a+b+c);
                    break;
     case CHESSBOARD:
                    return(max(max(a,b),c));
                    break;


     case  D2:
                   {
                   float val,a1,a3;
                   a1= a+b+c;
                   a3 = max(max(a,b),c);

                   if (((float)floor((double)(a1+1.0)/2.0)) > a3) 
	                val=((float)floor((double)(a1+1.0)/2.0)) ;
                   else val=a3;
                   return(val);
                   }
                   break;

     case D3:
                  {
                  float a3;
      
                  a3 = max(max(a,b),c);
                  return(a3);
                  }
                  break;


    case D12:
                 {
                 float val,a1,a3;
                 a1= a+b+c;
                 a3 = max(max(a,b),c);

                 if ((float)floor((double)(2.0*a1+2.0)/3.0) >a3) 
	              val = (float)floor((double)(2.0*a1+2.0)/3.0);
                 else val = a3;
                 return(val);
                 }
                 break;

   case D13:
                {
                float val,t1,t2,a1,a2,a3;

                a1= a+b+c;
                a2 = max(max((a+b),(b+c)),(c+a));
                a3 = max(max(a,b),c);

                 t1 = (float)floor((double)(a1+3.0)/4.0) +  (float)floor((double)(a1+2.0)/4.0);
                 t2 = (float)floor((double)(2*a2+2.0)/3.0);
                 val = max(max(t1,t2),a3);
                return(val);
                }
                break;

   case D23:
               {
                   float val, a1,a3,t1;

                a1= a+b+c;
                a3 = max(max(a,b),c);

                t1 = (float)floor((double)(2.0*a1+4.0)/5.0);
                val = max(max(t1, 0), a3);
               return(val);
              }
              break;

  case D112:
                {
               float val,a1,a3,t1;

                a1= a+b+c;
                a3 = max(max(a,b),c);

             t1= (float)floor((double)(3*a1+3.0)/4.0);
     
                   val = max(max(t1, 0), a3);
                  return(val);
                 }
                 break;

  case D113:
               {
              float a1,a2,a3,t1,t2,val;

              a1= a+b+c;
              a2 = max(max((a+b),(b+c)),(c+a));
              a3 = max(max(a,b),c);

            t1 = (float)floor((double)(a1+4.0)/5.0) + (float)floor((double)(a1+3.0)/5.0) + (float)floor((double)(a1+2.0)/5.0);
            t2 = (float)floor((double)(3*a2+3.0)/4.0);

               val = max(max(t1,t2),a3);
              return(val);
              }
              break;

  case D122:
             {
             float val,a1,a3,t1;

                a1= a+b+c;
                a3 = max(max(a,b),c);


             t1 = (float)floor((double)(3*a1+4.0)/5.0);
               val = max(max(t1, 0), a3);
              return(val);
              }
              break;

  case D123:
              {
              float a1,a2,a3,t1,t2,val;

           a1= a+b+c;
           a2 = max(max((a+b),(b+c)),(c+a));
           a3 = max(max(a,b),c);


           t1 = (float)floor((double)(a1+2.0)/3.0) + (float)floor((double)(a1+4.0)/6.0);
           t2 = (float)floor((double)(3*a2+4.0)/5.0);

           val = max(max(t1,t2),a3);
             return(val);
             }
           break;

  case D133:
             {
              float a1,a2,a3,t1,t2,val;

          a1= a+b+c;
          a2 = max(max((a+b),(b+c)),(c+a));
          a3 = max(max(a,b),c);
  
  
        t1 = (float)floor((double)(a1+6.0)/7.0) + (float)floor((double)(2*a1+4.0)/7.0);
        t2 = (float)floor((double)(3*a2+4.0)/5.0);

         val = max(max(t1,t2),a3);
        return(val);
        }
        break;

   case D223:
             {
             float val,a1,a3,t1;

                a1= a+b+c;
                a3 = max(max(a,b),c);


            t1 = (float)floor((double)(a1+6.0)/7.0) + (float)floor((double)(a1+4.0)/7.0) + (float)floor((double)(a1+2.0)/7.0);

            val = max(max(t1, 0), a3);
           return(val);
           }
           break;
    

  case D233:
          {
             float val,a1,a3,t1;

                a1= a+b+c;
                a3 = max(max(a,b),c);


      t1 = (float)floor((double)(a1+7.0)/8.0) + (float)floor((double)(a1+5.0)/8.0) + (float)floor((double)(a1+2.0)/8.0);
    
            val = max(max(t1, 0), a3);
           return(val);
           }
           break;
     default:
                    return((float)sqrt((double)(sqr(a)+sqr(b)+sqr(c))));
     }
     return(0); 
     }

     void _COLOR::segnum(int **thinpat,int a,int b,int num,int &npnt,int wsize,float diff,int mode,float wr,float wg,float wb)
     {
      int i,j,x,y;
      npnt=npnt+1;
      thinpat[a][b]= -num;
      for (i= -wsize;i<=wsize;i++)
      for (j= -wsize;j<=wsize;j++)
      if (((a+i)<(height)) && ((b+j)<(width)))
      if (((a+i)>=0) && ((b+j)>=0))
      if (thinpat[a+i][b+j]==0)
      if (col_dist(a,b,a+i,b+j,mode,wr,wg,wb)<=diff)
      segnum(thinpat,a+i,b+j,num,npnt,wsize,diff,mode,wr,wg,wb);
      }

     void _COLOR::segmentation(int **thinpat,int a,int b,int num,int &npnt,int wsize,float diff,int mode,float wr,float wg,float wb)
     {
      npnt=0;
      segnum(thinpat,a,b,num,npnt,wsize,diff, mode, wr, wg, wb);
      }


      _GREY  _COLOR::rgrow(float diff,int seg_thresh=50,int wsize=1,int fsmooth=-1,int mode=EUCLID,float wr=1,float wg=1,float wb=1)
      {
       int i,j,nums,num,k,npnt;
       int **thinpat;
       _GREY temp;

       temp.set(width,height,0,DINT);
       thinpat=temp.get_i();
       if(thinpat==NULL){
       cout<<"Memory not allocated----Region growing not possible \n";
       return(temp);
       }

       num=1;nums=0;
       for (i=0;i<height;i++)
       for (j=0;j<width;j++)
         //if (pixel(i,j)>0)
         if (thinpat[i][j]==0)
         {
          segmentation(thinpat,i,j,num,npnt,wsize,diff, mode, wr, wg,wb);
          if (npnt>seg_thresh) 
          {
           nums=nums+1;
           view_segment(thinpat,num,nums);
           cout<<"segment no.="<<nums<<" value="<<thinpat[i][j]<<" no of points="<<npnt<<"\n"<<flush;
            if (fsmooth>=0)
           fine_smooth(thinpat,nums,fsmooth);
           cout<<"Smoothened \n";
           }
          num++;
          }
         cout<<"Region Growing Over \n";
       for (i=0;i<height;i++)
       for (j=0;j<width;j++)
       if(thinpat[i][j]<0) thinpat[i][j]=0;
         temp.adjust_image();
         return(temp);
       }

      void _COLOR::view_segment(int **thinpat,int num,int nums)
      {
       int i,j;
       for (i=0;i<height;i++)
       for (j=0;j<width;j++)
       if (thinpat[i][j]== -num)
         thinpat[i][j]=nums;
       }


  void _COLOR::fine_smooth(int **thinpat,int num,int fth)
  {
   int i,j,k,l,m,depth;
   int found1,found2;

  for (i=0;i<height;i++) 
    {
       found1=0;
       found2=0;
        for (j=0;j<width;j++) 
         {
         if (thinpat[i][j]==num) 
          {
             if (!(found1)) 
                  l=j;
             if (found1) 
               {
                   m=j;
                   found2=1;
                }
              found1=1;
            if (found2) 
             {
             if ((m-l)<=fth) 
              {
                for (k=l;k<=m;k++)
                 if (thinpat[i][k]<=0) 
                   {
                   thinpat[i][k]=num;
                   }
               }
               else
                {
                 l=m;
                 found2=0;
                }
             }
            }
           }
      }
  for (j=0;j<width;j++)
    {
       found1=0;
       found2=0;
        for (i=0;i<height;i++)
        {
         if (thinpat[i][j]==num) 
           {
             if (!(found1)) l=i;
             if (found1)
               {
                   m=i;
                   found2=1;
               }
              found1=1;
            if (found2) 
            {
             if ((m-l)<=fth) 
             {
                for (k=l;k<=m;k++) 
                 if (thinpat[k][j]<=0) 
                  {
                   thinpat[k][j]=num;
                  }
              }
               else
                 { 
                 l=m;
                 found2=0;
                 }
              }
           }
         }
        }
 } /* of fine_smooth */


