/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
class _COLFRCODE{
  int width,height;
  int HRNG_SIZE,RNG_SIZE,L_GAP;
  float ERR_LB,ERR_TH;
  int aNbitG,bNbitG;
  int aNbitR,bNbitR;
  int aNbitB,bNbitB;
  _QDFSTDECODE frcG;
  _RELFRCODE rfrcR,rfrcB;
  int codeflag; // 1 or 0

public:
  _COLFRCODE(){
     aNbitG=bNbitG=aNbitR=aNbitB=bNbitR=bNbitB=0;
    codeflag=0;
  }
  ~_COLFRCODE(){}

    void setNumBitG(int aNbit, int bNbit)
    {
         aNbitG=aNbit;
         bNbitG=bNbit;
         frcG.setNumBitAB(aNbitG,bNbitG);
    }

    void setNumBitR(int aNbit, int bNbit)
    {
         aNbitR=aNbit;
         bNbitR=bNbit;
         rfrcR.setNumBitAB(aNbitR,bNbitR);
    }

    void setNumBitB(int aNbit, int bNbit)
    {
         aNbitB=aNbit;
         bNbitB=bNbit;
         rfrcB.setNumBitAB(aNbitB,bNbitB);
    }
    void quantise()
    {
      frcG.quantiseAB();
      rfrcR.quantiseAB();
      rfrcB.quantiseAB();
    }

    void dequantise()
    {
      frcG.dequantiseAB();
      rfrcR.dequantiseAB();
      rfrcB.dequantiseAB();
    }


   // void compress(_COLOR im, int hrsize,int rsize,int err_lb,int l_gap=1,int rng_subst=0,float a_th=0,float b_th=0)
    void compress(_COLOR im, int hrsize,int rsize,int err_lb,int l_gap=1,int rng_subst=0,float err_th=0)
{
 _GREY imG,imR,imB;

  HRNG_SIZE=hrsize;
  RNG_SIZE=rsize;
  ERR_LB=err_lb;
  L_GAP=l_gap;
  ERR_TH=err_th;



  imR=im.get_A();
  imG=im.get_B();
  imB=im.get_C();

  cout<<"Image components obtainbed \n"<<flush;


   cout<<"Going to compress green component... \n"<<flush;
   frcG.compress(imG,HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP);
   //frcG.compress(imG,HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP,1); //with range block substitution



  rfrcR.setFractalCode(frcG);
  rfrcB.setFractalCode(frcG);

   cout<<"Going to compress red component relative to fractal code of green ... \n"<<flush;
  if(rng_subst)
  rfrcR.compress(imR,1,err_th); //with range block substitution
  else
  rfrcR.compress(imR,0,err_th); //without range block substitution
  //rfrcR.writeCode("relresR.dat");

   cout<<"Going to compress blue component relative to fractal code of green ... \n"<<flush;
  if(rng_subst)
  rfrcB.compress(imB,1,err_th); //with range block substitution
  else
  rfrcB.compress(imB,0,err_th); //without range block substitution
  //rfrcB.writeCode("relresB.dat");

    codeflag=1;

 }

 _COLOR decompress()
  {
   
   _GREY dimG,dimR,dimB;
   _COLOR im1;

     if(codeflag==0){
     cout<<"WARNING! Returning NULL image \n";
     return(im1);
     }



    dimG=frcG.fastDecompress();
   cout<<"Green component recovered \n";
   dimR=rfrcR.decompress();
   cout<<"Red component recovered \n";
   dimB=rfrcB.decompress();
   cout<<"Blue component recovered \n";
    im1.load(dimR,dimG,dimB);
    im1.truncate_pic();
    return im1;
  }

   void writeCode(char *rfname,char *gfname,char *bfname)
   {
   frcG.quantiseAB();
   rfrcR.quantiseAB();
   rfrcB.quantiseAB();
   frcG.writeCode(gfname);
   rfrcR.writeCode(rfname);
   rfrcB.writeCode(bfname);
   }

   void writeCode(char *fname)
   {
   ofstream fout(fname);

        if(fout.bad()) {
          cout<<"Problem in creating the file "<<fname<<" \n";
          return;
        }
   frcG.quantiseAB();
   rfrcR.quantiseAB();
   rfrcB.quantiseAB();

   fout<<frcG;
   fout<<rfrcR;
   fout<<rfrcB;

   fout.close();
   }

   void readCode(char *rfname,char *gfname,char *bfname)
   {
   frcG.readCode(gfname);
   cout<<"Code from "<<gfname<<" read \n";
   rfrcR.readCode(rfname);
   cout<<"Code from "<<rfname<<" read \n";
   rfrcB.readCode(bfname);
   cout<<"Code from "<<bfname<<" read \n";
     rfrcR.setFractalCode(frcG);
     rfrcB.setFractalCode(frcG);
   codeflag=1;
   }

   void readCode(char *fname)
   {
    ifstream fin(fname);

      if(!fin) {
        cout<<"File "<<fname<<" NOT opened \n";
        return;
      }
  
   fin>>frcG;
   cout<<"green code read \n";

     rfrcR.setFractalCode(frcG);
     rfrcB.setFractalCode(frcG);
   fin>>rfrcR;
   cout<<"red code read \n";
   fin>>rfrcB;
   cout<<"blue code read \n";
   codeflag=1;
   }

   void printStat()
   {
        frcG.printStat();
        rfrcR.printStat();
        rfrcB.printStat();
   }
};
