/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
class _FRCODE{
   int codeflag;
  int width,height;
  int RNG_SIZE,DOM_SIZE;
  float ERR_LB;
  //int Rx[64][64],Ry[64][64],Tx[64][64];
  //float a[64][64],b[64][64];
  int **Rx,**Ry,**Tx;
  float **a,**b;

      int allocate_coeff_arrays()
       {
              a=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              if(a==NULL)
                 {
                  cout<<"COEFF a's not allocated \n";
                  return -1;
                 }
              b=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              if(b==NULL)
                 {
                  cout<<"COEFF b's not allocated \n";
                  return -1;
                 }
              Rx=allocate_matrix_int(height/RNG_SIZE,width/RNG_SIZE,sizeof(int));
              if(Rx==NULL)
                 {
                  cout<<"COEFF Rx's not allocated \n";
                  return -1;
                 }

              Ry=allocate_matrix_int(height/RNG_SIZE,width/RNG_SIZE,sizeof(int));
              if(Ry==NULL)
                 {
                  cout<<"COEFF Ry's not allocated \n";
                  return -1;
                 }

              Tx=allocate_matrix_int(height/RNG_SIZE,width/RNG_SIZE,sizeof(int));
              if(Tx==NULL)
                 {
                  cout<<"COEFF Tx's not allocated \n";
                  return -1;
                 }
              return 1;
       }
 public:

    _FRCODE(){width=height=RNG_SIZE=DOM_SIZE=codeflag=0;
              a=b=NULL;
              Rx=Ry=Tx=NULL;
             } 
     /*
    _FRCODE(int w,int h,int rs,int ds,int err){
              width=w;
              height=h;
              RNG_SIZE=rs;
              DOM_SIZE=ds;
              ERR_LB=err;
              } 
    _FRCODE(int w,int h,int rs,int err){
              width=w;
              height=h;
              RNG_SIZE=rs;
              DOM_SIZE=2*rs;
              ERR_LB=err;
              } 
     
    void set(int w,int h,int rs,int ds,int err){
              width=w;
              height=h;
              RNG_SIZE=rs;
              DOM_SIZE=ds;
              ERR_LB=err;
             }

    void set(int w,int h,int rs,int err){
              width=w;
              height=h;
              RNG_SIZE=rs;
              DOM_SIZE=2*rs;
              ERR_LB=err;
             }
      */

    ~_FRCODE(){} 
     void free()
       {
         if(a!=NULL) free_matrix_float(a,height/RNG_SIZE);
         if(b!=NULL) free_matrix_float(b,height/RNG_SIZE);
         if(Rx!=NULL) free_matrix_int(Rx,height/RNG_SIZE);
         if(Ry!=NULL) free_matrix_int(Ry,height/RNG_SIZE);
         if(Tx!=NULL) free_matrix_int(Tx,height/RNG_SIZE);
       }

   void compress(_GREY im,int rsize,float error,int L_GAP=1)
       {
           if(codeflag==1) {
             cout<<"WARNING! Valid codes overwritten. \n";
           }

          _MASK domain,shDomain, range,temp_shDomain;
          float tcorr;
          int i,j,k,l,m;
          float **sdDom,**meanDom;
          float **corr,**err;
          float **sdRng,**meanRng;

          //float sdDom[256][256],meanDom[256][256];
          //float corr[64][64],err[64][64];
          //float sdRng[64][64],meanRng[64][64];

              width=im.get_w();
              height=im.get_h();
              RNG_SIZE=rsize;
              DOM_SIZE=2*rsize;
              ERR_LB=error;
              codeflag=0;

              allocate_coeff_arrays();
              sdDom=allocate_matrix_float(height,width,sizeof(float));
              meanDom=allocate_matrix_float(height,width,sizeof(float));
              corr=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              err=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              sdRng=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              meanRng=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));

              if((sdDom==NULL) || (meanDom==NULL) || (corr==NULL) || (err==NULL) || (sdRng==NULL) || (meanRng==NULL))
              {
                 cout<<"WARNING! Memory not allocated for temporary arrays\n";
              return;
              }
                 cout<<"Allocated the temporary arrays \n";

              domain.set(DOM_SIZE,DOM_SIZE);
              shDomain.set(RNG_SIZE,RNG_SIZE);
              range.set(RNG_SIZE,RNG_SIZE);
              temp_shDomain.set(RNG_SIZE,RNG_SIZE);

              for(i=0;i<height-DOM_SIZE;i=i+L_GAP)
              for(j=0;j<width-DOM_SIZE;j=j+L_GAP)
              {
               im.get_Rect(domain,i,j,DOM_SIZE);
               domain.shrink(shDomain,2.0);
               sdDom[i][j]=shDomain.N_compute(SD_MODE);
               meanDom[i][j]=shDomain.N_compute(AVG_MODE);
             //   cout<<"at ("<<i<<","<<j<<") sd="<<sdDom[i][j]<<"\n";
              }

 cout<<"Statistics of Domain computed \n";

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
              {
               im.get_Rect(range,i*RNG_SIZE,j*RNG_SIZE,RNG_SIZE);
               sdRng[i][j]=range.N_compute(SD_MODE);
               meanRng[i][j]=range.N_compute(AVG_MODE);
               corr[i][j]=0.0;
               err[i][j]=100000;
              }

 cout<<"Stat of ranges computed \n"<<flush;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
              {
               im.get_Rect(range,i*RNG_SIZE,j*RNG_SIZE,RNG_SIZE);
                    for(l=0;l<height-DOM_SIZE;l+=L_GAP)
                    for(m=0;m<width-DOM_SIZE;m+=L_GAP)
                    {
                       if (err[i][j]<=ERR_LB) break;
                       if((l!=i*RNG_SIZE) && (m!=j*RNG_SIZE) && (sdDom[l][m]!=0))// && (sdDom[l][m]>=sdRng[i][j]))
                       {
                       im.get_Rect(domain,l,m,DOM_SIZE);
                       domain.shrink(shDomain,2.0);
          
                       if(sdRng[i][j]!=0)
                       {
                        shDomain.copy(temp_shDomain);
                       for(k=0;k<7;k++){
                       tcorr=(range.avg_product(temp_shDomain)-meanRng[i][j]*meanDom[l][m])/(sdRng[i][j]*sdDom[l][m]);
                       if(abs(tcorr)>abs(corr[i][j])) {
                               float tb,ta;
                               ta=corr[i][j]*sdRng[i][j]/sdDom[l][m];
                               tb=meanRng[i][j]-ta*meanDom[l][m];
                               if(abs(ta)<1.0)
                               {
                               corr[i][j]=tcorr;
                               Rx[i][j]=l;
                               Ry[i][j]=m;
                               Tx[i][j]=k;
                               a[i][j]=ta;
                               b[i][j]=tb;
                               err[i][j]=sqr(sdRng[i][j])*(1-tcorr*tcorr);
                       // cout<<"at ("<<i<<","<<j<<") l="<<l<<" m="<<m<<"err="<<err[i][j]<<"\n";
                               }
                               }
                             switch(k){
                             case 0:
                                       shDomain.rotate_90(temp_shDomain);
                                       break;
                             case 1:
                                       shDomain.rotate_180(temp_shDomain);
                                       break;
                             case 2:
                                       shDomain.rotate_270(temp_shDomain);
                                       break;
                             case 3:
                                       shDomain.reflect_x(temp_shDomain);
                                       break;
                             case 4:
                                       shDomain.reflect_y(temp_shDomain);
                                       break;
                             case 5:
                                       shDomain.reflect_diagonal(temp_shDomain);
                                       break;
                             case 6:
                                       shDomain.reflect_antidiagonal(temp_shDomain);
                                       break;
                             case 7:
                                       cout<<"Transform no. out of range \n";
                                       exit(0);
                             }
                         }
                       }
                       else
                       {
                               corr[i][j]=1.0;
                               Rx[i][j]=i;
                               Ry[i][j]=j;
                               Tx[i][j]=0;
                               a[i][j]=0;
                               b[i][j]=meanRng[i][j];
                               err[i][j]=0;
                       }
                    }
                 } 
                 cout<<"For range at "<<i<<","<<j<<":domain found at"<<Rx[i][j]<<","<<Ry[i][j]<<"With Error"<<err[i][j]<<'\n';;
    //cout<<"Tx="<<Tx[i][j]<<" Corr"<<corr[i][j]<<'\n';
              }
                 free_matrix_float(meanDom,height);
                 free_matrix_float(sdDom,height);
                 free_matrix_float(corr,height/RNG_SIZE);
                 free_matrix_float(err,height/RNG_SIZE);
                 free_matrix_float(meanRng,height/RNG_SIZE);
                 free_matrix_float(sdRng,height/RNG_SIZE);

                 domain.free();
                 shDomain.free();
                 range.free();
                 temp_shDomain.free();

                 cout<<"Freed the temporary arrays \n";
                 codeflag=1;
                 return;
             }

      void saveCode(char *fname)
          {
            int i,j;
            ofstream fout(fname);

            fout<<width<<" "<<height<<" "<<RNG_SIZE<<'\n';

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                  fout<<Rx[i][j]<<" "<<Ry[i][j]<<" "<<a[i][j]<<" "<<Tx[i][j]<<" "<<b[i][j]<<'\n';
            fout.close();
          }

       void readCode(char *fname)
          {
            int i,j;
            ifstream fin(fname);

                cout<<"Going to read code from file "<<fname<<"\n"<<flush;
            fin>>width>>height>>RNG_SIZE;

              allocate_coeff_arrays();
              cout<<"Memory for coeffcients allocated \n"<<flush;

            DOM_SIZE=2*RNG_SIZE;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                  fin>>Rx[i][j]>>Ry[i][j]>>a[i][j]>>Tx[i][j]>>b[i][j];
             codeflag=1;
            fin.close();
          }

     _GREY  decompress(int ITER_NO=30)
         {

          _GREY im;
          _MASK domain,range,shDomain,temp_shDomain;
          float tcorr;
          int i,j,k,l,m;
          int iter;

          if(codeflag==0){
             cout<<"WARNING! Not containing any codes! Returning NULL image \n";
           return(im);
          }

          domain.set(DOM_SIZE,DOM_SIZE);
          range.set(RNG_SIZE,RNG_SIZE);
          shDomain.set(RNG_SIZE,RNG_SIZE);
          temp_shDomain.set(RNG_SIZE,RNG_SIZE);

          im.set(width,height,100,DFLOAT);
          cout<<"Image Initialised \n";

          for(iter=0;iter<ITER_NO;iter++)
          {
          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
          {
           im.get_Rect(domain,Rx[i][j],Ry[i][j],DOM_SIZE);
           domain.shrink(shDomain,2.0);
           im.apply_affine_to(i*RNG_SIZE,j*RNG_SIZE,shDomain, a[i][j],b[i][j],Tx[i][j]);
           }

          cout<<"iteration no. "<<iter<<'\n';
          }
          //im.adjust_image();
         // im.normalise();
          domain.free();
          range.free();
          shDomain.free();
          temp_shDomain.free();
            return(im);
         }
      };
