/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
class _IFS3D{

  struct _qdbyte{
         unsigned char bit0:1;
         unsigned char bit1:1;
         unsigned char bit2:1;
         unsigned char bit3:1;
         unsigned char bit4:1;
         unsigned char bit5:1;
         unsigned char bit6:1;
         unsigned char bit7:1;
         } qdinfo;
  struct _txbyte{
          unsigned short int tx0:3;
          unsigned short int tx1:3;
          unsigned short int tx2:3;
          unsigned short int tx3:3;
          unsigned short int tx4:3;
         } txinfo;

  struct _impoint{
         int x,y;
         };

  struct _affVector[
          int x1,y1;
          int x2,y2;
          float a;
          float b;
          int   tx;
          int   ty;
          int type;
          int cl_num;
         };

   int height,width,RNG_SIZE;
  _QDFSTDECODE frc;
  int number_of_clusters;
  int number_of_tx;
  float **a, **b;
  int **Rx,**Ry,**Tx;
  int **Rqd;
  struct _affVector *w;
  struct _affvector *mean;
  int frcode_flag;
  

 _affVector getAffine(_impoint range)
    {
      int i,j,rx,ry,txno,Dx,Dy,factor;
      _affVector tmpVct;
      int m,n; // Offsets from range address
      int x,y;
 
          x=range.x;
          y=range.y;
          rx=x/RNG_SIZE;
          ry=y/RNG_SIZE;
          txno=Tx[rx][ry];
          Dx=Rx[rx][ry];
          Dy=Ry[rx][ry];
          factor=Rqd[rx][ry];

          m=x-RNG_SIZE*rx;
          n=y-RNG_SIZE*ry;
          //cout<<"m="<<m<<" n="<<n<<" Dx="<<Dx<<" Dy="<<Dy<<" factor="<<factor<<"\n";
           tmpVct.a=a[rx][ry];
           tmpVct.b=b[rx][ry];
           tmpVct.type=txno;
      
          switch(txno)
          {
          case ROT_0:
                    tmpVct.x1=0.5;
                    tmpVct.y1=0;
                    tmpVct.x2=0;
                    tmpVct.y2=0.5;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    break;
             case ROT_90:
                    tmpVct.x1=0;
                    tmpVct.y1=0.5;
                    tmpVct.x2=-0.5;
                    tmpVct.y2=0;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    break;
             case ROT_180:
                    tmpVct.x1=-0.5;
                    tmpVct.y1=0;
                    tmpVct.x2=0;
                    tmpVct.y2=0.5;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    break;
             case ROT_270:
                    tmpVct.x1=0;
                    tmpVct.y1=-0.5;
                    tmpVct.x2=-0.5;
                    tmpVct.y2=0;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    //val=pixel(i+hsize-1-n,j+wsize-1-m);
                    break;
             case REFLECT_Y:
                    tmpVct.x1=0.5;
                    tmpVct.y1=0;
                    tmpVct.x2=-0.5;
                    tmpVct.y2=0;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    //val=pixel(i+m,j+wsize-1-n);
                    break;
             case ROT_180_AND_REFLECT_Y:
                    tmpVct.x1=-0.5;
                    tmpVct.y1=0;
                    tmpVct.x2=-0.5;
                    tmpVct.y2=0;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    //val=pixel(i+hsize-1-m,j+wsize-1-n);
                    break;
             case TRANSPOSE:
                    tmpVct.x1=0;
                    tmpVct.y1=0.5;
                    tmpVct.x2=0.5;
                    tmpVct.y2=0;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    //val=pixel(i+n,j+m);
                    break;
             case REVERSE_TRANSPOSE:
                    tmpVct.x1=0;
                    tmpVct.y1=0.5;
                    tmpVct.x2=-0.5;
                    tmpVct.y2=0;
                    tmpVct.x=x-Dx/2;
                    tmpVct.y=y-Dy/2;
                    //val=pixel(i+n,j+wsize-1-m);
                    break;
             default:
                    cout<<"Transform out of domain \n";
                    exit(0);
                    // val=0;
                     break;

          }

        //cout<<"txpnt.x="<<txpnt.x<<" txpnt.y="<<txpnt.y<<"\n";

        return(tmpVct);
          
    }

   _affVector add(_affvector a,_affVector b)
    {
      -affVector tmp;
       if(a.type!=b.type)
         {
            cout<<"WARNING! Adding different types of affine transform \n";
         }
           tmpVct.a=a.a+b.a;
           tmpVct.b=a.b+b.b;
           tmpVct.tx=a.tx+b.tx;
           tmpVct.ty=a.ty+b.ty;
           tmpVct.type=a.type;
        return (tmpVct);
    }

   _affVector mpy(float factor,_affVector b)
    {
      -affVector tmp;

           tmpVct.a=a* b.a;
           tmpVct.b=a* b.b;
           tmpVct.tx=(int) (a* (float)b.tx);
           tmpVct.ty=(int) (a* (float)b.ty);
           tmpVct.type=a.type;
        return (tmpVct);
    }

    float distance(_affVector a,_affVector b)
    {
       float val=0;

       if(a.type!=b.type)
         {
            cout<<"WARNING! Comparing different types of affine transform \n";
            return 9999.0;
         }
       val=sqr(a.a-b.a)+sqr(a.b-b.b);
       val+=sqr((float)(a.tx-b.tx))+sqr((float)(a.ty-b.ty));
       return val;
    }


 public:

    _IFS3D(){ frcode_flag=0;} 

    ~_IFS3D(){} 

           void readQdfrcode(char *fname)
           {
             int i,j,k;

             frc.readCode(fname);

             height=frc.get_h();
             width=frc.get_w();
             RNG_SIZE=frc.get_rsize();
             Rqd=frc.get_QdHead();
             a=frc.get_a();
             b=frc.get_a();
             Rx=frc.get_Rx();
             Ry=frc.get_Ry();
             Tx=frc.get_Tx();
             frcode_flag=1;
             number_of_tx=0;

             for(i=0;i<height/RNG_SIZE;i++)
             for(j=0;j<width/RNG_SIZE;j++)
                if(Rqd[i][j]>0) number_of_tx++;

              w=(struct _affVector *) calloc(number_of_tx, sizeof(struct _affVector));
              if(w==NULL) {
               cout<<"Memory for transformations NOT allocated \n";
               exit(0);
              }

             k=0;

             for(i=0;i<height/RNG_SIZE;i++)
             for(j=0;j<width/RNG_SIZE;j++)
                if(Rqd[i][j]>0) 
                {
                  w[k]=getAffine(i*RNG_SIZE,j*RNG_SIZE);
                  w[k].cl_num=-1;
                  k++;
                }
           }

          struct _affVector *cluster(int nCluster,int afftype)
          {
            struct _affVector *meanVct;
            int *size;
            int k,clno;

              meanVct=(struct _affVector *) calloc(nCluster, sizeof(struct _affVector));
              if(meanVct==NULL) {
               cout<<"Memory for mean vectors NOT allocated \n";
               exit(0);
              }
              
              size=(int *) calloc(nCluster,sizeof(int));
              if(size==NULL) {
               cout<<"size NOT allocated \n";
               exit(0);
              }

              for(clno=0;clno<nCluster;clno++)
                 size[clno]++;

              clno=0;

              for(k=0;k<number_of_tx;k++)
               {
                  if(clno==nCluster) clno=0;
                  if(w[k].type==affType)
                  {
                  w[k].cl_num=clno;
                  size[clno]++;
                  meanVect[clno]=add(meanVect[clno],w[k]);
                  }
                  clno++;
               }

             return meanVct;
          }
      };
