/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
  struct _qdbyte{
         unsigned char bit0:1;
         unsigned char bit1:1;
         unsigned char bit2:1;
         unsigned char bit3:1;
         unsigned char bit4:1;
         unsigned char bit5:1;
         unsigned char bit6:1;
         unsigned char bit7:1;
         } qdinfo;
  struct _txbyte{
          unsigned short int tx0:3;
          unsigned short int tx1:3;
          unsigned short int tx2:3;
          unsigned short int tx3:3;
          unsigned short int tx4:3;
         } txinfo;

  struct _impoint{
         int x,y;
         };

class _QDFSTDECODE{


  struct _partition{
          int num;
          int visit;
          int type; // Node type: start (1), limit cycle (2), endpoint (3), other (4)
          int limit_sequence; // If limit cycle (2) stores the sequence no.
          float val;
         _impoint next,prev,range; //Next, Prev points and range addresses
         };

   struct _pStat{
          int nPartition;
          int *nLimitCycle;
          int *nPnt;
          int totalLimitPoints;
          float avgLimitCyclePoint;
         } partiStat;

   int codeflag, collectPartitionFlag, limitFlag, quantiseFlag;
  int width,height;
  int RNG_SIZE,HRNG_SIZE,DOM_SIZE;  //Low range size, high range size
  int L_GAP;  // Lattice of separation for domain pool
  float ERR_LB;
  int **Rx,**Ry,**Tx;
  float **a,**b,**err;
  int **Rqd;
  struct _partition **partinfo; 
  int  *limitPoints;
  int nLimitPoint;

  float aMin,aMax,bMin,bMax;
  int aNbit, bNbit; // -1 means floating point representation
  int dxNbit, dyNbit; // Bits for Domain addresses 
  int txNbit; // Bit for the transformation
  float aQnt,bQnt;  // 0 means floating point representation
  int partition_number;
  int limit_sequence_no;
  int decompress_limit_sequence_no;

      int allocate_coeff_arrays()
       {
         int i;

              a=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              if(a==NULL)
                 {
                  cout<<"COEFF a's not allocated \n";
                  return -1;
                 }
              b=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              if(b==NULL)
                 {
                  cout<<"COEFF b's not allocated \n";
                  return -1;
                 }

              err=allocate_matrix_float(height/RNG_SIZE,width/RNG_SIZE,sizeof(float));
              if(err==NULL)
                 {
                  cout<<"Error array not allocated \n";
                  return -1;
                 }

              Rx=allocate_matrix_int(height/RNG_SIZE,width/RNG_SIZE,sizeof(int));
              if(Rx==NULL)
                 {
                  cout<<"COEFF Rx's not allocated \n";
                  return -1;
                 }

              Ry=allocate_matrix_int(height/RNG_SIZE,width/RNG_SIZE,sizeof(int));
              if(Ry==NULL)
                 {
                  cout<<"COEFF Ry's not allocated \n";
                  return -1;
                 }

              Tx=allocate_matrix_int(height/RNG_SIZE,width/RNG_SIZE,sizeof(int));
              if(Tx==NULL)
                 {
                  cout<<"COEFF Tx's not allocated \n";
                  return -1;
                 }

              Rqd=allocate_matrix_int(height/RNG_SIZE,width/RNG_SIZE,sizeof(int));
              if(Rqd==NULL)
                 {
                  cout<<"Quad info array not allocated \n";
                  return -1;
                 }


              return 1;
       }

      int allocate_partition_arrays()
       {
        int i,j;

              partinfo=(struct _partition **)calloc(height,sizeof(struct _partition *));
              if(partinfo==NULL)
                 {
                  cout<<"Partinfo pointer array not allocated \n";
                  return -1;
                 }
               for(i=0;i<height;i++)
               {
                partinfo[i]= (struct _partition *)calloc(width,sizeof(struct _partition ));
              if(partinfo[i]==NULL)
                 {
                  cout<<"Partinfo  array not allocated \n";
                  return -1;
                 }
               }
              return 1;
       }


  void writeRangeAddress(int x,int y,int factor) 
     {
       int rx,ry,i,j;
 
       rx=x/RNG_SIZE;
       ry=y/RNG_SIZE;
       for(i=x;i<x+RNG_SIZE*factor;i++)
       for(j=y;j<y+RNG_SIZE*factor;j++)
         {
          partinfo[i][j].range.x=rx;
          partinfo[i][j].range.y=ry;
         }
     }

 _impoint getDomainPoint(_impoint start)
    {
      int i,j,rx,ry,txno,Dx,Dy,factor;
      _impoint dmpnt;
      int m,n; // Offsets from range address
      int x,y;
 
          x=start.x;
          y=start.y;

          rx=partinfo[x][y].range.x;
          ry=partinfo[x][y].range.y;
          txno=Tx[rx][ry];
          Dx=Rx[rx][ry];
          Dy=Ry[rx][ry];
          factor=Rqd[rx][ry];

          m=x-RNG_SIZE*rx;
          n=y-RNG_SIZE*ry;
          //cout<<"m="<<m<<" n="<<n<<" Dx="<<Dx<<" Dy="<<Dy<<" factor="<<factor<<"\n";
      
          switch(txno)
          {
          case ROT_0:
                    dmpnt.x=Dx+ 2*m;
                    dmpnt.y=Dy+ 2*n;
                    break;
             case ROT_90:
                    dmpnt.x=Dx+ 2*n;
                    dmpnt.y=Dy+ 2*factor*RNG_SIZE-2-2*m;
                    //val=pixel(i+n,j+wsize-1-m);
                    break;
             case ROT_180:
                    dmpnt.x=Dx+ 2*factor*RNG_SIZE-2-2*m;
                    dmpnt.y=Dy+ 2*factor*RNG_SIZE-2-2*n;
                    //val=pixel(i+hsize-1-m,j+wsize-1-n);
                    break;
             case ROT_270:
                    dmpnt.x=Dx+ 2*factor*RNG_SIZE-2-2*n;
                    dmpnt.y=Dy+ 2*m;
                    break;
             case REFLECT_X:
                    dmpnt.x=Dx+ 2*factor*RNG_SIZE-2-2*m;
                    dmpnt.y=Dy+ 2*n;
                    //val=pixel(i+hsize-1-m,j+n);
                    break;
             case REFLECT_Y:
                    dmpnt.x=Dx+ 2*m;
                    dmpnt.y=Dy+ 2*factor*RNG_SIZE-2-2*n;
                    //val=pixel(i+m,j+wsize-1-n);
                    break;
             case REFLECT_DIAGONAL:
                    dmpnt.x=Dx+ 2*factor*RNG_SIZE-2-2*n;
                    dmpnt.y=Dy+ 2*factor*RNG_SIZE-2-2*m;
                    //val=pixel(i+hsize-1-n,j+wsize-1-m);
                    break;
             case REFLECT_ANTIDIAGONAL:
                    dmpnt.x=Dx+ 2*n;
                    dmpnt.y=Dy+ 2*m;
                    //val=pixel(i+n,j+m);
                    break;
             default:
                    cout<<"Transform out of domain \n";
                    exit(0);
                    // val=0;
                     break;

          }

        //cout<<"dmpnt.x="<<dmpnt.x<<" dmpnt.y="<<dmpnt.y<<"\n";
        if((dmpnt.x<0) && (dmpnt.x>=height)) {
            cout<<"Domain Point Out of Range at Tx"<<txno<<"\n";
            // exit(0);
        }
        if((dmpnt.y<0) && (dmpnt.y>=width)) {
            cout<<"Domain Point Out of Range at Tx"<<txno<<"\n";
            // exit(0);
        }

        return(dmpnt);
          
    }

    void Initialize_arrays()
       {
         int i,j;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
               {
                a[i][j]=b[i][j]=0;
                err[i][j]=99999.0;
                Rqd[i][j]=0;
                Rx[i][j]=Ry[i][j]=Tx[i][j]=-1;
               }

       }

   void Initialize_Partition_Info()
        {
         int i,j;

              for(i=0;i<height;i++)
              for(j=0;j<width;j++)
               {
                 partinfo[i][j].visit=0;
                 partinfo[i][j].num=0;
                 partinfo[i][j].val=-99999.0;
               }
        }

    void Initialize_range_addresses()
      {
        int i,j,l,m;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                if(Rqd[i][j]>0)
                  {
                    writeRangeAddress(i*RNG_SIZE,j*RNG_SIZE,Rqd[i][j]); 
                  }
      }
                   

   int check_quadrant(int x,int y,int factor)
        {
           int i,j;
           int flag=1;
         
           if(factor==1) return 1;

           for(i=x;i<x+factor;i++)
           for(j=y;j<y+factor;j++)
            {
             if(err[i][j]>ERR_LB)
              {
              flag=0;
              }
             if(!flag) break;
            }
              if(flag)
                err[x][y]=99999.0; // For enforcing a code 
            return flag;
        }

  void adjustFactor(int x,int y,int factor)
       {
         int i,j;
          // if(factor>1)
          // cout<<"adjusting at "<<x<<","<<y<<" with "<<factor<<"\n";
           for(i=x;i<x+factor;i++)
           for(j=y;j<y+factor;j++)
               Rqd[i][j]=-1;
            Rqd[x][y]=factor;
       }

  void compute_factor_in_Rqd()
       {
         int i,j,k,found,lx,ly;
         int count_zero;

              for(i=0;i<height/RNG_SIZE;i++)
              {
                found=0;
                count_zero=0;
              for(j=0;j<width/RNG_SIZE;j++)
               {
                 if(Rqd[i][j]<0) {
                         if(found)
                         if(j==(width/RNG_SIZE-1))
                           adjustFactor(lx,ly,count_zero);
                  }    //continue;
                 else
                 if(Rqd[i][j]==0) {
                         count_zero++;
                         if(j==(width/RNG_SIZE-1))
                           adjustFactor(lx,ly,count_zero);
                          }
                 else{
                     if(found) {
                       adjustFactor(lx,ly,count_zero);
                      }
                     lx=i; ly=j;
                     found=1;
                       count_zero=1;
                         if(j==(width/RNG_SIZE-1))
                           adjustFactor(lx,ly,count_zero);
                 }
               }
              }
       }

  void save_code(int x,int y,int dx,int dy,int tx,float ta,float tb,float terror,int factor)
         {
           int i,j;

           for(i=x;i<x+factor;i++)
           for(j=y;j<y+factor;j++)
               {
               Rx[i][j]=Ry[i][j]=Tx[i][j]=-1;
               Rqd[i][j]=0;
               a[i][j]=b[i][j]=0;
               err[i][j]=terror;
               }
            Rqd[x][y]=factor;
            Rx[x][y]=dx;
            Ry[x][y]=dy;
            Tx[x][y]=tx;
            a[x][y]=ta;
            b[x][y]=tb;
            err[x][y]=terror;

            return;
         }

 void getMinMaxAB()
         {
           int i,j;
          aMin=bMin=9999999.0;
          aMax=bMax=-9999999.0;
          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
           {
             if(Rqd[i][j]>0)
             {
               if(a[i][j]<aMin) aMin=a[i][j];
               if(a[i][j]>aMax) aMax=a[i][j];
               if(b[i][j]<bMin) bMin=b[i][j];
               if(b[i][j]>bMax) bMax=b[i][j];
             }
           }
          return;
         }

       int getNbit(int val)
       {
         int i=1,count=0;;
         if(val==1) return 1;
         while(i<val) {i=i<<1; count++;}
         return count;
       }

      void collectLimitCycle(_impoint start)
      {
        _impoint tmp;
         float aeq,beq;
         int rx,ry;
         float prev_val;
         char ch;

          //cout<<"Collecting limit cycle at "<<start.x<<","<<start.y<<"\n";
         //cin>>ch;
         tmp=partinfo[start.x][start.y].prev;
         rx=partinfo[start.x][start.y].range.x;
         ry=partinfo[start.x][start.y].range.y;
         aeq=a[rx][ry];
         beq=b[rx][ry];
         partinfo[start.x][start.y].num= ++partition_number;
         partinfo[start.x][start.y].type=2; //Limit Cycle
         partinfo[start.x][start.y].limit_sequence=limit_sequence_no++; // sequence no
     
         //while((partinfo[tmp.x][tmp.y].prev.x!=start.x) || (partinfo[tmp.x][tmp.y].prev.y!=start.y))
         while((tmp.x!=start.x) || (tmp.y!=start.y))
          {
             //cout<<"("<<tmp.x<<","<<tmp.y<<") ";

             rx=partinfo[tmp.x][tmp.y].range.x;
             ry=partinfo[tmp.x][tmp.y].range.y;
             partinfo[tmp.x][tmp.y].num=partition_number;
             partinfo[tmp.x][tmp.y].type=2;
             partinfo[tmp.x][tmp.y].limit_sequence=limit_sequence_no++;
             beq=aeq*b[rx][ry]+beq;
             aeq=aeq*a[rx][ry];
             tmp=partinfo[tmp.x][tmp.y].prev;
          }
         partinfo[start.x][start.y].val=beq/(1-aeq);
           //  cout<<"Partition Number="<< partinfo[start.x][start.y].num;
             //cout<<"value ="<< partinfo[start.x][start.y].val;
         prev_val= partinfo[start.x][start.y].val;
         tmp=partinfo[start.x][start.y].prev;
         // while((partinfo[tmp.x][tmp.y].prev.x!=start.x) || (partinfo[tmp.x][tmp.y].prev.y!=start.y))
         while((tmp.x!=start.x) || (tmp.y!=start.y))
          {
             rx=partinfo[tmp.x][tmp.y].range.x;
             ry=partinfo[tmp.x][tmp.y].range.y;
             partinfo[tmp.x][tmp.y].val= a[rx][ry]*prev_val+b[rx][ry];
             prev_val= partinfo[tmp.x][tmp.y].val;
             tmp=partinfo[tmp.x][tmp.y].prev;
          }
      }

      //void collectLimitCycleWithLimitPoint(_impoint start,_GREY imsrc)
      void collectLimitCycleWithLimitPoint(_impoint start)
      {
        _impoint tmp;
         float aeq,beq;
         int rx,ry;
         float prev_val;
         char ch;

         // cout<<"Collecting limit cycle at "<<start.x<<","<<start.y<<"\n";
         //cin>>ch;
         tmp=partinfo[start.x][start.y].prev;
         rx=partinfo[start.x][start.y].range.x;
         ry=partinfo[start.x][start.y].range.y;
         aeq=a[rx][ry];
         beq=b[rx][ry];
         partinfo[start.x][start.y].num= ++partition_number;
         partinfo[start.x][start.y].type=2; //Limit Cycle
     
         //while((partinfo[tmp.x][tmp.y].prev.x!=start.x) || (partinfo[tmp.x][tmp.y].prev.y!=start.y))
         while((tmp.x!=start.x) || (tmp.y!=start.y))
          {

             rx=partinfo[tmp.x][tmp.y].range.x;
             ry=partinfo[tmp.x][tmp.y].range.y;
             partinfo[tmp.x][tmp.y].num=partition_number;
             partinfo[tmp.x][tmp.y].type=2;
             beq=aeq*b[rx][ry]+beq;
             aeq=aeq*a[rx][ry];
             tmp=partinfo[tmp.x][tmp.y].prev;
             //cout<<"("<<tmp.x<<","<<tmp.y<<") ";
          }
         // partinfo[start.x][start.y].val=imsrc.pixel(start.x,start.y);
          partinfo[start.x][start.y].val=limitPoints[decompress_limit_sequence_no++];
         prev_val= partinfo[start.x][start.y].val;
         tmp=partinfo[start.x][start.y].prev;
         // while((partinfo[tmp.x][tmp.y].prev.x!=start.x) || (partinfo[tmp.x][tmp.y].prev.y!=start.y))
         while((tmp.x!=start.x) || (tmp.y!=start.y))
          {
             rx=partinfo[tmp.x][tmp.y].range.x;
             ry=partinfo[tmp.x][tmp.y].range.y;
             //partinfo[tmp.x][tmp.y].val= a[rx][ry]*prev_val+b[rx][ry];
             // partinfo[tmp.x][tmp.y].val=imsrc.pixel(tmp.x,tmp.y);
              partinfo[tmp.x][tmp.y].val=limitPoints[decompress_limit_sequence_no++];
             prev_val= partinfo[tmp.x][tmp.y].val;
             tmp=partinfo[tmp.x][tmp.y].prev;
          }
      }
        /*
        void setQuantiseFlag()
        {
          quantiseFlag=1;
        }

        void resetQuantiseFlag()
        {
          quantiseFlag=0;
        }
         */



 public:

    _QDFSTDECODE(){width=height=RNG_SIZE=HRNG_SIZE=DOM_SIZE=codeflag=0;
              a=b=err=NULL;
              Rx=Ry=Tx=Rqd=NULL;
              partinfo=NULL;

               aNbit=bNbit=-1;
               dxNbit=dyNbit=8;
               txNbit=3;
               aQnt=bQnt=0;

               partition_number=0;
               collectPartitionFlag=0;
               limitFlag=0;
               quantiseFlag=0;
               nLimitPoint=0;
            } 

    ~_QDFSTDECODE(){} 

     void free_partition_arrays()
        {
          int i;
         if(partinfo!=NULL) 
               for(i=0;i<height;i++)
                 if(partinfo[i]!=NULL)
                  ::free(partinfo[i]);
          partinfo=NULL;
        }

     void free()
       {
         if(a!=NULL) free_matrix_float(a,height/RNG_SIZE);
         if(b!=NULL) free_matrix_float(b,height/RNG_SIZE);
         if(err!=NULL) free_matrix_float(err,height/RNG_SIZE);
         if(Rx!=NULL) free_matrix_int(Rx,height/RNG_SIZE);
         if(Ry!=NULL) free_matrix_int(Ry,height/RNG_SIZE);
         if(Tx!=NULL) free_matrix_int(Tx,height/RNG_SIZE);
         if(Rqd!=NULL) free_matrix_int(Rqd,height/RNG_SIZE);
         if(partinfo!=NULL) free_partition_arrays();
       }

 void setNumBitAB(int aBit,int bBit)
        {
           aNbit=aBit;
           bNbit=bBit;
           cout<<"Number of bits for a="<<aNbit<<" For b="<<bNbit<<"\n";
           return;
        }
 int **getQdHead()
       {
         return Rqd;
       }
 int get_w() {return width;}
 int get_h() {return height;}
 int get_rsize() {return RNG_SIZE;}
 int get_hrsize() {return HRNG_SIZE;}
 float **get_a() {return a;}
 float **get_b() {return b;}
 int **get_Tx() {return Tx;}
 int **get_Rx() {return Rx;}
 int **get_Ry() {return Ry;}
 float **get_err(){return err;}
 int *getLimitPoints() {return limitPoints;}

  void setNumLimitCyclePointToZero() {nLimitPoint=0;} // To ignore limit cycle

 _QDFSTDECODE replicateStructure()
      {
        _QDFSTDECODE tmp;

          tmp.width=width;
          tmp.height=height;
          tmp.RNG_SIZE=RNG_SIZE;
          tmp.HRNG_SIZE=HRNG_SIZE;
          tmp.L_GAP=L_GAP;
          tmp.Rqd=Rqd;
          tmp.Rx=Rx;
          tmp.Ry=Ry;
          tmp.Tx=Tx;
          tmp.partiStat=partiStat;

          cout<<"WARNING! Replicating the structure! Not contains any code! \n";
          return tmp;
      }

 void  set(float **ta,float **tb)
       {
          cout<<"WARNING! Changing the transformation content! Assumed Proper Array Dimensions \n";

          a=ta;
          b=tb;
          codeflag=1;
       }
 void setLimitPoints(int *lmpnt)
      {
          cout<<"WARNING! Changing the Limit Point Array Content \n";
          limitPoints=lmpnt;
      }
 
 void computeNbitDxDy()
      {
           dxNbit= getNbit(width/L_GAP);
           dyNbit= getNbit(height/L_GAP);
           cout<<"Number of bits for Dx="<<dxNbit<<" For Dy="<<dyNbit<<"\n";
      }

  void quantiseAB()
        {
         long int aNumber=1,bNumber=1;
         int i,j;
         char ch;

         if((aNbit== -1) || (bNbit==-1))
          {
           cout<<"No. of bits for a and b not set \n";
           return;
          }
          if(quantiseFlag==1){
           cout<<"Already quantised \n";
           return;
          }
          aNumber=aNumber<<aNbit;
          bNumber=bNumber<<bNbit;
          // cout<<"aNumber ="<<aNumber<<"\n";
           //cin>>ch;

           getMinMaxAB();

          aQnt=(aMax-aMin)/(float)aNumber;
          bQnt=(bMax-bMin)/(float)bNumber;
          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
          {
           if(Rqd[i][j]>0)
            {
             a[i][j]= (float)((int)((a[i][j]-aMin)/aQnt));
             b[i][j]= (float)((int)((b[i][j]-bMin)/bQnt));
            }
          }
          quantiseFlag=1;
          return;
        }

   void dequantiseAB()
        {
         int i,j;
         if((aNbit== -1) || (bNbit==-1))
          {
           cout<<"No. of bits for a and b not set \n";
           return;
          }
          if(quantiseFlag==0){
           cout<<"Already dequantised \n";
           return;
          }
          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
          {
           if(Rqd[i][j]>0)
            {
             a[i][j]= a[i][j]*aQnt+aMin;
             b[i][j]= b[i][j]*bQnt+bMin;
            }
          }
          quantiseFlag=0;
          return;
        }

  void printStat()
       {
           int i,j;
           int count[256];
           int total_count=0;
           int hfactor=HRNG_SIZE/RNG_SIZE;
           float bpp;

             //cout<<"Going to print the Statistics with highest factor "<<hfactor<<"\n";
            for(i=1;i<=hfactor;i++) count[i]=0;
             //cout<<"Count Initialised \n"<<flush;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
               if(Rqd[i][j]>0) count[Rqd[i][j]]++;
             //cout<<"Going to print the counts \n"<<flush;

        for(i=1;i<=hfactor;i++)
         if(count[i]>0)
          {
           total_count+=count[i];
           cout<<"No. of Blocks with size "<<RNG_SIZE*i<<" = "<<count[i]<<"\n"<<flush;
           }
           cout<<"Total No. of Blocks "<<total_count<<"\n"<<flush;
           cout<<"Total No. of Limit Points "<<nLimitPoint<<"\n"<<flush;
         computeNbitDxDy();
        if((aNbit!=-1) && (bNbit!=-1))
         bpp=((float)total_count * (float) (aNbit+bNbit+dxNbit+dyNbit+txNbit)+nLimitPoint) / ((float)height*(float)width);
         else
         bpp=((float)total_count * (16+16+dxNbit+dyNbit+txNbit)+nLimitPoint) / ((float)height*(float)width);
         cout<<"BPP for QDFC :"<<bpp<<"\n"<<flush;

       return;
       }

   float compute_bpp()
   {
           int i,j;
           int total_count=0;
           float bpp;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
               if(Rqd[i][j]>0) total_count++;

         computeNbitDxDy();
        if((aNbit!=-1) && (bNbit!=-1))
         bpp=(float)total_count * (float) (aNbit+bNbit+dxNbit+dyNbit+txNbit) / ((float)height*(float)width);
         else
         bpp=(float)total_count * (16+16+dxNbit+dyNbit+txNbit) / ((float)height*(float)width);
         return bpp;

   }




   void compress(_GREY im,int hrsize,int lrsize,float error,int l_gap=1,int rng_subst=0)
       {
           if(codeflag==1) {
             cout<<"WARNING! Valid codes overwritten. \n";
           }

          _MASK domain,shDomain, range,temp_shDomain;
          float tcorr;
          int i,j,k,l,m;
          float sdDom,meanDom;
          float sdRng,meanRng;
          int cur_rsize,factor;
          int domain_found;


              width=im.get_w();
              height=im.get_h();
              RNG_SIZE=lrsize;
              HRNG_SIZE=hrsize;
              ERR_LB=error;
              codeflag=0;
              cur_rsize=RNG_SIZE;
              L_GAP=l_gap;
      
              cout<<"Width="<<width<<" Height="<<height<<"\n";
              cout<<"Going to allocate the arrays for the coeffcients ..\n";
              

              allocate_coeff_arrays();
                      cout<<"Coefficients allocated  \n"<<flush;
              Initialize_arrays();
                      cout<<"Coefficients  initialised \n"<<flush;

           while(cur_rsize <=HRNG_SIZE)
              {
               // cout<<"For range size "<<cur_rsize<<":\n";
               factor=cur_rsize/RNG_SIZE;
               DOM_SIZE=cur_rsize*2;


              domain.set(DOM_SIZE,DOM_SIZE);
              shDomain.set(cur_rsize,cur_rsize);
              range.set(cur_rsize,cur_rsize);
              temp_shDomain.set(cur_rsize,cur_rsize);

              for(i=0;i<height/cur_rsize;i++)
              for(j=0;j<width/cur_rsize;j++)
              {
                if(check_quadrant(i*factor,j*factor,factor))
                  {

                     domain_found=0;

                    im.get_Rect(range,i*cur_rsize,j*cur_rsize,cur_rsize);
                    sdRng=range.N_compute(SD_MODE);
                    meanRng=range.N_compute(AVG_MODE);

                    for(l=0;l<height-DOM_SIZE;l+=L_GAP)
                    for(m=0;m<width-DOM_SIZE;m+=L_GAP)
                    {
                       if (err[i*factor][j*factor]<=ERR_LB) break;

                       im.get_Rect(domain,l,m,DOM_SIZE);
                       domain.shrink(shDomain,2.0);
                       sdDom=shDomain.N_compute(SD_MODE);
                       meanDom=shDomain.N_compute(AVG_MODE);
                         

                       if((l!=i*cur_rsize) && (m!=j*cur_rsize) && (sdDom!=0))
                       {
          
                       if(sdRng!=0)
                       {
                        shDomain.copy(temp_shDomain);
                       for(k=0;k<7;k++){
                       tcorr=(range.avg_product(temp_shDomain)-meanRng*meanDom)/(sdRng*sdDom);
                       error=sqr(sdRng)*(1-tcorr*tcorr);
                       if( (error<err[i*factor][j*factor])|| (error<ERR_LB)) {
                               float tb,ta;
                               ta=tcorr*sdRng/sdDom;
                               tb=meanRng-ta*meanDom;
                               if(abs(ta)<1.0)
                               {
                               domain_found=1;
                              save_code(i*factor,j*factor,l,m,k,ta,tb,error,factor);
                if(rng_subst)
                im.apply_affine_to(i*cur_rsize,j*cur_rsize,shDomain, a[i*factor][j*factor],b[i*factor][j*factor],Tx[i*factor][j*factor]); // Range Substitution
                               }
                               }
                             switch(k){
                             case 0:
                                       shDomain.rotate_90(temp_shDomain);
                                       break;
                             case 1:
                                       shDomain.rotate_180(temp_shDomain);
                                       break;
                             case 2:
                                       shDomain.rotate_270(temp_shDomain);
                                       break;
                             case 3:
                                       shDomain.reflect_x(temp_shDomain);
                                       break;
                             case 4:
                                       shDomain.reflect_y(temp_shDomain);
                                       break;
                             case 5:
                                       shDomain.reflect_diagonal(temp_shDomain);
                                       break;
                             case 6:
                                       shDomain.reflect_antidiagonal(temp_shDomain);
                                       break;
                             case 7:
                                       cout<<"Transform no. out of range \n";
                                       exit(0);
                             }
                         }
                       }
                       else
                       {
                             domain_found=1;
                    save_code(i*factor,j*factor,l,m,0,0,meanRng,0,factor);
                if(rng_subst)
                im.apply_affine_to(i*cur_rsize,j*cur_rsize,shDomain, a[i*factor][j*factor],b[i*factor][j*factor],Tx[i*factor][j*factor]); // Range Substitution
                       }
                    }
                 } 

                 if(domain_found)
                 {
                 // cout<<"For range at "<<i*factor<<","<<j*factor<<" Domain at"<<Rx[i*factor][j*factor]<<","<<Ry[i*factor][j*factor]<<"With Error"<<err[i*factor][j*factor]<<"\n";
                 }
               }//if check_quad 
              }

                 domain.free();
                 shDomain.free();
                 range.free();
                 temp_shDomain.free();
                 cout<<"Freed the temporary arrays \n";

               cur_rsize*=2;
             } //while

           // quantiseAB();
          cout<<"aMin= "<<aMin<<" aMax= "<<aMax<<"\n";
          cout<<"bMin= "<<bMin<<" bMax= "<<bMax<<"\n";
            codeflag=1;


           cout<<"Number of blocks as follows:\n";
           printStat();

                 return;
             }

   void compressWithLimitCycle(_GREY im,int hrsize,int lrsize,float error,int l_gap=1,int rng_subst=0)
       {
           if(codeflag==1) {
             cout<<"WARNING! Valid codes overwritten. \n";
           }

          _MASK domain,shDomain, range,temp_shDomain;
          float tcorr;
          int i,j,k,l,m;
          float sdDom,meanDom;
          float sdRng,meanRng;
          int cur_rsize,factor;
          int domain_found;


              width=im.get_w();
              height=im.get_h();
              RNG_SIZE=lrsize;
              HRNG_SIZE=hrsize;
              ERR_LB=error;
              codeflag=0;
              cur_rsize=RNG_SIZE;
              L_GAP=l_gap;
      
              cout<<"Width="<<width<<" Height="<<height<<"\n";
              cout<<"Going to allocate the arrays for the coeffcients ..\n";
              

              allocate_coeff_arrays();
                      cout<<"Coefficients allocated  \n"<<flush;
              Initialize_arrays();
                      cout<<"Coefficients  initialised \n"<<flush;

           while(cur_rsize <=HRNG_SIZE)
              {
               // cout<<"For range size "<<cur_rsize<<":\n";
               factor=cur_rsize/RNG_SIZE;
               DOM_SIZE=cur_rsize*2;


              domain.set(DOM_SIZE,DOM_SIZE);
              shDomain.set(cur_rsize,cur_rsize);
              range.set(cur_rsize,cur_rsize);
              temp_shDomain.set(cur_rsize,cur_rsize);

              for(i=0;i<height/cur_rsize;i++)
              for(j=0;j<width/cur_rsize;j++)
              {
                if(check_quadrant(i*factor,j*factor,factor))
                  {

                     domain_found=0;

                    im.get_Rect(range,i*cur_rsize,j*cur_rsize,cur_rsize);
                    sdRng=range.N_compute(SD_MODE);
                    meanRng=range.N_compute(AVG_MODE);

                    for(l=0;l<height-DOM_SIZE;l+=L_GAP)
                    for(m=0;m<width-DOM_SIZE;m+=L_GAP)
                    {
                       if (err[i*factor][j*factor]<=ERR_LB) break;

                       im.get_Rect(domain,l,m,DOM_SIZE);
                       domain.shrink(shDomain,2.0);
                       sdDom=shDomain.N_compute(SD_MODE);
                       meanDom=shDomain.N_compute(AVG_MODE);
                         

                       if((l!=i*cur_rsize) && (m!=j*cur_rsize) && (sdDom!=0))
                       {
          
                       if(sdRng!=0)
                       {
                        shDomain.copy(temp_shDomain);
                       for(k=0;k<7;k++){
                       tcorr=(range.avg_product(temp_shDomain)-meanRng*meanDom)/(sdRng*sdDom);
                       error=sqr(sdRng)*(1-tcorr*tcorr);
                       if( (error<err[i*factor][j*factor])|| (error<ERR_LB)) {
                               float tb,ta;
                               ta=tcorr*sdRng/sdDom;
                               tb=meanRng-ta*meanDom;
                               if(abs(ta)<1.0)
                               {
                               domain_found=1;
                              save_code(i*factor,j*factor,l,m,k,ta,tb,error,factor);
                if(rng_subst)
                im.apply_affine_to(i*cur_rsize,j*cur_rsize,shDomain, a[i*factor][j*factor],b[i*factor][j*factor],Tx[i*factor][j*factor]); // Range Substitution
                               }
                               }
                             switch(k){
                             case 0:
                                       shDomain.rotate_90(temp_shDomain);
                                       break;
                             case 1:
                                       shDomain.rotate_180(temp_shDomain);
                                       break;
                             case 2:
                                       shDomain.rotate_270(temp_shDomain);
                                       break;
                             case 3:
                                       shDomain.reflect_x(temp_shDomain);
                                       break;
                             case 4:
                                       shDomain.reflect_y(temp_shDomain);
                                       break;
                             case 5:
                                       shDomain.reflect_diagonal(temp_shDomain);
                                       break;
                             case 6:
                                       shDomain.reflect_antidiagonal(temp_shDomain);
                                       break;
                             case 7:
                                       cout<<"Transform no. out of range \n";
                                       exit(0);
                             }
                         }
                       }
                       else
                       {
                             domain_found=1;
                    save_code(i*factor,j*factor,l,m,0,0,meanRng,0,factor);
                if(rng_subst)
                im.apply_affine_to(i*cur_rsize,j*cur_rsize,shDomain, a[i*factor][j*factor],b[i*factor][j*factor],Tx[i*factor][j*factor]); // Range Substitution
                       }
                    }
                 } 

                 if(domain_found)
                 {
                 // cout<<"For range at "<<i*factor<<","<<j*factor<<" Domain at"<<Rx[i*factor][j*factor]<<","<<Ry[i*factor][j*factor]<<"With Error"<<err[i*factor][j*factor]<<"\n";
                 }
               }//if check_quad 
              }

                 domain.free();
                 shDomain.free();
                 range.free();
                 temp_shDomain.free();
                 cout<<"Freed the temporary arrays \n";

               cur_rsize*=2;
             } //while

           // quantiseAB();
          cout<<"aMin= "<<aMin<<" aMax= "<<aMax<<"\n";
          cout<<"bMin= "<<bMin<<" bMax= "<<bMax<<"\n";
            codeflag=1;

                limitFlag=1;
                storeLimitPoints(im,nLimitPoint);
                // nLimitPoint=get_Number_of_Limit_Points();

           cout<<"Number of blocks as follows:\n";
           printStat();

                 return;
             }

      void writeCode(char *fname)
          {
            int i,j,k;
            ofstream fout(fname);

             quantiseAB();
            fout<<width<<" "<<height<<" "<<RNG_SIZE<<" "<<HRNG_SIZE<<" "<<L_GAP<<"\n";
            fout<<aMin<<" "<<aQnt<<"\n";
            fout<<bMin<<" "<<bQnt<<"\n";
            fout<<aNbit<<" "<<bNbit<<"\n";
            fout<<nLimitPoint<<"\n";


            for(i=0;i<height/RNG_SIZE;i++)
              {
              for(j=0;j<width/RNG_SIZE;j++)
                {
                  fout<<Rqd[i][j]<<" ";
                }
                 fout<<"\n";
              }


              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                 if(Rqd[i][j]>0)
                  fout<<Rx[i][j]<<" "<<Ry[i][j]<<" "<<a[i][j]<<" "<<Tx[i][j]<<" "<<b[i][j]<<'\n';

              if(nLimitPoint>0)
                 for(i=0;i<nLimitPoint;i++)
                    fout<<limitPoints[i]<<"\n";

            fout.close();
          }


      friend ofstream& operator<<(ofstream& fout, const _QDFSTDECODE &ob);
      void writeBinCode(char *fname)
          {
            int i,j,k;
            int tmptxno;
            unsigned short int usint;
            unsigned char uchar;
            ofstream fout(fname);

             quantiseAB();

           fout.write((char *) &width,sizeof(int));
           fout.write((char *) &height,sizeof(int));
           fout.write((char *) &RNG_SIZE,sizeof(int));
           fout.write((char *) &HRNG_SIZE,sizeof(int));
           fout.write((char *) &L_GAP,sizeof(int));
           fout.write((char *) &aMin,sizeof(float));
           fout.write((char *) &bMin,sizeof(float));
           fout.write((char *) &aQnt,sizeof(float));
           fout.write((char *) &bQnt,sizeof(float));
           fout.write((char *) &aNbit,sizeof(int));
           fout.write((char *) &bNbit,sizeof(int));
           fout.write((char *) &nLimitPoint,sizeof(int));;


            for(i=0;i<height/RNG_SIZE;i++)
              {
              for(j=0;j<width/RNG_SIZE;j+=8)
                {
                for(k=0;k<8;k++)
                  switch(k){
                  case 0: qdinfo.bit0=((Rqd[i][j+k]>0)?1:0);
                          break;
                  case 1: qdinfo.bit1=((Rqd[i][j+k]>0)?1:0);
                          break;
                  case 2: qdinfo.bit2=((Rqd[i][j+k]>0)?1:0);
                          break;
                  case 3: qdinfo.bit3=((Rqd[i][j+k]>0)?1:0);
                          break;
                  case 4: qdinfo.bit4=((Rqd[i][j+k]>0)?1:0);
                          break;
                  case 5: qdinfo.bit5=((Rqd[i][j+k]>0)?1:0);
                          break;
                  case 6: qdinfo.bit6=((Rqd[i][j+k]>0)?1:0);
                          break;
                  case 7: qdinfo.bit7=((Rqd[i][j+k]>0)?1:0);
                          break;
                  default:
                          cout<<"Value of k exceeds 7 \n";
                          exit(0);
                  }
           fout.write((char *) &qdinfo,sizeof(struct _qdbyte));
                }
              }


          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
           if(Rqd[i][j]>0)
           {
           uchar=(unsigned char) (Rx[i][j]/L_GAP);
           fout.write((char *) &uchar,sizeof(unsigned char));

           uchar=(unsigned char) (Ry[i][j]/L_GAP);
           fout.write((char *) &uchar,sizeof(unsigned char));
           }

          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
           if(Rqd[i][j]>0)
           {
           if(a[i][j]==256) a[i][j]=255;
           uchar=(unsigned char) a[i][j];
           fout.write((char *) &uchar,sizeof(unsigned char));

           if(b[i][j]==256) b[i][j]=255;
           uchar=(unsigned char) b[i][j];
           fout.write((char *) &uchar,sizeof(unsigned char));
           }

           tmptxno=-1;

          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
           if(Rqd[i][j]>0)
           {
             /*
           uchar=(unsigned char) Tx[i][j];
           fout.write(&uchar,sizeof(unsigned char));
              */
            tmptxno++;
              if(tmptxno==5){
                fout.write((char *)&txinfo,sizeof(struct _txbyte));
                tmptxno=0;
              }
              switch(tmptxno){
              case 0: txinfo.tx0=Tx[i][j];
                      break;
              case 1: txinfo.tx1=Tx[i][j];
                      break;
              case 2: txinfo.tx2=Tx[i][j];
                      break;
              case 3: txinfo.tx3=Tx[i][j];
                      break;
              case 4: txinfo.tx4=Tx[i][j];
                      break;
             /*
              case 5: txinfo.tx5=Tx[i][j];
                      break;
              case 6: txinfo.tx6=Tx[i][j];
                      break;
              case 7: txinfo.tx7=Tx[i][j];
                      break;
              */
              default: 
                      cout<<"Transformation number out of range \n";
                      exit(0);
              }
           }
            if((tmptxno>=0) && (tmptxno<5))
                fout.write((char *) &txinfo,sizeof(struct _txbyte));

              if(nLimitPoint>0)
                 for(i=0;i<nLimitPoint;i++)
                    fout.write((char *) &limitPoints[i],sizeof(unsigned char));
            fout.close();
          }

       void readCode(char *fname)
          {
            int i,j;
            ifstream fin(fname);

            if(!fin)
             {
               cout<<"File "<<fname<<" NOT opened \n";
               return;
             }

                cout<<"Going to read code from file "<<fname<<"\n"<<flush;
            fin>>width>>height>>RNG_SIZE>>HRNG_SIZE>>L_GAP;
            fin>>aMin>>aQnt;
            fin>>bMin>>bQnt;
            fin>>aNbit>>bNbit;
            fin>>nLimitPoint;

            if((aNbit==-1) && (bNbit==-1))
             {
              quantiseFlag=0;
             }
             else
             {
              quantiseFlag=1;
             }


              cout<<"Going to allocate memory \n"<<flush;
              allocate_coeff_arrays();
              cout<<"Memory for coefficients allocated \n"<<flush;
              Initialize_arrays();

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                {
                   fin>>Rqd[i][j];
                }


              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
               {
                  if(Rqd[i][j]>0)
                  fin>>Rx[i][j]>>Ry[i][j]>>a[i][j]>>Tx[i][j]>>b[i][j];
                   else
                    {
                      Rx[i][j]=Ry[i][j]=-1;
                      a[i][j]=b[i][j]=0;
                      Tx[i][j]=-1;
                    }

               }
             if(nLimitPoint>0)
                {
                 limitPoints=(int *)calloc(nLimitPoint,sizeof(int));
                 if(limitPoints==NULL)
                    {
                      cout<<"Memory NOT allocated for Limit Points \n";
                      return;
                    }
                 for(i=0;i<nLimitPoint;i++)
                    fin>>limitPoints[i];
                }

             dequantiseAB();
             codeflag=1;
            fin.close();
          }

       friend ifstream& operator>>(ifstream& fin,_QDFSTDECODE &ob);

      void readBinCode(char *fname)
          {
            int i,j,k;
            unsigned char uchar;
            unsigned short int usint;
            int tmptxno;
            ifstream fin(fname);

           fin.read((char *) &width,sizeof(int));
           fin.read((char *) &height,sizeof(int));
           fin.read((char *) &RNG_SIZE,sizeof(int));
           fin.read((char *) &HRNG_SIZE,sizeof(int));
           fin.read((char *) &L_GAP,sizeof(int));
           fin.read((char *) &aMin,sizeof(float));
           fin.read((char *) &bMin,sizeof(float));
           fin.read((char *) &aQnt,sizeof(float));
           fin.read((char *) &bQnt,sizeof(float));
           fin.read((char *) &aNbit,sizeof(int));
           fin.read((char *) &bNbit,sizeof(int));
           fin.read((char *) &nLimitPoint,sizeof(int));

            if((aNbit==-1) && (bNbit==-1))
             {
              quantiseFlag=0;
             }
             else
             {
              quantiseFlag=1;
             }

              allocate_coeff_arrays();
              cout<<"Memory for coeffcients allocated \n"<<flush;
              Initialize_arrays();

            for(i=0;i<height/RNG_SIZE;i++)
              {
              for(j=0;j<width/RNG_SIZE;j+=8)
                {
                 fin.read((char *) &qdinfo,sizeof(struct _qdbyte));
                for(k=0;k<8;k++)
                  {
                  switch(k){
                  case 0: Rqd[i][j+k]=qdinfo.bit0;
                          break;
                  case 1: Rqd[i][j+k]=qdinfo.bit1;
                          break;
                  case 2: Rqd[i][j+k]=qdinfo.bit2;
                          break;
                  case 3: Rqd[i][j+k]=qdinfo.bit3;
                          break;
                  case 4: Rqd[i][j+k]=qdinfo.bit4;
                          break;
                  case 5: Rqd[i][j+k]=qdinfo.bit5;
                          break;
                  case 6: Rqd[i][j+k]=qdinfo.bit6;
                          break;
                  case 7: Rqd[i][j+k]=qdinfo.bit7;
                          break;
                  default:
                          cout<<"Value of k exceeds 7 \n";
                          exit(0);
                   }
                   //cout<<" "<<Rqd[i][j+k];
                  }
                  //cout<<"\n";
                }
              }

           cout<<"Going to compute factors ..\n";
        compute_factor_in_Rqd();
           cout<<"Factors computed ..\n";

           /*
            for(i=0;i<height/RNG_SIZE;i++)
              {
              for(j=0;j<width/RNG_SIZE;j++)
                    cout<<" "<<Rqd[i][j];
              cout<<"\n";
            }
           */


              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                 if(Rqd[i][j]>0)
                 {
                   fin.read((char *) &uchar,sizeof(unsigned char));
                     Rx[i][j]= L_GAP*(unsigned int)uchar;

                     fin.read((char *) &uchar,sizeof(unsigned char));
                     Ry[i][j]= L_GAP*(unsigned int)uchar;
                 }
                   else
                    {
                      Rx[i][j]=Ry[i][j]=-1;
                    }

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                 if(Rqd[i][j]>0)
                 {
                 fin.read((char *) &uchar,sizeof(unsigned char));
                 a[i][j]=(float) uchar;

                 fin.read((char *) &uchar,sizeof(unsigned char));
                 b[i][j]=(float) uchar;
                 }
                   else
                    {
                      a[i][j]=b[i][j]=0;
                    }
              tmptxno=5;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                 if(Rqd[i][j]>0)
                 {
                  /*
                 fin.read((char *) &uchar,sizeof(unsigned char));
                 Tx[i][j]= (unsigned int)uchar;
                  */
                      if(tmptxno==5)
                      {
                      fin.read((char *) &txinfo,sizeof(struct _txbyte));
                      tmptxno=0;
                      }
                      switch(tmptxno)
                      {
                       case 0: Tx[i][j]=txinfo.tx0;
                               break;
                       case 1: Tx[i][j]=txinfo.tx1;
                               break;
                       case 2: Tx[i][j]=txinfo.tx2;
                               break;
                       case 3: Tx[i][j]=txinfo.tx3;
                               break;
                       case 4: Tx[i][j]=txinfo.tx4;
                               break;
                       /*
                       case 5: Tx[i][j]=txinfo.tx5;
                               break;
                       case 6: Tx[i][j]=txinfo.tx6;
                               break;
                       case 7: Tx[i][j]=txinfo.tx7;
                               break;
                        */
                       default:
                                cout<<"Transformation Index out of range \n";
                                exit(0);
                      }
                      tmptxno++;

                 }
                  else
                      Tx[i][j]=-1;
             if(nLimitPoint>0)
                {
                 limitPoints=(int *)calloc(nLimitPoint,sizeof(int));
                 if(limitPoints==NULL)
                    {
                      cout<<"Memory NOT allocated for Limit Points \n";
                      return;
                    }
                 for(i=0;i<nLimitPoint;i++)
                    {
                    fin.read((char *) &uchar, sizeof(unsigned char));
                    limitPoints[i]=uchar;
                    }
                }

             dequantiseAB();
             codeflag=1;
            fin.close();
          }

     _GREY  decompress(int ITER_NO=30)
         {

          _GREY im;
          _MASK domain,shDomain,temp_shDomain;
          int i,j;
          int iter;
          int cur_rsize,factor;

          if(codeflag==0){
             cout<<"WARNING! Not containing any codes! Returning NULL image \n";
           return(im);
          }
          // dequantiseAB();

          im.set(width,height,100,DFLOAT);
          cout<<"Image Initialised \n";

          for(iter=0;iter<ITER_NO;iter++)
          {
            cur_rsize=RNG_SIZE;
            while(cur_rsize<=HRNG_SIZE)
            {
              DOM_SIZE=2*cur_rsize;
              factor=cur_rsize/RNG_SIZE;

                domain.set(DOM_SIZE,DOM_SIZE);
                shDomain.set(cur_rsize,cur_rsize);
                temp_shDomain.set(cur_rsize,cur_rsize);


          for(i=0;i<height/RNG_SIZE;i++)
          for(j=0;j<width/RNG_SIZE;j++)
          {
           if(Rqd[i][j]==factor)
            {
           // if(factor>1) cout<<"Domain size for Range Block at ("<<i<<","<<j<<") :"<<DOM_SIZE<<"\n";
           im.get_Rect(domain,Rx[i][j],Ry[i][j],DOM_SIZE);
           domain.shrink(shDomain,2.0);
           im.apply_affine_to(i*RNG_SIZE,j*RNG_SIZE,shDomain, a[i][j],b[i][j],Tx[i][j]);
            }
           }
           cur_rsize*=2;

          domain.free();
          shDomain.free();
          temp_shDomain.free();
           }
          cout<<"iteration no. "<<iter<<'\n';
          }
            // quantiseAB();
            return(im);
         }

      void visitPoint(_impoint start)
       {
         _impoint prev;
          int rx,ry;

          //cout<<"visiting at "<<start.x<<","<<start.y<<"\n";
          prev=getDomainPoint(start);
          partinfo[prev.x][prev.y].next.x=start.x;
          partinfo[prev.x][prev.y].next.y=start.y;
          partinfo[start.x][start.y].prev.x=prev.x;
          partinfo[start.x][start.y].prev.y=prev.y;
          partinfo[start.x][start.y].visit=1;

          if(partinfo[prev.x][prev.y].visit==1) {
             if(partinfo[prev.x][prev.y].num==0)
                 {
                 collectLimitCycle(prev);
                 return;
                 }
                 if(partinfo[start.x][start.y].num==0)
                  {
                 partinfo[start.x][start.y].num=partinfo[prev.x][prev.y].num;
                 rx=partinfo[start.x][start.y].range.x;
                 ry=partinfo[start.x][start.y].range.y;
                 partinfo[start.x][start.y].val=a[rx][ry]*partinfo[prev.x][prev.y].val+b[rx][ry];
                 partinfo[start.x][start.y].type=1; //Ordinary node
                  }
                 return;
            }
          else      visitPoint(prev);

                 if(partinfo[start.x][start.y].num==0)
                  {
                 partinfo[start.x][start.y].num=partinfo[prev.x][prev.y].num;
                 rx=partinfo[start.x][start.y].range.x;
                 ry=partinfo[start.x][start.y].range.y;
                 partinfo[start.x][start.y].val=a[rx][ry]*partinfo[prev.x][prev.y].val+b[rx][ry];
                 partinfo[start.x][start.y].type=1; //Ordinary node
                  }

            return;
       }

      void visitPointWithLimitPoint(_impoint start)
       {
         _impoint prev;
          int rx,ry;

          //cout<<"visiting at "<<start.x<<","<<start.y<<"\n";
          prev=getDomainPoint(start);
          partinfo[prev.x][prev.y].next.x=start.x;
          partinfo[prev.x][prev.y].next.y=start.y;
          partinfo[start.x][start.y].prev.x=prev.x;
          partinfo[start.x][start.y].prev.y=prev.y;
          partinfo[start.x][start.y].visit=1;

          if(partinfo[prev.x][prev.y].visit==1) {
             if(partinfo[prev.x][prev.y].num==0)
                 {
                 collectLimitCycleWithLimitPoint(prev);
                 return;
                 }
                 if(partinfo[start.x][start.y].num==0)
                  {
                 partinfo[start.x][start.y].num=partinfo[prev.x][prev.y].num;
                 rx=partinfo[start.x][start.y].range.x;
                 ry=partinfo[start.x][start.y].range.y;
                 partinfo[start.x][start.y].val=a[rx][ry]*partinfo[prev.x][prev.y].val+b[rx][ry];
                 partinfo[start.x][start.y].type=1; //Ordinary node
                  }
                 return;
            }
          else      visitPointWithLimitPoint(prev);

                 if(partinfo[start.x][start.y].num==0)
                  {
                 partinfo[start.x][start.y].num=partinfo[prev.x][prev.y].num;
                 rx=partinfo[start.x][start.y].range.x;
                 ry=partinfo[start.x][start.y].range.y;
                 partinfo[start.x][start.y].val=a[rx][ry]*partinfo[prev.x][prev.y].val+b[rx][ry];
                 partinfo[start.x][start.y].type=1; //Ordinary node
                  }

            return;
       }

     _GREY  fastDecompress()
         {

          _GREY im;
          int i,j;
          int iter;
          int cur_rsize,factor;
          _impoint start;
          float **rval;

          if(codeflag==0){
             cout<<"WARNING! Not containing any codes! Returning NULL image \n";
           return(im);
          }
          // dequantiseAB();

         // free_partition_arrays();
         allocate_partition_arrays();
         Initialize_Partition_Info();

        Initialize_range_addresses();
         cout<<"Range addresses initialised \n";
        im.set(width,height,0,DFLOAT);
         cout<<"Image pointer set \n";
        rval=im.get_f();

         limit_sequence_no=0;

          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
          {
            if(partinfo[i][j].visit==0){
             start.x=i; start.y=j;
             //cout<<"Starting visit at "<<i<<","<<j<<"\n";
             visitPoint(start);
            }
          }
          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
              rval[i][j]=partinfo[i][j].val;

               collectPartitionFlag=0;
                // quantiseAB();

            return(im);
         }
/*
     _GREY  fastDecompressWithLimitPoint(_GREY imsrc) //imsrc contains the original value at limit cycle points
         {

          _GREY im;
          int i,j;
          int iter;
          int cur_rsize,factor;
          _impoint start;
          float **rval;

          if(codeflag==0){
             cout<<"WARNING! Not containing any codes! Returning NULL image \n";
           return(im);
          }
          dequantiseAB();

         allocate_partition_arrays();
        Initialize_Partition_Info();

        Initialize_range_addresses();
         cout<<"Range addresses initialised \n";
        im.set(width,height,0,DFLOAT);
         cout<<"Image pointer set \n";
        rval=im.get_f();

          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
          {
            if(partinfo[i][j].visit==0){
             start.x=i; start.y=j;
             //cout<<"Starting visit at "<<i<<","<<j<<"\n";
             visitPointWithLimitPoint(start,imsrc);
            }
          }
          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
              rval[i][j]=partinfo[i][j].val;

               collectPartitionFlag=0;

            return(im);
         }
 */

     _GREY  fastDecompressWithLimitPoint() 
         {

          _GREY im;
          int i,j;
          int iter;
          int cur_rsize,factor;
          _impoint start;
          float **rval;

          if(codeflag==0){
             cout<<"WARNING! Not containing any codes! Returning NULL image \n";
           return(im);
          }
          /*
          if(limit_sequence_no==0){
             cout<<"No LIMIT Points. WARNING! Not containing any codes! Returning NULL image \n";
           return(im);
          }
          */
          // dequantiseAB();

         // free_partition_arrays();
         allocate_partition_arrays();
        Initialize_Partition_Info();

        Initialize_range_addresses();
         cout<<"Range addresses initialised \n";
        im.set(width,height,0,DFLOAT);
         cout<<"Image pointer set \n";
        rval=im.get_f();

        decompress_limit_sequence_no=0;

          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
          {
            if(partinfo[i][j].visit==0){
             start.x=i; start.y=j;
             //cout<<"Starting visit at "<<i<<","<<j<<"\n";
             //visitPointWithLimitPoint(start,imsrc);
             visitPointWithLimitPoint(start);
            }
          }
          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
              rval[i][j]=partinfo[i][j].val;

               collectPartitionFlag=0;
                // quantiseAB();

            return(im);
         }

   int * storeLimitPoints(_GREY im,int & nLimitPoint)
    {
      int i,j;

                fastDecompress();
                nLimitPoint=limit_sequence_no;
       if(limit_sequence_no>0)
       {
         limitPoints=(int *)calloc(limit_sequence_no,sizeof(int));
             if(limitPoints==NULL) {
               cout<<"Memory NOT allocated for the limit points \n";
               return limitPoints;
             }
          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
            if(partinfo[i][j].type==2)
             {
               limitPoints[partinfo[i][j].limit_sequence]= (int) im.pixel(i,j);
             }
             return limitPoints;
       }
       else
       {
         cout<<"Limit points NOT collected \n";
         return limitPoints;
       }
    }

   int get_Number_of_Limit_Points()
     {
         if(partition_number==0)
           {
              cout<<"Partitioning NOT performed \n";
              return -1;
           }
            if(collectPartitionFlag==0)
            collectPartitionStatistics();
               return(partiStat.totalLimitPoints);
     }
 
   void collectPartitionStatistics()
   {
         int i,j;
         float sum;

         partiStat.nPartition=partition_number;
         partiStat.nLimitCycle=(int *) calloc(partition_number,sizeof(int));
         if(partiStat.nLimitCycle==NULL)
            {
              cout<<"Array for partition statistics not allotted \n";
              return;
            }
         partiStat.nPnt=(int *) calloc(partition_number,sizeof(int));
         if(partiStat.nPnt==NULL)
            {
              cout<<"Array for partition statistics not allotted \n";
              return;
            }

          //Initialisation
          for(i=0;i<partition_number;i++)
            {
             partiStat.nLimitCycle[i]=partiStat.nPnt[i]=0;
             partiStat.totalLimitPoints=0;
            }

          for(i=0;i<height;i++)
          for(j=0;j<width;j++)
           {
             partiStat.nPnt[partinfo[i][j].num]++;
             if(partinfo[i][j].type==2)
              {
              partiStat.nLimitCycle[partinfo[i][j].num]++;
               partiStat.totalLimitPoints++;
              }
           }
          sum;
          for(i=0;i<partition_number;i++)
             sum+= partiStat.nLimitCycle[i];
          partiStat.avgLimitCyclePoint= sum/(float) partition_number;
               collectPartitionFlag=1;
   }

   void printPartitionStatistics()
       {
         int i,j;
         float sum;

         if(partition_number==0)
           {
              cout<<"Partitioning NOT performed \n";
              return;
           }
            if(collectPartitionFlag==0)
            collectPartitionStatistics();

           cout<<"Total Number of Partitions: "<<partiStat.nPartition <<"\n";
           cout<<"Total Number of Limit Points: "<<partiStat.totalLimitPoints <<"\n";
           cout<<"Average Number of Limit Points: "<<partiStat.avgLimitCyclePoint <<"\n";
       }

    _QDFSTDECODE filterLimitRanges()
         {
          _QDFSTDECODE tempCode;
           int rx,ry;
           int i,j;

            tempCode.width=width;
            tempCode.height=height;
            tempCode.RNG_SIZE=RNG_SIZE;
            tempCode.HRNG_SIZE=HRNG_SIZE;
            tempCode.L_GAP=L_GAP;
            tempCode.aMin=aMin;
            tempCode.aQnt=aQnt;
            tempCode.bMin=bMin;
            tempCode.bQnt=bQnt;
            tempCode.aNbit=aNbit;
            tempCode.bNbit=bNbit;

             if(partition_number==0)
              {
                cout<<"WARNING! Partitioning NOT done! \n";
                return tempCode;
              }


              cout<<"Going to allocate memory of temporary code \n"<<flush;
              tempCode.allocate_coeff_arrays();
              cout<<"Memory for coeffcients allocated \n"<<flush;

              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
                   {
                   tempCode.Rqd[i][j]=0;
                   tempCode.Rx[i][j]=-1;
                   tempCode.Ry[i][j]=-1;
                   tempCode.a[i][j]=0;
                   tempCode.Tx[i][j]=-1;
                   tempCode.b[i][j]=0;
                   }

              for(i=0;i<height;i++)
              for(j=0;j<width;j++)
                {
                  if(partinfo[i][j].type==2)
                   {
                     rx=partinfo[i][j].range.x;
                     ry=partinfo[i][j].range.y;
                     tempCode.Rqd[rx][ry]=Rqd[rx][ry];
                   }
                }
              for(i=0;i<height/RNG_SIZE;i++)
              for(j=0;j<width/RNG_SIZE;j++)
               {
                  if(tempCode.Rqd[i][j]>0)
                  tempCode.Rx[i][j]=Rx[i][j];
                  tempCode.Ry[i][j]=Ry[i][j];
                  tempCode.a[i][j]=a[i][j];
                  tempCode.Tx[i][j]=Tx[i][j];
                  tempCode.b[i][j]=b[i][j];
               }
              tempCode.codeflag=1;
             return tempCode;
         }
      };

       ifstream& operator>>(ifstream& fin,_QDFSTDECODE &ob)
          {
            int i,j;

            fin>>ob.width>>ob.height>>ob.RNG_SIZE>>ob.HRNG_SIZE>>ob.L_GAP;
            fin>>ob.aMin>>ob.aQnt;
            fin>>ob.bMin>>ob.bQnt;
            fin>>ob.aNbit>>ob.bNbit;

            if((ob.aNbit==-1) && (ob.bNbit==-1))
             {
              ob.quantiseFlag=0;
             }
             else
             {
              ob.quantiseFlag=1;
             }


              cout<<"Going to allocate memory \n"<<flush;
              ob.allocate_coeff_arrays();
              cout<<"Memory for coefficients allocated \n"<<flush;
              ob.Initialize_arrays();

              for(i=0;i<ob.height/ob.RNG_SIZE;i++)
              for(j=0;j<ob.width/ob.RNG_SIZE;j++)
                {
                   fin>>ob.Rqd[i][j];
                }


              for(i=0;i<ob.height/ob.RNG_SIZE;i++)
              for(j=0;j<ob.width/ob.RNG_SIZE;j++)
               {
                  if(ob.Rqd[i][j]>0)
                  fin>>ob.Rx[i][j]>>ob.Ry[i][j]>>ob.a[i][j]>>ob.Tx[i][j]>>ob.b[i][j];
                   else
                    {
                      ob.Rx[i][j]=ob.Ry[i][j]=-1;
                      ob.a[i][j]=ob.b[i][j]=0;
                      ob.Tx[i][j]=-1;
                    }
               }
             ob.dequantiseAB();
             ob.codeflag=1;

             return fin;
          }

      ofstream& operator<<(ofstream& fout, const _QDFSTDECODE &ob)
          {
            int i,j,k;

             // ob.quantiseAB();


            fout<<ob.width<<" "<<ob.height<<" "<<ob.RNG_SIZE<<" "<<ob.HRNG_SIZE<<" "<<ob.L_GAP<<"\n";
            fout<<ob.aMin<<" "<<ob.aQnt<<"\n";
            fout<<ob.bMin<<" "<<ob.bQnt<<"\n";
            fout<<ob.aNbit<<" "<<ob.bNbit<<"\n";


            for(i=0;i<ob.height/ob.RNG_SIZE;i++)
              {
              for(j=0;j<ob.width/ob.RNG_SIZE;j++)
                {
                  fout<<ob.Rqd[i][j]<<" ";
                }
                 fout<<"\n";
              }


              for(i=0;i<ob.height/ob.RNG_SIZE;i++)
              for(j=0;j<ob.width/ob.RNG_SIZE;j++)
                 if(ob.Rqd[i][j]>0)
                  fout<<ob.Rx[i][j]<<" "<<ob.Ry[i][j]<<" "<<ob.a[i][j]<<" "<<ob.Tx[i][j]<<" "<<ob.b[i][j]<<'\n';
           return fout;
          }
