/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
// Correlated Vector Quantization with Regression
class _RELFRCODE{
   int codeflag, frcodeflag, quantiseflag;
  int width,height;
  int BLK_SIZE; // Lower Block Size
  int HBLK_SIZE;
  int DOM_SIZE;
  //float ERROR;
  //float ERR_LB;
  // float A_TH, B_TH;
   float ERR_TH;
   float aMin,aMax,bMin,bMax;
   int aNbit, bNbit; // -1 means floating point representation
   float aQnt,bQnt;  // 0 means floating point representation
  int **Rx,**Ry,**Tx;
  float **a,**b,**err;
  float **frc_a, **frc_b, **frc_err;
  int **Rqd; // Quad info. for a range block
  int **rflag;
  _GREY imageCodeBook;
  _QDFSTDECODE frc;
  _QDFSTDECODE tmpfrc;
   int nLimitPoint;
   int *limitPoints;

      int allocate_coeff_arrays()
       {
              a=allocate_matrix_float(height/BLK_SIZE,width/BLK_SIZE,sizeof(float));
              if(a==NULL)
                 {
                  cout<<"COEFF a's not allocated \n";
                  return -1;
                 }
              b=allocate_matrix_float(height/BLK_SIZE,width/BLK_SIZE,sizeof(float));
              if(b==NULL)
                 {
                  cout<<"COEFF b's not allocated \n";
                  return -1;
                 }
              err=allocate_matrix_float(height/BLK_SIZE,width/BLK_SIZE,sizeof(float));
              if(err==NULL)
                 {
                  cout<<"Error array is not allocated \n";
                  return -1;
                 }

              rflag=allocate_matrix_int(height/BLK_SIZE,width/BLK_SIZE,sizeof(int));
              if(rflag==NULL)
                 {
                  cout<<"Quad Info. array is not allocated\n";
                  return -1;
                 }

             /*
              Rx=allocate_matrix_int(height/BLK_SIZE,width/BLK_SIZE,sizeof(int));
              if(Rx==NULL)
                 {
                  cout<<"COEFF Rx's not allocated \n";
                  return -1;
                 }

              Ry=allocate_matrix_int(height/BLK_SIZE,width/BLK_SIZE,sizeof(int));
              if(Ry==NULL)
                 {
                  cout<<"COEFF Ry's not allocated \n";
                  return -1;
                 }

              Tx=allocate_matrix_int(height/BLK_SIZE,width/BLK_SIZE,sizeof(int));
              if(Tx==NULL)
                 {
                  cout<<"COEFF Tx's not allocated \n";
                  return -1;
                 }
                */
              return 1;
       }

      void Initialize_arrays()
       {
         int i,j;

              for(i=0;i<height/BLK_SIZE;i++)
              for(j=0;j<width/BLK_SIZE;j++)
               {
                err[i][j]=a[i][j]=b[i][j]=0;
                rflag[i][j]=0;
               }

       }

         void getMinMaxAB()
         {
           int i,j;
          aMin=bMin=9999999.0;
          aMax=bMax=-9999999.0;
          for(i=0;i<height/BLK_SIZE;i++)
          for(j=0;j<width/BLK_SIZE;j++)
           {
             if(Rqd[i][j]>0)
             {
               if(a[i][j]<aMin) aMin=a[i][j];
               if(a[i][j]>aMax) aMax=a[i][j];
               if(b[i][j]<bMin) bMin=b[i][j];
               if(b[i][j]>bMax) bMax=b[i][j];
             }
           }
          return;
         }

 public:

    _RELFRCODE(){width=height=BLK_SIZE=HBLK_SIZE=codeflag=0;
               frcodeflag=0;
               quantiseflag=0;
                //ERROR=0;
                //ERR_LB=0;
              a=b=err=NULL;
               rflag=NULL;
               aNbit=bNbit=-1;
               aQnt=bQnt=0;
              Rx=Ry=Tx=NULL;
                nLimitPoint=0;
             } 

    ~_RELFRCODE(){} 
     void free()
       {
         if(a!=NULL) free_matrix_float(a,height/BLK_SIZE);
         if(b!=NULL) free_matrix_float(b,height/BLK_SIZE);
         if(err!=NULL) free_matrix_float(err,height/BLK_SIZE);
         if(rflag!=NULL) free_matrix_int(Rqd,height/BLK_SIZE);
         /*
         if(Rx!=NULL) free_matrix_int(Rx,height/BLK_SIZE);
         if(Ry!=NULL) free_matrix_int(Ry,height/BLK_SIZE);
         if(Tx!=NULL) free_matrix_int(Tx,height/BLK_SIZE);
         */
       }
       
        void setNumBitAB(int aBit,int bBit)
        {
           aNbit=aBit;
           bNbit=bBit;
           cout<<"Number of bits for a="<<aNbit<<" For b="<<bNbit<<"\n";
           return;
        } 
        void quantiseAB()
        {
         long int aNumber=1,bNumber=1;
         int i,j;
         char ch;

         if((aNbit== -1) || (bNbit==-1))
          {
           cout<<"No. of bits for a and b not set \n";
           return;
          }
          if(quantiseflag==1)
          {
             cout<<"Already quantised \n";
             return;
          }
          aNumber=aNumber<<aNbit;
          bNumber=bNumber<<bNbit;
         // cout<<"aNumber ="<<aNumber<<"\n";
           //cin>>ch;

          getMinMaxAB();

          aQnt=(aMax-aMin)/(float)aNumber;
          bQnt=(bMax-bMin)/(float)bNumber;
          for(i=0;i<height/BLK_SIZE;i++)
          for(j=0;j<width/BLK_SIZE;j++)
          {
           if(Rqd[i][j]>0)
            {
             a[i][j]= (float)((int)((a[i][j]-aMin)/aQnt));
             b[i][j]= (float)((int)((b[i][j]-bMin)/bQnt));
            }
          }
          quantiseflag=1;
          return;
        }

        void dequantiseAB()
        {
         int i,j;
         if((aNbit== -1) || (bNbit==-1))
          {
           cout<<"No. of bits for a and b not set \n";
           return;
          }
          if(quantiseflag==0)
          {
             cout<<"Already dequantised \n";
             return;
          }
          for(i=0;i<height/BLK_SIZE;i++)
          for(j=0;j<width/BLK_SIZE;j++)
          {
           if(Rqd[i][j]>0)
            {
             a[i][j]= a[i][j]*aQnt+aMin;
             b[i][j]= b[i][j]*bQnt+bMin;
            }
          }
          quantiseflag=0;
          return;
        }
  float **get_a() {return a;}
  float **get_b() {return b;}
  float **get_err() {return err;}

  void  setFractalCode(_QDFSTDECODE tfrc) 
                           {
                            frc=tfrc; 
                            Initialize_Frc_Resources();
                          }
  void  setFractalCode(_RELFRCODE& trfrc) 
                           {
                            /*
                            _QDFSTDECODE tfrc;
                             */

                            frc=trfrc.getFrc(); 
                            /*
                            trfrc.dequantiseAB();
                            frc.dequantiseAB();
                            */

                            trfrc.AdjustABForDecompression();
                             // frc.quantiseAB();
                            frc_a=trfrc.get_a();
                            frc_b=trfrc.get_b();

                             height=frc.get_h();
                             width=frc.get_w();
                             BLK_SIZE=frc.get_rsize();
                             HBLK_SIZE=frc.get_hrsize();
                             Rqd=frc.getQdHead();
                             frc_err=frc.get_err();
                             Rx=frc.get_Rx();
                             Ry=frc.get_Ry();
                             Tx=frc.get_Tx();
                             frcodeflag=1;

                             tmpfrc=frc.replicateStructure();
                          }
  _QDFSTDECODE getFrc() {return frc;}
  void Initialize_Frc_Resources()
       {
             height=frc.get_h();
             width=frc.get_w();
             BLK_SIZE=frc.get_rsize();
             HBLK_SIZE=frc.get_hrsize();
             Rqd=frc.getQdHead();
             frc_a=frc.get_a();
             frc_b=frc.get_b();
             frc_err=frc.get_err();
             Rx=frc.get_Rx();
             Ry=frc.get_Ry();
             Tx=frc.get_Tx();
             frcodeflag=1;

             tmpfrc=frc.replicateStructure();

       }

  void AdjustABForDecompression()
      {
        int i,j;

          for(i=0;i<height/BLK_SIZE;i++)
          for(j=0;j<width/BLK_SIZE;j++)
          {
           if((Rqd[i][j]>0) && (rflag[i][j]==0))
            {
             a[i][j]= frc_a[i][j];
             b[i][j]= frc_b[i][j];
            }
          }
      }

           void readQdfrcode(char *fname)
           {
             int i,j,k;

             frc.readCode(fname);
             Initialize_Frc_Resources();

           }

   //void compress(_GREY im, int rng_subst=0,float a_th=0, float b_th=0)//
   void compress(_GREY im, int rng_subst=0,float err_th=0)//
       {
           if(codeflag==1) {
             cout<<"WARNING! Valid codes overwritten. \n";
           }
           if(frcodeflag==0)
               {
                 cout<<"WARNING! No fractal code structure embedded. Compression NOT done! \n";
               return;
               }

        _MASK domain, shDomain, range, temp_shDomain;
          float tcorr;
          int i,j,k,l,m;
          float sdRng,meanRng;
          float sdDom,meanDom;
          int cur_rsize;
          int factor; //Quad factor
          float ta,tb,error;
          int qflag;
          float prev_err; //Error if existing transformation applied


              codeflag=0;
              //A_TH=a_th;
              //B_TH=b_th;
                ERR_TH=err_th;

              allocate_coeff_arrays();
              Initialize_arrays();


                 cout<<"Allocated the temporary masks\n";

                            // frc.dequantiseAB();

           cur_rsize=BLK_SIZE;
           while(cur_rsize <=HBLK_SIZE)
              {
               cout<<"For range size "<<cur_rsize<<":\n";
               factor=cur_rsize/BLK_SIZE;
               DOM_SIZE=cur_rsize*2;


              domain.set(DOM_SIZE,DOM_SIZE);
              shDomain.set(cur_rsize,cur_rsize);
              range.set(cur_rsize,cur_rsize);
              temp_shDomain.set(cur_rsize,cur_rsize);

              for(i=0;i<height/BLK_SIZE;i++)
              for(j=0;j<width/BLK_SIZE;j++)
              {
                if(Rqd[i][j]==factor)
                  {

                    im.get_Rect(range,i*BLK_SIZE,j*BLK_SIZE,cur_rsize);
                    im.get_Rect(domain,Rx[i][j],Ry[i][j],DOM_SIZE);
                       domain.shrink(shDomain,2.0);

                    sdRng=range.N_compute(SD_MODE);
                    meanRng=range.N_compute(AVG_MODE);
                    sdDom=shDomain.N_compute(SD_MODE);
                    meanDom=shDomain.N_compute(AVG_MODE);
                         
                       if(sdRng!=0)
                       {

                             switch(Tx[i][j]){
                             case ROT_0:     shDomain.copy(temp_shDomain);
                                         break;
                             case ROT_90:
                                       shDomain.rotate_90(temp_shDomain);
                                       break;
                             case ROT_180:
                                       shDomain.rotate_180(temp_shDomain);
                                       break;
                             case ROT_270:
                                       shDomain.rotate_270(temp_shDomain);
                                       break;
                             case REFLECT_Y:
                                       shDomain.reflect_y(temp_shDomain);
                                       break;
                             case REFLECT_X:
                                       shDomain.reflect_x(temp_shDomain);
                                       break;
                             case REFLECT_DIAGONAL:
                                       shDomain.reflect_diagonal(temp_shDomain);
                                       break;
                             case REFLECT_ANTIDIAGONAL:
                                       shDomain.reflect_antidiagonal(temp_shDomain);
                                       break;
                             default:
                                       cout<<"Transform no. out of range \n";
                                       exit(0);
                             }
                       tcorr=(range.avg_product(temp_shDomain)-meanRng*meanDom)/(sdRng*sdDom);
                               error=sqr(sdRng)*(1-tcorr*tcorr);
                               ta=tcorr*sdRng/sdDom;
                               tb=meanRng-ta*meanDom;
                                a[i][j]=ta;
                                b[i][j]=tb;
                               err[i][j]=(float)sqrt((double)error);
                               prev_err=range.RMS_Error(temp_shDomain,frc_a[i][j],frc_b[i][j]);
                         }
                       else
                       {
                                a[i][j]=0;
                                b[i][j]=meanRng;
                               error= -1;
                               err[i][j]=error;
                               prev_err=99999.0;
                       }
                  // if((abs(a[i][j]-frc_a[i][j])>A_TH) || (abs(b[i][j]-frc_b[i][j])))
                 //if(abs(err[i][j]-prev_err)>ERR_TH)
                 if((prev_err-err[i][j])>ERR_TH)
                       {
                        //  cout<<"At range "<<i<<","<<j<<" frc_a="<<frc_a[i][j]<<" frc_b="<<frc_b[i][j]<<" error="<<err[i][j]<< " Prev_Error="<<prev_err<<"\n";
 if(rng_subst)
                im.apply_affine_to(i*BLK_SIZE,j*BLK_SIZE,shDomain, a[i][j],b[i][j],Tx[i][j]); // Range Substitution

                        rflag[i][j]=1;
                       }
                      else
                         {
              // cout<<"At range "<<i<<","<<j<<" SUPPRESSING  Coefficients "<<" error="<<err[i][j]<< " Prev_Error="<<prev_err<<"\n";
                         }
                     }
                    }

                 domain.free();
                 shDomain.free();
                 range.free();
                 temp_shDomain.free();
                 cout<<"Freed the temporary arrays \n";

               cur_rsize*=2;
             } //while

  cout<<"Number of blocks as follows:\n";
           printStat();

          tmpfrc.set(a,b);

           limitPoints=tmpfrc.storeLimitPoints(im,nLimitPoint);
           // nLimitPoint=tmpfrc.get_Number_of_Limit_Points();

             // quantiseAB();
          // cout<<"aMin= "<<aMin<<" aMax= "<<aMax<<"\n";
          // cout<<"bMin= "<<bMin<<" bMax= "<<bMax<<"\n";
            // frc.quantiseAB();
           // cout<<"frc quantised \n";
            cout<<"compressed \n";

                 codeflag=1;
                 return;
             }

      void printStat()
       {
           int i,j;
           int total_count=0;
           float bpp;

             //cout<<"Going to print the Statistics with highest factor "<<hfactor<<"\n";

              for(i=0;i<height/BLK_SIZE;i++)
              for(j=0;j<width/BLK_SIZE;j++)
               if(rflag[i][j]>0) total_count++;
             //cout<<"Going to print the counts \n"<<flush;

           cout<<"Total No. of Blocks "<<total_count<<"\n"<<flush;
           cout<<"Total No. of Limit Points "<<nLimitPoint<<"\n"<<flush;
        if((aNbit!=-1) && (bNbit!=-1))
         bpp=((float)total_count * (float) (aNbit+bNbit)+nLimitPoint) / ((float)height*(float)width);
         else
         bpp=((float)total_count * 32.0+nLimitPoint) / ((float)height*(float)width);
         cout<<"BPP for RELFRCODE :"<<bpp<<"\n"<<flush;

       return;
       }

     float compute_bpp()
      {
           int i,j;
           int total_count=0;
           float bpp;

              for(i=0;i<height/BLK_SIZE;i++)
              for(j=0;j<width/BLK_SIZE;j++)
               if(rflag[i][j]>0) total_count++;

        if((aNbit!=-1) && (bNbit!=-1))
         bpp=((float)total_count * (float) (aNbit+bNbit)+nLimitPoint) / ((float)height*(float)width);
         else
         bpp=((float)total_count * 32.0+nLimitPoint) / ((float)height*(float)width);

          return bpp;
      }

      void writeCode(char *fname)
          {
            int i,j;
            ofstream fout(fname);
            
             quantiseAB();

            fout<<width<<" "<<height<<" "<<BLK_SIZE<<" "<<HBLK_SIZE<<'\n';
            fout<<aMin<<" "<<aQnt<<"\n";
            fout<<bMin<<" "<<bQnt<<"\n";
            fout<<aNbit<<" "<<bNbit<<"\n";
            fout<<nLimitPoint<<"\n";

              for(i=0;i<height/BLK_SIZE;i++)
              {
              for(j=0;j<width/BLK_SIZE;j++)
                  fout<<rflag[i][j]<<" ";
                 fout<<"\n";
              }

              for(i=0;i<height/BLK_SIZE;i++)
              for(j=0;j<width/BLK_SIZE;j++)
                if(rflag[i][j]>0)
                  fout<<a[i][j]<<" "<<b[i][j]<<'\n';
               if(nLimitPoint>0)
                 for(i=0;i<nLimitPoint;i++)
                    fout<<limitPoints[i]<<"\n";
            fout.close();
          }

       friend ofstream& operator<<(ofstream&  fout, const _RELFRCODE &ob);
       friend ifstream& operator>>(ifstream& fin, _RELFRCODE & ob);

       void readCode(char *fname)
          {
            int i,j;
            ifstream fin(fname);
            
            fin>>width>>height>>BLK_SIZE>>HBLK_SIZE;
            fin>>aMin>>aQnt;
            fin>>bMin>>bQnt;
            fin>>aNbit>>bNbit;
            fin>>nLimitPoint;

             if((aQnt==-1) && (bQnt==-1))
             {
               quantiseflag=0;
             }
             else
             {
               quantiseflag=1;
             }

             allocate_coeff_arrays();

              for(i=0;i<height/BLK_SIZE;i++)
              for(j=0;j<width/BLK_SIZE;j++)
                  fin>>rflag[i][j];

              for(i=0;i<height/BLK_SIZE;i++)
              for(j=0;j<width/BLK_SIZE;j++)
              {
                 if(rflag[i][j]>0)
                  fin>>a[i][j]>>b[i][j];
                 else
                   a[i][j]=b[i][j]=0;
              }

               if(nLimitPoint>0)
                {
                 limitPoints=(int *)calloc(nLimitPoint,sizeof(int));
                 if(limitPoints==NULL)
                    {
                      cout<<"Memory NOT allocated for Limit Points \n";
                      return;
                    }
                 for(i=0;i<nLimitPoint;i++)
                    fin>>limitPoints[i];
                }
              dequantiseAB();
             codeflag=1;
            fin.close();
          }


     // _GREY  decompress(_GREY imbook)
      _GREY  decompress()
         {

          _GREY im;
          _MASK vector,block;
          float tcorr;
          int i,j,k,l,m;
          int iter;
          int factor;
          int cur_blksize;

          if(codeflag==0){
             cout<<"WARNING! Not containing any codes! Returning NULL image \n";
           return(im);
          }

           cout<<"START DECOMPRESSION \n"<<flush;

          // dequantiseAB();
          // frc.dequantiseAB();
          AdjustABForDecompression();
          cout<<"AB adjusted \n"<<flush;
          // frc.quantiseAB();
          tmpfrc.set(a,b);
          tmpfrc.setLimitPoints(limitPoints);

          // im=tmpfrc.fastDecompressWithLimitPoint(imbook);
           cout<<"Going for fast decompression \n"<<flush;
           im=tmpfrc.fastDecompressWithLimitPoint();
          // nLimitPoint=tmpfrc.get_Number_of_Limit_Points();
           // printStat();
            // quantiseAB();

            return(im);
         }
      };

       ofstream& operator<<(ofstream&  fout, const _RELFRCODE &ob)
          {
            int i,j;


            // fout<<ob.width<<" "<<ob.height<<" "<<ob.BLK_SIZE<<" "<<ob.HBLK_SIZE<<'\n';
            // ob.quantiseAB();

            fout<<ob.aMin<<" "<<ob.aQnt<<"\n";
            fout<<ob.bMin<<" "<<ob.bQnt<<"\n";
            fout<<ob.aNbit<<" "<<ob.bNbit<<"\n";
            fout<<ob.nLimitPoint<<"\n";

              for(i=0;i<ob.height/ob.BLK_SIZE;i++)
              {
              for(j=0;j<ob.width/ob.BLK_SIZE;j++)
                  fout<<ob.rflag[i][j]<<" ";
                 fout<<"\n";
              }

              for(i=0;i<ob.height/ob.BLK_SIZE;i++)
              for(j=0;j<ob.width/ob.BLK_SIZE;j++)
                if(ob.rflag[i][j]>0)
                  fout<<ob.a[i][j]<<" "<<ob.b[i][j]<<'\n';

               if(ob.nLimitPoint>0)
                 for(i=0;i<ob.nLimitPoint;i++)
                    fout<<ob.limitPoints[i]<<"\n";
         return fout;
          }

       ifstream& operator>>(ifstream& fin, _RELFRCODE & ob)
          {
            int i,j;

            // fin>>ob.width>>ob.height>>ob.BLK_SIZE>>ob.HBLK_SIZE;
            fin>>ob.aMin>>ob.aQnt;
            fin>>ob.bMin>>ob.bQnt;
            fin>>ob.aNbit>>ob.bNbit;
            fin>>ob.nLimitPoint;

             if((ob.aNbit==-1) && (ob.bNbit==-1))
             {
               ob.quantiseflag=0;
             }
             else
             {
               ob.quantiseflag=1;
             }

             ob.allocate_coeff_arrays();

              for(i=0;i<ob.height/ob.BLK_SIZE;i++)
              for(j=0;j<ob.width/ob.BLK_SIZE;j++)
                  fin>>ob.rflag[i][j];

              for(i=0;i<ob.height/ob.BLK_SIZE;i++)
              for(j=0;j<ob.width/ob.BLK_SIZE;j++)
              {
                 if(ob.rflag[i][j]>0)
                  fin>>ob.a[i][j]>>ob.b[i][j];
                 else
                   ob.a[i][j]=ob.b[i][j]=0;
              }

               if(ob.nLimitPoint>0)
                {
                 ob.limitPoints=(int *)calloc(ob.nLimitPoint,sizeof(int));
                 if(ob.limitPoints==NULL)
                    {
                      cout<<"Memory NOT allocated for Limit Points \n";
                      return fin;
                    }
                 for(i=0;i<ob.nLimitPoint;i++)
                    fin>>ob.limitPoints[i];
                }
             ob.dequantiseAB();
             ob.codeflag=1;
             return fin;
          }
