/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
#include <iostream>
#include <fstream>
#include <backward/strstream>
using namespace std;
#include <math.h>
#include <ctype.h>
#include <stddef.h>
#include <stdlib.h>
#include <strings.h>

#include <sys/types.h>    /* only include <sys/types.h> once */

#include "../classes_linux9/all.h"
#include "../fractal_codec_classes/qdfstdecode.h"
#include "../fractal_codec_classes/relfrcode.h"
#include "../fractal_codec_classes/colfrcode.h"

int HRNG_SIZE,RNG_SIZE,L_GAP=1;
float ERR_LB,ERR_TH;

main(int argc,char **argv)
{
 _COLOR im,im2,im1;
  _COLFRCODE cfrc;
  char *fname= new char[100], *code_fname=new char[100];
  int width,height;
  int i,j,k,l,m;
  double RMS_ERROR;
  int aNbitG,bNbitG;
  int aNbitR,bNbitR;
  int aNbitB,bNbitB;

 if(argc==8){
  fname=argv[1];
  width=atoi(argv[2]);
  height=atoi(argv[3]);
  HRNG_SIZE=atoi(argv[4]);
  RNG_SIZE=atoi(argv[5]);
  ERR_LB=atof(argv[6]);
  ERR_TH=atof(argv[7]);
  }
 else{
 cout<<"This is a test programme \n";
 cout<<"Name of image file, width, height, Higher & Lower Range Block, Error lb and Error threshold for Relative Coding?\n";
 cin>>fname>>width>>height>>HRNG_SIZE>>RNG_SIZE>>ERR_LB>>ERR_TH;
 }

 cout<<"Number of bits for a & b for the green\n";
 cin>>aNbitG>>bNbitG;

 cout<<"Number of bits for a & b for the red\n";
 cin>>aNbitR>>bNbitR;
 cout<<"Number of bits for a & b for the blue\n";
 cin>>aNbitB>>bNbitB;

 cfrc.setNumBitG(aNbitG,bNbitG);
 cfrc.setNumBitR(aNbitR,bNbitR);
 cfrc.setNumBitB(aNbitR,bNbitB);

 im.load(fname,width,height);
 im2.load(fname,width,height);
 cout<<fname<<" loaded \n"<<flush;


   cout<<"Going to compress ... \n"<<flush;
   cfrc.compress(im,HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP);
   //cfrc.compress(im,HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP,1); //with range block substitution
   cfrc.writeCode("cres.dat");

 //  im1=cfrc.decompress(im2);
    cfrc.dequantise();
   
   im1=cfrc.decompress();

  RMS_ERROR=im2%im1;
  cout<<"RMS Error= "<<RMS_ERROR<<"\n";

  //im1.adjust_image();
  //im1.normalise(0,255);
  //im1.truncate_pic();
  im1.save("dcomp.jrgb");

  cout<<"The image is saved in dcomp.jrgb\n";

 }
