/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
#include <iostream>
#include <fstream>
#include <backward/strstream>
using namespace std;
#include <math.h>
#include <ctype.h>
#include <stddef.h>
#include <stdlib.h>
#include <strings.h>

#include <sys/types.h>    /* only include <sys/types.h> once */

#include "../classes_linux9/all.h"
#include "../fractal_codec_classes/qdfstdecode.h"

int DOM_SIZE,RNG_SIZE,HRNG_SIZE;
int aNbit,bNbit;
float ERR_LB;
#define L_GAP 3

main(int argc,char **argv)
{
 _GREY im,im1,imdiff,im2,imtotal;
  _QDFSTDECODE frc;
  char *fname=new char[100];
  int width,height;
  int i,j,k,l,m;
  double RMS_ERROR;

 if(argc==7){
  fname=argv[1];
  width=atoi(argv[2]);
  height=atoi(argv[3]);
  HRNG_SIZE=atoi(argv[4]);
  RNG_SIZE=atoi(argv[5]);
  ERR_LB=atof(argv[6]);
  }
 else{
 cout<<"This is a test programme \n";
 cout<<"Name of image file, width, height, higher, lower range block size and error?\n";
 cin>>fname>>width>>height>>HRNG_SIZE>>RNG_SIZE>>ERR_LB;
 }

 cout<<"Number of bits for a & b \n";
 cin>>aNbit>>bNbit;

  ifstream fin(fname);
  im2.set(width,height);

 /*
 im2.load_picture(fname,width,height);
 im.load_picture(fname,width,height);
 cout<<fname<<" loaded"<<flush;
  */
   fin>>im2;
   im=im2;
   fin.close();

   frc.setNumBitAB(aNbit,bNbit);
    //frc.compress(im,HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP,1); //With range susbstitution
   frc.compressWithLimitCycle(im,HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP,0); //Without range susbstitution
  frc.writeCode("qdres.dat");
   frc.dequantiseAB();
  // im1=frc.decompress();
  im1=frc.fastDecompress();
   frc.printStat();
  RMS_ERROR=im2%im1;
  cout<<"RMS Error= "<<RMS_ERROR<<"\n";
  im1.adjust_image();
  im1.normalise(0,255);
  im1.save("dcqdout");
  
  cout<<"The image is saved in dcqdout \n";

 }
