/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
#include <iostream>
#include <fstream>
#include <backward/strstream>
using namespace std;
#include <math.h>
#include <ctype.h>
#include <stddef.h>
#include <stdlib.h>
#include <strings.h>

#include <sys/types.h>    /* only include <sys/types.h> once */

#include "../classes_linux9/allqcif.h"
#include "../fractal_codec_classes/qdfstdecode.h"
#include "../fractal_codec_classes/relfrcode.h"
#include "../fractal_codec_classes/colvidfrcode.h"

int HRNG_SIZE,RNG_SIZE,L_GAP=1,GOP;
int startFrame, endFrame;
float ERR_LB,ERR_TH;

main(int argc,char **argv)
{
  _COLOR cim;
   _GREY im, im1;
  _COLVIDFRCODE vfrc;
  _QCIFVIDEO   vid;
  char * fname = new char[100],code_fname[100];
  int width,height;
  int i;
  double RMS_ERROR;
  int aNbitQ,bNbitQ;
  int aNbitR,bNbitR;

 if(argc==8){
  fname=argv[1];
  width=atoi(argv[2]);
  height=atoi(argv[3]);
  HRNG_SIZE=atoi(argv[4]);
  RNG_SIZE=atoi(argv[5]);
  ERR_LB=atof(argv[6]);
  ERR_TH=atof(argv[7]);
  }
 else{
 cout<<"This is a test programme \n";
 cout<<"Name of image file, width, height, Higher & Lower Range Block, Error and ERR_TH?\n";
 cin>>fname>>width>>height>>HRNG_SIZE>>RNG_SIZE>>ERR_LB>>ERR_TH;
 }

 cout<<"Number of bits for a & b for the Q Frames\n";
 cin>>aNbitQ>>bNbitQ;

 cout<<"Number of bits for a & b for the R frames \n";
 cin>>aNbitR>>bNbitR;

 vfrc.setNumBitQ(aNbitQ,bNbitQ);
 vfrc.setNumBitR(aNbitR,bNbitR);
 vfrc.openVideoStream(fname,width,height);

  cout<<"Start Frame and End Frame ? \n";
  cin>>startFrame>>endFrame;

  vfrc.setStartFrameNo(startFrame);
  vfrc.setEndFrameNo(endFrame);

  cout<<"GOP ? \n";
  cin>>GOP;
  vfrc.setGOP(GOP);

   cout<<"Going to compress ... \n"<<flush;
   // vfrc.compress(HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP,1,ERR_TH);
    vfrc.compress(HRNG_SIZE,RNG_SIZE,ERR_LB,L_GAP,0,ERR_TH); // Without substitution
   cout<<"Going to write in the file cvres.dat \n";
   vfrc.writeCode("cvres.dat");

     cout<<"The encoded file saved in cvres.dat \n";

 }
